CREATE TABLE USER_LOCKS(  USER_LOCK_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1, CACHE 20, NO MINVALUE, NO MAXVALUE, NO CYCLE, NO ORDER),  USER_ID VARCHAR(256) NOT NULL,  HYPERVISOR VARCHAR(256) NOT NULL,  LOCK_SESSION_ID VARCHAR(256) NOT NULL,  TIMESTAMP TIMESTAMP ) DATA CAPTURE NONE@
ALTER TABLE RULEOUTPUT ADD COLUMN  TARGET_TABLE VARCHAR(255) 	 @
ALTER TABLE RULEOUTPUT ADD COLUMN  TARGET_FIELD VARCHAR(255)	 @
CREATE OR REPLACE VIEW ANL_VIRTUAL_MACHINE_INVENTORY_V
(VIRTUAL_MACHINE_PK,VMID,LPAR_NUMBER,HOST_NAME,VM_NAME,IP_ADDRESS,FQDN,NUM_CPUS,CPU_MIN,CPU_MAX,CPU_DESIRED,MEMORY_MIN,MEMORY_MAX,MEMORY_DESIRED,OPERATING_SYSTEM_NAME,OPERATING_SYSTEM_VERSION,MIDDLEWARE_NAME,MIDDLEWARE_VERSION,DATA_SOURCE,PHYSICAL_SERVER_PK,PS_HOST_NAME,HMC_HOST_NAME,SHARED_MODE,CAPPED_MODE,ENTITLEMENT,MEMORY_SIZE,
STORAGE_ASSIGNED,
STORAGE_CONSUMED,
STORAGE_PROTECTION,
VIOS_STORAGE_VIRT_MC_PK,
VIOS_STORAGE_NAME,
VIOS_NETWORK_VIRT_MC_PK,
VIOS_NETWORK_NAME,
WorkingSet,TAG_TYPE, TAG_NAME)
AS
SELECT A.VIRTUAL_MACHINE_PK,A.VMID,A.LPAR_NUMBER,A.HOST_NAME,A.VM_NAME,A.IP_ADDRESS,A.FQDN,A.NUM_CPUS,A.CPU_MIN,A.CPU_MAX,A.CPU_DESIRED,A.MEMORY_MIN,A.MEMORY_MAX,A.MEMORY_DESIRED,A.OPERATING_SYSTEM_NAME,A.OPERATING_SYSTEM_VERSION,A.MIDDLEWARE_NAME, A.MIDDLEWARE_VERSION,A.DATA_SOURCE,A.PHYSICAL_SERVER_PK,A.PS_HOST_NAME,A.HMC_HOST_NAME,A.SHARED_MODE,A.CAPPED_MODE,A.ENTITLEMENT,A.MEMORY_SIZE,
A.STORAGE_ASSIGNED,
A.STORAGE_CONSUMED,
A.STORAGE_PROTECTION,
A.VIOS_STORAGE_VIRT_MC_PK,
VIOS_STORAGE.VIOS_STORAGE_NAME,
A.VIOS_NETWORK_VIRT_MC_PK,
VIOS_NETWORK.VIOS_NETWORK_NAME,
B.WorkingSet, C.TAG_TYPE, C.TAG_NAME
FROM 
(SELECT 
VM.VIRTUAL_MACHINE_PK,
VM.VMID, 
VM.LPAR_NUMBER,     
VM.HOST_NAME,
VM.VM_NAME,
VM.IP_ADDRESS,
VM.FQDN,
VM.NUM_CPUS,
VM.CPU_MIN,
VM.CPU_MAX,
VM.CPU_DESIRED,
VM.MEMORY_MIN,
VM.MEMORY_MAX,
VM.MEMORY_DESIRED,
VM.OPERATING_SYSTEM_NAME,
VM.OPERATING_SYSTEM_VERSION,
VM.MIDDLEWARE_NAME, 
VM.MIDDLEWARE_VERSION,
VM.DATA_SOURCE,
VM.SHARED_MODE,
VM.CAPPED_MODE,
VM.ENTITLEMENT,
VM.MEMORY_SIZE,
VM.STORAGE_ASSIGNED,
VM.STORAGE_CONSUMED,
VM.STORAGE_PROTECTION,
VM.VIOS_STORAGE_VIRT_MC_PK,
VM.VIOS_NETWORK_VIRT_MC_PK,
PS.PHYSICAL_SERVER_PK,
PS.HOST_NAME AS PS_HOST_NAME,
PS.HMC_HOST_NAME AS HMC_HOST_NAME
FROM CFG_VIRTUAL_MACHINE VM, CFG_PHYSICAL_SERVER PS
WHERE VM.PHYSICAL_SERVER_PK = PS.PHYSICAL_SERVER_PK 
) A
LEFT OUTER JOIN
(SELECT 
STM.PHYSICAL_SERVER_PK,
ST.TAG_NAME AS WorkingSet
FROM ANL_SERVER_TAGS ST, ANL_SERVER_TAG_MAP STM
WHERE
ST.SERVER_TAGS_PK=STM.SERVER_TAGS_PK
AND ST.TAG_TYPE = 'WorkingSet') B
ON A.PHYSICAL_SERVER_PK=B.PHYSICAL_SERVER_PK
LEFT OUTER JOIN
(SELECT VIRTUAL_MACHINE_PK, SERVER_TAGS_PK, TAG_TYPE, TAG_NAME
	FROM
	(SELECT Q.VIRTUAL_MACHINE_PK, P.SERVER_TAGS_PK, P.TAG_TYPE, P.TAG_NAME
		FROM
		(SELECT SERVER_TAGS_PK, TAG_TYPE, TAG_NAME FROM ANL_SERVER_TAGS WHERE TAG_TYPE <> 'WorkingSet') P
		LEFT OUTER JOIN
		(SELECT VIRTUAL_MACHINE_PK, SERVER_TAGS_PK FROM ANL_VIRTUAL_MACHINE_TAG_MAP) Q
		ON P.SERVER_TAGS_PK = Q.SERVER_TAGS_PK
	)
)C
ON A.VIRTUAL_MACHINE_PK = C.VIRTUAL_MACHINE_PK
LEFT OUTER JOIN
(
SELECT 
VIRTUAL_MACHINE_PK AS VIOS_STORAGE_KEY,
VM_NAME AS VIOS_STORAGE_NAME
FROM CFG_VIRTUAL_MACHINE
WHERE OPERATING_SYSTEM_NAME = 'VIOS'
) VIOS_STORAGE
ON A.VIOS_STORAGE_VIRT_MC_PK = VIOS_STORAGE.VIOS_STORAGE_KEY
LEFT OUTER JOIN
(
SELECT 
VIRTUAL_MACHINE_PK AS VIOS_NETWORK_KEY,
VM_NAME AS VIOS_NETWORK_NAME
FROM CFG_VIRTUAL_MACHINE
WHERE OPERATING_SYSTEM_NAME = 'VIOS'
) VIOS_NETWORK
ON A.VIOS_NETWORK_VIRT_MC_PK = VIOS_NETWORK.VIOS_NETWORK_KEY
@
