#!/bin/bash 

#export PATH=/home/db2inst1/sqllib/bin:/home/db2inst1/sqllib/adm:/home/db2inst1/sqllib/misc:/home/db2inst1/bin:$JAVA_HOME:$JAVA_HOME/jre/bin/:$PATH

# Check the arguments

function InvalidOptions()
{
	echo "Usage : dbinstaller Java_Home_Path [ -f <config_file_name_vmware> <config_file_name_power> ]";
	echo "If -f option is not specified then tadfdcdbinstaller.cfg, tadfdcdbinstaller_p.cfg  will be used";
}

###########################################
# Main program
###########################################


#FILENAME="tadfdcdbinstaller.cfg";
#FILENAME1="tadfdcdbinstaller_p.cfg";

JAVA=java
CLASSNAME=com.ibm.sunset.dbcreation.LynxDatabaseInstaller
export CLASSPATH=./AnalyticsDatabaseInstaller.jar:./lib/log4j-1.2.15.jar:./lib/db2jcc.jar:./lib/db2jcc_license_cu.jar:$CLASSPATH

# Validate the input parameters
if [ $# -gt 4 ]
then
	echo "Incorrect number of arguments";
	InvalidOptions
	exit 1
fi

if [ $# -lt 1 ]
then
	echo "Error !! JAVA_HOME is not specified "
	InvalidOptions
	exit 1
fi

if [ $# -ge 2 -a "$2" != "-f" ]
then
	echo "Error !! Invalid option";
	InvalidOptions
	exit 1
fi

if [ $# -eq 3 -a "$2" == "-f" ]
then
	FILENAME=$3;
	JAVA_HOME=$1
fi;

if [ $# -eq 2 -a "$2" == "-f" ]
then
	echo "Error !! Configuration File is missing."
        InvalidOptions
        exit 1
fi;

if [ $# -eq 4 -a "$2" == "-f" ]
then
          
	FILENAME=$3;
	FILENAME1=$4;
	JAVA_HOME=$1
fi;


if [ $# -eq 1 -a "$1" != "-f" ]
then
	JAVA_HOME=$1
        FILENAME="tadfdcdbinstaller.cfg";
        FILENAME1="tadfdcdbinstaller_p.cfg";
fi

# Make sure that the given java home exists

if [ ! -e /$JAVA_HOME ]
then
    echo " Specified Java Home directory doesn't exist, specify full path to Java Home " 
    exit 1
fi
		   
echo "Entered JAVA_HOME is:$JAVA_HOME"
echo "Config File1:$FILENAME Config File2:$FILENAME1"

# Added user defined JAVA_HOME to the PATH
export PATH=/home/db2inst1/sqllib/bin:/home/db2inst1/sqllib/adm:/home/db2inst1/sqllib/misc:/home/db2inst1/bin:$JAVA_HOME:$JAVA_HOME/bin:$JAVA_HOME/jre/bin/:$PATH

 
if [ -z $FILENAME1 ] ; then
   $JAVA $CLASSNAME $FILENAME
  else
   $JAVA $CLASSNAME $FILENAME $FILENAME1
fi


status=$?

#echo $status
# Check the return status
if [ $? -ne 0 ]
then
	echo "Program failed. Please see log file";
fi

exit $status
