# *******************************************************************************
# IBM Confidential
# OCO Source Materials
# © Copyright IBM Corp. 2011
#
# The source code for this program is not published or otherwise divested of its trade secrets, 
# irrespective of what has been deposited with the U.S. Copyright Office.
# ******************************************************************************/

#!/bin/bash

# Check the arguments
InvalidOptions()
{
	echo "Usage : fed_admin.bat/.sh  [JAVA_HOME] | [-i] | [-v] | [ -f <config_file_name> ] ";
	echo "where  JAVA_HOME = Path to Java Home. If JAVA_HOME is not already set, it should be 1st argument to the script"
	echo "-i runs script in interactive mode"
	echo "-v runs script in DBA verification mode"
	echo "filename = custom configuration file"
	echo "Default filename is fed_config.cfg"
	echo "If no option is specified then federation server is configured and views for all utilization tables are created";
	
}

###########################################
# Main program
###########################################
JAVA=java

CLASSNAME=com.ibm.sunset.dbcreation.FederationWrapper
if [ $# -eq 1 -a "$1" == "-help" ]
then
	InvalidOptions
	exit 1
fi

if [ "$1" == "-i" -o "$1" == "-v" -o "$1" == "-f" ]
then
	if type -p java; then
    _java=java
	elif [[ -n "$JAVA_HOME" ]] && [[ -x "$JAVA_HOME/bin/java" ]];  then
     _java="$JAVA_HOME/bin/java"
	else
    echo "Can not find java executable"
	fi
elif [ "$1" != "" ]; then
			JAVA_HOME=$1;
			if [ ! -d $JAVA_HOME ]
			then	
			echo "Invalid options";
			InvalidOptions
			exit 1
			fi
			
else
		if [ ! -d $JAVA_HOME ]
			then	
			echo "Invalid options";
			InvalidOptions
			exit 1
		fi
fi

export CLASSPATH=./federation.jar:./MessageRetrieval.jar:./lib/log4j-1.2.15.jar:./lib/dlutil.jar:$CLASSPATH

# Added user defined JAVA_HOME to the PATH
export PATH=/home/db2inst1/sqllib/bin:/home/db2inst1/sqllib/adm:/home/db2inst1/sqllib/misc:/home/db2inst1/bin:$JAVA_HOME:$JAVA_HOME/bin:$JAVA_HOME/jre/bin/:$PATH

$JAVA $CLASSNAME $*

status=$?
# Check the return status
if [ $? -ne 0 ]
then
	echo "Program failed. Please see log file";
fi

exit $status
