@ECHO OFF

SETLOCAL EnableDelayedExpansion
SET JAVA=java
SET CLASSNAME=com.ibm.sunset.common.globalization.Server.MessageRetrieval
SET CLASSPATH=.\MessageRetrieval.jar;.\lib\log4j-1.2.15.jar;.\lib\db2jcc.jar;.\lib\db2jcc_license_cu.jar;%CLASSPATH%


SET PROG_NAME=%0
SET ARGUMENTS=


SET DB2=db2

SET TMP_F_NAME=sql.tmp
SET TMP_DDL_FILE_NAME=federationqueries.ddl

SET SPACE=
SET DB2_CMD_SEPARATOR=@
SET SUCCESS_VIEW=,
SET ARGUMENTS_ALL=0
SET IS_CONNECTED=0
SET /A FAILED_COUNT=0

SET TDW_SCHEMA_NAME=ITMUSER

SET SQL_CREATE_NICKNAME=CREATE OR REPLACE NICKNAME
SET SQL_DROP_NICKNAME=DROP NICKNAME
SET SQL_CREATE_VIEW=CREATE OR REPLACE VIEW
SET SQL_DROP_VIEW=DROP VIEW

SET SQL_CREATE_TABLE=CREATE TABLE
SET SQL_DROP_TABLE=DROP TABLE

SET QC="

::##############################################################################
:: List of supported federated metrices.
::##############################################################################
SET ALL_SUPPORTED=PS_CPU PS_CPU_H PS_CPU_D PS_CPU_W PS_CPU_M PS_CPU_Q PS_CPU_Y PS_MEM PS_MEM_H PS_MEM_D PS_MEM_W PS_MEM_M PS_MEM_Q PS_MEM_Y PS_IO PS_IO_H PS_IO_D PS_IO_W PS_IO_M PS_IO_Q PS_IO_Y PS_NET PS_NET_H PS_NET_D PS_NET_W PS_NET_M PS_NET_Q PS_NET_Y VM_CPU VM_CPU_H VM_CPU_D VM_CPU_W VM_CPU_M VM_CPU_Q VM_CPU_Y VM_MEM VM_MEM_H VM_MEM_D VM_MEM_W VM_MEM_M VM_MEM_Q VM_MEM_Y VM_NET VM_NET_H VM_NET_D VM_NET_W VM_NET_M VM_NET_Q VM_NET_Y VM_DS VM_DS_H VM_DS_D VM_DS_W VM_DS_M VM_DS_Q VM_DS_Y

::##############################################################################
:: List of percentile views.
::##############################################################################

SET VIEW_PERC_CPU_H_V=MES_PERCENTILE_CPU_H_V (VM_KEY, VM_NAME, WRITETIME, AVG_CPU_UTILIZATION) AS (SELECT VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME, MES.AVG_CPU_UTILIZATION FROM MES_VM_CPU_H AS MES, ANL_WORKING_SET_V AS WORKINGSET, ANL_TIME_DIM AS TIME, CFG_USER_CONFIGURATION AS USER_CONFIG, CFG_VIRTUAL_MACHINE AS VM WHERE MES.VM_NAME = VM.VM_NAME AND VM.PHYSICAL_SERVER_PK = WORKINGSET.PHYSICAL_SERVER_PK AND MES.WRITETIME = TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN USER_CONFIG.START_TIME AND USER_CONFIG.END_TIME AND MES.AVG_CPU_UTILIZATION ^>=0)

SET VIEW_PERC_DISK_H_V=MES_PERCENTILE_DISK_H_V (VM_KEY, VM_NAME, WRITETIME, AVG_TOTAL_IO) AS ( SELECT VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME, MES.AVG_TOTAL_IO FROM MES_VM_DATA_STORE_H AS MES , ANL_WORKING_SET_V AS WORKINGSET , ANL_TIME_DIM AS TIME , CFG_USER_CONFIGURATION AS USER_CONFIG , CFG_VIRTUAL_MACHINE AS VM WHERE MES.VM_NAME = VM.VM_NAME AND VM.PHYSICAL_SERVER_PK = WORKINGSET.PHYSICAL_SERVER_PK AND MES.WRITETIME = TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN USER_CONFIG.START_TIME AND USER_CONFIG.END_TIME AND MES.AVG_TOTAL_IO ^>=0)

SET VIEW_PERC_MEM_H_V=MES_PERCENTILE_MEM_H_V (VM_KEY, VM_NAME, WRITETIME, AVG_GUEST_UTILIZATION) AS ( SELECT VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME, MES.AVG_GUEST_UTILIZATION FROM MES_VM_MEM_H AS MES , ANL_WORKING_SET_V AS WORKINGSET , ANL_TIME_DIM AS TIME , CFG_USER_CONFIGURATION AS USER_CONFIG , CFG_VIRTUAL_MACHINE AS VM WHERE MES.VM_NAME = VM.VM_NAME AND VM.PHYSICAL_SERVER_PK = WORKINGSET.PHYSICAL_SERVER_PK AND MES.WRITETIME = TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN USER_CONFIG.START_TIME AND USER_CONFIG.END_TIME AND MES.AVG_GUEST_UTILIZATION ^>=0)

SET VIEW_PERC_NW_H_V=MES_PERCENTILE_NW_H_V (VM_KEY, VM_NAME, WRITETIME, AVG_TOTAL_KBPS) AS ( SELECT VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME, (MES.AVG_RECEIVED_KBPS + MES.AVG_TRANSMITTED_KBPS) FROM MES_VM_NETWORK_H AS MES , ANL_WORKING_SET_V AS WORKINGSET , ANL_TIME_DIM AS TIME , CFG_USER_CONFIGURATION AS USER_CONFIG , CFG_VIRTUAL_MACHINE AS VM WHERE MES.VM_NAME = VM.VM_NAME AND VM.PHYSICAL_SERVER_PK = WORKINGSET.PHYSICAL_SERVER_PK AND MES.WRITETIME = TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN USER_CONFIG.START_TIME AND USER_CONFIG.END_TIME AND MES.AVG_RECEIVED_KBPS ^>=0 AND MES.AVG_TRANSMITTED_KBPS ^>=0)
::##############################################################################

::##############################################################################
:: List of SQL statements forming bodies of the metric tables.
::##############################################################################
SET TABLE_BODY_SERVER_CPU=( 		PS_CPU_PK BIGINT NOT NULL, 		HOST_NAME VARCHAR(256), 		CPU_NUMBER INTEGER, 		CPU_UTILIZATION BIGINT, 		PHYSICAL_SERVER_PK BIGINT, 		TIMESTAMP TIMESTAMP 	)

SET TABLE_BODY_SERVER_CPU_AGG=( 		PS_CPU_PK BIGINT NOT NULL, 		HOST_NAME VARCHAR(256), 		CPU_NUMBER INTEGER, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_SERVER_MEM=( 		PS_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		PHYSICAL_MEMORY BIGINT, 		MEMORY_USAGE BIGINT, 		MEMORY_UTILIZATION BIGINT, 		ACTIVE_MEMORY BIGINT, 		GRANTED_MEMORY BIGINT, 		SWAP_USED BIGINT, 		FREE_MEM BIGINT, 		BALLOON_USED BIGINT, 		SWAP_IN_RATE BIGINT, 		SWAP_OUT_RATE BIGINT, 		SWAP_TOTAL_RATE BIGINT, 		PHYSICAL_SERVER_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_SERVER_MEM_AGG=( 		PS_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		PHYSICAL_MEMORY BIGINT, 		MIN_MEMORY_USAGE BIGINT, 		MAX_MEMORY_USAGE BIGINT, 		SUM_MEMORY_USAGE BIGINT, 		AVG_MEMORY_USAGE BIGINT, 		MIN_MEMORY_UTILIZATION BIGINT, 		MAX_MEMORY_UTILIZATION BIGINT, 		SUM_MEMORY_UTILIZATION BIGINT, 		AVG_MEMORY_UTILIZATION BIGINT, 		MIN_ACTIVE_MEMORY BIGINT, 		MAX_ACTIVE_MEMORY BIGINT, 		SUM_ACTIVE_MEMORY BIGINT, 		AVG_ACTIVE_MEMORY BIGINT, 		MIN_GRANTED_MEMORY BIGINT, 		MAX_GRANTED_MEMORY BIGINT, 		SUM_GRANTED_MEMORY BIGINT, 		AVG_GRANTED_MEMORY BIGINT, 		MIN_SWAP_USED BIGINT, 		MAX_SWAP_USED BIGINT, 		SUM_SWAP_USED BIGINT, 		AVG_SWAP_USED BIGINT, 		MIN_FREE_MEM BIGINT, 		MAX_FREE_MEM BIGINT, 		SUM_FREE_MEM BIGINT, 		AVG_FREE_MEM BIGINT, 		MIN_BALLOON_USED BIGINT, 		MAX_BALLOON_USED BIGINT, 		SUM_BALLOON_USED BIGINT, 		AVG_BALLOON_USED BIGINT, 		MIN_SWAP_IN_RATE BIGINT, 		MAX_SWAP_IN_RATE BIGINT, 		SUM_SWAP_IN_RATE BIGINT, 		AVG_SWAP_IN_RATE BIGINT, 		MIN_SWAP_OUT_RATE BIGINT, 		MAX_SWAP_OUT_RATE BIGINT, 		SUM_SWAP_OUT_RATE BIGINT, 		AVG_SWAP_OUT_RATE BIGINT, 		MIN_SWAP_TOTAL_RATE BIGINT, 		MAX_SWAP_TOTAL_RATE BIGINT, 		SUM_SWAP_TOTAL_RATE BIGINT, 		AVG_SWAP_TOTAL_RATE BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_SERVER_DISK=( 		HOST_NAME VARCHAR(256), 		PS_DISK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DISK_NAME VARCHAR(256), 		DATA_STORE_NAME VARCHAR(256), 		READ_KBPS BIGINT, 		WRITE_KBPS BIGINT, 		READ_COUNT BIGINT, 		WRITE_COUNT BIGINT, 		BUS_RESET BIGINT, 		COMMANDS_COUNT BIGINT, 		COMMANDS_ABORTED_COUNT BIGINT, 		DEVICE_READ_LATENCY BIGINT, 		DEVICE_WRITE_LATENCY BIGINT, 		DEVICE_TOTAL_LATENCY BIGINT, 		DEVICE_LATENCY BIGINT, 		PHYSICAL_SERVER_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_SERVER_DISK_AGG=( 		HOST_NAME VARCHAR(256), 		PS_DISK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DISK_NAME VARCHAR(256), 		DATA_STORE_NAME VARCHAR(256), 		MIN_READ_KBPS BIGINT, 		MAX_READ_KBPS BIGINT, 		SUM_READ_KBPS BIGINT, 		AVG_READ_KBPS BIGINT, 		MIN_WRITE_KBPS BIGINT, 		MAX_WRITE_KBPS BIGINT, 		SUM_WRITE_KBPS BIGINT, 		AVG_WRITE_KBPS BIGINT, 		MIN_READ_COUNT BIGINT, 		MAX_READ_COUNT BIGINT, 		SUM_READ_COUNT BIGINT, 		AVG_READ_COUNT BIGINT, 		MIN_WRITE_COUNT BIGINT, 		MAX_WRITE_COUNT BIGINT, 		SUM_WRITE_COUNT BIGINT, 		AVG_WRITE_COUNT BIGINT, 		MIN_BUS_RESET BIGINT, 		MAX_BUS_RESET BIGINT, 		SUM_BUS_RESET BIGINT, 		AVG_BUS_RESET BIGINT, 		MIN_COMMANDS_COUNT BIGINT, 		MAX_COMMANDS_COUNT BIGINT, 		SUM_COMMANDS_COUNT BIGINT, 		AVG_COMMANDS_COUNT BIGINT, 		MIN_COMMANDS_ABORTED_COUNT BIGINT, 		MAX_COMMANDS_ABORTED_COUNT BIGINT, 		SUM_COMMANDS_ABORTED_COUNT BIGINT, 		AVG_COMMANDS_ABORTED_COUNT BIGINT, 		MIN_DEVICE_READ_LATENCY BIGINT, 		MAX_DEVICE_READ_LATENCY BIGINT, 		SUM_DEVICE_READ_LATENCY BIGINT, 		AVG_DEVICE_READ_LATENCY BIGINT, 		MIN_DEVICE_WRITE_LATENCY BIGINT, 		MAX_DEVICE_WRITE_LATENCY BIGINT, 		SUM_DEVICE_WRITE_LATENCY BIGINT, 		AVG_DEVICE_WRITE_LATENCY BIGINT, 		MIN_DEVICE_TOTAL_LATENCY BIGINT, 		MAX_DEVICE_TOTAL_LATENCY BIGINT, 		SUM_DEVICE_TOTAL_LATENCY BIGINT, 		AVG_DEVICE_TOTAL_LATENCY BIGINT, 		MIN_DEVICE_LATENCY BIGINT, 		MAX_DEVICE_LATENCY BIGINT, 		SUM_DEVICE_LATENCY BIGINT, 		AVG_DEVICE_LATENCY BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_SERVER_NET=( 		PS_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		USAGE BIGINT, 		TRANSMITTED_KBPS BIGINT, 		RECEIVED_KBPS BIGINT, 		PKTS_TRANSMITTED BIGINT, 		PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_SERVER_NET_AGG=( 		PS_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM=( 		VM_CPU_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		VM_CPU_NUMBER INTEGER, 		WAIT_TIME BIGINT, 		USED_TIME BIGINT, 		READY_TIME BIGINT, 		SYS_TIME BIGINT, 		CPU_UTILIZATION BIGINT, 		PERCENT_READY INTEGER, 		USER_TIME BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_AGG=( 		VM_CPU_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		VM_CPU_NUMBER INTEGER, 		MIN_WAIT_TIME BIGINT, 		MAX_WAIT_TIME BIGINT, 		SUM_WAIT_TIME BIGINT, 		AVG_WAIT_TIME BIGINT, 		MIN_USED_TIME BIGINT, 		MAX_USED_TIME BIGINT, 		SUM_USED_TIME BIGINT, 		AVG_USED_TIME BIGINT, 		MIN_READY_TIME BIGINT, 		MAX_READY_TIME BIGINT, 		SUM_READY_TIME BIGINT, 		AVG_READY_TIME BIGINT, 		MIN_SYS_TIME BIGINT, 		MAX_SYS_TIME BIGINT, 		SUM_SYS_TIME BIGINT, 		AVG_SYS_TIME BIGINT, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		MIN_PERCENT_READY INTEGER, 		MAX_PERCENT_READY INTEGER, 		SUM_PERCENT_READY INTEGER, 		AVG_PERCENT_READY INTEGER, 		IN_USER_TIME BIGINT, 		MAX_USER_TIME BIGINT, 		SUM_USER_TIME BIGINT, 		AVG_USER_TIME BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_MEM=( 		VM_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		HOST_USAGE BIGINT, 		GUEST_USAGE BIGINT, 		HOST_UTILIZATION BIGINT, 		GUEST_UTILIZATION BIGINT, 		HOST_FREE BIGINT, 		GUEST_FREE BIGINT, 		BALLOON_USAGE BIGINT, 		SWAP_TO_FILE BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_MEM_AGG=( 		VM_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_HOST_USAGE BIGINT, 		MAX_HOST_USAGE BIGINT, 		SUM_HOST_USAGE BIGINT, 		AVG_HOST_USAGE BIGINT, 		MIN_GUEST_USAGE BIGINT, 		MAX_GUEST_USAGE BIGINT, 		SUM_GUEST_USAGE BIGINT, 		AVG_GUEST_USAGE BIGINT, 		MIN_HOST_UTILIZATION BIGINT, 		MAX_HOST_UTILIZATION BIGINT, 		SUM_HOST_UTILIZATION BIGINT, 		AVG_HOST_UTILIZATION BIGINT, 		MIN_GUEST_UTILIZATION BIGINT, 		MAX_GUEST_UTILIZATION BIGINT, 		SUM_GUEST_UTILIZATION BIGINT, 		AVG_GUEST_UTILIZATION BIGINT, 		MIN_HOST_FREE BIGINT, 		MAX_HOST_FREE BIGINT, 		SUM_HOST_FREE BIGINT, 		AVG_HOST_FREE BIGINT, 		MIN_GUEST_FREE BIGINT, 		MAX_GUEST_FREE BIGINT, 		SUM_GUEST_FREE BIGINT, 		AVG_GUEST_FREE BIGINT, 		MIN_BALLOON_USAGE BIGINT, 		MAX_BALLOON_USAGE BIGINT, 		SUM_BALLOON_USAGE BIGINT, 		AVG_BALLOON_USAGE BIGINT, 		MIN_SWAP_TO_FILE BIGINT, 		MAX_SWAP_TO_FILE BIGINT, 		SUM_SWAP_TO_FILE BIGINT, 		AVG_SWAP_TO_FILE BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_NET=( 		VM_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		TRANSMITTED_KBPS BIGINT, 		RECEIVED_KBPS BIGINT, 		PKTS_TRANSMITTED BIGINT, 		PKTS_RECEIVED BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_NET_AGG=( 		VM_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_DS=( 		VM_DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		TOTAL_READ BIGINT, 		TOTAL_WRITE BIGINT, 		TOTAL_IO BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_DS_AGG=( 		VM_DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

::##############################################################################

:MAIN
:: BEGIN {
IF "%1" == "-CONFIGSERVER" (
	IF "%2" == "SET_AUTO_STATS_PROF_OFF" (
		GOTO :PROFOFF
	) ELSE IF "%2" == "CREATE_WRAPPER" (
		GOTO :CREATE_WRAPPER
	) ELSE IF "%2" == "CREATE_SERVER" (
		GOTO :CREATE_SERVER
	) ELSE IF "%2" == "CREATE_USER_MAPPING" (
		GOTO :CREATE_USER_MAPPING	
	) ELSE IF "%2" == "UPDATE_USER_MAPPING" (
		GOTO :UPDATE_USER_MAPPING
	) ELSE IF "%2" == "DROP_WRAPPER" (
		GOTO :DROP_WRAPPER
	)
)
	GOTO :STEP_1

:: } END - MAIN

:PROFOFF
:: BEGIN {
		SET DB_NAME=%3
	SET USER_NAME=%4
	SET USER_PASSWORD=%5
	
	
IF "%6" == "DBAMODE" (
	ECHO !DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD! >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! "update db cfg using AUTO_STATS_PROF OFF" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD!
	!DB2! "update db cfg using AUTO_STATS_PROF OFF"
	)
	SET STATUS=%ERRORLEVEL%
	IF "%6" == "DBAMODE" (
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! TERMINATE 2>&1 
	)
	
	GOTO :EXIT
	
:: } END - PROFOFF

:CREATE_WRAPPER
:: BEGIN {

	SET DB_NAME=%3
	SET USER_NAME=%4
	SET USER_PASSWORD=%5
	SET WRAPPER_NAME=%6
	
	IF "%7" == "DBAMODE" (
	ECHO !DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD! >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! "CREATE WRAPPER !WRAPPER_NAME!" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD!
	!DB2! "CREATE WRAPPER !WRAPPER_NAME!"
	)
	SET STATUS=%ERRORLEVEL%
	IF "%7" == "DBAMODE" (
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! TERMINATE 2>&1 
	)
	GOTO :EXIT
	
:: } END - CREATE_WRAPPER

:DROP_WRAPPER
:: BEGIN {
	SET DB_NAME=%3
	SET USER_NAME=%4
	SET USER_PASSWORD=%5
	SET WRAPPER_NAME=%6
	IF "%7" == "DBAMODE" (
	ECHO !DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD! >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! "DROP WRAPPER !WRAPPER_NAME!" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD! >> !TMP_DDL_FILE_NAME!
	!DB2! "DROP WRAPPER !WRAPPER_NAME!" >> !TMP_DDL_FILE_NAME!
	)
	SET STATUS=%ERRORLEVEL%
	IF "%7" == "DBAMODE" (
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! TERMINATE 2>&1 
	)
	GOTO :EXIT
	
:: } END - CREATE_WRAPPER

:CREATE_SERVER
:: BEGIN {

	SET CONN_STRING=%3
	call :indexOf delim_index %CONN_STRING% ":"

	set /A delim_index+=1
	set CONN_STRING=!CONN_STRING:~%delim_index%!
	call :indexOf delim_index %CONN_STRING% "/"
	set "DB_NAME=!CONN_STRING:~0,%delim_index%!"

	set /A delim_index+=1
	set "CONN_STRING=!CONN_STRING:~%delim_index%!"

	call :indexOf delim_index %CONN_STRING% "/"
	set USER_NAME=!CONN_STRING:~0,%delim_index%!

	set /A delim_index+=1
	set "CONN_STRING=!CONN_STRING:~%delim_index%!"
	set PASSWORD=!CONN_STRING:~0!

	SET SERVER_NAME=%4
	SET SERVER_TYPE=%5
	SET SERVER_VERSION=%6
	SET REMOTE_USER=%7
	SET REMOTE_PASSWORD=%8%
	
	SET REMOTE_DB_CONF_STRING=%9%
	SETLOCAL ENABLEEXTENSIONS
	SHIFT
	SET DBA_MODE=%9%
	call :indexOf delim_index %REMOTE_DB_CONF_STRING% "/"
	SET "WRAPPER_NAME=!REMOTE_DB_CONF_STRING:~0,%delim_index%!"
	
	set /A delim_index+=1
	set "REMOTE_DB_CONF_STRING=!REMOTE_DB_CONF_STRING:~%delim_index%!"
	call :indexOf delim_index %REMOTE_DB_CONF_STRING% "/"
	SET NODE_NAME=!REMOTE_DB_CONF_STRING:~0,%delim_index%!
	
	set /A delim_index+=1
	set "TDW_NAME=!REMOTE_DB_CONF_STRING:~%delim_index%!"
	
	IF NOT "!NODE_NAME!" == "" (
		SET OPTIONS=NODE '!NODE_NAME!'
	)
	IF NOT "!TDW_NAME!" == "" (
		if NOT "!OPTIONS!" == "" (
			SET "OPTIONS=!OPTIONS!, DBNAME '!TDW_NAME!'"
		) ELSE (
			SET "OPTIONS=DBNAME '!TDW_NAME!'"
		)
	)
	
	IF  "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !PASSWORD! >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! "CREATE SERVER !SERVER_NAME! TYPE !SERVER_TYPE! VERSION !SERVER_VERSION! WRAPPER !WRAPPER_NAME! AUTHORIZATION \"!REMOTE_USER!\" PASSWORD \"!REMOTE_PASSWORD!\" OPTIONS (!OPTIONS!)" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !PASSWORD!
	!DB2! "CREATE SERVER !SERVER_NAME! TYPE !SERVER_TYPE! VERSION !SERVER_VERSION! WRAPPER !WRAPPER_NAME! AUTHORIZATION \"!REMOTE_USER!\" PASSWORD \"!REMOTE_PASSWORD!\" OPTIONS (!OPTIONS!)"
	)
	SET STATUS=%ERRORLEVEL%
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! TERMINATE 2>&1 
	)
	GOTO :EXIT

:: } END - CREATE_SERVER

:CREATE_USER_MAPPING
:: BEGIN {

	SET DB_NAME=%3
	SET USER_NAME=%4
	SET USER_PASSWORD=%5
	SET SERVER_NAME=%6
	SET REMOTE_USER='%7'
	SET REMOTE_PASSWORD='%8'
	SET DBA_MODE=%9%
	IF  "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD! >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! "CREATE USER MAPPING FOR !USER_NAME! SERVER !SERVER_NAME! OPTIONS (REMOTE_AUTHID !REMOTE_USER!, REMOTE_PASSWORD !REMOTE_PASSWORD!)" >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! SET PASSTHRU !SERVER_NAME! >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD!
	!DB2! "CREATE USER MAPPING FOR !USER_NAME! SERVER !SERVER_NAME! OPTIONS (REMOTE_AUTHID !REMOTE_USER!, REMOTE_PASSWORD !REMOTE_PASSWORD!)"
	!DB2! SET PASSTHRU !SERVER_NAME!
	)
	SET STATUS=%ERRORLEVEL%
	IF "!DBA_MODE!" == "DBAMODE" (
		ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
		!DB2! TERMINATE 2>&1 
	)
	GOTO :EXIT
	
:: } END - CREATE_USER_MAPPING

:UPDATE_USER_MAPPING
:: BEGIN {

	SET DB_NAME=%3
	SET USER_NAME=%4
	SET USER_PASSWORD=%5
	SET SERVER_NAME=%6
	SET REMOTE_USER='%7'
	SET REMOTE_PASSWORD='%8'
	SET DBA_MODE=%9
	IF  "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD!  >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! "ALTER USER MAPPING FOR !USER_NAME! SERVER !SERVER_NAME! OPTIONS (SET REMOTE_AUTHID !REMOTE_USER!, SET REMOTE_PASSWORD !REMOTE_PASSWORD!)"  >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD!
	!DB2! "ALTER USER MAPPING FOR !USER_NAME! SERVER !SERVER_NAME! OPTIONS (SET REMOTE_AUTHID !REMOTE_USER!, SET REMOTE_PASSWORD !REMOTE_PASSWORD!)"
	)
	SET STATUS=%ERRORLEVEL%
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! TERMINATE 2>&1 
	)
	GOTO :EXIT
	
:: } END - UPDATE_USER_MAPPING

:STEP_1
:: BEGIN {
CALL :GET_WRAPPER_NAME_FOR_SERVER %*
CALL :INIT_TABLE_DEFS

GOTO :PARSE_ARGUMENTS

:: } END - STEP_1

:STEP_2
:: BEGIN {

GOTO :INIT

:: } END - STEP_2

:STEP_3
:: BEGIN {

GOTO :PROCESS_ARGUMENTS

:: } END - STEP_3


:STEP_4
:: BEGIN {
GOTO :PROCESS_REPORT
::  } END STEP_4

:STEP_5
:: BEGIN {

GOTO :SHUT_DOWN

:: } END - STEP_5

:USAGE
:: BEGIN {

ECHO Usage: %PROG_NAME% -help
ECHO        %PROG_NAME% -server ^<SERVER_NAME^> ^-dm ^<DATABASE_NAME^>
ECHO           -dmschema ^<SCHEMA_NAME^> [-add ^| -delete]
ECHO           [ all ^| PS_CPU[_[H^|D^|W^|M^|Q^|Y]] PS_MEM[_[H^|D^|W^|M^|Q^|Y]]
ECHO           PS_IO[_[H^|D^|W^|M^|Q^|Y]] PS_NET[_[H^|D^|W^|M^|Q^|Y]]
ECHO           VM_CPU[_[H^|D^|W^|M^|Q^|Y]] VM_MEM[_[H^|D^|W^|M^|Q^|Y]]
ECHO           VM_NET[_[H^|D^|W^|M^|Q^|Y]] VM_DS[_[H^|D^|W^|M^|Q^|Y]] ]
ECHO where
ECHO        ^-server    : Name of the remote data source configured with
ECHO                     the DRDA wrapper using CREATE SERVER command
ECHO        ^-dm        : Name of the Capacity Planner database
ECHO        ^-dmschema  : Name of the Capacity Planner database schema
ECHO        ^-add       : Adds a federation link
ECHO        ^-delete    : Removes a federation link
ECHO.
ECHO Arguments are of the form MACHINE_COMPONENT[_AGGREGATION-LEVEL]
ECHO.
ECHO where
ECHO    MACHINE     : physical server ^(PS^) or virtual machine ^(VM^),
ECHO    COMPONENT   : CPU ^(CPU^), memory ^(MEM^), IO ^(IO^),
ECHO                  network ^(NET^) or datastore ^(DS^)
ECHO and
ECHO    AGGREGATION-LEVEL   : Hourly ^(_H^), Daily ^(_D^), Weekly ^(_W^),
ECHO                          Monthly ^(_M^), Quarterly ^(_Q^) or Yearly ^(_Y^)
ECHO Argument all adds or deletes all the required federation links.
ECHO.
ECHO Examples
ECHO.
ECHO ^(i^) Set up federation for Physical Server CPU Hourly utilization:
ECHO.
ECHO tadfdc_setup_fed.bat -server WHSERVER -dm TADFDCDB -dmschema TADFDC -add PS_CPU_H
ECHO.
ECHO ^(ii^) Set up federation for Virtual Machine Memory Daily utilization:
ECHO.
ECHO tadfdc_setup_fed.bat -server WHSERVER -dm TADFDCDB -dmschema TADFDC -add VM_MEM_D
ECHO.
ECHO ^(iii^) Set up federation for Physical Server Network Weekly utilization:
ECHO.
ECHO tadfdc_setup_fed.bat -server WHSERVER -dm TADFDCDB -dmschema TADFDC -add PS_NET_W
ECHO.
ECHO ^(iv^) Set up federation for all supported utilization metrics:
ECHO.
ECHO tadfdc_setup_fed.bat -server WHSERVER -dm TADFDCDB -dmschema TADFDC -add all
ECHO.
ECHO ^(v^) Remove federation for Virtual Machine Datastore Monthly utilization:
ECHO.
ECHO tadfdc_setup_fed.bat -server WHSERVER -dm TADFDCDB -dmschema TADFDC -delete VM_DS_M
ECHO.
ECHO ^(vi^) Remove federation for Physical Server Disk IO Quarterly utilization:
ECHO.
ECHO tadfdc_setup_fed.bat -server WHSERVER -dm TADFDCDB -dmschema TADFDC -delete PS_IO_Q


GOTO :SHUT_DOWN

:: } END - USAGE

:PARSE_ARGUMENTS
:: BEGIN {

SET /A ARGS_CNT=0

FOR %%I IN (%*) DO (
SET /A ARGS_CNT+=1
IF !ARGS_CNT! GEQ 10 (
SET ARGUMENTS=!ARGUMENTS! %%I
)
)

IF %ARGS_CNT% EQU 1 (
IF "%1" == "-help" (
%JAVA% %CLASSNAME% "ANA01003I"
GOTO :USAGE
) ELSE (
%JAVA% %CLASSNAME% "ANA01002E"
GOTO :USAGE
)
)

IF %ARGS_CNT% LSS 8 (
%JAVA% %CLASSNAME% "ANA01002E"
GOTO :USAGE
)

IF NOT "%1" == "-server" (
%JAVA% %CLASSNAME% "ANA01002E"
GOTO :USAGE
)

IF NOT "%3" == "-dm" (
%JAVA% %CLASSNAME% "ANA01002E"
GOTO :USAGE
)

IF NOT "%5" == "-dmschema" (
%JAVA% %CLASSNAME% "ANA01002E"
GOTO :USAGE
)
IF "%7" == "DBAMODE" (
SET DBA_MODE="DBAMODE" 
)
SET TDW_SCHEMA_NAME=%8

IF NOT "%9" == "-add" (
IF NOT "%9" == "-delete" (
%JAVA% %CLASSNAME% "ANA01002E"
GOTO :USAGE
)
)
REM TO GET THE 10TH ARGUMENT USING SHIFT COMMAND. THIS WILL CHANGE THE SEQUENCE IN INIT BLOCK TOO 
SHIFT
IF "%9" == "all" (
SET ARGUMENTS_ALL=1
SET ARGUMENTS=!ALL_SUPPORTED!
GOTO :STEP_2
)

SET TMP_CNT=0
FOR %%F IN (%*) DO (

SET /A TMP_CNT+=1
SET ARG=%%F

IF !TMP_CNT! GEQ 10 (

SET FOUND="0"

FOR %%I IN ( PS_CPU PS_CPU_H PS_CPU_D PS_CPU_W PS_CPU_M PS_CPU_Q PS_CPU_Y PS_MEM PS_MEM_H PS_MEM_D PS_MEM_W PS_MEM_M PS_MEM_Q PS_MEM_Y PS_IO PS_IO_H PS_IO_D PS_IO_W PS_IO_M PS_IO_Q PS_IO_Y PS_NET PS_NET_H PS_NET_D PS_NET_W PS_NET_M PS_NET_Q PS_NET_Y VM_CPU VM_CPU_H VM_CPU_D VM_CPU_W VM_CPU_M VM_CPU_Q VM_CPU_Y VM_MEM VM_MEM_H VM_MEM_D VM_MEM_W VM_MEM_M VM_MEM_Q VM_MEM_Y VM_NET VM_NET_H VM_NET_D VM_NET_W VM_NET_M VM_NET_Q VM_NET_Y VM_DS VM_DS_H VM_DS_D VM_DS_W VM_DS_M VM_DS_Q VM_DS_Y ) DO (

SET OPT=%%I
IF "!ARG!" == "!OPT!" (
SET FOUND="1"
)

)

IF !FOUND! == "0" (
%JAVA% %CLASSNAME% "ANA01002E"
GOTO :USAGE
)

)

)

GOTO :STEP_2

:: } END - PARSE_ARGUMENTS

:INIT
:: BEGIN {

%JAVA% %CLASSNAME% "ANA01003I"
REM WE DID SHIFT IN PARSE_ARGUMENTS BLOCK. THE ARGUMENTS WILL SHIFT 
SET LOCAL_SERVER_NAME=%1
SET DM_NAME=%3
SET DM_SCHEMA_NAME=%5
SET ACTION=%8
SET DBA_MODE=%6
SET TDW_SCHEMA_NAME=%7

SET TDW_TABLE_PREFIX=%LOCAL_SERVER_NAME%.%TDW_SCHEMA_NAME%
SET DM_VIEW_NAME_PREFIX=%DM_SCHEMA_NAME%.MES
IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! CONNECT TO !DM_NAME! >> !TMP_DDL_FILE_NAME!
ECHO !DB2! SET SCHEMA=!DM_SCHEMA_NAME! >> !TMP_DDL_FILE_NAME!
ECHO !DB2! -x "SELECT SUBSTR(SERVICE_LEVEL,8,1) FROM SYSIBMADM.ENV_INST_INFO" >> !TMP_DDL_FILE_NAME!
) ELSE (
ECHO Connecting to: !DM_NAME! ... 
!DB2! CONNECT TO !DM_NAME! 2>&1 
ECHO. 
SET IS_CONNECTED=1
)
SET STATUS=%ERRORLEVEL%

IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! SET SCHEMA=!DM_SCHEMA_NAME! >> !TMP_DDL_FILE_NAME!
) ELSE (
!DB2! SET SCHEMA=!DM_SCHEMA_NAME! 2>&1 
ECHO. 
)
IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! -x "SELECT SUBSTR(SERVICE_LEVEL,8,1) FROM SYSIBMADM.ENV_INST_INFO" >> !TMP_DDL_FILE_NAME!
) ELSE (
!DB2! -x "SELECT SUBSTR(SERVICE_LEVEL,8,1) FROM SYSIBMADM.ENV_INST_INFO" > !TMP_F_NAME!
)

FOR /F %%V IN (!TMP_F_NAME!) DO (
SET VERSION=%%V
SET DB2_VERSION=!VERSION!
REM ECHO DB2 FULL VERSION:  !DB2_VERSION!
)

IF "!DBA_MODE!" == "DBAMODE" (
SET /A DB2_VERSION = 7
)
IF %DB2_VERSION% == 5 (
SET SQL_CREATE_NICKNAME=CREATE NICKNAME
SET SQL_CREATE_VIEW=CREATE VIEW
)
GOTO :STEP_3

:: } END - INIT

:PROCESS_ARGUMENTS
:: BEGIN {

IF NOT "!DBA_MODE!" == "DBAMODE" (
ECHO ................................................................................ 
ECHO. 
)

FOR %%J IN (%ARGUMENTS%) DO (
SET AN_ARG=%%J
SET ARG_MACHINE=!AN_ARG:~0,2!
SET ARG_MACHINE_COMP=!AN_ARG:~3,1!
SET ARG_AGGREGATION=
IF "!AN_ARG:~-2,1!" == "_" (
SET ARG_AGGREGATION=!AN_ARG:~-2!
)

IF "!ARG_MACHINE!" == "PS" (
SET TDW_TABLE_MACHINE=KVM_SERVER
SET FED_TABLE_NAME=FED_KVM_SERVER
SET DM_VIEW_NAME_MACHINE=PS
) ELSE IF "!ARG_MACHINE!" == "VM" (
SET TDW_TABLE_MACHINE=KVM_VM
SET FED_TABLE_VM_CPU=KVM_VIRTUAL_MACHINES
SET FED_TABLE_NAME=FED_KVM_VM
SET DM_VIEW_NAME_MACHINE=VM
)

IF "!ARG_MACHINE_COMP!" == "C" (

SET TDW_TABLE_COMP=_CPU
SET FED_TABLE_NAME_COMP=_CPU
SET DM_VIEW_MACHINE_COMP=CPU

:: Set view body
IF "!ARG_MACHINE!" == "PS" (

IF "!AN_ARG:~-2,1!" == "_" (
SET DM_VIEW_BODY=!VIEW_BODY_SERVER_CPU_AGG!
SET TABLE_BODY=!TABLE_BODY_SERVER_CPU_AGG!
) ELSE (
SET DM_VIEW_BODY=!VIEW_BODY_SERVER_CPU!
SET TABLE_BODY=!TABLE_BODY_SERVER_CPU!
)

) ELSE IF "!ARG_MACHINE!" == "VM" (

SET TDW_TABLE_MACHINE=KVM_VIRTUAL_MACHINES
SET TDW_TABLE_COMP=
SET FED_TABLE_NAME=KVM_VIRTUAL_MACHINES
SET FED_TABLE_NAME_COMP=

:: Set view body
IF "!AN_ARG:~-2,1!" == "_" (
SET DM_VIEW_BODY=!VIEW_BODY_VM_AGG!
SET TABLE_BODY=!TABLE_BODY_VM_AGG!
) ELSE (
SET DM_VIEW_BODY=!VIEW_BODY_VM!
SET TABLE_BODY=!TABLE_BODY_VM!
)
)

) ELSE IF "!ARG_MACHINE_COMP!" == "M" (

SET TDW_TABLE_COMP=_MEMORY
SET FED_TABLE_NAME_COMP=_MEMORY
SET DM_VIEW_MACHINE_COMP=MEM

:: Set view body
IF "!ARG_MACHINE!" == "PS" (

IF "!AN_ARG:~-2,1!" == "_" (
SET DM_VIEW_BODY=!VIEW_BODY_SERVER_MEM_AGG!
SET TABLE_BODY=!TABLE_BODY_SERVER_MEM_AGG!
) ELSE (
SET DM_VIEW_BODY=!VIEW_BODY_SERVER_MEM!
SET TABLE_BODY=!TABLE_BODY_SERVER_MEM!
)

) ELSE IF "!ARG_MACHINE!" == "VM" (

IF "!AN_ARG:~-2,1!" == "_" (
SET DM_VIEW_BODY=!VIEW_BODY_VM_MEM_AGG!
SET TABLE_BODY=!TABLE_BODY_VM_MEM_AGG!
) ELSE (
SET DM_VIEW_BODY=!VIEW_BODY_VM_MEM!
SET TABLE_BODY=!TABLE_BODY_VM_MEM!
)

)

) ELSE IF "!ARG_MACHINE_COMP!" == "I" (

SET TDW_TABLE_COMP=_DISK
SET FED_TABLE_NAME_COMP=_DISK
SET DM_VIEW_MACHINE_COMP=DISK

:: Set view body
IF "!ARG_MACHINE!" == "PS" (

IF "!AN_ARG:~-2,1!" == "_" (
SET DM_VIEW_BODY=!VIEW_BODY_SERVER_DISK_AGG!
SET TABLE_BODY=!TABLE_BODY_SERVER_DISK_AGG!
) ELSE (
SET DM_VIEW_BODY=!VIEW_BODY_SERVER_DISK!
SET TABLE_BODY=!TABLE_BODY_SERVER_DISK!
)

)

) ELSE IF "!ARG_MACHINE_COMP!" == "N" (

SET TDW_TABLE_COMP=_NETWORK
SET FED_TABLE_NAME_COMP=_NETWORK
SET DM_VIEW_MACHINE_COMP=NETWORK

:: Set view body
IF "!ARG_MACHINE!" == "PS" (

IF "!AN_ARG:~-2,1!" == "_" (
SET DM_VIEW_BODY=!VIEW_BODY_SERVER_NET_AGG!
SET TABLE_BODY=!TABLE_BODY_SERVER_NET_AGG!
) ELSE (
SET DM_VIEW_BODY=!VIEW_BODY_SERVER_NET!
SET TABLE_BODY=!TABLE_BODY_SERVER_NET!
)

) ELSE IF "!ARG_MACHINE!" == "VM" (

IF "!AN_ARG:~-2,1!" == "_" (
SET DM_VIEW_BODY=!VIEW_BODY_VM_NET_AGG!
SET TABLE_BODY=!TABLE_BODY_VM_NET_AGG!
) ELSE (
SET DM_VIEW_BODY=!VIEW_BODY_VM_NET!
SET TABLE_BODY=!TABLE_BODY_VM_NET!
)

)

) ELSE IF "!ARG_MACHINE_COMP!" == "D" (

SET TDW_TABLE_COMP=_DATASTORE
SET FED_TABLE_NAME_COMP=_DATASTORE
SET DM_VIEW_MACHINE_COMP=DATA_STORE

:: Set view body
IF "!ARG_MACHINE!" == "PS" (

rem Not supported at this time.

) ELSE IF "!ARG_MACHINE!" == "VM" (

SET TDW_TABLE_COMP=_DATASTORE_UTILIZATION
SET FED_TABLE_NAME_COMP=_DATASTORE_UTIL

IF "!AN_ARG:~-2,1!" == "_" (
SET DM_VIEW_BODY=!VIEW_BODY_VM_DS_AGG!
SET TABLE_BODY=!TABLE_BODY_VM_DS_AGG!
) ELSE (
SET DM_VIEW_BODY=!VIEW_BODY_VM_DS!
SET TABLE_BODY=!TABLE_BODY_VM_DS!
)

)

)

SET TDW_TABLE_NAME=!TDW_TABLE_PREFIX!.!TDW_TABLE_MACHINE!!TDW_TABLE_COMP!!ARG_AGGREGATION!
SET O_FED_TABLE_NAME=!FED_TABLE_NAME!!FED_TABLE_NAME_COMP!!ARG_AGGREGATION!
SET FED_TABLE_NAME=!DM_SCHEMA_NAME!.!FED_TABLE_NAME!!FED_TABLE_NAME_COMP!!ARG_AGGREGATION!
SET DM_VIEW_NAME=!DM_VIEW_NAME_PREFIX!_!DM_VIEW_NAME_MACHINE!_!DM_VIEW_MACHINE_COMP!!ARG_AGGREGATION!
SET DM_ENTITY_NAME=MES_!DM_VIEW_NAME_MACHINE!_!DM_VIEW_MACHINE_COMP!!ARG_AGGREGATION!

IF "!ACTION!" == "-add" (

	REM In case of DB2 9.5, first drop the nickname if it already exists.
	IF %DB2_VERSION% == 5 (
		rem Check if the nick name exists.
			IF "!DBA_MODE!" == "DBAMODE" (
				ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!O_FED_TABLE_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'N'" >> !TMP_DDL_FILE_NAME!
			) ELSE (
				!DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!O_FED_TABLE_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'N'" > !TMP_F_NAME!
			)
	
		IF "!DBA_MODE!" == "DBAMODE" (
		ECHO !O_FED_TABLE_NAME! > !TMP_F_NAME!
		)
		SET FLAG=0
		
		FOR /F %%T IN (!TMP_F_NAME!) DO (
			SET MES_NAME=%%T
			SET DB2_CMD_NICK_NAME=!SQL_DROP_NICKNAME! !FED_TABLE_NAME!
			IF "!DBA_MODE!" == "DBAMODE" (
			ECHO !DB2! "!DB2_CMD_NICK_NAME!" >> !TMP_DDL_FILE_NAME!
			) ELSE (
			ECHO Dropping nick name:  !FED_TABLE_NAME! 
			ECHO !DB2_CMD_NICK_NAME! 
			!DB2! "!DB2_CMD_NICK_NAME!" 2>&1 
			SET FLAG=1
			)
		)
		
		REM IF "!DBA_MODE!" == "DBAMODE" (
		REM ECHO !DB2! "!DB2_CMD_NICK_NAME!" >> !TMP_DDL_FILE_NAME!
		REM SET FLAG=1
		REM )
		
		IF !FLAG! EQU 0 (
			ECHO Nick name: !FED_TABLE_NAME! does not exist. 
		)
	)

	
	
	SET DB2_CMD_NICK_NAME=!SQL_CREATE_NICKNAME! !FED_TABLE_NAME! FOR !TDW_TABLE_NAME!
	
	IF "!DBA_MODE!" == "DBAMODE" (
		ECHO !DB2! "!DB2_CMD_NICK_NAME!" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	ECHO Creating nick name:  !FED_TABLE_NAME! 
	ECHO Running: !DB2_CMD_NICK_NAME! 
	!DB2! "!DB2_CMD_NICK_NAME!" 2>&1 
	)
	
	rem Verify that the nickname was created.
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! -x "SELECT TABNAME FROM SYSCT.NICKNAMES WHERE TABNAME = '!O_FED_TABLE_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!'" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! -x "SELECT TABNAME FROM SYSCAT.NICKNAMES WHERE TABNAME = '!O_FED_TABLE_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!'" > !TMP_F_NAME!
	)
	
	SET FLAG=0
	FOR /F %%T IN (!TMP_F_NAME!) DO (
		SET FLAG=1
	)
	IF "!DBA_MODE!" == "DBAMODE" (
	SET FLAG=1
	)
	IF !FLAG! EQU 0 (
		ECHO Failed to create nick name: !FED_TABLE_NAME!  
		SET /A FAILED_COUNT+=1
		SET STATUS=1
	) ELSE (
		rem Drop measurement table if it exists.
		IF "!DBA_MODE!" == "DBAMODE" (
		ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!DM_ENTITY_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'T'" >> !TMP_DDL_FILE_NAME!
		) ELSE (
		ECHO Nick name !FED_TABLE_NAME! created successfully 
		!DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!DM_ENTITY_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'T'" > !TMP_F_NAME!
		)
		IF "!DBA_MODE!" == "DBAMODE" (
			ECHO !DM_ENTITY_NAME! > !TMP_F_NAME!
		)
		FOR /F %%T IN (!TMP_F_NAME!) DO (
			SET MES_NAME=%%T
			
			IF "!DBA_MODE!" == "DBAMODE" (
			ECHO !DB2! DROP TABLE !DM_SCHEMA_NAME!.!DM_ENTITY_NAME! >> !TMP_DDL_FILE_NAME!
			) ELSE (
			ECHO Dropping Datamart table: !DM_SCHEMA_NAME!.!MES_NAME! 
			!DB2! DROP TABLE !DM_SCHEMA_NAME!.!MES_NAME! 2>&1 
			)
		)
		
		
		REM In case of DB2 9.5, first drop the view if it already exists.
		IF %DB2_VERSION% == 5 (
			rem Check if the view exists.
			!DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!DM_ENTITY_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'V'" > !TMP_F_NAME!
	
			SET FLAG=0
			FOR /F %%T IN (!TMP_F_NAME!) DO (
				SET MES_NAME=%%T
				
				IF "!DBA_MODE!" == "DBAMODE" (
				ECHO !DB2! DROP VIEW !DM_SCHEMA_NAME!.!DM_ENTITY_NAME! >> !TMP_DDL_FILE_NAME!
				) ELSE (
				ECHO Dropping Datamart view: !DM_SCHEMA_NAME!.!MES_NAME! 
				!DB2! DROP VIEW !DM_SCHEMA_NAME!.!MES_NAME! 2>&1
				)
				 
				ECHO. 
				SET FLAG=1
			)
			IF !FLAG! EQU 0 (
				ECHO View: !DM_SCHEMA_NAME!.!DM_ENTITY_NAME! does not exist. 
			)

		)

		
		SET DB2_CMD_DM_VIEW=!SQL_CREATE_VIEW! !DM_VIEW_NAME! AS !DM_VIEW_BODY! FROM !FED_TABLE_NAME! T
		ECHO !DB2_CMD_DM_VIEW! > !TMP_F_NAME!
		ECHO !DB2_CMD_SEPARATOR! >> !TMP_F_NAME!
		IF "!DBA_MODE!" == "DBAMODE" (
		ECHO !DB2! !DB2_CMD_DM_VIEW! >> !TMP_DDL_FILE_NAME!
		) ELSE (
		ECHO Creating Datamart view:  !DM_VIEW_NAME! 
		ECHO !DB2_CMD_DM_VIEW! 
		!DB2! -td@ -sf !TMP_F_NAME! 2>&1
		)
		IF ERRORLEVEL 1  (
		ECHO Failed to create a view !DM_VIEW_NAME!
		SET /A FAILED_COUNT+=1
		) ELSE (
		SET SUCCESS_VIEW=!SUCCESS_VIEW!,!DM_VIEW_NAME!
		IF NOT "!DBA_MODE!" == "DBAMODE" (
		ECHO View !DM_VIEW_NAME! created successfully.
		)
		)
		REM as currently we do not support db2 9.5 not checking the DBA mode flag.
		REM Update Percentile views.
		SET PERC_VIEW=UNKNOWN
		IF %DB2_VERSION% == 5 (
			IF "!AN_ARG!" == "VM_CPU_H" (
				SET PERC_VIEW=MES_PERCENTILE_CPU_H_V
				SET DB2_CMD_DM_VIEW=!VIEW_PERC_CPU_H_V!
			) ELSE IF "!AN_ARG!" == "VM_MEM_H" (
				SET PERC_VIEW=MES_PERCENTILE_MEM_H_V
				SET DB2_CMD_DM_VIEW=!VIEW_PERC_MEM_H_V!
			) ELSE IF "!AN_ARG!" == "VM_DS_H" (
				SET PERC_VIEW=MES_PERCENTILE_DISK_H_V
				SET DB2_CMD_DM_VIEW=!VIEW_PERC_DISK_H_V!
			) ELSE IF "!AN_ARG!" == "VM_NET_H" (
				SET PERC_VIEW=MES_PERCENTILE_NW_H_V
				SET DB2_CMD_DM_VIEW=!VIEW_PERC_NW_H_V!
			)
			IF NOT "!PERC_VIEW!" == "UNKNOWN" (
				ECHO. 
				ECHO Dropping Datamart view: !DM_SCHEMA_NAME!.!PERC_VIEW! 
				!DB2! DROP VIEW !DM_SCHEMA_NAME!.!PERC_VIEW! 2>&1 
				ECHO. 
				ECHO Creating Datamart view:  !DM_SCHEMA_NAME!.!PERC_VIEW! 
				ECHO !SQL_CREATE_VIEW! !DM_SCHEMA_NAME!.!DB2_CMD_DM_VIEW! 
				ECHO !SQL_CREATE_VIEW! !DM_SCHEMA_NAME!.!DB2_CMD_DM_VIEW! > !TMP_F_NAME!
				ECHO !DB2_CMD_SEPARATOR! >> !TMP_F_NAME!
				!DB2! -td@ -sf !TMP_F_NAME! 2>&1 
				ECHO. 
			)
		)
	)

) ELSE IF "!ACTION!" == "-delete" (

rem Check if the view exists.
IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!DM_ENTITY_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'V'" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!DM_ENTITY_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'V'" > !TMP_F_NAME!
	)

	IF "!DBA_MODE!" == "DBAMODE" (
		ECHO !DM_ENTITY_NAME! > !TMP_F_NAME!
	)
SET FLAG=0

FOR /F %%T IN (!TMP_F_NAME!) DO (
SET MES_NAME=%%T

IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! DROP VIEW !DM_SCHEMA_NAME!.!DM_ENTITY_NAME! >> !TMP_DDL_FILE_NAME!
) ELSE (
ECHO Dropping Datamart view: !DM_SCHEMA_NAME!.!MES_NAME! 
!DB2! DROP VIEW !DM_SCHEMA_NAME!.!MES_NAME! 2>&1 
)

ECHO. 
SET FLAG=1
)

IF !FLAG! EQU 0 (
ECHO View: !DM_SCHEMA_NAME!.!DM_ENTITY_NAME! does not exist. 
)

rem Restore measurements table if not present.
IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!DM_ENTITY_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'T'" >> !TMP_DDL_FILE_NAME!
) ELSE (
!DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!DM_ENTITY_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'T'" > !TMP_F_NAME!
)

IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DM_ENTITY_NAME! > !TMP_F_NAME!
)
SET FLAG=0
FOR /F %%T IN (!TMP_F_NAME!) DO (
SET MES_NAME=%%T
IF "!MES_NAME!" == "!DM_ENTITY_NAME!" (
SET FLAG=1
)
)
IF "!DBA_MODE!" == "DBAMODE" (
SET FLAG=0
)
IF !FLAG! EQU 0 (
rem ECHO Creating Datamart table: !DM_SCHEMA_NAME!.!DM_ENTITY_NAME!. 
SET DB2_CMD_CREATE_TABLE=!SQL_CREATE_TABLE! !DM_SCHEMA_NAME!.!DM_ENTITY_NAME! !TABLE_BODY!
IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! "!DB2_CMD_CREATE_TABLE!" >> !TMP_DDL_FILE_NAME!
) ELSE (
!DB2! "!DB2_CMD_CREATE_TABLE!" 2>&1 
)

)

REM Update Percentile views.
SET PERC_VIEW=UNKNOWN
IF %DB2_VERSION% == 5 (
IF "!AN_ARG!" == "VM_CPU_H" (
SET PERC_VIEW=MES_PERCENTILE_CPU_H_V
SET DB2_CMD_DM_VIEW=!VIEW_PERC_CPU_H_V!
) ELSE IF "!AN_ARG!" == "VM_MEM_H" (
SET PERC_VIEW=MES_PERCENTILE_MEM_H_V
SET DB2_CMD_DM_VIEW=!VIEW_PERC_MEM_H_V!
) ELSE IF "!AN_ARG!" == "VM_DS_H" (
SET PERC_VIEW=MES_PERCENTILE_DISK_H_V
SET DB2_CMD_DM_VIEW=!VIEW_PERC_DISK_H_V!
) ELSE IF "!AN_ARG!" == "VM_NET_H" (
SET PERC_VIEW=MES_PERCENTILE_NW_H_V
SET DB2_CMD_DM_VIEW=!VIEW_PERC_NW_H_V!
)
IF NOT "!PERC_VIEW!" == "UNKNOWN" (
ECHO. 

IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! DROP VIEW !DM_SCHEMA_NAME!.!PERC_VIEW! >> !TMP_DDL_FILE_NAME!
) ELSE ( 
ECHO Dropping Datamart view: !DM_SCHEMA_NAME!.!PERC_VIEW! 
!DB2! DROP VIEW !DM_SCHEMA_NAME!.!PERC_VIEW! 2>&1 
)
ECHO. 

IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! !SQL_CREATE_VIEW! !DM_SCHEMA_NAME!.!DB2_CMD_DM_VIEW! >> !TMP_DDL_FILE_NAME!
) ELSE (
ECHO Creating Datamart view:  !DM_SCHEMA_NAME!.!PERC_VIEW! 
ECHO !SQL_CREATE_VIEW! !DM_SCHEMA_NAME!.!DB2_CMD_DM_VIEW! 
ECHO !SQL_CREATE_VIEW! !DM_SCHEMA_NAME!.!DB2_CMD_DM_VIEW! > !TMP_F_NAME!
ECHO !DB2_CMD_SEPARATOR! >> !TMP_F_NAME!
!DB2! -td@ -sf !TMP_F_NAME! 2>&1 
)
ECHO. 
)
)

rem Check if the nick name exists.
IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!O_FED_TABLE_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'N'" >> !TMP_DDL_FILE_NAME!
) ELSE (
!DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!O_FED_TABLE_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'N'" > !TMP_F_NAME!
)
IF "!DBA_MODE!" == "DBAMODE" (
ECHO !O_FED_TABLE_NAME! > !TMP_F_NAME!
)

SET FLAG=0
FOR /F %%T IN (!TMP_F_NAME!) DO (
SET MES_NAME=%%T

SET DB2_CMD_NICK_NAME=!SQL_DROP_NICKNAME! !FED_TABLE_NAME!

IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! "!DB2_CMD_NICK_NAME!" >> !TMP_DDL_FILE_NAME! 
) ELSE (
ECHO Dropping nick name:  !FED_TABLE_NAME! 
ECHO !DB2_CMD_NICK_NAME! 
!DB2! "!DB2_CMD_NICK_NAME!" 2>&1 
)
SET FLAG=1
)
IF !FLAG! EQU 0 (
ECHO Nick name: !FED_TABLE_NAME! does not exist. 
)

)
	IF NOT "!DBA_MODE!" == "DBAMODE" (
	ECHO ................................................................................ 
	ECHO. 
	)
)

GOTO :STEP_4
:: } END - PROCESS_ARGUMENTS

:: ################################## START ------ Code added for Expense reduction report table support, by Rahul Shekatkar

:PROCESS_REPORT
:: BEGIN {
SET EXPENSE_REDUCTION_REPORT_TDW_TABLE_LIST="CLUSTERS_D VIRTUAL_MACHINES_D  CLUSTERED_DATASTORES_D  VM_DATASTORE_UTILIZATION_D  VM_MEMORY_D VM_CPU_H SERVER_D VM_MEMORY_H VIRTUAL_MACHINES_H"

::FOR %%i IN ( %EXPENSE_REDUCTION_REPORT_TDW_TABLE_LIST% ) DO (

FOR %%i IN  ( CLUSTERS_D VIRTUAL_MACHINES_D  CLUSTERED_DATASTORES_D  VM_DATASTORE_UTILIZATION_D  VM_MEMORY_D VM_CPU_H SERVER_D VM_MEMORY_H VIRTUAL_MACHINES_H ) DO (
IF "%9" == "all" (

SET TDW_TABLE_NAME=!TDW_TABLE_PREFIX!.KVM_%%i
SET FED_TABLE_NAME=!DM_SCHEMA_NAME!.FED_KVM_%%i
SET O_FED_TABLE_NAME=FED_KVM_%%i
SET CURVAL=%%i
IF "%CURVAL" == "VM_DATASTORE_UTILIZATION_D" (
SET FED_TABLE_NAME=!DM_SCHEMA_NAME!."FED_KVM_VM_DATASTORE_UTIL_D"
)

IF "!ACTION!" == "-add" (

	REM In case of DB2 9.5, first drop the nickname if it already exists.
	IF %DB2_VERSION% == 5 (
		rem Check if the nick name exists.
		IF "!DBA_MODE!" == "DBAMODE" (	
		ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!O_FED_TABLE_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'N'" >> !TMP_DDL_FILE_NAME!
		) ELSE (
		!DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!O_FED_TABLE_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'N'" > !TMP_F_NAME!
		)
		SET FLAG=0
		IF "!DBA_MODE!" == "DBAMODE" (
		ECHO !O_FED_TABLE_NAME! > !TMP_F_NAME!
		)
		FOR /F %%T IN (!TMP_F_NAME!) DO (
			SET MES_NAME=%%T
			SET DB2_CMD_NICK_NAME=!SQL_DROP_NICKNAME! !FED_TABLE_NAME!
				
			IF "!DBA_MODE!" == "DBAMODE" (
			ECHO !DB2! "!DB2_CMD_NICK_NAME!" >> !TMP_DDL_FILE_NAME!
			) ELSE (
			ECHO Dropping nick name:  !FED_TABLE_NAME! 
			ECHO !DB2_CMD_NICK_NAME! 
			!DB2! "!DB2_CMD_NICK_NAME!" 2>&1 
			)
			SET FLAG=1
		)
		IF !FLAG! EQU 0 (
			ECHO Nick name: !FED_TABLE_NAME! does not exist. 
		)
	)
	
	
	SET DB2_CMD_NICK_NAME=!SQL_CREATE_NICKNAME! !FED_TABLE_NAME! FOR !TDW_TABLE_NAME!
	
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! "!DB2_CMD_NICK_NAME!" >> !TMP_DDL_FILE_NAME!
	) ELSE ( 
	ECHO Creating nick name for Expense reduction Reports:  !FED_TABLE_NAME! 
	ECHO Running: !DB2_CMD_NICK_NAME! 
	!DB2! "!DB2_CMD_NICK_NAME!" 2>&1 
	)
	
	rem Verify that the nickname was created.
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.NICKNAMES WHERE TABNAME = '!O_FED_TABLE_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!'" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! -x "SELECT TABNAME FROM SYSCAT.NICKNAMES WHERE TABNAME = '!O_FED_TABLE_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!'" > !TMP_F_NAME!
	)
	
	SET FLAG=0
	FOR /F %%T IN (!TMP_F_NAME!) DO (
		SET FLAG=1
	)
	IF "!DBA_MODE!" == "DBAMODE" (
	SET FLAG=1
	)
	IF !FLAG! EQU 0 (
		ECHO Failed to create nick name: !FED_TABLE_NAME!  
		SET /A FAILED_COUNT+=1
		SET STATUS=1
	)
) ELSE IF "!ACTION!" == "-delete" (

rem Check if the nick name exists.
IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!O_FED_TABLE_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'N'" >> !TMP_DDL_FILE_NAME!
) ELSE (
!DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '!O_FED_TABLE_NAME!' AND TABSCHEMA = '!DM_SCHEMA_NAME!' AND TYPE = 'N'" > !TMP_F_NAME!
)
IF "!DBA_MODE!" == "DBAMODE" (
ECHO !O_FED_TABLE_NAME! > !TMP_F_NAME!
)
SET FLAG=0
FOR /F %%T IN (!TMP_F_NAME!) DO (
SET MES_NAME=%%T
SET DB2_CMD_NICK_NAME=!SQL_DROP_NICKNAME! !FED_TABLE_NAME!

IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! "!DB2_CMD_NICK_NAME!"  >> !TMP_DDL_FILE_NAME!
SET FLAG=1
) ELSE (
ECHO Dropping nick name for Expense reduction Reports:  !FED_TABLE_NAME! 
ECHO !DB2_CMD_NICK_NAME! 
!DB2! "!DB2_CMD_NICK_NAME!" 2>&1 
SET FLAG=1
)

)
IF !FLAG! EQU 0 (
ECHO Nick name: !FED_TABLE_NAME! does not exist. 
)

) 

)
	IF NOT "!DBA_MODE!" == "DBAMODE" (
	ECHO ................................................................................ 
	ECHO. 
	)
)

GOTO :STEP_5
:: } END - PROCESS_REPORT

:: ################################## END ------ Code added for Expense reduction report table support, by Rahul Shekatkar

:SHUT_DOWN
:: BEGIN {

%JAVA% %CLASSNAME% "ANA01004I"

IF !IS_CONNECTED! EQU 1 (
ECHO Disconnecting from: !DM_NAME! 
!DB2! TERMINATE 2>&1 
)
IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
)
IF EXIST "!TMP_F_NAME!" (
DEL !TMP_F_NAME!
)

REM BELOW CODE IS IMPLEMENTED FOR PRINT SUMMARY OF VIEWS STORY
	ECHO SUCCESS_VIEWS=!SUCCESS_VIEW!
	SET TEMPSTR=%SUCCESS_VIEW:MES_VM_MEM_=%
	IF "%SUCCESS_VIEW%"=="%TEMPSTR%" (
	ECHO MEM_TDW_TABLES=KVM_VM_MEMORY
	)
	
	SET TEMPSTR=%SUCCESS_VIEW:MES_VM_CPU_=%
	IF "%SUCCESS_VIEW%"=="%TEMPSTR%" (
	ECHO CPU_TDW_TABLES=KVM_VIRTUAL_MACHINES
	) 
	
	SET TEMPSTR=%SUCCESS_VIEW:MES_VM_DATA_STORE_=%
	IF "%SUCCESS_VIEW%"=="%TEMPSTR%" (
	ECHO DATA_STORE_TDW_TABLES=KVM_VM_DATASTORE_UTILIZATION
	)
	
	SET TEMPSTR=%SUCCESS_VIEW:MES_VM_NETWORK_=%
	IF "%SUCCESS_VIEW%"=="%TEMPSTR%" (
	ECHO NETWORK_TDW_TABLES=KVM_VM_NETWORK
	) 
REM ABOVE CODE IS IMPLEMENTED FOR PRINT SUMMARY OF VIEWS STORY


SET PROG_NAME=
SET ARGUMENTS=

SET DB2=
SET TMP_F_NAME=
SET LOG_F_NAME=
SET SPACE=
SET DB2_CMD_SEPARATOR=
SET VERSION=
SET DB2_VERSION=
SET TDW_SCHEMA_NAME=
SET DM_VIEW_NAME_PREFIX=
SET TDW_TABLE_PREFIX=
SET SQL_CREATE_NICKNAME=
SET SQL_DROP_NICKNAME=
SET SQL_CREATE_VIEW=
SET SQL_DROP_VIEW=
SET ALL_SUPPORTED=

SET VIEW_BODY_SERVER_CPU=
SET VIEW_BODY_SERVER_CPU_AGG=
SET VIEW_BODY_SERVER_MEM=
SET VIEW_BODY_SERVER_MEM_AGG=
SET VIEW_BODY_SERVER_DISK=
SET VIEW_BODY_SERVER_DISK_AGG=
SET VIEW_BODY_SERVER_NET=
SET VIEW_BODY_SERVER_NET_AGG=
SET VIEW_BODY_VM=
SET VIEW_BODY_VM_AGG=
SET VIEW_BODY_VM_MEM=
SET VIEW_BODY_VM_MEM_AGG=
SET VIEW_BODY_VM_NET=
SET VIEW_BODY_VM_NET_AGG=
SET VIEW_BODY_VM_DS=
SET VIEW_BODY_VM_DS_AGG=
SET VIEW_PERC_CPU_H_V=
SET VIEW_PERC_DISK_H_V=
SET VIEW_PERC_MEM_H_V=
SET VIEW_PERC_NW_H_V=
SET PERC_VIEW=

SET TABLE_BODY_SERVER_CPU=
SET TABLE_BODY_SERVER_CPU_AGG=
SET TABLE_BODY_SERVER_MEM=
SET TABLE_BODY_SERVER_MEM_AGG=
SET TABLE_BODY_SERVER_DISK=
SET TABLE_BODY_SERVER_DISK_AGG=
SET TABLE_BODY_SERVER_NET=
SET TABLE_BODY_SERVER_NET_AGG=
SET TABLE_BODY_VM=
SET TABLE_BODY_VM_AGG=
SET TABLE_BODY_VM_MEM=
SET TABLE_BODY_VM_MEM_AGG=
SET TABLE_BODY_VM_NET=
SET TABLE_BODY_VM_NET_AGG=
SET TABLE_BODY_VM_DS=
SET TABLE_BODY_VM_DS_AGG=

SET ARGS_CNT=
SET TMP_CNT=
SET F=
SET I=
SET J=
SET OPT=
SET ARG=
SET FOUND=
SET T=

SET LOCAL_SERVER_NAME=
SET DM_NAME=
SET DM_SCHEMA_NAME=
SET ACTION=

SET AN_ARG=
SET ARG_MACHINE=
SET ARG_MACHINE_COMP=
SET ARG_AGGREGATION=
SET DM_VIEW_NAME_MACHINE=
SET DM_VIEW_MACHINE_COMP=
SET DM_VIEW_NAME=
SET FED_TABLE_NAME=
SET FED_TABLE_VM_CPU=
SET FED_TABLE_NAME_COMP=
SET NICK_NAME_PREFIX=
SET TDW_TABLE_MACHINE=
SET TDW_TABLE_COMP=
SET TDW_TABLE_NAME=

SET DB2_CMD_NICK_NAME=
SET DM_VIEW_BODY=
SET IS_CONNECTED=
SET ARGUMENTS_ALL=

SET MES_NAME=
SET DM_ENTITY_NAME=
SET FLAG=
SET TABLE_BODY=
SET DB2_CMD_CREATE_TABLE=
SET O_FED_TABLE_NAME=
SET DBA_MODE=
ECHO FAILED_COUNT=%FAILED_COUNT%

GOTO :EXIT
:: } END SHUT_DOWN

:strlen <resultVar> <stringVar>
(
SETLOCAL
    set "s=!%~2!#"
    set "len=0"
    for %%P in (4096 2048 1024 512 256 128 64 32 16 8 4 2 1) do (
        if "!s:~%%P,1!" NEQ "" ( 
            set /a "len+=%%P"
            set "s=!s:~%%P!"
        )
    )
)
( 
    endlocal
    set "%~1=%len%"
    exit /b
)

:indexOf <resultVar> <strVar> <find>
SETLOCAL
set str=%~2
call set "part=%%str:%~3=&rem.%%"
set partB=%part%
call :strlen len partB
( ENDLOCAL
set %~1=%len%
EXIT /b
)

:GET_WRAPPER_NAME_FOR_SERVER
 SETLOCAL
	SET DB_NAME=%4
	SET SERVER_NAME=%2
	SET DBA_MODE=%7

IF "!DBA_MODE!" == "DBAMODE" (
ECHO !DB2! CONNECT TO !DB_NAME! >> !TMP_DDL_FILE_NAME!
ECHO !DB2! -x "SELECT WRAPNAME FROM SYSCAT.SERVERS WHERE SERVERNAME='!SERVER_NAME!'" >> !TMP_DDL_FILE_NAME!
) ELSE (
!DB2! CONNECT TO !DB_NAME! 
!DB2! -x "SELECT WRAPNAME FROM SYSCAT.SERVERS WHERE SERVERNAME='!SERVER_NAME!'" > !TMP_F_NAME!
)
	SET STATUS=%ERRORLEVEL%
	FOR /F %%T IN (!TMP_F_NAME!) DO (
        SET WRAPPER_NAME=%%T
        IF ERRORLEVEL 1 GOTO :EOF
    )
	SET Q_CHAR="
	IF "!WRAPPER_NAME!" == "MSSQLODBC3" (
		SET Q_CHAR=
	)
IF "!DBA_MODE!" == "DBAMODE" (	
ECHO !DB2! TERMINATE 2>&1 >> !TMP_DDL_FILE_NAME!
) ELSE (
!DB2! TERMINATE 2>&1
)
ENDLOCAL & SET QC=%Q_CHAR%
EXIT /B

:INIT_TABLE_DEFS
::##############################################################################
:: List of SQL statements forming bodies of the DB2 commands to be run.
::##############################################################################
SET VIEW_BODY_SERVER_CPU=SELECT T.!QC!Server_Hostname!QC! AS HOST_NAME, T.!QC!CPU_Number!QC! AS CPU_NUMBER, T.!QC!CPU_Utilization!QC! AS CPU_UTILIZATION, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_SERVER_CPU_AGG=SELECT T.!QC!Server_Hostname!QC! AS HOST_NAME, T.!QC!CPU_Number!QC! AS CPU_NUMBER, T.!QC!MIN_CPU_Utilization!QC! AS MIN_CPU_UTILIZATION, T.!QC!MAX_CPU_Utilization!QC! AS MAX_CPU_UTILIZATION, T.!QC!SUM_CPU_Utilization!QC! AS SUM_CPU_UTILIZATION, T.!QC!AVG_CPU_Utilization!QC! AS AVG_CPU_UTILIZATION, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_SERVER_MEM=SELECT T.!QC!Server_Hostname!QC! AS HOST_NAME, T.!QC!Physical_Memory!QC! AS PHYSICAL_MEMORY, T.!QC!Memory_Usage!QC! AS MEMORY_USAGE, T.!QC!Memory_Utilization!QC! AS MEMORY_UTILIZATION, T.!QC!Active_Memory!QC! AS ACTIVE_MEMORY, T.!QC!Granted_Memory!QC! AS GRANTED_MEMORY, T.!QC!Swap_Used!QC! AS SWAP_USED, T.!QC!Free_Memory!QC! AS FREE_MEM, T.!QC!Balloon_Used!QC! AS BALLOON_USED, T.!QC!Swap_In_Rate!QC! AS SWAP_IN_RATE, T.!QC!Swap_Out_Rate!QC! AS SWAP_OUT_RATE, T.!QC!Swap_Total_Rate!QC! AS SWAP_TOTAL_RATE, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_SERVER_MEM_AGG=SELECT T.!QC!Server_Hostname!QC! AS HOST_NAME, T.!QC!MIN_Physical_Memory!QC! AS PHYSICAL_MEMORY, T.!QC!MIN_Memory_Usage!QC! AS MIN_MEMORY_USAGE, T.!QC!MAX_Memory_Usage!QC! AS MAX_MEMORY_USAGE, T.!QC!SUM_Memory_Usage!QC! AS SUM_MEMORY_USAGE, T.!QC!AVG_Memory_Usage!QC! AS AVG_MEMORY_USAGE, T.!QC!MIN_Memory_Utilization!QC! AS MIN_MEMORY_UTILIZATION, T.!QC!MAX_Memory_Utilization!QC! AS MAX_MEMORY_UTILIZATION, T.!QC!SUM_Memory_Utilization!QC! AS SUM_MEMORY_UTILIZATION, T.!QC!AVG_Memory_Utilization!QC! AS AVG_MEMORY_UTILIZATION, T.!QC!MIN_Active_Memory!QC! AS MIN_ACTIVE_MEMORY, T.!QC!MAX_Active_Memory!QC! AS MAX_ACTIVE_MEMORY, T.!QC!SUM_Active_Memory!QC! AS SUM_ACTIVE_MEMORY, T.!QC!AVG_Active_Memory!QC! AS AVG_ACTIVE_MEMORY, T.!QC!MIN_Granted_Memory!QC! AS MIN_GRANTED_MEMORY, T.!QC!MAX_Granted_Memory!QC! AS MAX_GRANTED_MEMORY, T.!QC!SUM_Granted_Memory!QC! AS SUM_GRANTED_MEMORY, T.!QC!AVG_Granted_Memory!QC! AS AVG_GRANTED_MEMORY, T.!QC!MIN_Swap_Used!QC! AS MIN_SWAP_USED, T.!QC!MAX_Swap_Used!QC! AS MAX_SWAP_USED, T.!QC!SUM_Swap_Used!QC! AS SUM_SWAP_USED, T.!QC!AVG_Swap_Used!QC! AS AVG_SWAP_USED, T.!QC!MIN_Free_Memory!QC! AS MIN_FREE_MEM, T.!QC!MAX_Free_Memory!QC! AS MAX_FREE_MEM, T.!QC!SUM_Free_Memory!QC! AS SUM_FREE_MEM, T.!QC!AVG_Free_Memory!QC! AS AVG_FREE_MEM, T.!QC!MIN_Balloon_Used!QC! AS MIN_BALLOON_USED, T.!QC!MAX_Balloon_Used!QC! AS MAX_BALLOON_USED, T.!QC!SUM_Balloon_Used!QC! AS SUM_BALLOON_USED, T.!QC!AVG_Balloon_Used!QC! AS AVG_BALLOON_USED, T.!QC!MIN_Swap_In_Rate!QC! AS MIN_SWAP_IN_RATE, T.!QC!MAX_Swap_In_Rate!QC! AS MAX_SWAP_IN_RATE, T.!QC!SUM_Swap_In_Rate!QC! AS SUM_SWAP_IN_RATE, T.!QC!AVG_Swap_In_Rate!QC! AS AVG_SWAP_IN_RATE, T.!QC!MIN_Swap_Out_Rate!QC! AS MIN_SWAP_OUT_RATE, T.!QC!MAX_Swap_Out_Rate!QC! AS MAX_SWAP_OUT_RATE, T.!QC!SUM_Swap_Out_Rate!QC! AS SUM_SWAP_OUT_RATE, T.!QC!AVG_Swap_Out_Rate!QC! AS AVG_SWAP_OUT_RATE, T.!QC!MIN_Swap_Total_Rate!QC! AS MIN_SWAP_TOTAL_RATE, T.!QC!MAX_Swap_Total_Rate!QC! AS MAX_SWAP_TOTAL_RATE, T.!QC!SUM_Swap_Total_Rate!QC! AS SUM_SWAP_TOTAL_RATE, T.!QC!AVG_Swap_Total_Rate!QC! AS AVG_SWAP_TOTAL_RATE, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_SERVER_DISK=SELECT T.!QC!Server_Hostname!QC! AS HOST_NAME, T.!QC!Disk_Name!QC! AS DISK_NAME, T.!QC!Backing_Datastore!QC! AS DATA_STORE_NAME, T.!QC!Read!QC! AS READ_KBPS, T.!QC!Write!QC! AS WRITE_KBPS, T.!QC!Number_Read!QC! AS READ_COUNT, T.!QC!Number_Write!QC! AS WRITE_COUNT, T.!QC!BUS_Resets!QC! AS BUS_RESET, T.!QC!Commands!QC! AS COMMANDS_COUNT, T.!QC!Commands_Aborted!QC! AS COMMANDS_ABORTED_COUNT, T.!QC!Device_Read_Latency!QC! AS DEVICE_READ_LATENCY, T.!QC!Device_Write_Latency!QC! AS DEVICE_WRITE_LATENCY, T.!QC!Device_Total_Latency!QC! AS DEVICE_TOTAL_LATENCY, T.!QC!Device_Latency!QC! AS DEVICE_LATENCY, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_SERVER_DISK_AGG=SELECT T.!QC!Server_Hostname!QC! AS HOST_NAME, T.!QC!Disk_Name!QC! AS DISK_NAME, T.!QC!LAT_Backing_Datastore!QC! AS DATA_STORE_NAME, T.!QC!MIN_Read!QC! AS MIN_READ_KBPS, T.!QC!MAX_Read!QC! AS MAX_READ_KBPS, T.!QC!SUM_Read!QC! AS	SUM_READ_KBPS, T.!QC!AVG_Read!QC! AS	AVG_READ_KBPS, T.!QC!MIN_Write!QC! AS MIN_WRITE_KBPS, T.!QC!MAX_Write!QC! AS MAX_WRITE_KBPS, T.!QC!SUM_Write!QC! AS SUM_WRITE_KBPS, T.!QC!AVG_Write!QC! AS AVG_WRITE_KBPS, T.!QC!SUM_Number_Read!QC! AS SUM_READ_COUNT, T.!QC!AVG_Number_Read!QC! AS AVG_READ_COUNT, T.!QC!MIN_Number_Write!QC! AS MIN_WRITE_COUNT, T.!QC!MAX_Number_Write!QC! AS MAX_WRITE_COUNT, T.!QC!SUM_Number_Write!QC! AS SUM_WRITE_COUNT, T.!QC!AVG_Number_Write!QC! AS AVG_WRITE_COUNT, T.!QC!MIN_BUS_Resets!QC! AS MIN_BUS_RESET, T.!QC!MAX_BUS_Resets!QC! AS MAX_BUS_RESET, T.!QC!SUM_BUS_Resets!QC! AS SUM_BUS_RESET, T.!QC!AVG_BUS_Resets!QC! AS AVG_BUS_RESET, T.!QC!MIN_Commands!QC! AS MIN_COMMANDS_COUNT, T.!QC!MAX_Commands!QC! AS	MAX_COMMANDS_COUNT, T.!QC!SUM_Commands!QC! AS SUM_COMMANDS_COUNT, T.!QC!AVG_Commands!QC! AS AVG_COMMANDS_COUNT, T.!QC!MIN_Commands_Aborted!QC! AS MIN_COMMANDS_ABORTED_COUNT, T.!QC!MAX_Commands_Aborted!QC! AS MAX_COMMANDS_ABORTED_COUNT, T.!QC!SUM_Commands_Aborted!QC! AS SUM_COMMANDS_ABORTED_COUNT, T.!QC!AVG_Commands_Aborted!QC! AS AVG_COMMANDS_ABORTED_COUNT, T.!QC!MIN_Device_Latency!QC! AS MIN_DEVICE_READ_LATENCY, T.!QC!MAX_Device_Read_Latency!QC! AS MAX_DEVICE_READ_LATENCY, T.!QC!SUM_Device_Read_Latency!QC! AS SUM_DEVICE_READ_LATENCY, T.!QC!AVG_Device_Read_Latency!QC! AS AVG_DEVICE_READ_LATENCY, T.!QC!MIN_Device_Write_Latency!QC! AS MIN_DEVICE_WRITE_LATENCY, T.!QC!MAX_Device_Write_Latency!QC! AS MAX_DEVICE_WRITE_LATENCY, T.!QC!SUM_Device_Write_Latency!QC! AS SUM_DEVICE_WRITE_LATENCY, T.!QC!AVG_Device_Write_Latency!QC! AS AVG_DEVICE_WRITE_LATENCY, T.!QC!MIN_Device_Total_Latency!QC! AS MIN_DEVICE_TOTAL_LATENCY, T.!QC!MAX_Device_Total_Latency!QC! AS MAX_DEVICE_TOTAL_LATENCY, T.!QC!SUM_Device_Total_Latency!QC! AS SUM_DEVICE_TOTAL_LATENCY, T.!QC!AVG_Device_Total_Latency!QC! AS AVG_DEVICE_TOTAL_LATENCY, T.!QC!MIN_Device_Latency!QC! AS MIN_DEVICE_LATENCY, T.!QC!MAX_Device_Latency!QC! AS MAX_DEVICE_LATENCY, T.!QC!SUM_Device_Latency!QC! AS SUM_DEVICE_LATENCY, T.!QC!AVG_Device_Latency!QC! AS AVG_DEVICE_LATENCY, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_SERVER_NET=SELECT T.!QC!Server_Hostname!QC! AS HOST_NAME, T.!QC!NIC_Name!QC! AS NIC_NAME, T.!QC!Usage!QC! AS USAGE, T.!QC!Transmitted!QC!	AS TRANSMITTED_KBPS, T.!QC!Received!QC! AS RECEIVED_KBPS, T.!QC!Pkts_Transmitted!QC! AS PKTS_TRANSMITTED, T.!QC!Pkts_Received!QC! AS PKTS_RECEIVED, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_SERVER_NET_AGG=SELECT T.!QC!Server_Hostname!QC! AS HOST_NAME, T.!QC!NIC_Name!QC! AS NIC_NAME, T.!QC!MIN_Usage!QC! AS MIN_USAGE, T.!QC!MAX_Usage!QC! AS MAX_USAGE, T.!QC!SUM_Usage!QC! AS SUM_USAGE, T.!QC!AVG_Usage!QC! AS AVG_USAGE, T.!QC!MIN_Transmitted!QC! AS MIN_TRANSMITTED_KBPS, T.!QC!MAX_Transmitted!QC! AS MAX_TRANSMITTED_KBPS, T.!QC!SUM_Transmitted!QC! AS SUM_TRANSMITTED_KBPS, T.!QC!AVG_Transmitted!QC! AS AVG_TRANSMITTED_KBPS, T.!QC!MIN_Received!QC! AS MIN_RECEIVED_KBPS, T.!QC!MAX_Received!QC! AS MAX_RECEIVED_KBPS, T.!QC!SUM_Received!QC! AS SUM_RECEIVED_KBPS, T.!QC!AVG_Received!QC! AS AVG_RECEIVED_KBPS, T.!QC!MIN_Pkts_Received!QC! AS MIN_PKTS_TRANSMITTED, T.!QC!MAX_Pkts_Received!QC! AS MAX_PKTS_TRANSMITTED, T.!QC!SUM_Pkts_Received!QC! AS SUM_PKTS_TRANSMITTED, T.!QC!AVG_Pkts_Received!QC! AS AVG_PKTS_TRANSMITTED, T.!QC!MIN_Pkts_Transmitted!QC! AS MIN_PKTS_RECEIVED, T.!QC!MAX_Pkts_Transmitted!QC! AS MAX_PKTS_RECEIVED, T.!QC!SUM_Pkts_Transmitted!QC! AS SUM_PKTS_RECEIVED, T.!QC!AVG_Pkts_Transmitted!QC! AS AVG_PKTS_RECEIVED, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_VM=SELECT T.!QC!VM_Name!QC! AS HOST_NAME, T.!QC!VM_Server_Name!QC! AS VM_SERVER_NAME, T.!QC!VM_Name!QC! AS VM_NAME, T.!QC!Datacenter!QC! AS DATA_CENTER_NAME, T.!QC!Cluster!QC! AS VM_POOL_NAME, T.!QC!Used_CPU_MHz!QC! AS CPU_UTILIZATION, T.!QC!Used_CPU_MHz!QC! AS USED_CPU_MHZ, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_VM_AGG=SELECT T.!QC!VM_Name!QC! AS HOST_NAME, T.!QC!VM_Server_Name!QC! AS VM_SERVER_NAME, T.!QC!VM_Name!QC! AS VM_NAME, T.!QC!Datacenter!QC! AS DATA_CENTER_NAME, T.!QC!LAT_Cluster!QC! AS VM_POOL_NAME, T.!QC!MIN_Used_CPU_MHz!QC! AS MIN_USED_CPU_MHZ, T.!QC!MAX_Used_CPU_MHz!QC! AS MAX_USED_CPU_MHZ, T.!QC!SUM_Used_CPU_MHz!QC! AS SUM_USED_CPU_MHZ, T.!QC!AVG_Used_CPU_MHz!QC! AS AVG_USED_CPU_MHZ, T.!QC!MIN_Used_CPU_MHz!QC! AS MIN_CPU_UTILIZATION, T.!QC!MAX_Used_CPU_MHz!QC! AS MAX_CPU_UTILIZATION, T.!QC!SUM_Used_CPU_MHz!QC! AS SUM_CPU_UTILIZATION, T.!QC!AVG_Used_CPU_MHz!QC! AS AVG_CPU_UTILIZATION, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_VM_MEM=SELECT T.!QC!VM_Name!QC! AS HOST_NAME, T.!QC!VM_Server_Name!QC! AS VM_SERVER_NAME, T.!QC!VM_Name!QC! AS VM_NAME, T.!QC!Host_Usage!QC! AS HOST_USAGE, T.!QC!Guest_Usage!QC! AS GUEST_USAGE,T.!QC!Host_Util!QC! AS HOST_UTILIZATION, T.!QC!Host_Usage!QC! AS GUEST_UTILIZATION, T.!QC!Host_Free!QC! AS HOST_FREE, T.!QC!Guest_Free!QC! AS GUEST_FREE, T.!QC!Balloon_Usage!QC! AS BALLOON_USAGE, T.!QC!Swap_To_File!QC! AS SWAP_TO_FILE, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_VM_MEM_AGG=SELECT T.!QC!VM_Name!QC! AS HOST_NAME, T.!QC!VM_Server_Name!QC! AS VM_SERVER_NAME, T.!QC!VM_Name!QC! AS VM_NAME, T.!QC!MIN_Host_Usage!QC! AS MIN_HOST_USAGE, T.!QC!MAX_Host_Usage!QC! AS MAX_HOST_USAGE, T.!QC!SUM_Host_Usage!QC! AS SUM_HOST_USAGE, T.!QC!AVG_Host_Usage!QC! AS AVG_HOST_USAGE, T.!QC!MIN_Guest_Usage!QC! AS MIN_GUEST_USAGE, T.!QC!MAX_Guest_Usage!QC! AS MAX_GUEST_USAGE, T.!QC!SUM_Guest_Usage!QC! AS SUM_GUEST_USAGE, T.!QC!AVG_Guest_Usage!QC! AS AVG_GUEST_USAGE, T.!QC!MIN_Host_Util!QC! AS MIN_HOST_UTILIZATION, T.!QC!MAX_Host_Util!QC! AS MAX_HOST_UTILIZATION, T.!QC!SUM_Host_Util!QC! AS SUM_HOST_UTILIZATION, T.!QC!AVG_Host_Util!QC! AS AVG_HOST_UTILIZATION, T.!QC!MIN_Host_Usage!QC! AS MIN_GUEST_UTILIZATION, T.!QC!MAX_Host_Usage!QC! AS MAX_GUEST_UTILIZATION, T.!QC!SUM_Host_Usage!QC! AS SUM_GUEST_UTILIZATION, T.!QC!AVG_Host_Usage!QC! AS AVG_GUEST_UTILIZATION, T.!QC!MIN_Host_Free!QC! AS MIN_HOST_FREE, T.!QC!MAX_Host_Free!QC! AS MAX_HOST_FREE, T.!QC!SUM_Host_Free!QC! AS SUM_HOST_FREE, T.!QC!AVG_Host_Free!QC! AS AVG_HOST_FREE, T.!QC!MIN_Guest_Free!QC! AS MIN_GUEST_FREE, T.!QC!MAX_Guest_Free!QC! AS MAX_GUEST_FREE, T.!QC!SUM_Guest_Free!QC! AS SUM_GUEST_FREE, T.!QC!AVG_Guest_Free!QC! AS AVG_GUEST_FREE, T.!QC!MIN_Balloon_Usage!QC! AS MIN_BALLOON_USAGE, T.!QC!MAX_Balloon_Usage!QC! AS MAX_BALLOON_USAGE, T.!QC!SUM_Balloon_Usage!QC! AS SUM_BALLOON_USAGE, T.!QC!AVG_Balloon_Usage!QC! AS AVG_BALLOON_USAGE, T.!QC!MIN_Swap_To_File!QC! AS MIN_SWAP_TO_FILE, T.!QC!MAX_Swap_To_File!QC! AS MAX_SWAP_TO_FILE, T.!QC!SUM_Swap_To_File!QC! AS SUM_SWAP_TO_FILE, T.!QC!AVG_Swap_To_File!QC! AS AVG_SWAP_TO_FILE, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_VM_NET=SELECT T.!QC!VM_Name!QC! AS HOST_NAME, T.!QC!VM_Server_Name!QC! AS VM_SERVER_NAME, T.!QC!VM_Name!QC! AS VM_NAME, T.!QC!Transmitted!QC! AS TRANSMITTED_KBPS, T.!QC!Received!QC! AS RECEIVED_KBPS, T.!QC!Pkts_Trans!QC! AS PKTS_TRANSMITTED, T.!QC!Pkts_Recd!QC! AS PKTS_RECEIVED, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_VM_NET_AGG=SELECT T.!QC!VM_Name!QC! AS HOST_NAME, T.!QC!LAT_Description!QC! AS NIC_NAME, T.!QC!VM_Server_Name!QC! AS VM_SERVER_NAME, T.!QC!VM_Name!QC! AS VM_NAME, T.!QC!MIN_Transmitted!QC! AS MIN_TRANSMITTED_KBPS, T.!QC!MAX_Transmitted!QC! AS MAX_TRANSMITTED_KBPS, T.!QC!SUM_Transmitted!QC! AS SUM_TRANSMITTED_KBPS, T.!QC!AVG_Transmitted!QC! AS AVG_TRANSMITTED_KBPS, T.!QC!MIN_Received!QC! AS	MIN_RECEIVED_KBPS, T.!QC!MAX_Received!QC! AS MAX_RECEIVED_KBPS, T.!QC!SUM_Received!QC! AS SUM_RECEIVED_KBPS, T.!QC!AVG_Received!QC! AS AVG_RECEIVED_KBPS, T.!QC!MIN_Pkts_Trans!QC! AS MIN_PKTS_TRANSMITTED, T.!QC!MAX_Pkts_Trans!QC! AS MAX_PKTS_TRANSMITTED, T.!QC!SUM_Pkts_Trans!QC! AS SUM_PKTS_TRANSMITTED, T.!QC!AVG_Pkts_Trans!QC! AS AVG_PKTS_TRANSMITTED, T.!QC!MIN_Pkts_Recd!QC! AS MIN_PKTS_RECEIVED, T.!QC!MAX_Pkts_Recd!QC! AS MAX_PKTS_RECEIVED, T.!QC!SUM_Pkts_Recd!QC! AS SUM_PKTS_RECEIVED, T.!QC!AVG_Pkts_Recd!QC! AS AVG_PKTS_RECEIVED, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_VM_DS=SELECT T.!QC!Name!QC! AS DATA_STORE_NAME, T.!QC!Virtual_Machine!QC! AS HOST_NAME, T.!QC!Virtual_Machine!QC! AS VM_NAME, T.!QC!DataCenter!QC! AS DATA_CENTER_NAME, T.!QC!Total_Read_KBps!QC! AS TOTAL_READ, T.!QC!Total_Write_KBps!QC! AS TOTAL_WRITE, T.!QC!Total_IO_KBps!QC! AS TOTAL_IO, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_VM_DS_AGG=SELECT T.!QC!Name!QC! AS DATA_STORE_NAME, T.!QC!LAT_Virtual_Machine!QC! AS HOST_NAME, T.!QC!LAT_Virtual_Machine!QC! AS VM_NAME, T.!QC!DataCenter!QC! AS DATA_CENTER_NAME, T.!QC!MIN_Total_Read_KBps!QC! AS MIN_TOTAL_READ, T.!QC!MAX_Total_Read_KBps!QC! AS MAX_TOTAL_READ, T.!QC!SUM_Total_Read_KBps!QC! AS SUM_TOTAL_READ, T.!QC!AVG_Total_Read_KBps!QC! AS AVG_TOTAL_READ, T.!QC!MIN_Total_Write_KBps!QC! AS MIN_TOTAL_WRITE, T.!QC!MAX_Total_Write_KBps!QC! AS MAX_TOTAL_WRITE, T.!QC!SUM_Total_Write_KBps!QC! AS SUM_TOTAL_WRITE, T.!QC!AVG_Total_Write_KBps!QC! AS AVG_TOTAL_WRITE, T.!QC!MIN_Total_IO_KBps!QC! AS MIN_TOTAL_IO, T.!QC!MAX_Total_IO_KBps!QC! AS MAX_TOTAL_IO, T.!QC!SUM_Total_IO_KBps!QC! AS SUM_TOTAL_IO, T.!QC!AVG_Total_IO_KBps!QC! AS AVG_TOTAL_IO, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

EXIT /B

:EXIT
REM ECHO EXITING THE PROGRAMME STATUS IS %STATUS% >> !TMP_DDL_FILE_NAME!
EXIT /B %STATUS%