#--------------------------------------------------------------
# creates an classloader 
#
# parameters:
# appID        - the application ID
# libraries    - the libraries for the classloader
# mode         - the classloader mode (one of 'PARENT_FIRST' or 'PARENT_LAST')
# 
#--------------------------------------------------------------
def createClassLoader(appId, libraries, mode):
   classLoaderId = AdminConfig.create('Classloader', appId, [['libraries', libraries ], ['mode', mode]])
   return classLoaderId

#--------------------------------------------------------------
# return the ID for a classloader
#
# parameters:
# id  - the ID of an application or webmodule
# 
#--------------------------------------------------------------             
def getClassLoaders(id):
   classLoaderIds = AdminConfig.list('Classloader',id).split(lineSeparator)
   return classLoaderIds      

#-----------------------------------------------------------------
# Main
#-----------------------------------------------------------------

print "Adding sharedLib to aucConsole WebModule."

ModuleName  = sys.argv[0]
TADfDCSharedLibName  = sys.argv[1]
deployed = AdminConfig.getid('/Deployment:isc/')
print "ISC deployment: " + deployed
appDeployed = AdminConfig.showAttribute( deployed, 'deployedObject')
print "Application attributes for isc: " + appDeployed
webModules = AdminConfig.list('WebModuleDeployment', appDeployed ).split(lineSeparator)
for webModule in webModules:
    print "WebModule: " + webModule
    uri = AdminConfig.showAttribute(webModule, 'uri')
    print "Attributes for webModule " + webModule + ": "
    if ( uri == ModuleName ) :
        AdminConfig.modify( webModule, [['classloaderMode', 'PARENT_FIRST']] )
        classLoaderId  = None
        classLoaderIds = getClassLoaders(webModule)

        if ( len(classLoaderIds) == 0) :
            classLoaderId = createClassLoader(webModule, [], 'PARENT_FIRST')
        else:
            classLoaderId = classLoaderIds[0]
            if ( len(classLoaderId) == 0 ):
                classLoaderId = createClassLoader(webModule, [], 'PARENT_FIRST')

        AdminConfig.modify(classLoaderId, [['mode', 'PARENT_FIRST']] )        
        AdminConfig.save()
        print "ClassloaderID : " + classLoaderId
        libraryRef = AdminConfig.create('LibraryRef', classLoaderId, [['libraryName', TADfDCSharedLibName ],  ['sharedClassloader', 'true']])
        print "LibraryRef: " + libraryRef
        AdminConfig.save()
        attrs = AdminConfig.showall(webModule)
        print "WebModule " + ModuleName + "attribute update: " + attrs

print "Completed sharedLib addition: " + TADfDCSharedLibName
AdminConfig.save()

