#!/bin/sh
# Licensed Materials - Property of IBM
# 5648-F10 (C) Copyright International Business Machines Corp. 2005, 2010
# All Rights Reserved
# US Government Users Restricted Rights - Use, duplication or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
SCRIPTDIR=$(dirname $0)
cd ..
EXECDIR=`pwd`
current_os=`uname`
current_arch=`uname -m`
if [ "$current_os" == "AIX" ]
then
  DIRNAME=im.aix
else
  if [ "$current_arch" == "s390x" ]
  then
    DIRNAME=im.linux.s390
  else
    DIRNAME=im.linux.x86
  fi
fi
cd $DIRNAME
if [ ${1:-root} = 'user' ] ; then    
	echo "Installing IBM Tivoli Monitoring Virtualization Dashboard components in user mode..."
	./userinstc -acceptLicense -input "$EXECDIR/silentInstall/install_VMware_CP_sample.xml" -showProgress
else	
	echo "Installing IBM Tivoli Monitoring Virtualization Dashboard components..."
	./installc -acceptLicense -input "$EXECDIR/silentInstall/install_VMware_CP_sample.xml" -showProgress
fi
cd $SCRIPTDIR
exit $?