--<ScriptOptions statementTerminator="@"/>

CREATE TABLE CFG_PHYSICAL_SERVER ( 		PHYSICAL_SERVER_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 2 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		GUID VARCHAR(256), 		HOST_NAME VARCHAR(256), 		IP_ADDRESS VARCHAR(256), 		FQDN VARCHAR(256), 		SERVER_POOL_NAME VARCHAR(256), 		DATA_CENTER_NAME VARCHAR(256), 		NUM_CPUS INTEGER, 		CPU_SPEED BIGINT, 		CPU_CORES_INSTALLED INTEGER, 		CPU_CORES_ENABLED INTEGER, 		MEMORY_LIMIT BIGINT, 		MEMORY_INSTALLED BIGINT, 		MANUFACTURER VARCHAR(256), 		MODEL VARCHAR(256), 		SERIAL_NUMBER VARCHAR(256), 		SIGNATURE VARCHAR(256), 		ARCHITECTURE VARCHAR(128), 		SYSTEM_SHORT_NAME VARCHAR(64), 		MANAGED_SYSTEM_NAME VARCHAR(256), 		MAX_POWER INTEGER, 		TIMEZONE VARCHAR(256), 		HYPERVISOR_TYPE VARCHAR(64), 		HYPERVISOR_VERSION VARCHAR(32), 		HYPER_THREADING_CAPABLE CHAR(1), 		HYPER_THREADING_ENABLED CHAR(1), 		IS_VIRTUALIZED CHAR(1), 		BIOS_DATE DATE, 		DATA_SOURCE VARCHAR(64), 		LAST_EDIT_TIMESTAMP TIMESTAMP, 		OPERATING_SYSTEM_VERSION VARCHAR(32), 		OPERATING_SYSTEM_NAME VARCHAR(64), 		ENCLOSURE_PK BIGINT, 		MATCHED_SERVER_CATALOG_PK BIGINT, 		NUMBER_OF_NICS INTEGER, 		DISPLAY_NAME VARCHAR(256), 		NUMBER_OF_VMS INTEGER, UPDATE_FLAG CHAR 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_VIRTUAL_MACHINE ( 		VIRTUAL_MACHINE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 2 INCREMENT BY 2 MINVALUE 2 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VMID VARCHAR(256) NOT NULL, VM_NAME VARCHAR(256), 		HOST_NAME VARCHAR(256), 		IP_ADDRESS VARCHAR(256), 		FQDN VARCHAR(256), 		CPU_MIN BIGINT, 		CPU_MAX BIGINT, 		CPU_DESIRED BIGINT, 		MEMORY_MIN BIGINT, 		MEMORY_MAX BIGINT, 		MEMORY_DESIRED BIGINT, 		OPERATING_SYSTEM_NAME VARCHAR(256), 		OPERATING_SYSTEM_VERSION VARCHAR(256), 		MIDDLEWARE_NAME VARCHAR(256), 		MIDDLEWARE_VERSION VARCHAR(256), 		SYSTEM_SHORT_NAME VARCHAR(64), 		MANAGED_SYSTEM_NAME VARCHAR(256), 		DATA_SOURCE VARCHAR(64), 		LAST_EDIT_TIMESTAMP TIMESTAMP, 		NUMBER_OF_NICS INTEGER, 		PHYSICAL_SERVER_PK BIGINT NOT NULL, 		DISPLAY_NAME VARCHAR(256), 		VM_POOL_NAME VARCHAR(256), 		NUM_CPUS INTEGER, 		MEMORY_SIZE BIGINT, 		DATA_CENTER_NAME VARCHAR(256) 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_NETWORK ( 		NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		NAME VARCHAR(256), 		DESCRIPTION VARCHAR(256), 		DOMAIN VARCHAR(256), 		SECURITY_ZONE VARCHAR(64), 		SUBNET_MASK VARCHAR(256), 		GATEWAY VARCHAR(256), 		SEGMENT VARCHAR(64), 		NETWORK_ID VARCHAR(64), 		SUBNET_ID VARCHAR(64), 		VLANS INTEGER 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_ENCLOSURE ( 		ENCLOSURE_PK BIGINT NOT NULL, 		NAME VARCHAR(256) 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_IP_INTERFACE ( 		IP_INTERFACE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		GUID VARCHAR(256), 		HOST_NAME VARCHAR(256), 		IP_ADDRESS VARCHAR(256), 		INTERFACE VARCHAR(256), 		IS_PRIMARY CHAR(1), 		NIC_PK BIGINT, 		NETWORK_PK BIGINT 	) 	DATA CAPTURE NONE@

CREATE TABLE ANL_RESOURCE_DEMAND ( 		RESOURCE_DEMAND_KEY BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20),CPU_DEMAND_PERCENTAGE INTEGER, 	CPU_DEMAND_BENCHMARK FLOAT, 		MEMORY_DEMAND_PERCENTAGE INTEGER, 		MEMORY_DEMAND_MB FLOAT, 		NETWORK_DEMAND_MBPS FLOAT, 		DISK_DEMAND_MBPS FLOAT, 		SERVER_PK BIGINT, DEVICE_TYPE VARCHAR(32), CPU_UTIL_TYPE VARCHAR(32), MEM_UTIL_TYPE VARCHAR(32), DISK_UTIL_TYPE VARCHAR(32), NETWORK_UTIL_TYPE VARCHAR(32), CPU_VAR VARCHAR(32), MEM_VAR VARCHAR(32), DISK_VAR VARCHAR(32), NETWORK_VAR VARCHAR(32)) 	DATA CAPTURE NONE@

CREATE TABLE KBS_FP_CUSTOMER_SPECIFIC ( 		FP_CUSTOMER_SPECIFIC_PK BIGINT NOT NULL, 		COOLING_COST_SOURCE REAL, 		COOLING_COST_TARGET REAL, 		POWER_COST_SOURCE REAL, 		POWER_COST_TARGET REAL, 		RACK_HEIGHT_U REAL, 		SQUAREFEET_PER_RACK REAL, 		FLOORSPACE_COST_SOURCE REAL, 		FLOORSPACE_COST_TARGET REAL, 		RACK_OCCUPANCY_SOURCE INTEGER, 		RACK_OCCUPANCY_TARGET INTEGER 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_FP_HYPERVISOR ( 		FP_HYPERVISOR_PK BIGINT NOT NULL, 		HYPERVISOR_TYPE VARCHAR(50), 		HYPERVISOR_VERSION VARCHAR(50), 		HYPERVISOR_COST_PER_PROCESSOR BIGINT, 		HYPERVISOR_COST_PER_PVU BIGINT, 		ANNUAL_MAINTENANCE BIGINT 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_FP_PVU ( 		FP_PVU_PK BIGINT NOT NULL, 		VENDOR VARCHAR(20), 		SERVER_DESCRIPTION VARCHAR(50), 		MODEL VARCHAR(50), 		FAMILY VARCHAR(20), 		PROCESSOR VARCHAR(50), 		PROCESSOR_SPEED_MHZ INTEGER, 		PROCESSOR_CHIPS INTEGER, 		PROCESSOR_CORES INTEGER, 		PVUS_PER_CORE INTEGER, 		SERVER_COST INTEGER, 		ANNUAL_MAINTENANCE_COST INTEGER, 		MEMORY_STANDARD INTEGER, 		MEM_PRICE_PER_GB INTEGER, 		LIFE_CYCLE INTEGER, 		NOTES VARCHAR(50) 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_IDEAS_RPE_MODEL ( 		IDEAS_RPE_MODEL_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		TYPE_FEATURE VARCHAR(75), 		IDEAS_MODEL VARCHAR(50), 		DESCRIPTION VARCHAR(75) 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_SERVER_MODEL_CATALOG ( 		SERVER_MODEL_CATALOG_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1000000 INCREMENT BY 1 MINVALUE 1000000 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), MODEL_DESCRIPTION VARCHAR(50), 		VENDOR VARCHAR(20), 		MODEL VARCHAR(128), 		PROCESSOR VARCHAR(50), 		PROCESSOR_SPEED_MHZ INTEGER, 		PROCESSOR_CHIPS INTEGER, 		PROCESSOR_CORES INTEGER 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_VIRTUALIZATION_OVERHEAD ( 		VIRTUALIZATION_OVERHEAD_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HYPERVISOR_TYPE VARCHAR(64), 		HYPERVISOR_VERSION VARCHAR(64), 		CPU_CORES_RANGE_LOWER INTEGER, 		CPU_CORES_RANGE_UPPER INTEGER, 		PERCENTAGE_CPU_OVERHEAD INTEGER, 		PERCENTAGE_MEMORY_OVERHEAD INTEGER, 		PERCENTAGE_NETWORK_OVERHEAD INTEGER, 		PERCENTAGE_INTERNAL_DISK_OVERHEAD INTEGER, 		PERCENTAGE_DISK_IO_OVERHEAD INTEGER, 		APPLICATION_TYPE VARCHAR(30) 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_APP_COMPATIBILITY (APP_COMPATIBILITY_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 1000000 NO CYCLE CACHE 20), SOFTWARE_NAME VARCHAR(128), SOFTWARE_VERSION VARCHAR(50), OS_FULL_NAME VARCHAR(128), ARCHITECTURE VARCHAR(10), COMPATIBILITY VARCHAR(10)) @

CREATE TABLE KBS_DC_PROFILE_CAPACITY_UTILIZATION ( 		DC_PROF_CAP_UTIL_PK INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20), 		CAP_TOTAL_SPACE BIGINT, 		CAP_USED_SPACE INTEGER, 		CAP_TOTAL_COOLING REAL, 		CAP_USED_COOLING INTEGER, 		CAP_TOTAL_FLOOR_SPACE BIGINT, 		CAP_USED_FLOOR_SPACE INTEGER, 		CAP_TOTAL_ENERGY BIGINT, 		CAP_USED_ENERGY INTEGER, 		CAP_AVAILABLE_IT_ENERGY BIGINT, 		CAP_USED_IT_ENERGY INTEGER, 		CAP_TOTAL_RACK_SPACE BIGINT, 		CAP_USED_RACK_SPACE INTEGER, 		COUNT_TOTAL_UNITS_RACKS INTEGER, 		COUNT_USED_UNITS_RACKS INTEGER, 		COUNT_SERVERS INTEGER, 		COUNT_STORAGE_DEVICES INTEGER, 		COUNT_EQUIPMENT_TOTAL INTEGER, 		COUNT_STAFF BIGINT, 		DC_PK BIGINT 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_DC_PROFILE_COST ( 		DC_PROF_COST_PK INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20), 		COST_PER_KWH REAL, 		COST_SECURITY REAL, 		COST_IT_INFRASTRUCTURE REAL, 		COST_SPACE REAL, 		COST_FACILITY_LEASE REAL, 		COST_FACILITY_MAINTENANCE REAL, 		COST_FACILITY_ENERGY REAL, 		COST_FACILITY_UTILITIES REAL, 		COST_HARDWARE_LEASE REAL, 		COST_HARDWARE_PURCHASE REAL, 		COST_HARDWARE_MAINTENANCE REAL, 		COST_SOFTWARE_FEES REAL, 		COST_SOFTWARE_LICENSES REAL, 		COST_SOFTWARE_MAINTENANCE REAL, 		COST_SOFTWARE_PURCHASE REAL, 		COST_NETWORK_PURCHASE REAL, 		COST_NETWORK_MAINTENANCE REAL, 		COST_NETWORK_SERVICE REAL, 		COST_SERVICES_EXPENSES REAL, 		COST_SERVICES_OVERHEADS REAL, 		EXPENSE_ANNUAL_NETWORK REAL, 		EXPENSE_ANNUAL_POWER REAL, 		EXPENSE_ANNUAL_STAFF REAL, 		COST_LABOUR REAL, 		COST_OTHER REAL, 		DC_PK BIGINT 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_DC_PROFILE_STORAGE ( 		DC_PROF_STORAGE_PK INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20), 		CAP_TOTAL_STORAGE BIGINT, 		CAP_TOTAL_STORAGE_ACROSS_TIERS BIGINT, 		CAP_TOTAL_STORAGE_TIERING REAL, 		CAP_STORAGE_HOST_FS BIGINT, 		COUNT_DEVICE_NAS INTEGER, 		COUNT_DEVICE_SAN INTEGER, 		COUNT_DEVICE_DAS INTEGER, 		COUNT_FABRIC_PORTS BIGINT, 		COUNT_FTE_STAFF INTEGER, 		UTIL_CURRENT_FABRIC_PORT REAL, 		UTIL_TARGET_FABRIC_PORT REAL, 		UTIL_CURRENT_OVERALL_ACROSS_ARRAY_TIERS REAL, 		UTIL_CURRENT_STORAGE_HOST_FS REAL, 		UTIL_TARGET_STORAGE_HOST_FS REAL, 		RATE_GROWTH_FABRIC REAL, 		RATE_GROWTH_STORAGE REAL, 		RATE_GROWTH_STORAGE_EXPECTED_ANNUAL REAL, 		RATE_UTIL_STORAGE REAL, 		RATE_GROWTH_STORAGE_HOST_FS REAL, 		PROCESS_ILM_IN_USE CHAR(1), 		PROCESS_SLAS_DEFINED CHAR(1), 		PROCESS_CHARGEBACKS_IN_PLACE CHAR(1), 		DC_PK BIGINT 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_DC_SUMMARY ( 		DC_PK INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20), 		NAME VARCHAR(20) NOT NULL, 		ADDRESS VARCHAR(100), 		DESCRIPTION VARCHAR(50), 		CONTACT_INFO VARCHAR(200), 		TYPE VARCHAR(15), 		DATE_START_OF_OPERATION DATE, 		TIER VARCHAR(15) 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_IDEAS_OTHER ( 		IDEAS_OTHER_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VENDOR VARCHAR(50), 		SERVER_DESCRIPTION VARCHAR(50), 		MODEL VARCHAR(50), 		FAMILY VARCHAR(20), 		PROCESSOR VARCHAR(50), 		PROCESSOR_SPEED_MHZ INTEGER, 		PROCESSOR_CHIPS INTEGER, 		PROCESSOR_CORES INTEGER, 		RPE2 BIGINT, 		OLTP_RPE BIGINT, 		OS VARCHAR(50), 		DATE DATE, 		UVALUES INTEGER, 		HEIGHT_MM INTEGER, 		WIDTH_MM INTEGER, 		DEPTH_MM INTEGER, 		MAX_HEAT_MBTU BIGINT, 		MAX_POWER_WATTS BIGINT, 		NOTES VARCHAR(50) 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_IDEAS_RISC_IPF ( 		IDEAS_RISC_IPF_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VENDOR VARCHAR(50), 		SERVER_DESCRIPTION VARCHAR(50), 		MODEL VARCHAR(50), 		FAMILY VARCHAR(20), 		PROCESSOR VARCHAR(50), 		PROCESSOR_SPEED_MHZ INTEGER, 		PROCESSOR_CHIPS INTEGER, 		PROCESSOR_CORES INTEGER, 		RPE2 BIGINT, 		OLTP_RPE BIGINT, 		OS VARCHAR(50), 		DATE DATE, 		UVALUES INTEGER, 		HEIGHT_MM INTEGER, 		WIDTH_MM INTEGER, 		DEPTH_MM INTEGER, 		MAX_HEAT_MBTU BIGINT, 		MAX_POWER_WATTS BIGINT, 		NOTES VARCHAR(50) 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_IDEAS_X86_IPF ( 		IDEAS_X86_IPF_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VENDOR VARCHAR(50), 		SERVER_DESCRIPTION VARCHAR(50), 		MODEL VARCHAR(50), 		FAMILY VARCHAR(20), 		PROCESSOR VARCHAR(50), 		PROCESSOR_SPEED_MHZ INTEGER, 		PROCESSOR_CHIPS INTEGER, 		PROCESSOR_CORES INTEGER, 		RPE2 BIGINT, 		OLTP_RPE BIGINT, 		OS VARCHAR(50), 		DATE DATE, 		UVALUES INTEGER, 		HEIGHT_MM INTEGER, 		WIDTH_MM INTEGER, 		DEPTH_MM INTEGER, 		MAX_HEAT_MBTU BIGINT, 		MAX_POWER_WATTS BIGINT, 		NOTES VARCHAR(50) 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_ZSERIES_MIPS ( 		ZSERIES_MIPS_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VENDOR VARCHAR(50), 		SERVER_DESCRIPTION VARCHAR(50), 		MODEL CHAR(50), 		FAMILY VARCHAR(20), 		PROCESSOR VARCHAR(50), 		PROCESSOR_SPEED_MHZ INTEGER, 		PROCESSOR_CHIPS INTEGER, 		PROCESSOR_CORES INTEGER, 		MIPS BIGINT, 		MSU BIGINT, 		OS VARCHAR(50), 		DATE DATE, 		UVALUES INTEGER, 		HEIGHT_MM INTEGER, 		WIDTH_MM INTEGER, 		DEPTH_MM INTEGER, 		MAX_HEAT_MBTU BIGINT, 		MAX_POWER_WATTS BIGINT, 		NOTES VARCHAR(50) 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_OPERATING_SYSTEM ( 		OS_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		OS_SHORT_NAME VARCHAR(64), 		OS_LONG_NAME VARCHAR(256), 		OS_VERSION VARCHAR(64), 		SERVICE_PACK VARCHAR(64), 		ARCHITECTURE VARCHAR(32), 		KERNEL_ARCHITECTURE VARCHAR(64), 		KERNEL_VERSION VARCHAR(64), 		CONFIDENCE INTEGER, 		PHYSICAL_SERVER_PK BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_SOFTWARE ( 		SOFTWARE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		NAME VARCHAR(256), 		CLASS VARCHAR(128), 		SUBCLASS VARCHAR(128), 		PORT INTEGER, 		COMMAND_LINE VARCHAR(256), 		MIDDLEWARE_STACK VARCHAR(64), 		MIDDLEWARE_GROUP VARCHAR(64), 		IS_ROOT CHAR(1), 		PHYSICAL_SERVER_PK BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		DISPLAY_NAME VARCHAR(256) 	) 	DATA CAPTURE NONE@

CREATE TABLE KBS_MISSING_SERVER_BENCHMARK ( 		MISSING_SERVER_BENCHMARK_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VENDOR VARCHAR(20), 		SERVER_DESCRIPTION VARCHAR(50), 		FAMILY VARCHAR(20), 		PROCESSOR VARCHAR(50), 		PROCESSOR_SPEED_MHZ INTEGER, 		PROCESSOR_CHIPS INTEGER, 		PROCESSOR_CORES INTEGER, 		CPU_BENCHMARK_CAPACITY BIGINT, 		CPU_OLTP_BENCHMARK_CAPACITY BIGINT, 		OS VARCHAR(50), 		DATE DATE, 		UVALUES INTEGER, 		HEIGHT_MM INTEGER, 		WIDTH_MM INTEGER, 		DEPTH_MM INTEGER, 		MAX_HEAT_BTU BIGINT, 		MAX_POWER_WATTS BIGINT, 		NOTES VARCHAR(50), 		MODEL VARCHAR(50) 	) 	DATA CAPTURE NONE@

CREATE TABLE ANL_APP_TAG_MAP ( 		APP_TAG_MAP_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE NO CACHE), 		SERVER_TAGS_PK BIGINT NOT NULL, 		SOFTWARE_PK BIGINT NOT NULL 	) 	DATA CAPTURE NONE@

CREATE TABLE ANL_SERVER_TAG_MAP ( 		SERVER_TAG_MAP_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE NO CACHE), 		SERVER_TAGS_PK BIGINT NOT NULL, 		PHYSICAL_SERVER_PK BIGINT NOT NULL 	) 	DATA CAPTURE NONE@

CREATE TABLE ANL_SERVER_TAGS ( 		SERVER_TAGS_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		TAG_TYPE VARCHAR(50) NOT NULL, 		TAG_NAME VARCHAR(50) NOT NULL, 		TAG_DESCRIPTION VARCHAR(75), TAG_CATEGORY VARCHAR(75), TAG_OPTIONS VARCHAR(256)) DATA CAPTURE NONE@

CREATE TABLE ANL_MATCHED_SERVER_CATALOG ( 		MATCHED_SERVER_CATALOG_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VENDOR VARCHAR(256), SERVER_DESCRIPTION VARCHAR(256), MODEL VARCHAR(64), 		FAMILY VARCHAR(64), 		PROCESSOR VARCHAR(64), 		PROCESSOR_SPEED_MHZ INTEGER, 		PROCESSOR_CHIPS INTEGER, 		PROCESSOR_CORES INTEGER, 		CPU_BENCHMARK_CAPACITY BIGINT, 		CPU_OLTP_BENCHMARK_CAPACITY BIGINT, 		OS VARCHAR(128), 		DATE DATE, 		UVALUES INTEGER, 		HEIGHT_MM INTEGER, 		WIDTH_MM INTEGER, 		DEPTH_MM INTEGER, 		MAX_HEAT_MBTU BIGINT, 		MAX_POWER_WATTS BIGINT, 		NOTES VARCHAR(256) 	) 	DATA CAPTURE NONE@

CREATE TABLE ANL_TARGET_DESIGN ( 		TARGET_DESIGN_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		TARGET_SERVER_ID BIGINT, 		CPU_BENCHMARK_CAPACITY_REQ BIGINT, 		MEM_CAPACITY_REQ_MB BIGINT, 		DISK_IO_REQ_MBPS BIGINT, 		NET_BW_REQ_MBPS BIGINT, 		SOURCE_SERVER_ID BIGINT, 		TARGET_CPU_BENCHMARK_CAP BIGINT, DEVICE_TYPE VARCHAR(32)) 	DATA CAPTURE NONE@

CREATE TABLE CFG_NIC ( 		NIC_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		NAME VARCHAR(64), 		SPEED BIGINT, PHYSICAL_SERVER_PK BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, DISPLAY_NAME VARCHAR(256) 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_FILE_SYSTEM ( 		FILE_SYSTEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		MOUNT_POINT VARCHAR(256), 		TYPE VARCHAR(64), 		PERMISSIONS VARCHAR(64), 		IS_REMOTE CHAR(1), 		REMOTE_SERVER_NAME VARCHAR(256), 		REMOTE_DEVICE_URI VARCHAR(256), 		EXPORT_NAME VARCHAR(256), 		PHYSICAL_SERVER_PK BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		DISPLAY_NAME VARCHAR(256) 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_DATA_STORE ( 		DATA_STORE_PK INTEGER NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 2147483647 NO CYCLE CACHE 20), 		NAME VARCHAR(256), 		MULTIPLE_HOST_ACCESS CHAR(1), 		TYPE VARCHAR(32), 		VERSION VARCHAR(256), 		URL VARCHAR(256), 		IS_ACCESSIBLE INTEGER, 		CAPACITY BIGINT, REMOTE_SERVER_NAME VARCHAR(256), 		REMOTE_DEVICE_URI VARCHAR(1024), DISPLAY_NAME VARCHAR(256), 		DATA_CENTER_NAME VARCHAR(256), LAST_EDIT_TIMESTAMP TIMESTAMP 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_STORAGE_VOLUME ( 		STORAGE_VOLUME_KEY BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		NAME VARCHAR(256), 		TYPE VARCHAR(64), 		DEVICE_ID VARCHAR(64), 		VOLUME_GROUP_NAME VARCHAR(64), 		SIZE BIGINT, 		FREE_SPACE BIGINT, 		NUM_BLOCKS BIGINT, 		BLOCK_SIZE BIGINT, 		IS_LOGICAL CHAR(1), 		IS_REMOTE CHAR(1), 		NODE_WWN VARCHAR(64), 		PORT_WWN VARCHAR(32), 		WWN VARCHAR(64), 		FCP_LUN BIGINT, 		ZONE VARCHAR(64), 		FABRIC_NAME VARCHAR(64), 		ISCSI_NAME VARCHAR(64), 		ISCSI_SERVER VARCHAR(64), 		ISNS_SERVER VARCHAR(64), 		VLAN_NAME VARCHAR(64), 		VLAN_ID VARCHAR(64), 		PHYSICAL_SERVER_PK BIGINT, 		FILE_SYSTEM_PK BIGINT, 		DISPLAY_NAME VARCHAR(256),	VIRTUAL_MACHINE_PK BIGINT) 	DATA CAPTURE NONE@

CREATE TABLE COLOCATIONRULES ( 		COLOCATIONRULES_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 10000000000 NO CYCLE CACHE 20), 		SERVERID1 BIGINT, 		SERVERID2 BIGINT, 		CONSTRAINTTYPE VARCHAR(25), 		DEPENDENTTYPE VARCHAR(25), 		RULEDIMKEY BIGINT 	) 	DATA CAPTURE NONE@

CREATE TABLE RULEDIM ( 		RULEDIMKEY BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 1000000 NO CYCLE CACHE 20), 		RULENAME VARCHAR(256), 		PRIORITY INTEGER, 		SOURCE VARCHAR(50), 		ISACTIVE CHAR(1), 		RULETYPE VARCHAR(50), 		NOTES VARCHAR(255), 		RULEXML VARCHAR(2000) 	) 	DATA CAPTURE NONE@

CREATE TABLE RULEOUTPUT ( 		SELECTEDSERVERS_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 1000000 NO CYCLE CACHE 20), 		HASHKEY VARCHAR(100), 		HASHVALUE VARCHAR(255), 		RULETYPE VARCHAR(50), 			TARGET_TABLE VARCHAR(255),		TARGET_FIELD VARCHAR(255) 	) 	DATA CAPTURE NONE@

CREATE TABLE RULESTATUS ( 		PK_ID BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 1000000 NO CYCLE CACHE 20), 		RULETYPE_ID INTEGER, 		EXECUTED VARCHAR(10), 		EXECUTIONTIME VARCHAR(50) 	) 	DATA CAPTURE NONE@

CREATE TABLE ANL_IDEAS_MATCHED_SERVER_CATALOG ( 		MATCHED_SERVER_CATALOG_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VENDOR VARCHAR(50), 		SERVER_DESCRIPTION VARCHAR(50), 		MODEL VARCHAR(50), 		FAMILY VARCHAR(20), 		PROCESSOR VARCHAR(50), 		PROCESSOR_SPEED_MHZ INTEGER, 		PROCESSOR_CHIPS INTEGER, 		PROCESSOR_CORES INTEGER, 		CPU_BENCHMARK_CAPACITY BIGINT, 		CPU_OLTP_BENCHMARK_CAPACITY BIGINT, 		OS VARCHAR(128), 		DATE DATE, 		UVALUES INTEGER, 		HEIGHT_MM INTEGER, 		WIDTH_MM INTEGER, 		DEPTH_MM INTEGER, 		MAX_HEAT_MBTU BIGINT, 		MAX_POWER_WATTS BIGINT, 		NOTES VARCHAR(256) 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_DATA_STORE_TO_PHYSICAL_SERVER_MAP ( 		DS_PS_MAP_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_PK INTEGER, 		PHYSICAL_SERVER_PK BIGINT 	) 	DATA CAPTURE NONE@

CREATE TABLE ANL_VIRTUAL_MACHINE_TAG_MAP ( 		VIRTUAL_MACHINE_TAG_MAP_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		SERVER_TAGS_PK BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	) 	DATA CAPTURE NONE@

CREATE TABLE ANL_SOFTWARE_TAG_MAP ( 		SOFTWARE_TAG_MAP_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		SOFTWARE_PK BIGINT, 		SERVER_TAGS_PK BIGINT 	) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_CPU ( 		PS_CPU_PK BIGINT NOT NULL, 		HOST_NAME VARCHAR(256), 		CPU_NUMBER INTEGER, 		CPU_UTILIZATION BIGINT, 		PHYSICAL_SERVER_PK BIGINT, 		TIMESTAMP TIMESTAMP 	) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_CPU ( 		VM_CPU_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		VM_CPU_NUMBER INTEGER, 		WAIT_TIME BIGINT, 		USED_TIME BIGINT, 		READY_TIME BIGINT, 		SYS_TIME BIGINT, 		CPU_UTILIZATION BIGINT, 		PERCENT_READY INTEGER, 		USER_TIME BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_MEM ( 		PS_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		PHYSICAL_MEMORY BIGINT, 		MEMORY_USAGE BIGINT, 		MEMORY_UTILIZATION BIGINT, 		ACTIVE_MEMORY BIGINT, 		GRANTED_MEMORY BIGINT, 		SWAP_USED BIGINT, 		FREE_MEM BIGINT, 		BALLOON_USED BIGINT, 		SWAP_IN_RATE BIGINT, 		SWAP_OUT_RATE BIGINT, 		SWAP_TOTAL_RATE BIGINT, 		PHYSICAL_SERVER_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_MEM ( 		VM_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		HOST_USAGE BIGINT, 		GUEST_USAGE BIGINT, 		HOST_UTILIZATION BIGINT, 		GUEST_UTILIZATION BIGINT, 		HOST_FREE BIGINT, 		GUEST_FREE BIGINT, 		BALLOON_USAGE BIGINT, 		SWAP_TO_FILE BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_DATA_STORE ( 		DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		HOST_NAME VARCHAR(256), 		USED_SPACE BIGINT, 		FREE_SPACE BIGINT, 		PERCENT_USED BIGINT, 		PERCENT_FREE BIGINT, 		TOTAL_READ BIGINT, 		TOTAL_WRITE BIGINT, 		TOTAL_IO BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_DATA_STORE ( 		VM_DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		TOTAL_READ BIGINT, 		TOTAL_WRITE BIGINT, 		TOTAL_IO BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_DISK ( 		HOST_NAME VARCHAR(256), 		PS_DISK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DISK_NAME VARCHAR(256), 		DATA_STORE_NAME VARCHAR(256), 		READ_KBPS BIGINT, 		WRITE_KBPS BIGINT, 		READ_COUNT BIGINT, 		WRITE_COUNT BIGINT, 		BUS_RESET BIGINT, 		COMMANDS_COUNT BIGINT, 		COMMANDS_ABORTED_COUNT BIGINT, 		DEVICE_READ_LATENCY BIGINT, 		DEVICE_WRITE_LATENCY BIGINT, 		DEVICE_TOTAL_LATENCY BIGINT, 		DEVICE_LATENCY BIGINT, 		PHYSICAL_SERVER_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_NETWORK ( 		PS_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		USAGE BIGINT, 		TRANSMITTED_KBPS BIGINT, 		RECEIVED_KBPS BIGINT, 		PKTS_TRANSMITTED BIGINT, 		PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_NETWORK ( 		VM_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		TRANSMITTED_KBPS BIGINT, 		RECEIVED_KBPS BIGINT, 		PKTS_TRANSMITTED BIGINT, 		PKTS_RECEIVED BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE CFG_DATA_STORE_TO_STORAGE_VOLUME_MAP ( 		DS_SV_MAP_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_PK INTEGER, 		STORAGE_VOLUME_KEY BIGINT 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_DATA_STORE_TO_VIRTUAL_MACHINE_MAP ( 		DS_VM_MAP_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_PK INTEGER, 		VIRTUAL_MACHINE_PK BIGINT 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_USER_CONFIGURATION ( 		USER_CONFIGURATION_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		USERNAME VARCHAR(64), 		COMPONENT_NAME VARCHAR(64), 		START_TIME TIMESTAMP, 		END_TIME TIMESTAMP, 		LOG_LEVEL INTEGER, 		ALERT_LEVEL INTEGER, 		SPECIFIC_CONFIGS VARCHAR(256), 		DESCRIPTION VARCHAR(256) 	) 	DATA CAPTURE NONE@

CREATE TABLE CFG_HBA ( 		HBA_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		NAME VARCHAR(256), 		MODEL VARCHAR(256), 		WWN VARCHAR(64), 		NUM_PORTS BIGINT, 		DISPLAY_NAME VARCHAR(256), 		PHYSICAL_SERVER_PK BIGINT, 	SPEED BIGINT) 	DATA CAPTURE NONE@

CREATE TABLE ANL_THRESHOLDS ( 		ANL_THRESHOLDS_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DESC VARCHAR(32), 		CPU_UTIL_LOW BIGINT, 		CPU_UTIL_HIGH BIGINT, 		MEM_UTIL_LOW BIGINT, 		MEM_UTIL_HIGH BIGINT, 		DISK_UTIL_LOW BIGINT, 		DISK_UTIL_HIGH BIGINT, 		NETWORK_UTIL_LOW BIGINT, 		NETWORK_UTIL_HIGH BIGINT, 		CPU_VAR_LOW BIGINT, 		CPU_VAR_HIGH BIGINT, 		MEM_VAR_LOW BIGINT, 		MEM_VAR_HIGH BIGINT, 		DISK_VAR_LOW BIGINT, 		DISK_VAR_HIGH BIGINT, 		NETWORK_VAR_LOW BIGINT, 		NETWORK_VAR_HIGH BIGINT,	DESC_VAR VARCHAR(32) 	) 	DATA CAPTURE NONE@

CREATE TABLE ANL_CORRELATION_GROUPS (	ANL_CORRELATION_GROUPS_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20),	HOST_NAME VARCHAR(256), 	GROUP_ID VARCHAR(256),	CORRELATION_TYPE VARCHAR(32), GRANULARITY VARCHAR(25), AGGREGATION VARCHAR(32), PARAMETER VARCHAR(32), 	PEAK_LIMIT BIGINT, VALLEY_LIMIT BIGINT, HOST_KEY BIGINT	) DATA CAPTURE NONE@

CREATE TABLE CFG_CORRELATION_BRACKETS (	CFG_BRACKETS_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20),	BRACKET_DESCRIPTION VARCHAR(32), 	LOWER_LIMIT DOUBLE,		HIGHER_LIMIT DOUBLE	) DATA CAPTURE NONE@

CREATE TABLE ANL_STMT  (STMT VARCHAR(2048) ) DATA CAPTURE NONE@
 
CREATE TABLE ANL_TIME_DIM(  
  TimeDim_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20),
  TIME_RANGE_START TIMESTAMP NOT NULL,  
  TIME_RANGE_END TIMESTAMP NOT NULL, 
  HOUR_KEY TIMESTAMP NOT NULL,  
  DAY_KEY TIMESTAMP NOT NULL,  
  WEEK_KEY TIMESTAMP NOT NULL,  
  MONTH_KEY TIMESTAMP NOT NULL,  
  QUARTER_KEY TIMESTAMP NOT NULL,
  YEAR_KEY TIMESTAMP NOT NULL,  
  CURRENT_DATE DATE NOT NULL,  
  CURRENT_MINUTE SMALLINT,  
  CURRENT_HOUR SMALLINT,  
  CURRENT_DAY SMALLINT,  
  CURRENT_WEEK SMALLINT,  
  CURRENT_MONTH SMALLINT,  
  CURRENT_QUARTER SMALLINT,  
  CURRENT_YEAR SMALLINT, 
  DAY_OF_WEEK SMALLINT,  
  DAYS_IN_MONTH SMALLINT,  
  DAY_OF_YEAR SMALLINT,  
  WEEK_OF_MONTH SMALLINT,  
  WEEK_OF_QUARTER SMALLINT,
  CANDLETIMESTAMP CHAR(16) NOT NULL,  
  END_CANDLETIMESTAMP CHAR(16) NOT NULL,  
  TIME_PK BIGINT
) @

CREATE TABLE USER_DEFINED_BENCHMARK (
  USER_DEFINED_BENCHMARK_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1, CACHE 20, NO MINVALUE, NO MAXVALUE, NO CYCLE, NO ORDER),
  VENDOR VARCHAR(128),
  SERVER_DESCRIPTION VARCHAR(50),
  FAMILY VARCHAR(20),
  PROCESSOR VARCHAR(256),
  PROCESSOR_SPEED_MHZ INTEGER,
  PROCESSOR_CHIPS INTEGER,
  PROCESSOR_CORES INTEGER,
  CPU_BENCHMARK_CAPACITY BIGINT,
  CPU_OLTP_BENCHMARK_CAPACITY BIGINT,
  OS VARCHAR(50),
  DATE DATE,
  UVALUES INTEGER,
  HEIGHT_MM INTEGER,
  WIDTH_MM INTEGER,
  DEPTH_MM INTEGER,
  MAX_HEAT_BTU BIGINT,
  MAX_POWER_WATTS BIGINT,
  NOTES VARCHAR(50),
  MODEL VARCHAR(128)
)
DATA CAPTURE NONE@

CREATE TABLE CUSTOM_USER_DEFINED_BENCHMARK (
  USER_DEFINED_BENCHMARK_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1, CACHE 20, NO MINVALUE, NO MAXVALUE, NO CYCLE, NO ORDER),
  VENDOR VARCHAR(128),
  SERVER_DESCRIPTION VARCHAR(50),
  FAMILY VARCHAR(20),
  PROCESSOR VARCHAR(256),
  PROCESSOR_SPEED_MHZ INTEGER,
  PROCESSOR_CHIPS INTEGER,
  PROCESSOR_CORES INTEGER,
  CPU_BENCHMARK_CAPACITY BIGINT,
  CPU_OLTP_BENCHMARK_CAPACITY BIGINT,
  OS VARCHAR(50),
  DATE DATE,
  UVALUES INTEGER,
  HEIGHT_MM INTEGER,
  WIDTH_MM INTEGER,
  DEPTH_MM INTEGER,
  MAX_HEAT_BTU BIGINT,
  MAX_POWER_WATTS BIGINT,
  NOTES VARCHAR(50),
  MODEL VARCHAR(128)
)
DATA CAPTURE NONE@

CREATE TABLE CAPACITY_VIOLATION (
		CAPACITY_VIOLATION_PK BIGINT ,
		SERVER_ID BIGINT ,
		RESOURCE_TYPE VARCHAR (50) ,
		NUMBER_OF_VIOLATIONS BIGINT ,
		AVERAGE_VIOLATION_PERCENTAGE REAL ,
		MAXIMUM_VIOLATION_PERCENTAGE REAL
		) DATA CAPTURE NONE@

CREATE TABLE MES_DATA_STORE_D ( 		DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		HOST_NAME VARCHAR(256), 		MIN_USED_SPACE BIGINT, 		MAX_USED_SPACE BIGINT, 		SUM_USED_SPACE BIGINT, 		AVG_USED_SPACE BIGINT, 		MIN_FREE_SPACE BIGINT, 		MAX_FREE_SPACE BIGINT, 		SUM_FREE_SPACE BIGINT, 		AVG_FREE_SPACE BIGINT, 		MIN_PERCENT_USED BIGINT, 		MAX_PERCENT_USED BIGINT, 		SUM_PERCENT_USED BIGINT, 		AVG_PERCENT_USED BIGINT, 		MIN_PERCENT_FREE BIGINT, 		MAX_PERCENT_FREE BIGINT, 		SUM_PERCENT_FREE BIGINT, 		AVG_PERCENT_FREE BIGINT, 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_DATA_STORE_H ( 		DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		HOST_NAME VARCHAR(256), 		MIN_USED_SPACE BIGINT, 		MAX_USED_SPACE BIGINT, 		SUM_USED_SPACE BIGINT, 		AVG_USED_SPACE BIGINT, 		MIN_FREE_SPACE BIGINT, 		MAX_FREE_SPACE BIGINT, 		SUM_FREE_SPACE BIGINT, 		AVG_FREE_SPACE BIGINT, 		MIN_PERCENT_USED BIGINT, 		MAX_PERCENT_USED BIGINT, 		SUM_PERCENT_USED BIGINT, 		AVG_PERCENT_USED BIGINT, 		MIN_PERCENT_FREE BIGINT, 		MAX_PERCENT_FREE BIGINT, 		SUM_PERCENT_FREE BIGINT, 		AVG_PERCENT_FREE BIGINT, 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_DATA_STORE_M ( 		DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		HOST_NAME VARCHAR(256), 		MIN_USED_SPACE BIGINT, 		MAX_USED_SPACE BIGINT, 		SUM_USED_SPACE BIGINT, 		AVG_USED_SPACE BIGINT, 		MIN_FREE_SPACE BIGINT, 		MAX_FREE_SPACE BIGINT, 		SUM_FREE_SPACE BIGINT, 		AVG_FREE_SPACE BIGINT, 		MIN_PERCENT_USED BIGINT, 		MAX_PERCENT_USED BIGINT, 		SUM_PERCENT_USED BIGINT, 		AVG_PERCENT_USED BIGINT, 		MIN_PERCENT_FREE BIGINT, 		MAX_PERCENT_FREE BIGINT, 		SUM_PERCENT_FREE BIGINT, 		AVG_PERCENT_FREE BIGINT, 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_DATA_STORE_Q ( 		DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		HOST_NAME VARCHAR(256), 		MIN_USED_SPACE BIGINT, 		MAX_USED_SPACE BIGINT, 		SUM_USED_SPACE BIGINT, 		AVG_USED_SPACE BIGINT, 		MIN_FREE_SPACE BIGINT, 		MAX_FREE_SPACE BIGINT, 		SUM_FREE_SPACE BIGINT, 		AVG_FREE_SPACE BIGINT, 		MIN_PERCENT_USED BIGINT, 		MAX_PERCENT_USED BIGINT, 		SUM_PERCENT_USED BIGINT, 		AVG_PERCENT_USED BIGINT, 		MIN_PERCENT_FREE BIGINT, 		MAX_PERCENT_FREE BIGINT, 		SUM_PERCENT_FREE BIGINT, 		AVG_PERCENT_FREE BIGINT, 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_DATA_STORE_W ( 		DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		HOST_NAME VARCHAR(256), 		MIN_USED_SPACE BIGINT, 		MAX_USED_SPACE BIGINT, 		SUM_USED_SPACE BIGINT, 		AVG_USED_SPACE BIGINT, 		MIN_FREE_SPACE BIGINT, 		MAX_FREE_SPACE BIGINT, 		SUM_FREE_SPACE BIGINT, 		AVG_FREE_SPACE BIGINT, 		MIN_PERCENT_USED BIGINT, 		MAX_PERCENT_USED BIGINT, 		SUM_PERCENT_USED BIGINT, 		AVG_PERCENT_USED BIGINT, 		MIN_PERCENT_FREE BIGINT, 		MAX_PERCENT_FREE BIGINT, 		SUM_PERCENT_FREE BIGINT, 		AVG_PERCENT_FREE BIGINT, 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_DATA_STORE_Y ( 		DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		HOST_NAME VARCHAR(256), 		MIN_USED_SPACE BIGINT, 		MAX_USED_SPACE BIGINT, 		SUM_USED_SPACE BIGINT, 		AVG_USED_SPACE BIGINT, 		MIN_FREE_SPACE BIGINT, 		MAX_FREE_SPACE BIGINT, 		SUM_FREE_SPACE BIGINT, 		AVG_FREE_SPACE BIGINT, 		MIN_PERCENT_USED BIGINT, 		MAX_PERCENT_USED BIGINT, 		SUM_PERCENT_USED BIGINT, 		AVG_PERCENT_USED BIGINT, 		MIN_PERCENT_FREE BIGINT, 		MAX_PERCENT_FREE BIGINT, 		SUM_PERCENT_FREE BIGINT, 		AVG_PERCENT_FREE BIGINT, 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_CPU_D ( 		PS_CPU_PK BIGINT NOT NULL, 		HOST_NAME VARCHAR(256), 		CPU_NUMBER INTEGER, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_CPU_H ( 		PS_CPU_PK BIGINT NOT NULL, 		HOST_NAME VARCHAR(256), 		CPU_NUMBER INTEGER, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_CPU_M ( 		PS_CPU_PK BIGINT NOT NULL, 		HOST_NAME VARCHAR(256), 		CPU_NUMBER INTEGER, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_CPU_Q ( 		PS_CPU_PK BIGINT NOT NULL, 		HOST_NAME VARCHAR(256), 		CPU_NUMBER INTEGER, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_CPU_W ( 		PS_CPU_PK BIGINT NOT NULL, 		HOST_NAME VARCHAR(256), 		CPU_NUMBER INTEGER, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_CPU_Y ( 		PS_CPU_PK BIGINT NOT NULL, 		HOST_NAME VARCHAR(256), 		CPU_NUMBER INTEGER, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_DISK_D ( 		HOST_NAME VARCHAR(256), 		PS_DISK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DISK_NAME VARCHAR(256), 		DATA_STORE_NAME VARCHAR(256), 		MIN_READ_KBPS BIGINT, 		MAX_READ_KBPS BIGINT, 		SUM_READ_KBPS BIGINT, 		AVG_READ_KBPS BIGINT, 		MIN_WRITE_KBPS BIGINT, 		MAX_WRITE_KBPS BIGINT, 		SUM_WRITE_KBPS BIGINT, 		AVG_WRITE_KBPS BIGINT, 		MIN_READ_COUNT BIGINT, 		MAX_READ_COUNT BIGINT, 		SUM_READ_COUNT BIGINT, 		AVG_READ_COUNT BIGINT, 		MIN_WRITE_COUNT BIGINT, 		MAX_WRITE_COUNT BIGINT, 		SUM_WRITE_COUNT BIGINT, 		AVG_WRITE_COUNT BIGINT, 		MIN_BUS_RESET BIGINT, 		MAX_BUS_RESET BIGINT, 		SUM_BUS_RESET BIGINT, 		AVG_BUS_RESET BIGINT, 		MIN_COMMANDS_COUNT BIGINT, 		MAX_COMMANDS_COUNT BIGINT, 		SUM_COMMANDS_COUNT BIGINT, 		AVG_COMMANDS_COUNT BIGINT, 		MIN_COMMANDS_ABORTED_COUNT BIGINT, 		MAX_COMMANDS_ABORTED_COUNT BIGINT, 		SUM_COMMANDS_ABORTED_COUNT BIGINT, 		AVG_COMMANDS_ABORTED_COUNT BIGINT, 		MIN_DEVICE_READ_LATENCY BIGINT, 		MAX_DEVICE_READ_LATENCY BIGINT, 		SUM_DEVICE_READ_LATENCY BIGINT, 		AVG_DEVICE_READ_LATENCY BIGINT, 		MIN_DEVICE_WRITE_LATENCY BIGINT, 		MAX_DEVICE_WRITE_LATENCY BIGINT, 		SUM_DEVICE_WRITE_LATENCY BIGINT, 		AVG_DEVICE_WRITE_LATENCY BIGINT, 		MIN_DEVICE_TOTAL_LATENCY BIGINT, 		MAX_DEVICE_TOTAL_LATENCY BIGINT, 		SUM_DEVICE_TOTAL_LATENCY BIGINT, 		AVG_DEVICE_TOTAL_LATENCY BIGINT, 		MIN_DEVICE_LATENCY BIGINT, 		MAX_DEVICE_LATENCY BIGINT, 		SUM_DEVICE_LATENCY BIGINT, 		AVG_DEVICE_LATENCY BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_DISK_H ( 		HOST_NAME VARCHAR(256), 		PS_DISK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DISK_NAME VARCHAR(256), 		DATA_STORE_NAME VARCHAR(256), 		MIN_READ_KBPS BIGINT, 		MAX_READ_KBPS BIGINT, 		SUM_READ_KBPS BIGINT, 		AVG_READ_KBPS BIGINT, 		MIN_WRITE_KBPS BIGINT, 		MAX_WRITE_KBPS BIGINT, 		SUM_WRITE_KBPS BIGINT, 		AVG_WRITE_KBPS BIGINT, 		MIN_READ_COUNT BIGINT, 		MAX_READ_COUNT BIGINT, 		SUM_READ_COUNT BIGINT, 		AVG_READ_COUNT BIGINT, 		MIN_WRITE_COUNT BIGINT, 		MAX_WRITE_COUNT BIGINT, 		SUM_WRITE_COUNT BIGINT, 		AVG_WRITE_COUNT BIGINT, 		MIN_BUS_RESET BIGINT, 		MAX_BUS_RESET BIGINT, 		SUM_BUS_RESET BIGINT, 		AVG_BUS_RESET BIGINT, 		MIN_COMMANDS_COUNT BIGINT, 		MAX_COMMANDS_COUNT BIGINT, 		SUM_COMMANDS_COUNT BIGINT, 		AVG_COMMANDS_COUNT BIGINT, 		MIN_COMMANDS_ABORTED_COUNT BIGINT, 		MAX_COMMANDS_ABORTED_COUNT BIGINT, 		SUM_COMMANDS_ABORTED_COUNT BIGINT, 		AVG_COMMANDS_ABORTED_COUNT BIGINT, 		MIN_DEVICE_READ_LATENCY BIGINT, 		MAX_DEVICE_READ_LATENCY BIGINT, 		SUM_DEVICE_READ_LATENCY BIGINT, 		AVG_DEVICE_READ_LATENCY BIGINT, 		MIN_DEVICE_WRITE_LATENCY BIGINT, 		MAX_DEVICE_WRITE_LATENCY BIGINT, 		SUM_DEVICE_WRITE_LATENCY BIGINT, 		AVG_DEVICE_WRITE_LATENCY BIGINT, 		MIN_DEVICE_TOTAL_LATENCY BIGINT, 		MAX_DEVICE_TOTAL_LATENCY BIGINT, 		SUM_DEVICE_TOTAL_LATENCY BIGINT, 		AVG_DEVICE_TOTAL_LATENCY BIGINT, 		MIN_DEVICE_LATENCY BIGINT, 		MAX_DEVICE_LATENCY BIGINT, 		SUM_DEVICE_LATENCY BIGINT, 		AVG_DEVICE_LATENCY BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_DISK_Q ( 		HOST_NAME VARCHAR(256), 		PS_DISK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DISK_NAME VARCHAR(256), 		DATA_STORE_NAME VARCHAR(256), 		MIN_READ_KBPS BIGINT, 		MAX_READ_KBPS BIGINT, 		SUM_READ_KBPS BIGINT, 		AVG_READ_KBPS BIGINT, 		MIN_WRITE_KBPS BIGINT, 		MAX_WRITE_KBPS BIGINT, 		SUM_WRITE_KBPS BIGINT, 		AVG_WRITE_KBPS BIGINT, 		MIN_READ_COUNT BIGINT, 		MAX_READ_COUNT BIGINT, 		SUM_READ_COUNT BIGINT, 		AVG_READ_COUNT BIGINT, 		MIN_WRITE_COUNT BIGINT, 		MAX_WRITE_COUNT BIGINT, 		SUM_WRITE_COUNT BIGINT, 		AVG_WRITE_COUNT BIGINT, 		MIN_BUS_RESET BIGINT, 		MAX_BUS_RESET BIGINT, 		SUM_BUS_RESET BIGINT, 		AVG_BUS_RESET BIGINT, 		MIN_COMMANDS_COUNT BIGINT, 		MAX_COMMANDS_COUNT BIGINT, 		SUM_COMMANDS_COUNT BIGINT, 		AVG_COMMANDS_COUNT BIGINT, 		MIN_COMMANDS_ABORTED_COUNT BIGINT, 		MAX_COMMANDS_ABORTED_COUNT BIGINT, 		SUM_COMMANDS_ABORTED_COUNT BIGINT, 		AVG_COMMANDS_ABORTED_COUNT BIGINT, 		MIN_DEVICE_READ_LATENCY BIGINT, 		MAX_DEVICE_READ_LATENCY BIGINT, 		SUM_DEVICE_READ_LATENCY BIGINT, 		AVG_DEVICE_READ_LATENCY BIGINT, 		MIN_DEVICE_WRITE_LATENCY BIGINT, 		MAX_DEVICE_WRITE_LATENCY BIGINT, 		SUM_DEVICE_WRITE_LATENCY BIGINT, 		AVG_DEVICE_WRITE_LATENCY BIGINT, 		MIN_DEVICE_TOTAL_LATENCY BIGINT, 		MAX_DEVICE_TOTAL_LATENCY BIGINT, 		SUM_DEVICE_TOTAL_LATENCY BIGINT, 		AVG_DEVICE_TOTAL_LATENCY BIGINT, 		MIN_DEVICE_LATENCY BIGINT, 		MAX_DEVICE_LATENCY BIGINT, 		SUM_DEVICE_LATENCY BIGINT, 		AVG_DEVICE_LATENCY BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_DISK_M ( 		HOST_NAME VARCHAR(256), 		PS_DISK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DISK_NAME VARCHAR(256), 		DATA_STORE_NAME VARCHAR(256), 		MIN_READ_KBPS BIGINT, 		MAX_READ_KBPS BIGINT, 		SUM_READ_KBPS BIGINT, 		AVG_READ_KBPS BIGINT, 		MIN_WRITE_KBPS BIGINT, 		MAX_WRITE_KBPS BIGINT, 		SUM_WRITE_KBPS BIGINT, 		AVG_WRITE_KBPS BIGINT, 		MIN_READ_COUNT BIGINT, 		MAX_READ_COUNT BIGINT, 		SUM_READ_COUNT BIGINT, 		AVG_READ_COUNT BIGINT, 		MIN_WRITE_COUNT BIGINT, 		MAX_WRITE_COUNT BIGINT, 		SUM_WRITE_COUNT BIGINT, 		AVG_WRITE_COUNT BIGINT, 		MIN_BUS_RESET BIGINT, 		MAX_BUS_RESET BIGINT, 		SUM_BUS_RESET BIGINT, 		AVG_BUS_RESET BIGINT, 		MIN_COMMANDS_COUNT BIGINT, 		MAX_COMMANDS_COUNT BIGINT, 		SUM_COMMANDS_COUNT BIGINT, 		AVG_COMMANDS_COUNT BIGINT, 		MIN_COMMANDS_ABORTED_COUNT BIGINT, 		MAX_COMMANDS_ABORTED_COUNT BIGINT, 		SUM_COMMANDS_ABORTED_COUNT BIGINT, 		AVG_COMMANDS_ABORTED_COUNT BIGINT, 		MIN_DEVICE_READ_LATENCY BIGINT, 		MAX_DEVICE_READ_LATENCY BIGINT, 		SUM_DEVICE_READ_LATENCY BIGINT, 		AVG_DEVICE_READ_LATENCY BIGINT, 		MIN_DEVICE_WRITE_LATENCY BIGINT, 		MAX_DEVICE_WRITE_LATENCY BIGINT, 		SUM_DEVICE_WRITE_LATENCY BIGINT, 		AVG_DEVICE_WRITE_LATENCY BIGINT, 		MIN_DEVICE_TOTAL_LATENCY BIGINT, 		MAX_DEVICE_TOTAL_LATENCY BIGINT, 		SUM_DEVICE_TOTAL_LATENCY BIGINT, 		AVG_DEVICE_TOTAL_LATENCY BIGINT, 		MIN_DEVICE_LATENCY BIGINT, 		MAX_DEVICE_LATENCY BIGINT, 		SUM_DEVICE_LATENCY BIGINT, 		AVG_DEVICE_LATENCY BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_DISK_W ( 		HOST_NAME VARCHAR(256), 		PS_DISK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DISK_NAME VARCHAR(256), 		DATA_STORE_NAME VARCHAR(256), 		MIN_READ_KBPS BIGINT, 		MAX_READ_KBPS BIGINT, 		SUM_READ_KBPS BIGINT, 		AVG_READ_KBPS BIGINT, 		MIN_WRITE_KBPS BIGINT, 		MAX_WRITE_KBPS BIGINT, 		SUM_WRITE_KBPS BIGINT, 		AVG_WRITE_KBPS BIGINT, 		MIN_READ_COUNT BIGINT, 		MAX_READ_COUNT BIGINT, 		SUM_READ_COUNT BIGINT, 		AVG_READ_COUNT BIGINT, 		MIN_WRITE_COUNT BIGINT, 		MAX_WRITE_COUNT BIGINT, 		SUM_WRITE_COUNT BIGINT, 		AVG_WRITE_COUNT BIGINT, 		MIN_BUS_RESET BIGINT, 		MAX_BUS_RESET BIGINT, 		SUM_BUS_RESET BIGINT, 		AVG_BUS_RESET BIGINT, 		MIN_COMMANDS_COUNT BIGINT, 		MAX_COMMANDS_COUNT BIGINT, 		SUM_COMMANDS_COUNT BIGINT, 		AVG_COMMANDS_COUNT BIGINT, 		MIN_COMMANDS_ABORTED_COUNT BIGINT, 		MAX_COMMANDS_ABORTED_COUNT BIGINT, 		SUM_COMMANDS_ABORTED_COUNT BIGINT, 		AVG_COMMANDS_ABORTED_COUNT BIGINT, 		MIN_DEVICE_READ_LATENCY BIGINT, 		MAX_DEVICE_READ_LATENCY BIGINT, 		SUM_DEVICE_READ_LATENCY BIGINT, 		AVG_DEVICE_READ_LATENCY BIGINT, 		MIN_DEVICE_WRITE_LATENCY BIGINT, 		MAX_DEVICE_WRITE_LATENCY BIGINT, 		SUM_DEVICE_WRITE_LATENCY BIGINT, 		AVG_DEVICE_WRITE_LATENCY BIGINT, 		MIN_DEVICE_TOTAL_LATENCY BIGINT, 		MAX_DEVICE_TOTAL_LATENCY BIGINT, 		SUM_DEVICE_TOTAL_LATENCY BIGINT, 		AVG_DEVICE_TOTAL_LATENCY BIGINT, 		MIN_DEVICE_LATENCY BIGINT, 		MAX_DEVICE_LATENCY BIGINT, 		SUM_DEVICE_LATENCY BIGINT, 		AVG_DEVICE_LATENCY BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_DISK_Y ( 		HOST_NAME VARCHAR(256), 		PS_DISK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DISK_NAME VARCHAR(256), 		DATA_STORE_NAME VARCHAR(256), 		MIN_READ_KBPS BIGINT, 		MAX_READ_KBPS BIGINT, 		SUM_READ_KBPS BIGINT, 		AVG_READ_KBPS BIGINT, 		MIN_WRITE_KBPS BIGINT, 		MAX_WRITE_KBPS BIGINT, 		SUM_WRITE_KBPS BIGINT, 		AVG_WRITE_KBPS BIGINT, 		MIN_READ_COUNT BIGINT, 		MAX_READ_COUNT BIGINT, 		SUM_READ_COUNT BIGINT, 		AVG_READ_COUNT BIGINT, 		MIN_WRITE_COUNT BIGINT, 		MAX_WRITE_COUNT BIGINT, 		SUM_WRITE_COUNT BIGINT, 		AVG_WRITE_COUNT BIGINT, 		MIN_BUS_RESET BIGINT, 		MAX_BUS_RESET BIGINT, 		SUM_BUS_RESET BIGINT, 		AVG_BUS_RESET BIGINT, 		MIN_COMMANDS_COUNT BIGINT, 		MAX_COMMANDS_COUNT BIGINT, 		SUM_COMMANDS_COUNT BIGINT, 		AVG_COMMANDS_COUNT BIGINT, 		MIN_COMMANDS_ABORTED_COUNT BIGINT, 		MAX_COMMANDS_ABORTED_COUNT BIGINT, 		SUM_COMMANDS_ABORTED_COUNT BIGINT, 		AVG_COMMANDS_ABORTED_COUNT BIGINT, 		MIN_DEVICE_READ_LATENCY BIGINT, 		MAX_DEVICE_READ_LATENCY BIGINT, 		SUM_DEVICE_READ_LATENCY BIGINT, 		AVG_DEVICE_READ_LATENCY BIGINT, 		MIN_DEVICE_WRITE_LATENCY BIGINT, 		MAX_DEVICE_WRITE_LATENCY BIGINT, 		SUM_DEVICE_WRITE_LATENCY BIGINT, 		AVG_DEVICE_WRITE_LATENCY BIGINT, 		MIN_DEVICE_TOTAL_LATENCY BIGINT, 		MAX_DEVICE_TOTAL_LATENCY BIGINT, 		SUM_DEVICE_TOTAL_LATENCY BIGINT, 		AVG_DEVICE_TOTAL_LATENCY BIGINT, 		MIN_DEVICE_LATENCY BIGINT, 		MAX_DEVICE_LATENCY BIGINT, 		SUM_DEVICE_LATENCY BIGINT, 		AVG_DEVICE_LATENCY BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_MEM_D ( 		PS_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		PHYSICAL_MEMORY BIGINT, 		MIN_MEMORY_USAGE BIGINT, 		MAX_MEMORY_USAGE BIGINT, 		SUM_MEMORY_USAGE BIGINT, 		AVG_MEMORY_USAGE BIGINT, 		MIN_MEMORY_UTILIZATION BIGINT, 		MAX_MEMORY_UTILIZATION BIGINT, 		SUM_MEMORY_UTILIZATION BIGINT, 		AVG_MEMORY_UTILIZATION BIGINT, 		MIN_ACTIVE_MEMORY BIGINT, 		MAX_ACTIVE_MEMORY BIGINT, 		SUM_ACTIVE_MEMORY BIGINT, 		AVG_ACTIVE_MEMORY BIGINT, 		MIN_GRANTED_MEMORY BIGINT, 		MAX_GRANTED_MEMORY BIGINT, 		SUM_GRANTED_MEMORY BIGINT, 		AVG_GRANTED_MEMORY BIGINT, 		MIN_SWAP_USED BIGINT, 		MAX_SWAP_USED BIGINT, 		SUM_SWAP_USED BIGINT, 		AVG_SWAP_USED BIGINT, 		MIN_FREE_MEM BIGINT, 		MAX_FREE_MEM BIGINT, 		SUM_FREE_MEM BIGINT, 		AVG_FREE_MEM BIGINT, 		MIN_BALLOON_USED BIGINT, 		MAX_BALLOON_USED BIGINT, 		SUM_BALLOON_USED BIGINT, 		AVG_BALLOON_USED BIGINT, 		MIN_SWAP_IN_RATE BIGINT, 		MAX_SWAP_IN_RATE BIGINT, 		SUM_SWAP_IN_RATE BIGINT, 		AVG_SWAP_IN_RATE BIGINT, 		MIN_SWAP_OUT_RATE BIGINT, 		MAX_SWAP_OUT_RATE BIGINT, 		SUM_SWAP_OUT_RATE BIGINT, 		AVG_SWAP_OUT_RATE BIGINT, 		MIN_SWAP_TOTAL_RATE BIGINT, 		MAX_SWAP_TOTAL_RATE BIGINT, 		SUM_SWAP_TOTAL_RATE BIGINT, 		AVG_SWAP_TOTAL_RATE BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_MEM_H ( 		PS_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		PHYSICAL_MEMORY BIGINT, 		MIN_MEMORY_USAGE BIGINT, 		MAX_MEMORY_USAGE BIGINT, 		SUM_MEMORY_USAGE BIGINT, 		AVG_MEMORY_USAGE BIGINT, 		MIN_MEMORY_UTILIZATION BIGINT, 		MAX_MEMORY_UTILIZATION BIGINT, 		SUM_MEMORY_UTILIZATION BIGINT, 		AVG_MEMORY_UTILIZATION BIGINT, 		MIN_ACTIVE_MEMORY BIGINT, 		MAX_ACTIVE_MEMORY BIGINT, 		SUM_ACTIVE_MEMORY BIGINT, 		AVG_ACTIVE_MEMORY BIGINT, 		MIN_GRANTED_MEMORY BIGINT, 		MAX_GRANTED_MEMORY BIGINT, 		SUM_GRANTED_MEMORY BIGINT, 		AVG_GRANTED_MEMORY BIGINT, 		MIN_SWAP_USED BIGINT, 		MAX_SWAP_USED BIGINT, 		SUM_SWAP_USED BIGINT, 		AVG_SWAP_USED BIGINT, 		MIN_FREE_MEM BIGINT, 		MAX_FREE_MEM BIGINT, 		SUM_FREE_MEM BIGINT, 		AVG_FREE_MEM BIGINT, 		MIN_BALLOON_USED BIGINT, 		MAX_BALLOON_USED BIGINT, 		SUM_BALLOON_USED BIGINT, 		AVG_BALLOON_USED BIGINT, 		MIN_SWAP_IN_RATE BIGINT, 		MAX_SWAP_IN_RATE BIGINT, 		SUM_SWAP_IN_RATE BIGINT, 		AVG_SWAP_IN_RATE BIGINT, 		MIN_SWAP_OUT_RATE BIGINT, 		MAX_SWAP_OUT_RATE BIGINT, 		SUM_SWAP_OUT_RATE BIGINT, 		AVG_SWAP_OUT_RATE BIGINT, 		MIN_SWAP_TOTAL_RATE BIGINT, 		MAX_SWAP_TOTAL_RATE BIGINT, 		SUM_SWAP_TOTAL_RATE BIGINT, 		AVG_SWAP_TOTAL_RATE BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_MEM_M ( 		PS_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		PHYSICAL_MEMORY BIGINT, 		MIN_MEMORY_USAGE BIGINT, 		MAX_MEMORY_USAGE BIGINT, 		SUM_MEMORY_USAGE BIGINT, 		AVG_MEMORY_USAGE BIGINT, 		MIN_MEMORY_UTILIZATION BIGINT, 		MAX_MEMORY_UTILIZATION BIGINT, 		SUM_MEMORY_UTILIZATION BIGINT, 		AVG_MEMORY_UTILIZATION BIGINT, 		MIN_ACTIVE_MEMORY BIGINT, 		MAX_ACTIVE_MEMORY BIGINT, 		SUM_ACTIVE_MEMORY BIGINT, 		AVG_ACTIVE_MEMORY BIGINT, 		MIN_GRANTED_MEMORY BIGINT, 		MAX_GRANTED_MEMORY BIGINT, 		SUM_GRANTED_MEMORY BIGINT, 		AVG_GRANTED_MEMORY BIGINT, 		MIN_SWAP_USED BIGINT, 		MAX_SWAP_USED BIGINT, 		SUM_SWAP_USED BIGINT, 		AVG_SWAP_USED BIGINT, 		MIN_FREE_MEM BIGINT, 		MAX_FREE_MEM BIGINT, 		SUM_FREE_MEM BIGINT, 		AVG_FREE_MEM BIGINT, 		MIN_BALLOON_USED BIGINT, 		MAX_BALLOON_USED BIGINT, 		SUM_BALLOON_USED BIGINT, 		AVG_BALLOON_USED BIGINT, 		MIN_SWAP_IN_RATE BIGINT, 		MAX_SWAP_IN_RATE BIGINT, 		SUM_SWAP_IN_RATE BIGINT, 		AVG_SWAP_IN_RATE BIGINT, 		MIN_SWAP_OUT_RATE BIGINT, 		MAX_SWAP_OUT_RATE BIGINT, 		SUM_SWAP_OUT_RATE BIGINT, 		AVG_SWAP_OUT_RATE BIGINT, 		MIN_SWAP_TOTAL_RATE BIGINT, 		MAX_SWAP_TOTAL_RATE BIGINT, 		SUM_SWAP_TOTAL_RATE BIGINT, 		AVG_SWAP_TOTAL_RATE BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_MEM_Q ( 		PS_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		PHYSICAL_MEMORY BIGINT, 		MIN_MEMORY_USAGE BIGINT, 		MAX_MEMORY_USAGE BIGINT, 		SUM_MEMORY_USAGE BIGINT, 		AVG_MEMORY_USAGE BIGINT, 		MIN_MEMORY_UTILIZATION BIGINT, 		MAX_MEMORY_UTILIZATION BIGINT, 		SUM_MEMORY_UTILIZATION BIGINT, 		AVG_MEMORY_UTILIZATION BIGINT, 		MIN_ACTIVE_MEMORY BIGINT, 		MAX_ACTIVE_MEMORY BIGINT, 		SUM_ACTIVE_MEMORY BIGINT, 		AVG_ACTIVE_MEMORY BIGINT, 		MIN_GRANTED_MEMORY BIGINT, 		MAX_GRANTED_MEMORY BIGINT, 		SUM_GRANTED_MEMORY BIGINT, 		AVG_GRANTED_MEMORY BIGINT, 		MIN_SWAP_USED BIGINT, 		MAX_SWAP_USED BIGINT, 		SUM_SWAP_USED BIGINT, 		AVG_SWAP_USED BIGINT, 		MIN_FREE_MEM BIGINT, 		MAX_FREE_MEM BIGINT, 		SUM_FREE_MEM BIGINT, 		AVG_FREE_MEM BIGINT, 		MIN_BALLOON_USED BIGINT, 		MAX_BALLOON_USED BIGINT, 		SUM_BALLOON_USED BIGINT, 		AVG_BALLOON_USED BIGINT, 		MIN_SWAP_IN_RATE BIGINT, 		MAX_SWAP_IN_RATE BIGINT, 		SUM_SWAP_IN_RATE BIGINT, 		AVG_SWAP_IN_RATE BIGINT, 		MIN_SWAP_OUT_RATE BIGINT, 		MAX_SWAP_OUT_RATE BIGINT, 		SUM_SWAP_OUT_RATE BIGINT, 		AVG_SWAP_OUT_RATE BIGINT, 		MIN_SWAP_TOTAL_RATE BIGINT, 		MAX_SWAP_TOTAL_RATE BIGINT, 		SUM_SWAP_TOTAL_RATE BIGINT, 		AVG_SWAP_TOTAL_RATE BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_MEM_W ( 		PS_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		PHYSICAL_MEMORY BIGINT, 		MIN_MEMORY_USAGE BIGINT, 		MAX_MEMORY_USAGE BIGINT, 		SUM_MEMORY_USAGE BIGINT, 		AVG_MEMORY_USAGE BIGINT, 		MIN_MEMORY_UTILIZATION BIGINT, 		MAX_MEMORY_UTILIZATION BIGINT, 		SUM_MEMORY_UTILIZATION BIGINT, 		AVG_MEMORY_UTILIZATION BIGINT, 		MIN_ACTIVE_MEMORY BIGINT, 		MAX_ACTIVE_MEMORY BIGINT, 		SUM_ACTIVE_MEMORY BIGINT, 		AVG_ACTIVE_MEMORY BIGINT, 		MIN_GRANTED_MEMORY BIGINT, 		MAX_GRANTED_MEMORY BIGINT, 		SUM_GRANTED_MEMORY BIGINT, 		AVG_GRANTED_MEMORY BIGINT, 		MIN_SWAP_USED BIGINT, 		MAX_SWAP_USED BIGINT, 		SUM_SWAP_USED BIGINT, 		AVG_SWAP_USED BIGINT, 		MIN_FREE_MEM BIGINT, 		MAX_FREE_MEM BIGINT, 		SUM_FREE_MEM BIGINT, 		AVG_FREE_MEM BIGINT, 		MIN_BALLOON_USED BIGINT, 		MAX_BALLOON_USED BIGINT, 		SUM_BALLOON_USED BIGINT, 		AVG_BALLOON_USED BIGINT, 		MIN_SWAP_IN_RATE BIGINT, 		MAX_SWAP_IN_RATE BIGINT, 		SUM_SWAP_IN_RATE BIGINT, 		AVG_SWAP_IN_RATE BIGINT, 		MIN_SWAP_OUT_RATE BIGINT, 		MAX_SWAP_OUT_RATE BIGINT, 		SUM_SWAP_OUT_RATE BIGINT, 		AVG_SWAP_OUT_RATE BIGINT, 		MIN_SWAP_TOTAL_RATE BIGINT, 		MAX_SWAP_TOTAL_RATE BIGINT, 		SUM_SWAP_TOTAL_RATE BIGINT, 		AVG_SWAP_TOTAL_RATE BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_MEM_Y ( 		PS_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		PHYSICAL_MEMORY BIGINT, 		MIN_MEMORY_USAGE BIGINT, 		MAX_MEMORY_USAGE BIGINT, 		SUM_MEMORY_USAGE BIGINT, 		AVG_MEMORY_USAGE BIGINT, 		MIN_MEMORY_UTILIZATION BIGINT, 		MAX_MEMORY_UTILIZATION BIGINT, 		SUM_MEMORY_UTILIZATION BIGINT, 		AVG_MEMORY_UTILIZATION BIGINT, 		MIN_ACTIVE_MEMORY BIGINT, 		MAX_ACTIVE_MEMORY BIGINT, 		SUM_ACTIVE_MEMORY BIGINT, 		AVG_ACTIVE_MEMORY BIGINT, 		MIN_GRANTED_MEMORY BIGINT, 		MAX_GRANTED_MEMORY BIGINT, 		SUM_GRANTED_MEMORY BIGINT, 		AVG_GRANTED_MEMORY BIGINT, 		MIN_SWAP_USED BIGINT, 		MAX_SWAP_USED BIGINT, 		SUM_SWAP_USED BIGINT, 		AVG_SWAP_USED BIGINT, 		MIN_FREE_MEM BIGINT, 		MAX_FREE_MEM BIGINT, 		SUM_FREE_MEM BIGINT, 		AVG_FREE_MEM BIGINT, 		MIN_BALLOON_USED BIGINT, 		MAX_BALLOON_USED BIGINT, 		SUM_BALLOON_USED BIGINT, 		AVG_BALLOON_USED BIGINT, 		MIN_SWAP_IN_RATE BIGINT, 		MAX_SWAP_IN_RATE BIGINT, 		SUM_SWAP_IN_RATE BIGINT, 		AVG_SWAP_IN_RATE BIGINT, 		MIN_SWAP_OUT_RATE BIGINT, 		MAX_SWAP_OUT_RATE BIGINT, 		SUM_SWAP_OUT_RATE BIGINT, 		AVG_SWAP_OUT_RATE BIGINT, 		MIN_SWAP_TOTAL_RATE BIGINT, 		MAX_SWAP_TOTAL_RATE BIGINT, 		SUM_SWAP_TOTAL_RATE BIGINT, 		AVG_SWAP_TOTAL_RATE BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_NETWORK_D ( 		PS_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_NETWORK_H ( 		PS_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_NETWORK_M ( 		PS_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_NETWORK_Q ( 		PS_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_NETWORK_W ( 		PS_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_PS_NETWORK_Y ( 		PS_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_CPU_D ( 		VM_CPU_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		VM_CPU_NUMBER INTEGER, 		MIN_WAIT_TIME BIGINT, 		MAX_WAIT_TIME BIGINT, 		SUM_WAIT_TIME BIGINT, 		AVG_WAIT_TIME BIGINT, 		MIN_USED_TIME BIGINT, 		MAX_USED_TIME BIGINT, 		SUM_USED_TIME BIGINT, 		AVG_USED_TIME BIGINT, 		MIN_READY_TIME BIGINT, 		MAX_READY_TIME BIGINT, 		SUM_READY_TIME BIGINT, 		AVG_READY_TIME BIGINT, 		MIN_SYS_TIME BIGINT, 		MAX_SYS_TIME BIGINT, 		SUM_SYS_TIME BIGINT, 		AVG_SYS_TIME BIGINT, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		MIN_PERCENT_READY INTEGER, 		MAX_PERCENT_READY INTEGER, 		SUM_PERCENT_READY INTEGER, 		AVG_PERCENT_READY INTEGER, 		IN_USER_TIME BIGINT, 		MAX_USER_TIME BIGINT, 		SUM_USER_TIME BIGINT, 		AVG_USER_TIME BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_CPU_H ( 		VM_CPU_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		VM_CPU_NUMBER INTEGER, 		MIN_WAIT_TIME BIGINT, 		MAX_WAIT_TIME BIGINT, 		SUM_WAIT_TIME BIGINT, 		AVG_WAIT_TIME BIGINT, 		MIN_USED_TIME BIGINT, 		MAX_USED_TIME BIGINT, 		SUM_USED_TIME BIGINT, 		AVG_USED_TIME BIGINT, 		MIN_READY_TIME BIGINT, 		MAX_READY_TIME BIGINT, 		SUM_READY_TIME BIGINT, 		AVG_READY_TIME BIGINT, 		MIN_SYS_TIME BIGINT, 		MAX_SYS_TIME BIGINT, 		SUM_SYS_TIME BIGINT, 		AVG_SYS_TIME BIGINT, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		MIN_PERCENT_READY INTEGER, 		MAX_PERCENT_READY INTEGER, 		SUM_PERCENT_READY INTEGER, 		AVG_PERCENT_READY INTEGER, 		IN_USER_TIME BIGINT, 		MAX_USER_TIME BIGINT, 		SUM_USER_TIME BIGINT, 		AVG_USER_TIME BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_CPU_M ( 		VM_CPU_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		VM_CPU_NUMBER INTEGER, 		MIN_WAIT_TIME BIGINT, 		MAX_WAIT_TIME BIGINT, 		SUM_WAIT_TIME BIGINT, 		AVG_WAIT_TIME BIGINT, 		MIN_USED_TIME BIGINT, 		MAX_USED_TIME BIGINT, 		SUM_USED_TIME BIGINT, 		AVG_USED_TIME BIGINT, 		MIN_READY_TIME BIGINT, 		MAX_READY_TIME BIGINT, 		SUM_READY_TIME BIGINT, 		AVG_READY_TIME BIGINT, 		MIN_SYS_TIME BIGINT, 		MAX_SYS_TIME BIGINT, 		SUM_SYS_TIME BIGINT, 		AVG_SYS_TIME BIGINT, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		MIN_PERCENT_READY INTEGER, 		MAX_PERCENT_READY INTEGER, 		SUM_PERCENT_READY INTEGER, 		AVG_PERCENT_READY INTEGER, 		IN_USER_TIME BIGINT, 		MAX_USER_TIME BIGINT, 		SUM_USER_TIME BIGINT, 		AVG_USER_TIME BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_CPU_Q ( 		VM_CPU_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		VM_CPU_NUMBER INTEGER, 		MIN_WAIT_TIME BIGINT, 		MAX_WAIT_TIME BIGINT, 		SUM_WAIT_TIME BIGINT, 		AVG_WAIT_TIME BIGINT, 		MIN_USED_TIME BIGINT, 		MAX_USED_TIME BIGINT, 		SUM_USED_TIME BIGINT, 		AVG_USED_TIME BIGINT, 		MIN_READY_TIME BIGINT, 		MAX_READY_TIME BIGINT, 		SUM_READY_TIME BIGINT, 		AVG_READY_TIME BIGINT, 		MIN_SYS_TIME BIGINT, 		MAX_SYS_TIME BIGINT, 		SUM_SYS_TIME BIGINT, 		AVG_SYS_TIME BIGINT, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		MIN_PERCENT_READY INTEGER, 		MAX_PERCENT_READY INTEGER, 		SUM_PERCENT_READY INTEGER, 		AVG_PERCENT_READY INTEGER, 		IN_USER_TIME BIGINT, 		MAX_USER_TIME BIGINT, 		SUM_USER_TIME BIGINT, 		AVG_USER_TIME BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_CPU_W ( 		VM_CPU_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		VM_CPU_NUMBER INTEGER, 		MIN_WAIT_TIME BIGINT, 		MAX_WAIT_TIME BIGINT, 		SUM_WAIT_TIME BIGINT, 		AVG_WAIT_TIME BIGINT, 		MIN_USED_TIME BIGINT, 		MAX_USED_TIME BIGINT, 		SUM_USED_TIME BIGINT, 		AVG_USED_TIME BIGINT, 		MIN_READY_TIME BIGINT, 		MAX_READY_TIME BIGINT, 		SUM_READY_TIME BIGINT, 		AVG_READY_TIME BIGINT, 		MIN_SYS_TIME BIGINT, 		MAX_SYS_TIME BIGINT, 		SUM_SYS_TIME BIGINT, 		AVG_SYS_TIME BIGINT, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		MIN_PERCENT_READY INTEGER, 		MAX_PERCENT_READY INTEGER, 		SUM_PERCENT_READY INTEGER, 		AVG_PERCENT_READY INTEGER, 		IN_USER_TIME BIGINT, 		MAX_USER_TIME BIGINT, 		SUM_USER_TIME BIGINT, 		AVG_USER_TIME BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_CPU_Y ( 		VM_CPU_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		VM_CPU_NUMBER INTEGER, 		MIN_WAIT_TIME BIGINT, 		MAX_WAIT_TIME BIGINT, 		SUM_WAIT_TIME BIGINT, 		AVG_WAIT_TIME BIGINT, 		MIN_USED_TIME BIGINT, 		MAX_USED_TIME BIGINT, 		SUM_USED_TIME BIGINT, 		AVG_USED_TIME BIGINT, 		MIN_READY_TIME BIGINT, 		MAX_READY_TIME BIGINT, 		SUM_READY_TIME BIGINT, 		AVG_READY_TIME BIGINT, 		MIN_SYS_TIME BIGINT, 		MAX_SYS_TIME BIGINT, 		SUM_SYS_TIME BIGINT, 		AVG_SYS_TIME BIGINT, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		MIN_PERCENT_READY INTEGER, 		MAX_PERCENT_READY INTEGER, 		SUM_PERCENT_READY INTEGER, 		AVG_PERCENT_READY INTEGER, 		IN_USER_TIME BIGINT, 		MAX_USER_TIME BIGINT, 		SUM_USER_TIME BIGINT, 		AVG_USER_TIME BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_DATA_STORE_D ( 		VM_DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_DATA_STORE_H ( 		VM_DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_DATA_STORE_M ( 		VM_DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_DATA_STORE_Q ( 		VM_DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_DATA_STORE_W ( 		VM_DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_DATA_STORE_Y ( 		VM_DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_MEM_D ( 		VM_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_HOST_USAGE BIGINT, 		MAX_HOST_USAGE BIGINT, 		SUM_HOST_USAGE BIGINT, 		AVG_HOST_USAGE BIGINT, 		MIN_GUEST_USAGE BIGINT, 		MAX_GUEST_USAGE BIGINT, 		SUM_GUEST_USAGE BIGINT, 		AVG_GUEST_USAGE BIGINT, 		MIN_HOST_UTILIZATION BIGINT, 		MAX_HOST_UTILIZATION BIGINT, 		SUM_HOST_UTILIZATION BIGINT, 		AVG_HOST_UTILIZATION BIGINT, 		MIN_GUEST_UTILIZATION BIGINT, 		MAX_GUEST_UTILIZATION BIGINT, 		SUM_GUEST_UTILIZATION BIGINT, 		AVG_GUEST_UTILIZATION BIGINT, 		MIN_HOST_FREE BIGINT, 		MAX_HOST_FREE BIGINT, 		SUM_HOST_FREE BIGINT, 		AVG_HOST_FREE BIGINT, 		MIN_GUEST_FREE BIGINT, 		MAX_GUEST_FREE BIGINT, 		SUM_GUEST_FREE BIGINT, 		AVG_GUEST_FREE BIGINT, 		MIN_BALLOON_USAGE BIGINT, 		MAX_BALLOON_USAGE BIGINT, 		SUM_BALLOON_USAGE BIGINT, 		AVG_BALLOON_USAGE BIGINT, 		MIN_SWAP_TO_FILE BIGINT, 		MAX_SWAP_TO_FILE BIGINT, 		SUM_SWAP_TO_FILE BIGINT, 		AVG_SWAP_TO_FILE BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_MEM_H ( 		VM_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_HOST_USAGE BIGINT, 		MAX_HOST_USAGE BIGINT, 		SUM_HOST_USAGE BIGINT, 		AVG_HOST_USAGE BIGINT, 		MIN_GUEST_USAGE BIGINT, 		MAX_GUEST_USAGE BIGINT, 		SUM_GUEST_USAGE BIGINT, 		AVG_GUEST_USAGE BIGINT, 		MIN_HOST_UTILIZATION BIGINT, 		MAX_HOST_UTILIZATION BIGINT, 		SUM_HOST_UTILIZATION BIGINT, 		AVG_HOST_UTILIZATION BIGINT, 		MIN_GUEST_UTILIZATION BIGINT, 		MAX_GUEST_UTILIZATION BIGINT, 		SUM_GUEST_UTILIZATION BIGINT, 		AVG_GUEST_UTILIZATION BIGINT, 		MIN_HOST_FREE BIGINT, 		MAX_HOST_FREE BIGINT, 		SUM_HOST_FREE BIGINT, 		AVG_HOST_FREE BIGINT, 		MIN_GUEST_FREE BIGINT, 		MAX_GUEST_FREE BIGINT, 		SUM_GUEST_FREE BIGINT, 		AVG_GUEST_FREE BIGINT, 		MIN_BALLOON_USAGE BIGINT, 		MAX_BALLOON_USAGE BIGINT, 		SUM_BALLOON_USAGE BIGINT, 		AVG_BALLOON_USAGE BIGINT, 		MIN_SWAP_TO_FILE BIGINT, 		MAX_SWAP_TO_FILE BIGINT, 		SUM_SWAP_TO_FILE BIGINT, 		AVG_SWAP_TO_FILE BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_MEM_M ( 		VM_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_HOST_USAGE BIGINT, 		MAX_HOST_USAGE BIGINT, 		SUM_HOST_USAGE BIGINT, 		AVG_HOST_USAGE BIGINT, 		MIN_GUEST_USAGE BIGINT, 		MAX_GUEST_USAGE BIGINT, 		SUM_GUEST_USAGE BIGINT, 		AVG_GUEST_USAGE BIGINT, 		MIN_HOST_UTILIZATION BIGINT, 		MAX_HOST_UTILIZATION BIGINT, 		SUM_HOST_UTILIZATION BIGINT, 		AVG_HOST_UTILIZATION BIGINT, 		MIN_GUEST_UTILIZATION BIGINT, 		MAX_GUEST_UTILIZATION BIGINT, 		SUM_GUEST_UTILIZATION BIGINT, 		AVG_GUEST_UTILIZATION BIGINT, 		MIN_HOST_FREE BIGINT, 		MAX_HOST_FREE BIGINT, 		SUM_HOST_FREE BIGINT, 		AVG_HOST_FREE BIGINT, 		MIN_GUEST_FREE BIGINT, 		MAX_GUEST_FREE BIGINT, 		SUM_GUEST_FREE BIGINT, 		AVG_GUEST_FREE BIGINT, 		MIN_BALLOON_USAGE BIGINT, 		MAX_BALLOON_USAGE BIGINT, 		SUM_BALLOON_USAGE BIGINT, 		AVG_BALLOON_USAGE BIGINT, 		MIN_SWAP_TO_FILE BIGINT, 		MAX_SWAP_TO_FILE BIGINT, 		SUM_SWAP_TO_FILE BIGINT, 		AVG_SWAP_TO_FILE BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_MEM_Q ( 		VM_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_HOST_USAGE BIGINT, 		MAX_HOST_USAGE BIGINT, 		SUM_HOST_USAGE BIGINT, 		AVG_HOST_USAGE BIGINT, 		MIN_GUEST_USAGE BIGINT, 		MAX_GUEST_USAGE BIGINT, 		SUM_GUEST_USAGE BIGINT, 		AVG_GUEST_USAGE BIGINT, 		MIN_HOST_UTILIZATION BIGINT, 		MAX_HOST_UTILIZATION BIGINT, 		SUM_HOST_UTILIZATION BIGINT, 		AVG_HOST_UTILIZATION BIGINT, 		MIN_GUEST_UTILIZATION BIGINT, 		MAX_GUEST_UTILIZATION BIGINT, 		SUM_GUEST_UTILIZATION BIGINT, 		AVG_GUEST_UTILIZATION BIGINT, 		MIN_HOST_FREE BIGINT, 		MAX_HOST_FREE BIGINT, 		SUM_HOST_FREE BIGINT, 		AVG_HOST_FREE BIGINT, 		MIN_GUEST_FREE BIGINT, 		MAX_GUEST_FREE BIGINT, 		SUM_GUEST_FREE BIGINT, 		AVG_GUEST_FREE BIGINT, 		MIN_BALLOON_USAGE BIGINT, 		MAX_BALLOON_USAGE BIGINT, 		SUM_BALLOON_USAGE BIGINT, 		AVG_BALLOON_USAGE BIGINT, 		MIN_SWAP_TO_FILE BIGINT, 		MAX_SWAP_TO_FILE BIGINT, 		SUM_SWAP_TO_FILE BIGINT, 		AVG_SWAP_TO_FILE BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_MEM_W ( 		VM_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_HOST_USAGE BIGINT, 		MAX_HOST_USAGE BIGINT, 		SUM_HOST_USAGE BIGINT, 		AVG_HOST_USAGE BIGINT, 		MIN_GUEST_USAGE BIGINT, 		MAX_GUEST_USAGE BIGINT, 		SUM_GUEST_USAGE BIGINT, 		AVG_GUEST_USAGE BIGINT, 		MIN_HOST_UTILIZATION BIGINT, 		MAX_HOST_UTILIZATION BIGINT, 		SUM_HOST_UTILIZATION BIGINT, 		AVG_HOST_UTILIZATION BIGINT, 		MIN_GUEST_UTILIZATION BIGINT, 		MAX_GUEST_UTILIZATION BIGINT, 		SUM_GUEST_UTILIZATION BIGINT, 		AVG_GUEST_UTILIZATION BIGINT, 		MIN_HOST_FREE BIGINT, 		MAX_HOST_FREE BIGINT, 		SUM_HOST_FREE BIGINT, 		AVG_HOST_FREE BIGINT, 		MIN_GUEST_FREE BIGINT, 		MAX_GUEST_FREE BIGINT, 		SUM_GUEST_FREE BIGINT, 		AVG_GUEST_FREE BIGINT, 		MIN_BALLOON_USAGE BIGINT, 		MAX_BALLOON_USAGE BIGINT, 		SUM_BALLOON_USAGE BIGINT, 		AVG_BALLOON_USAGE BIGINT, 		MIN_SWAP_TO_FILE BIGINT, 		MAX_SWAP_TO_FILE BIGINT, 		SUM_SWAP_TO_FILE BIGINT, 		AVG_SWAP_TO_FILE BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_MEM_Y ( 		VM_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_HOST_USAGE BIGINT, 		MAX_HOST_USAGE BIGINT, 		SUM_HOST_USAGE BIGINT, 		AVG_HOST_USAGE BIGINT, 		MIN_GUEST_USAGE BIGINT, 		MAX_GUEST_USAGE BIGINT, 		SUM_GUEST_USAGE BIGINT, 		AVG_GUEST_USAGE BIGINT, 		MIN_HOST_UTILIZATION BIGINT, 		MAX_HOST_UTILIZATION BIGINT, 		SUM_HOST_UTILIZATION BIGINT, 		AVG_HOST_UTILIZATION BIGINT, 		MIN_GUEST_UTILIZATION BIGINT, 		MAX_GUEST_UTILIZATION BIGINT, 		SUM_GUEST_UTILIZATION BIGINT, 		AVG_GUEST_UTILIZATION BIGINT, 		MIN_HOST_FREE BIGINT, 		MAX_HOST_FREE BIGINT, 		SUM_HOST_FREE BIGINT, 		AVG_HOST_FREE BIGINT, 		MIN_GUEST_FREE BIGINT, 		MAX_GUEST_FREE BIGINT, 		SUM_GUEST_FREE BIGINT, 		AVG_GUEST_FREE BIGINT, 		MIN_BALLOON_USAGE BIGINT, 		MAX_BALLOON_USAGE BIGINT, 		SUM_BALLOON_USAGE BIGINT, 		AVG_BALLOON_USAGE BIGINT, 		MIN_SWAP_TO_FILE BIGINT, 		MAX_SWAP_TO_FILE BIGINT, 		SUM_SWAP_TO_FILE BIGINT, 		AVG_SWAP_TO_FILE BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_NETWORK_D ( 		VM_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_NETWORK_H ( 		VM_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_NETWORK_M ( 		VM_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_NETWORK_Q ( 		VM_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_NETWORK_W ( 		VM_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@

CREATE TABLE MES_VM_NETWORK_Y ( 		VM_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16)) 	DATA CAPTURE NONE@



CREATE TABLE VM_PROFILES (
VM_PROFILE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20),
NAME VARCHAR(256) NOT NULL,
ARCHITECTURE VARCHAR(256),
CPU_ALLOCATION BIGINT,
MEMORY_ALLOCATION BIGINT,
NUM_VCPUS INTEGER,
CPU_USAGE BIGINT,
MEMORY_USAGE BIGINT,
STORAGE_USAGE BIGINT,
NETWORK_USAGE BIGINT,
OPERATING_SYSTEM VARCHAR(256),
APPLICATION VARCHAR(256)
) 	DATA CAPTURE NONE@


CREATE TABLE USAGE_PROFILES (
USAGE_PROFILE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20),
NAME VARCHAR(256) NOT NULL,
CPU_SUMM_TYPE VARCHAR(48),
CPU_SUMM_MODE VARCHAR(48),
CPU_SUMM_TIME VARCHAR(256),
CPU_GROWTH_PERC BIGINT,
MEM_SUMM_TYPE VARCHAR(48),
MEM_SUMM_MODE VARCHAR(48),
MEM_SUMM_TIME VARCHAR(256),
MEM_GROWTH_PERC BIGINT,
STORAGE_SUMM_TYPE VARCHAR(48),
STORAGE_SUMM_MODE VARCHAR(48),
STORAGE_SUMM_TIME VARCHAR(256),
STORAGE_GROWTH_PERC BIGINT,
NETWORK_SUMM_TYPE VARCHAR(48),
NETWORK_SUMM_MODE VARCHAR(48),
NETWORK_SUMM_TIME VARCHAR(256),
NETWORK_GROWTH_PERC BIGINT
) 	DATA CAPTURE NONE@


CREATE TABLE PLACEMENT_PROFILES (
PL_PROFILE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20),
NAME VARCHAR(256) NOT NULL,
GOAL INT,
INCREMENTAL INTEGER,
POLICIES VARCHAR(256)
) 	DATA CAPTURE NONE@


CREATE TABLE AUDIT_LOG (
AUDIT_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20),
START_TIMESTAMP BIGINT,
END_TIMESTAMP BIGINT,
OP_CODE VARCHAR(32),
DATA_1 INTEGER,
DATA_2 INTEGER,
STATUS INTEGER
) 	DATA CAPTURE NONE@

CREATE TABLE USER_LOCKS(
 USER_LOCK_PK BIGINT NOT NULL GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1, CACHE 20, NO MINVALUE, NO MAXVALUE, NO CYCLE, NO ORDER),
 USER_ID VARCHAR(256) NOT NULL,
 HYPERVISOR VARCHAR(256) NOT NULL,
 LOCK_SESSION_ID VARCHAR(256) NOT NULL,
 TIMESTAMP TIMESTAMP
) DATA CAPTURE NONE@

ALTER TABLE CFG_PHYSICAL_SERVER ADD CONSTRAINT CFG_PHYSICAL_SERVER_PK PRIMARY KEY 	(PHYSICAL_SERVER_PK)@

ALTER TABLE CFG_VIRTUAL_MACHINE ADD CONSTRAINT CFG_VIRTUAL_MACHINE_PK PRIMARY KEY 	(VIRTUAL_MACHINE_PK)@

ALTER TABLE CFG_NETWORK ADD CONSTRAINT CFG_NETWORK_PK PRIMARY KEY 	(NETWORK_PK)@

ALTER TABLE CFG_ENCLOSURE ADD CONSTRAINT CFG_ENCLOSURE_PK PRIMARY KEY 	(ENCLOSURE_PK)@

ALTER TABLE CFG_IP_INTERFACE ADD CONSTRAINT CFG_IP_INTERFACE_PK PRIMARY KEY 	(IP_INTERFACE_PK)@

ALTER TABLE ANL_RESOURCE_DEMAND ADD CONSTRAINT ANL_RESOURCE_DEMAND_PK PRIMARY KEY 	(RESOURCE_DEMAND_KEY)@

ALTER TABLE ANL_CORRELATION_GROUPS ADD CONSTRAINT ANL_CORR_GRP_PK PRIMARY KEY 	(ANL_CORRELATION_GROUPS_PK)@

ALTER TABLE CFG_CORRELATION_BRACKETS ADD CONSTRAINT CFG_CORR_BRACKET_PK PRIMARY KEY 	(CFG_BRACKETS_PK)@

ALTER TABLE KBS_FP_CUSTOMER_SPECIFIC ADD CONSTRAINT KBS_FP_CUSTOMER_SPECIFIC_PK PRIMARY KEY 	(FP_CUSTOMER_SPECIFIC_PK)@

ALTER TABLE KBS_FP_HYPERVISOR ADD CONSTRAINT KBS_FP_HYPERVISOR_PK PRIMARY KEY 	(FP_HYPERVISOR_PK)@

ALTER TABLE KBS_FP_PVU ADD CONSTRAINT KBS_FP_PVU_PK PRIMARY KEY 	(FP_PVU_PK)@

ALTER TABLE KBS_IDEAS_RPE_MODEL ADD CONSTRAINT KBS_IDEAS_RPE_MODEL_PK PRIMARY KEY 	(IDEAS_RPE_MODEL_PK)@

ALTER TABLE KBS_SERVER_MODEL_CATALOG ADD CONSTRAINT KBS_SERVER_MODEL_CATALOG_PK PRIMARY KEY 	(SERVER_MODEL_CATALOG_PK)@

ALTER TABLE KBS_VIRTUALIZATION_OVERHEAD ADD CONSTRAINT KBS_VIRTUALIZATION_OVERHEAD_PK PRIMARY KEY 	(VIRTUALIZATION_OVERHEAD_PK)@

ALTER TABLE KBS_DC_PROFILE_CAPACITY_UTILIZATION ADD CONSTRAINT DC_PROFILE_CAPACITY_UTILIZATION_PK PRIMARY KEY 	(DC_PROF_CAP_UTIL_PK)@

ALTER TABLE KBS_DC_PROFILE_COST ADD CONSTRAINT DC_PROFILE_COST_PK PRIMARY KEY 	(DC_PROF_COST_PK)@

ALTER TABLE KBS_DC_PROFILE_STORAGE ADD CONSTRAINT DC_PROFILE_STORAGE_PK PRIMARY KEY 	(DC_PROF_STORAGE_PK)@

ALTER TABLE KBS_DC_SUMMARY ADD CONSTRAINT DC_SUMMARY_PK PRIMARY KEY 	(DC_PK)@

ALTER TABLE KBS_IDEAS_OTHER ADD CONSTRAINT KBS_IDEAS_OTHER_PK PRIMARY KEY 	(IDEAS_OTHER_PK)@

ALTER TABLE KBS_IDEAS_RISC_IPF ADD CONSTRAINT KBS_IDEAS_RISC_IPF_PK PRIMARY KEY 	(IDEAS_RISC_IPF_PK)@

ALTER TABLE KBS_IDEAS_X86_IPF ADD CONSTRAINT KBS_IDEAS_X86_IPF_PK PRIMARY KEY 	(IDEAS_X86_IPF_PK)@

ALTER TABLE KBS_ZSERIES_MIPS ADD CONSTRAINT KBS_ZSERIES_MIPS_PK PRIMARY KEY 	(ZSERIES_MIPS_PK)@

ALTER TABLE CFG_OPERATING_SYSTEM ADD CONSTRAINT CFG_OPERATING_SYSTEM_PK PRIMARY KEY 	(OS_PK)@

ALTER TABLE CFG_SOFTWARE ADD CONSTRAINT CFG_SOFTWARE_PK PRIMARY KEY 	(SOFTWARE_PK)@

ALTER TABLE KBS_MISSING_SERVER_BENCHMARK ADD CONSTRAINT KBS_MISSING_SERVER_BENCHMARK_PK PRIMARY KEY 	(MISSING_SERVER_BENCHMARK_PK)@

ALTER TABLE ANL_APP_TAG_MAP ADD CONSTRAINT APPTAGMAP_PK PRIMARY KEY 	(APP_TAG_MAP_PK)@

ALTER TABLE ANL_APP_TAG_MAP ADD CONSTRAINT APPTAGMAPUQ UNIQUE 	(SOFTWARE_PK, 	 SERVER_TAGS_PK)@

ALTER TABLE ANL_SERVER_TAG_MAP ADD CONSTRAINT SERVERTAGMAP_PK PRIMARY KEY 	(SERVER_TAG_MAP_PK)@

ALTER TABLE ANL_SERVER_TAG_MAP ADD CONSTRAINT SERVERTAGPHYSICALSERVERDIMUQ UNIQUE 	(PHYSICAL_SERVER_PK, 	 SERVER_TAGS_PK)@

ALTER TABLE ANL_SERVER_TAGS ADD CONSTRAINT SERVER_TAGS_PK PRIMARY KEY 	(SERVER_TAGS_PK)@

ALTER TABLE ANL_SERVER_TAGS ADD CONSTRAINT TAGNAMETAGTYPE UNIQUE 	(TAG_NAME, 	 TAG_TYPE)@

ALTER TABLE ANL_MATCHED_SERVER_CATALOG ADD CONSTRAINT ANL_MATCHED_SERVER_CATALOG_PK PRIMARY KEY 	(MATCHED_SERVER_CATALOG_PK)@

ALTER TABLE ANL_TARGET_DESIGN ADD CONSTRAINT ANL_TARGET_DESIGN_PK PRIMARY KEY 	(TARGET_DESIGN_PK)@

ALTER TABLE CFG_NIC ADD CONSTRAINT CFG_NIC_PK PRIMARY KEY 	(NIC_PK)@

ALTER TABLE CFG_FILE_SYSTEM ADD CONSTRAINT CFG_FILE_SYSTEM_PK PRIMARY KEY 	(FILE_SYSTEM_PK)@

ALTER TABLE CFG_DATA_STORE ADD CONSTRAINT CFG_DATA_STORE_PK PRIMARY KEY 	(DATA_STORE_PK)@

ALTER TABLE CFG_STORAGE_VOLUME ADD CONSTRAINT CFG_STORAGE_VOLUME_PK PRIMARY KEY 	(STORAGE_VOLUME_KEY)@

ALTER TABLE COLOCATIONRULES ADD CONSTRAINT COLOCATIONRULES_PK PRIMARY KEY 	(COLOCATIONRULES_PK)@

ALTER TABLE RULEDIM ADD CONSTRAINT RULEDIM_PK PRIMARY KEY 	(RULEDIMKEY)@

ALTER TABLE ANL_IDEAS_MATCHED_SERVER_CATALOG ADD CONSTRAINT ANL_MATCHED_SERVER_CATALOG_PK PRIMARY KEY 	(MATCHED_SERVER_CATALOG_PK)@

ALTER TABLE CFG_DATA_STORE_TO_PHYSICAL_SERVER_MAP ADD CONSTRAINT CFG_DATA_STORE_TO_SERVER_MAP_PK PRIMARY KEY 	(DS_PS_MAP_PK)@

ALTER TABLE ANL_VIRTUAL_MACHINE_TAG_MAP ADD CONSTRAINT ANL_VM_TAG_MAP_PK PRIMARY KEY 	(VIRTUAL_MACHINE_TAG_MAP_PK)@

ALTER TABLE ANL_SOFTWARE_TAG_MAP ADD CONSTRAINT ANL_SOFTWARE_TAG_MAP_PK PRIMARY KEY 	(SOFTWARE_TAG_MAP_PK)@

ALTER TABLE MES_PS_CPU ADD CONSTRAINT MES_PS_CPU_PK PRIMARY KEY 	(PS_CPU_PK)@

ALTER TABLE MES_VM_CPU ADD CONSTRAINT MES_VM_CPU_PK PRIMARY KEY 	(VM_CPU_PK)@

ALTER TABLE MES_PS_MEM ADD CONSTRAINT MES_PS_MEM_PK PRIMARY KEY 	(PS_MEM_PK)@

ALTER TABLE MES_VM_MEM ADD CONSTRAINT MES_VM_MEM_PK PRIMARY KEY 	(VM_MEM_PK)@

ALTER TABLE MES_DATA_STORE ADD CONSTRAINT MES_PS_DATA_STORE_PK PRIMARY KEY 	(DATA_STORE_PK)@

ALTER TABLE MES_VM_DATA_STORE ADD CONSTRAINT MES_VM_DATA_STORE_PK PRIMARY KEY 	(VM_DATA_STORE_PK)@

ALTER TABLE MES_PS_DISK ADD CONSTRAINT MES_PS_DISK_PK PRIMARY KEY 	(PS_DISK_PK)@

ALTER TABLE MES_PS_NETWORK ADD CONSTRAINT MES_PS_NETWORK_PK PRIMARY KEY 	(PS_NETWORK_PK)@

ALTER TABLE MES_VM_NETWORK ADD CONSTRAINT MES_VM_NETWORK_PK PRIMARY KEY 	(VM_NETWORK_PK)@

ALTER TABLE CFG_DATA_STORE_TO_STORAGE_VOLUME_MAP ADD CONSTRAINT CFG_DATA_STORE_STORAGE_VOLUME_MAP_PK PRIMARY KEY 	(DS_SV_MAP_PK)@

ALTER TABLE CFG_DATA_STORE_TO_VIRTUAL_MACHINE_MAP ADD CONSTRAINT CFG_DATA_STORE_TO_VIRTUAL_MACHINE_MAP_PK PRIMARY KEY 	(DS_VM_MAP_PK)@

ALTER TABLE CFG_USER_CONFIGURATION ADD CONSTRAINT CFG_USER_CONFIGURATION_PK PRIMARY KEY 	(USER_CONFIGURATION_PK)@

ALTER TABLE CFG_HBA ADD CONSTRAINT CFG_HBA_PK PRIMARY KEY 	(HBA_PK)@

ALTER TABLE MES_DATA_STORE_D ADD CONSTRAINT MES_DATA_STORE_D_PK PRIMARY KEY 	(DATA_STORE_PK)@

ALTER TABLE MES_DATA_STORE_H ADD CONSTRAINT MES_DATA_STORE_H_PK PRIMARY KEY 	(DATA_STORE_PK)@

ALTER TABLE MES_DATA_STORE_M ADD CONSTRAINT MES_DATA_STORE_M_PK PRIMARY KEY 	(DATA_STORE_PK)@

ALTER TABLE MES_DATA_STORE_Q ADD CONSTRAINT MES_DATA_STORE_Q_PK PRIMARY KEY 	(DATA_STORE_PK)@

ALTER TABLE MES_DATA_STORE_W ADD CONSTRAINT MES_DATA_STORE_W_PK PRIMARY KEY 	(DATA_STORE_PK)@

ALTER TABLE MES_PS_CPU_D ADD CONSTRAINT MES_PS_CPU_D_PK PRIMARY KEY 	(PS_CPU_PK)@

ALTER TABLE MES_PS_CPU_H ADD CONSTRAINT MES_PS_CPU_H_PK PRIMARY KEY 	(PS_CPU_PK)@

ALTER TABLE MES_PS_CPU_M ADD CONSTRAINT MES_PS_CPU_M_PK PRIMARY KEY 	(PS_CPU_PK)@

ALTER TABLE MES_PS_CPU_Q ADD CONSTRAINT MES_PS_CPU_Q_PK PRIMARY KEY 	(PS_CPU_PK)@

ALTER TABLE MES_PS_CPU_W ADD CONSTRAINT MES_PS_CPU_W_PK PRIMARY KEY 	(PS_CPU_PK)@

ALTER TABLE MES_PS_DISK_D ADD CONSTRAINT MES_PS_DISK_D_PK PRIMARY KEY 	(PS_DISK_PK)@

ALTER TABLE MES_PS_DISK_H ADD CONSTRAINT MES_PS_DISK_H_PK PRIMARY KEY 	(PS_DISK_PK)@

ALTER TABLE MES_PS_DISK_Q ADD CONSTRAINT MES_PS_DISK_Q_PK PRIMARY KEY 	(PS_DISK_PK)@

ALTER TABLE MES_PS_DISK_W ADD CONSTRAINT MES_PS_DISK_W_PK PRIMARY KEY 	(PS_DISK_PK)@

ALTER TABLE MES_PS_MEM_D ADD CONSTRAINT MES_PS_MEM_D_PK PRIMARY KEY 	(PS_MEM_PK)@

ALTER TABLE MES_PS_MEM_H ADD CONSTRAINT MES_PS_MEM_H_PK PRIMARY KEY 	(PS_MEM_PK)@

ALTER TABLE MES_PS_MEM_M ADD CONSTRAINT MES_PS_MEM_M_PK PRIMARY KEY 	(PS_MEM_PK)@

ALTER TABLE MES_PS_MEM_Q ADD CONSTRAINT MES_PS_MEM_Q_PK PRIMARY KEY 	(PS_MEM_PK)@

ALTER TABLE MES_PS_MEM_W ADD CONSTRAINT MES_PS_MEM_W_PK PRIMARY KEY 	(PS_MEM_PK)@

ALTER TABLE MES_PS_NETWORK_D ADD CONSTRAINT MES_PS_NETWORK_D_PK PRIMARY KEY 	(PS_NETWORK_PK)@

ALTER TABLE MES_PS_NETWORK_H ADD CONSTRAINT MES_PS_NETWORK_H_PK PRIMARY KEY 	(PS_NETWORK_PK)@

ALTER TABLE MES_PS_NETWORK_M ADD CONSTRAINT MES_PS_NETWORK_M_PK PRIMARY KEY 	(PS_NETWORK_PK)@

ALTER TABLE MES_PS_NETWORK_Q ADD CONSTRAINT MES_PS_NETWORK_Q_PK PRIMARY KEY 	(PS_NETWORK_PK)@

ALTER TABLE MES_PS_NETWORK_W ADD CONSTRAINT MES_PS_NETWORK_W_PK PRIMARY KEY 	(PS_NETWORK_PK)@

ALTER TABLE MES_VM_CPU_D ADD CONSTRAINT MES_VM_CPU_H_PK PRIMARY KEY 	(VM_CPU_PK)@

ALTER TABLE MES_VM_CPU_H ADD CONSTRAINT MES_VM_CPU_H_PK PRIMARY KEY 	(VM_CPU_PK)@

ALTER TABLE MES_VM_CPU_M ADD CONSTRAINT MES_VM_CPU_M_PK PRIMARY KEY 	(VM_CPU_PK)@

ALTER TABLE MES_VM_CPU_Q ADD CONSTRAINT MES_VM_CPU_Q_PK PRIMARY KEY 	(VM_CPU_PK)@

ALTER TABLE MES_VM_CPU_W ADD CONSTRAINT MES_VM_CPU_W_PK PRIMARY KEY 	(VM_CPU_PK)@

ALTER TABLE MES_VM_DATA_STORE_D ADD CONSTRAINT MES_VM_DATA_STORE_D_PK PRIMARY KEY 	(VM_DATA_STORE_PK)@

ALTER TABLE MES_VM_DATA_STORE_H ADD CONSTRAINT MES_VM_DATA_STORE_H_PK PRIMARY KEY 	(VM_DATA_STORE_PK)@

ALTER TABLE MES_VM_DATA_STORE_M ADD CONSTRAINT MES_VM_DATA_STORE_M_PK PRIMARY KEY 	(VM_DATA_STORE_PK)@

ALTER TABLE MES_VM_DATA_STORE_Q ADD CONSTRAINT MES_VM_DATA_STORE_Q_PK PRIMARY KEY 	(VM_DATA_STORE_PK)@

ALTER TABLE MES_VM_DATA_STORE_W ADD CONSTRAINT MES_VM_DATA_STORE_W_PK PRIMARY KEY 	(VM_DATA_STORE_PK)@

ALTER TABLE MES_VM_MEM_D ADD CONSTRAINT MES_VM_MEM_D_PK PRIMARY KEY 	(VM_MEM_PK)@

ALTER TABLE MES_VM_MEM_H ADD CONSTRAINT MES_VM_MEM_H_PK PRIMARY KEY 	(VM_MEM_PK)@

ALTER TABLE MES_VM_MEM_M ADD CONSTRAINT MES_VM_MEM_M_PK PRIMARY KEY 	(VM_MEM_PK)@

ALTER TABLE MES_VM_MEM_Q ADD CONSTRAINT MES_VM_MEM_Q_PK PRIMARY KEY 	(VM_MEM_PK)@

ALTER TABLE MES_VM_MEM_W ADD CONSTRAINT MES_VM_MEM_W_PK PRIMARY KEY 	(VM_MEM_PK)@

ALTER TABLE MES_VM_NETWORK_D ADD CONSTRAINT MES_VM_NETWORK_D_PK PRIMARY KEY 	(VM_NETWORK_PK)@

ALTER TABLE MES_VM_NETWORK_H ADD CONSTRAINT MES_VM_NETWORK_H_PK PRIMARY KEY 	(VM_NETWORK_PK)@

ALTER TABLE MES_VM_NETWORK_M ADD CONSTRAINT MES_VM_NETWORK_M_PK PRIMARY KEY 	(VM_NETWORK_PK)@

ALTER TABLE MES_VM_NETWORK_Q ADD CONSTRAINT MES_VM_NETWORK_Q_PK PRIMARY KEY 	(VM_NETWORK_PK)@

ALTER TABLE MES_VM_NETWORK_W ADD CONSTRAINT MES_VM_NETWORK_W_PK PRIMARY KEY 	(VM_NETWORK_PK)@

ALTER TABLE CFG_PHYSICAL_SERVER ADD CONSTRAINT CFG_PHYSICAL_SERVER_CFG_ENCLOSURE_FK FOREIGN KEY 	(ENCLOSURE_PK) 	REFERENCES CFG_ENCLOSURE 	(ENCLOSURE_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_PHYSICAL_SERVER ADD CONSTRAINT CFG_PHYSICAL_SERVER_ANL_MATCHED_SERVER_CATALOG_FK FOREIGN KEY 	(MATCHED_SERVER_CATALOG_PK) 	REFERENCES ANL_MATCHED_SERVER_CATALOG 	(MATCHED_SERVER_CATALOG_PK) 	ON DELETE RESTRICT 	NOT ENFORCED@

ALTER TABLE CFG_VIRTUAL_MACHINE ADD CONSTRAINT CFG_VIRTUAL_MACHINE_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_IP_INTERFACE ADD CONSTRAINT CFG_IP_INTERFACE_CFG_NIC_FK FOREIGN KEY 	(NIC_PK) 	REFERENCES CFG_NIC 	(NIC_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_IP_INTERFACE ADD CONSTRAINT CFG_IP_INTERFACE_CFG_NETWORK_FK FOREIGN KEY 	(NETWORK_PK) 	REFERENCES CFG_NETWORK 	(NETWORK_PK) 	ON DELETE RESTRICT@

ALTER TABLE KBS_DC_PROFILE_CAPACITY_UTILIZATION ADD CONSTRAINT SQL110118124955546 FOREIGN KEY 	(DC_PK) 	REFERENCES KBS_DC_SUMMARY 	(DC_PK) 	ON DELETE CASCADE@

ALTER TABLE KBS_DC_PROFILE_COST ADD CONSTRAINT SQL110118124955640 FOREIGN KEY 	(DC_PK) 	REFERENCES KBS_DC_SUMMARY 	(DC_PK) 	ON DELETE CASCADE@

ALTER TABLE KBS_DC_PROFILE_STORAGE ADD CONSTRAINT SQL110118124955609 FOREIGN KEY 	(DC_PK) 	REFERENCES KBS_DC_SUMMARY 	(DC_PK) 	ON DELETE CASCADE@

ALTER TABLE CFG_OPERATING_SYSTEM ADD CONSTRAINT CFG_OPERATING_SYSTEM_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE CASCADE 	NOT ENFORCED@

ALTER TABLE CFG_OPERATING_SYSTEM ADD CONSTRAINT CFG_OPERATING_SYSTEM_CFG_VIRTUAL_MACHINE_FK FOREIGN KEY 	(VIRTUAL_MACHINE_PK) 	REFERENCES CFG_VIRTUAL_MACHINE 	(VIRTUAL_MACHINE_PK) 	ON DELETE CASCADE 	NOT ENFORCED@

ALTER TABLE CFG_SOFTWARE ADD CONSTRAINT CFG_SOFTWARE_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE CASCADE 	NOT ENFORCED@

ALTER TABLE CFG_SOFTWARE ADD CONSTRAINT CFG_SOFTWARE_CFG_VIRTUAL_MACHINE_FK FOREIGN KEY 	(VIRTUAL_MACHINE_PK) 	REFERENCES CFG_VIRTUAL_MACHINE 	(VIRTUAL_MACHINE_PK) 	ON DELETE CASCADE 	NOT ENFORCED@

ALTER TABLE ANL_SERVER_TAG_MAP ADD CONSTRAINT ANL_SERVER_TAG_MAP_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE CASCADE@

ALTER TABLE ANL_SERVER_TAG_MAP ADD CONSTRAINT ANL_SERVER_TAG_MAP_ANL_SERVER_TAGS_FK FOREIGN KEY 	(SERVER_TAGS_PK) 	REFERENCES ANL_SERVER_TAGS 	(SERVER_TAGS_PK) 	ON DELETE CASCADE@

ALTER TABLE ANL_SERVER_TAG_MAP ADD CONSTRAINT ANL_SERVER_TAG_MAP_ANL_SERVER_TAGS_FK1 FOREIGN KEY 	(SERVER_TAGS_PK) 	REFERENCES ANL_SERVER_TAGS 	(SERVER_TAGS_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_NIC ADD CONSTRAINT CFG_NIC_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_NIC ADD CONSTRAINT CFG_NIC_CFG_VIRTUAL_MACHINE_FK FOREIGN KEY 	(VIRTUAL_MACHINE_PK) 	REFERENCES CFG_VIRTUAL_MACHINE 	(VIRTUAL_MACHINE_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_FILE_SYSTEM ADD CONSTRAINT CFG_FILE_SYSTEM_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_FILE_SYSTEM ADD CONSTRAINT CFG_FILE_SYSTEM_CFG_VIRTUAL_MACHINE_FK FOREIGN KEY 	(VIRTUAL_MACHINE_PK) 	REFERENCES CFG_VIRTUAL_MACHINE 	(VIRTUAL_MACHINE_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_STORAGE_VOLUME ADD CONSTRAINT CFG_STORAGE_VOLUME_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_STORAGE_VOLUME ADD CONSTRAINT CFG_STORAGE_VOLUME_CFG_VIRTUAL_MACHINE_FK FOREIGN KEY 	(VIRTUAL_MACHINE_PK) 	REFERENCES CFG_VIRTUAL_MACHINE 	(VIRTUAL_MACHINE_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_STORAGE_VOLUME ADD CONSTRAINT CFG_STORAGE_VOLUME_CFG_FILE_SYSTEM_FK FOREIGN KEY 	(FILE_SYSTEM_PK) 	REFERENCES CFG_FILE_SYSTEM 	(FILE_SYSTEM_PK) 	ON DELETE RESTRICT@

ALTER TABLE COLOCATIONRULES ADD CONSTRAINT COLOCATIONRULES_RULEDIM_FK FOREIGN KEY 	(RULEDIMKEY) 	REFERENCES RULEDIM 	(RULEDIMKEY) 	ON DELETE CASCADE@

ALTER TABLE CFG_DATA_STORE_TO_PHYSICAL_SERVER_MAP ADD CONSTRAINT CFG_DATA_STORE_TO_SERVER_MAP_CFG_DATA_STORE_FK FOREIGN KEY 	(DATA_STORE_PK) 	REFERENCES CFG_DATA_STORE 	(DATA_STORE_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_DATA_STORE_TO_PHYSICAL_SERVER_MAP ADD CONSTRAINT CFG_DATA_STORE_TO_SERVER_MAP_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE RESTRICT@

ALTER TABLE ANL_VIRTUAL_MACHINE_TAG_MAP ADD CONSTRAINT ANL_VM_TAG_MAP_ANL_SERVER_TAGS_FK FOREIGN KEY 	(SERVER_TAGS_PK) 	REFERENCES ANL_SERVER_TAGS 	(SERVER_TAGS_PK) 	ON DELETE RESTRICT@

ALTER TABLE ANL_VIRTUAL_MACHINE_TAG_MAP ADD CONSTRAINT ANL_VM_TAG_MAP_CFG_VIRTUAL_MACHINE_FK FOREIGN KEY 	(VIRTUAL_MACHINE_PK) 	REFERENCES CFG_VIRTUAL_MACHINE 	(VIRTUAL_MACHINE_PK) 	ON DELETE CASCADE@

ALTER TABLE ANL_SOFTWARE_TAG_MAP ADD CONSTRAINT ANL_SOFTWARE_TAG_MAP_CFG_SOFTWARE_FK FOREIGN KEY 	(SOFTWARE_PK) 	REFERENCES CFG_SOFTWARE 	(SOFTWARE_PK) 	ON DELETE RESTRICT@

ALTER TABLE ANL_SOFTWARE_TAG_MAP ADD CONSTRAINT ANL_SOFTWARE_TAG_MAP_ANL_SERVER_TAGS_FK FOREIGN KEY 	(SERVER_TAGS_PK) 	REFERENCES ANL_SERVER_TAGS 	(SERVER_TAGS_PK) 	ON DELETE RESTRICT@

ALTER TABLE MES_PS_CPU ADD CONSTRAINT MES_PS_CPU_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE RESTRICT@

ALTER TABLE MES_VM_CPU ADD CONSTRAINT MES_VM_CPU_CFG_VIRTUAL_MACHINE_FK FOREIGN KEY 	(VIRTUAL_MACHINE_PK) 	REFERENCES CFG_VIRTUAL_MACHINE 	(VIRTUAL_MACHINE_PK) 	ON DELETE RESTRICT@

ALTER TABLE MES_PS_MEM ADD CONSTRAINT MES_PS_MEM_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE RESTRICT@

ALTER TABLE MES_VM_MEM ADD CONSTRAINT MES_VM_MEM_CFG_VIRTUAL_MACHINE_FK FOREIGN KEY 	(VIRTUAL_MACHINE_PK) 	REFERENCES CFG_VIRTUAL_MACHINE 	(VIRTUAL_MACHINE_PK) 	ON DELETE RESTRICT@

ALTER TABLE MES_VM_DATA_STORE ADD CONSTRAINT MES_VM_DATA_STORE_CFG_VIRTUAL_MACHINE_FK FOREIGN KEY 	(VIRTUAL_MACHINE_PK) 	REFERENCES CFG_VIRTUAL_MACHINE 	(VIRTUAL_MACHINE_PK) 	ON DELETE RESTRICT@

ALTER TABLE MES_PS_DISK ADD CONSTRAINT MES_PS_DISK_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE RESTRICT@

ALTER TABLE MES_PS_NETWORK ADD CONSTRAINT MES_PS_NETWORK_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE RESTRICT@

ALTER TABLE MES_VM_NETWORK ADD CONSTRAINT MES_VM_NETWORK_CFG_VIRTUAL_MACHINE_FK FOREIGN KEY 	(VIRTUAL_MACHINE_PK) 	REFERENCES CFG_VIRTUAL_MACHINE 	(VIRTUAL_MACHINE_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_DATA_STORE_TO_STORAGE_VOLUME_MAP ADD CONSTRAINT CFG_DATA_STORE_STORAGE_VOLUME_MAP_CFG_DATA_STORE_FK FOREIGN KEY 	(DATA_STORE_PK) 	REFERENCES CFG_DATA_STORE 	(DATA_STORE_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_DATA_STORE_TO_STORAGE_VOLUME_MAP ADD CONSTRAINT CFG_DATA_STORE_STORAGE_VOLUME_MAP_CFG_STORAGE_VOLUME_FK FOREIGN KEY 	(STORAGE_VOLUME_KEY) 	REFERENCES CFG_STORAGE_VOLUME 	(STORAGE_VOLUME_KEY) 	ON DELETE RESTRICT@

ALTER TABLE CFG_DATA_STORE_TO_VIRTUAL_MACHINE_MAP ADD CONSTRAINT CFG_DATA_STORE_TO_VIRTUAL_MACHINE_MAP_CFG_DATA_STORE_FK FOREIGN KEY 	(DATA_STORE_PK) 	REFERENCES CFG_DATA_STORE 	(DATA_STORE_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_DATA_STORE_TO_VIRTUAL_MACHINE_MAP ADD CONSTRAINT CFG_DATA_STORE_TO_VIRTUAL_MACHINE_MAP_CFG_VIRTUAL_MACHINE_FK FOREIGN KEY 	(VIRTUAL_MACHINE_PK) 	REFERENCES CFG_VIRTUAL_MACHINE 	(VIRTUAL_MACHINE_PK) 	ON DELETE RESTRICT@

ALTER TABLE CFG_HBA ADD CONSTRAINT CFG_HBA_CFG_PHYSICAL_SERVER_FK FOREIGN KEY 	(PHYSICAL_SERVER_PK) 	REFERENCES CFG_PHYSICAL_SERVER 	(PHYSICAL_SERVER_PK) 	ON DELETE RESTRICT@

CREATE VIEW ANL_WORKING_SET_V (PHYSICAL_SERVER_PK, GUID, HOST_NAME, IP_ADDRESS, FQDN, SERVER_POOL_NAME, DATA_CENTER_NAME, NUM_CPUS, CPU_SPEED, CPU_CORES_INSTALLED, CPU_CORES_ENABLED, MEMORY_LIMIT, MEMORY_INSTALLED, MANUFACTURER, MODEL, SERIAL_NUMBER, SIGNATURE, ARCHITECTURE, SYSTEM_SHORT_NAME, MANAGED_SYSTEM_NAME, MAX_POWER, TIMEZONE, HYPERVISOR_TYPE, HYPERVISOR_VERSION, HYPER_THREADING_CAPABLE, HYPER_THREADING_ENABLED, IS_VIRTUALIZED, BIOS_DATE, OPERATING_SYSTEM_NAME, OPERATING_SYSTEM_VERSION, ENCLOSURE_PK, MATCHED_SERVER_CATALOG_PK) AS (SELECT PHYSICAL_SERVER_PK, GUID,HOST_NAME, IP_ADDRESS, FQDN, SERVER_POOL_NAME, DATA_CENTER_NAME, NUM_CPUS, CPU_SPEED, CPU_CORES_INSTALLED, CPU_CORES_ENABLED, MEMORY_LIMIT, MEMORY_INSTALLED, MANUFACTURER, MODEL, SERIAL_NUMBER, SIGNATURE, ARCHITECTURE, SYSTEM_SHORT_NAME, MANAGED_SYSTEM_NAME, MAX_POWER, TIMEZONE, HYPERVISOR_TYPE, HYPERVISOR_VERSION, HYPER_THREADING_CAPABLE, HYPER_THREADING_ENABLED, IS_VIRTUALIZED, BIOS_DATE, OPERATING_SYSTEM_NAME, OPERATING_SYSTEM_VERSION,  ENCLOSURE_PK, MATCHED_SERVER_CATALOG_PK FROM CFG_PHYSICAL_SERVER WHERE Physical_Server_PK IN (SELECT DISTINCT Physical_Server_PK  FROM ANL_Server_Tag_Map  WHERE Server_Tags_PK IN (SELECT Server_Tags_PK FROM ANL_Server_Tags WHERE (Tag_Type = 'WorkingSet' AND Tag_Name = 'TRUE') ) ) )@

CREATE VIEW ANL_PLACEMENT_SET_V AS
(SELECT VIRTUAL_MACHINE_PK AS SERVER_PK, VM_NAME AS HOST_NAME, IP_ADDRESS, FQDN, NUM_CPUS, MEMORY_MAX AS MEMORY_LIMIT, OPERATING_SYSTEM_NAME, OPERATING_SYSTEM_VERSION, SYSTEM_SHORT_NAME, MANAGED_SYSTEM_NAME
        FROM CFG_VIRTUAL_MACHINE
        WHERE VIRTUAL_MACHINE_PK IN
				(SELECT DISTINCT A.VIRTUAL_MACHINE_PK FROM 
					(SELECT VIRTUAL_MACHINE_PK, PHYSICAL_SERVER_PK FROM CFG_VIRTUAL_MACHINE 
						UNION
					SELECT SOURCE_SERVER_ID AS VIRTUAL_MACHINE_PK, TARGET_SERVER_ID AS PHYSICAL_SERVER_PK FROM ANL_TARGET_DESIGN) A
				INNER JOIN
				(SELECT X.PHYSICAL_SERVER_PK
	                        FROM
	                                (SELECT DISTINCT  PHYSICAL_SERVER_PK
	                                FROM ANL_SERVER_TAG_MAP
	                                WHERE SERVER_TAGS_PK = (SELECT SERVER_TAGS_PK FROM ANL_SERVER_TAGS WHERE (TAG_TYPE = 'WorkingSet' AND TAG_NAME = 'TRUE'))                                	
	                                ) X
	                        INNER JOIN
	                                (SELECT DISTINCT PHYSICAL_SERVER_PK
	                                FROM ANL_SERVER_TAG_MAP
	                                WHERE SERVER_TAGS_PK IN (SELECT SERVER_TAGS_PK FROM ANL_SERVER_TAGS WHERE(Tag_Type = 'Type' AND (Tag_Name = 'Source' OR Tag_Name = 'Target')))
	                                ) U
	
	                        ON X.PHYSICAL_SERVER_PK = U.PHYSICAL_SERVER_PK) B
		ON A.PHYSICAL_SERVER_PK = B.PHYSICAL_SERVER_PK)
)@


CREATE VIEW ANL_INVENTORY_V
(PHYSICAL_SERVER_PK, HOST_NAME, IP_ADDRESS, FQDN, SERVER_POOL_NAME, DATA_CENTER_NAME, NUM_CPUS, CPU_SPEED, CPU_CORES_INSTALLED, CPU_CORES_ENABLED, MEMORY_LIMIT, MEMORY_INSTALLED, MODEL, MANUFACTURER, ARCHITECTURE, HYPERVISOR_VERSION, HYPERVISOR_TYPE, BIOS_DATE, OPERATING_SYSTEM_VERSION, OPERATING_SYSTEM_NAME, SERIAL_NUMBER, SIGNATURE, DATA_SOURCE, UPDATE_FLAG, TAG_TYPE, TAG_NAME)
AS
SELECT P.PHYSICAL_SERVER_PK, P.HOST_NAME, P.IP_ADDRESS, P.FQDN, P.SERVER_POOL_NAME, P.DATA_CENTER_NAME, P.NUM_CPUS, P.CPU_SPEED, P.CPU_CORES_INSTALLED, P.CPU_CORES_ENABLED, P.MEMORY_LIMIT, P.MEMORY_INSTALLED, P.MODEL, P.MANUFACTURER, P.ARCHITECTURE, P.HYPERVISOR_VERSION, P.HYPERVISOR_TYPE, P.BIOS_DATE, P.OPERATING_SYSTEM_VERSION, P.OPERATING_SYSTEM_NAME, P.SERIAL_NUMBER, P.SIGNATURE, P.DATA_SOURCE, P.UPDATE_FLAG, U.TAG_TYPE, U.TAG_NAME
FROM
(
        SELECT PHYSICAL_SERVER_PK, HOST_NAME, IP_ADDRESS, FQDN, SERVER_POOL_NAME, DATA_CENTER_NAME, NUM_CPUS, CPU_SPEED, CPU_CORES_INSTALLED, CPU_CORES_ENABLED, MEMORY_LIMIT, MEMORY_INSTALLED, MODEL, MANUFACTURER, ARCHITECTURE, HYPERVISOR_VERSION, HYPERVISOR_TYPE, BIOS_DATE, OPERATING_SYSTEM_VERSION, OPERATING_SYSTEM_NAME, SERIAL_NUMBER, SIGNATURE, DATA_SOURCE, UPDATE_FLAG
        FROM CFG_PHYSICAL_SERVER) P
        LEFT OUTER JOIN
                (SELECT PHYSICAL_SERVER_PK, SERVER_TAGS_PK, TAG_TYPE, TAG_NAME
                 FROM
                        (SELECT Q.PHYSICAL_SERVER_PK, P.SERVER_TAGS_PK, P.TAG_TYPE, P.TAG_NAME
                         FROM
                                (SELECT SERVER_TAGS_PK, TAG_TYPE, TAG_NAME FROM ANL_SERVER_TAGS) P
                                LEFT OUTER JOIN
                                (SELECT PHYSICAL_SERVER_PK, SERVER_TAGS_PK FROM ANL_SERVER_TAG_MAP) Q
                                ON P.SERVER_TAGS_PK = Q.SERVER_TAGS_PK
                        )
        ) U
ON P.PHYSICAL_SERVER_PK = U.PHYSICAL_SERVER_PK@


CREATE VIEW ANL_NORMALIZED_CAPACITY_V
(PHYSICAL_SERVER_PK, HOST_NAME,SERVER_POOL_NAME, DATA_CENTER_NAME, MODEL, CPU_SPEED, CPU_CORES_INSTALLED, MATCHED_SERVER_CATALOG_PK, MAPPED_MODEL, PROCESSOR_SPEED_MHZ, PROCESSOR_CHIPS, PROCESSOR_CORES, CPU_BENCHMARK_CAPACITY, UVALUES, HEIGHT_MM, WIDTH_MM, DEPTH_MM, MAX_HEAT_MBTU, MAX_POWER_WATTS, SERVER_TAGS_PK, TAG_TYPE, TAG_NAME)
AS
SELECT P.PHYSICAL_SERVER_PK, P.HOST_NAME, P.SERVER_POOL_NAME, P.DATA_CENTER_NAME,P.MODEL, P.CPU_SPEED, P.CPU_CORES_INSTALLED, M.MATCHED_SERVER_CATALOG_PK, M.MAPPED_MODEL, M.PROCESSOR_SPEED_MHZ, M.PROCESSOR_CHIPS, M.PROCESSOR_CORES, M.CPU_BENCHMARK_CAPACITY, M.UVALUES, M.HEIGHT_MM, M.WIDTH_MM, M.DEPTH_MM, M.MAX_HEAT_MBTU, M.MAX_POWER_WATTS, P.SERVER_TAGS_PK, P.TAG_TYPE, P.TAG_NAME
FROM
(
        SELECT X.PHYSICAL_SERVER_PK, X.HOST_NAME, X.SERVER_POOL_NAME, X.DATA_CENTER_NAME, X.MODEL, X.CPU_SPEED, X.CPU_CORES_INSTALLED, X.MATCHED_SERVER_CATALOG_PK, U.SERVER_TAGS_PK, U.TAG_TYPE, U.TAG_NAME
        FROM
                (
                        SELECT PHYSICAL_SERVER_PK AS PHYSICAL_SERVER_PK, HOST_NAME AS HOST_NAME, SERVER_POOL_NAME AS SERVER_POOL_NAME, DATA_CENTER_NAME AS DATA_CENTER_NAME,MODEL AS MODEL, CPU_SPEED AS CPU_SPEED, CPU_CORES_INSTALLED AS                              CPU_CORES_INSTALLED, MATCHED_SERVER_CATALOG_PK AS MATCHED_SERVER_CATALOG_PK
                        FROM CFG_PHYSICAL_SERVER
                        WHERE PHYSICAL_SERVER_PK IN
                                (SELECT PHYSICAL_SERVER_PK FROM ANL_WORKING_SET_V)
                ) X
        INNER JOIN
        (
                SELECT Q.PHYSICAL_SERVER_PK, Z.SERVER_TAGS_PK, Z.TAG_TYPE, Z.TAG_NAME
                FROM
                        (SELECT SERVER_TAGS_PK, TAG_TYPE, TAG_NAME FROM ANL_SERVER_TAGS) Z
                        LEFT OUTER JOIN
                        (SELECT PHYSICAL_SERVER_PK, SERVER_TAGS_PK FROM ANL_SERVER_TAG_MAP) Q
                ON Z.SERVER_TAGS_PK = Q.SERVER_TAGS_PK

        ) U
        ON X.PHYSICAL_SERVER_PK = U.PHYSICAL_SERVER_PK

) P
LEFT OUTER JOIN
(
        SELECT MATCHED_SERVER_CATALOG_PK AS MATCHED_SERVER_CATALOG_PK, MODEL AS MAPPED_MODEL, PROCESSOR_SPEED_MHZ AS PROCESSOR_SPEED_MHZ, PROCESSOR_CHIPS, PROCESSOR_CORES      AS PROCESSOR_CORES, CPU_BENCHMARK_CAPACITY AS CPU_BENCHMARK_CAPACITY, UVALUES AS UVALUES, HEIGHT_MM as HEIGHT_MM, WIDTH_MM AS WIDTH_MM, DEPTH_MM AS DEPTH_MM,   MAX_HEAT_MBTU MAX_HEAT_MBTU, MAX_POWER_WATTS AS MAX_POWER_WATTS
        FROM ANL_MATCHED_SERVER_CATALOG
) M
ON P.MATCHED_SERVER_CATALOG_PK = M.MATCHED_SERVER_CATALOG_PK@

CREATE VIEW ANL_RESOURCE_DEMAND_V AS
SELECT W.PHYSICAL_SERVER_PK, W.HOST_NAME AS PHOST_NAME, R.CPU_DEMAND_PERCENTAGE, R.CPU_DEMAND_BENCHMARK, R.MEMORY_DEMAND_PERCENTAGE, R.MEMORY_DEMAND_MB, R.DISK_DEMAND_MBPS, R.NETWORK_DEMAND_MBPS, R.CPU_UTIL_TYPE, R.MEM_UTIL_TYPE, R.DISK_UTIL_TYPE, R.NETWORK_UTIL_TYPE, R.CPU_VAR, R.MEM_VAR, R.DISK_VAR, R.NETWORK_VAR, R.SERVER_PK, W.SERVER_TAGS_PK, W.TAG_TYPE, W.TAG_NAME
FROM
(
        SELECT P.PHYSICAL_SERVER_PK, P.HOST_NAME, U.SERVER_TAGS_PK, U.TAG_TYPE, U.TAG_NAME
        FROM
        (SELECT PHYSICAL_SERVER_PK, HOST_NAME
         FROM ANL_WORKING_SET_V
         WHERE PHYSICAL_SERVER_PK IN
                (SELECT DISTINCT PHYSICAL_SERVER_PK
                 FROM ANL_SERVER_TAG_MAP WHERE
                 SERVER_TAGS_PK IN (SELECT SERVER_TAGS_PK FROM ANL_SERVER_TAGS WHERE (TAG_TYPE = 'Type' AND TAG_NAME <>'Target'))
                )
        ) P
        INNER JOIN
        (
        SELECT Q.PHYSICAL_SERVER_PK, Z.SERVER_TAGS_PK, Z.TAG_TYPE, Z.TAG_NAME
        FROM
                (SELECT  SERVER_TAGS_PK, TAG_TYPE, TAG_NAME FROM ANL_SERVER_TAGS) Z
                 LEFT OUTER JOIN
                (SELECT PHYSICAL_SERVER_PK, SERVER_TAGS_PK FROM ANL_SERVER_TAG_MAP) Q
                ON Z.SERVER_TAGS_PK = Q.SERVER_TAGS_PK
        ) U
        ON P.PHYSICAL_SERVER_PK = U.PHYSICAL_SERVER_PK
) W
LEFT OUTER JOIN
(SELECT CPU_DEMAND_PERCENTAGE AS CPU_DEMAND_PERCENTAGE, CPU_DEMAND_BENCHMARK AS CPU_DEMAND_BENCHMARK, MEMORY_DEMAND_PERCENTAGE AS MEMORY_DEMAND_PERCENTAGE, MEMORY_DEMAND_MB AS MEMORY_DEMAND_MB, DISK_DEMAND_MBPS AS DISK_DEMAND_MBPS, NETWORK_DEMAND_MBPS AS NETWORK_DEMAND_MBPS, SERVER_PK as SERVER_PK, DEVICE_TYPE as DEVICE_TYPE, CPU_UTIL_TYPE, MEM_UTIL_TYPE, DISK_UTIL_TYPE, NETWORK_UTIL_TYPE, CPU_VAR, MEM_VAR, DISK_VAR, NETWORK_VAR
FROM ANL_RESOURCE_DEMAND
) R
ON W.PHYSICAL_SERVER_PK = R.SERVER_PK@

CREATE VIEW ANL_VIRTUAL_MACHINE_INVENTORY_V
(VIRTUAL_MACHINE_PK,VMID,HOST_NAME,VM_NAME,IP_ADDRESS,FQDN,NUM_CPUS,CPU_MIN,CPU_MAX,CPU_DESIRED,MEMORY_MIN,MEMORY_MAX,MEMORY_DESIRED,OPERATING_SYSTEM_NAME,OPERATING_SYSTEM_VERSION,MIDDLEWARE_NAME,MIDDLEWARE_VERSION,DATA_SOURCE,PHYSICAL_SERVER_PK,PS_HOST_NAME,WorkingSet,TAG_TYPE, TAG_NAME)
AS
SELECT A.VIRTUAL_MACHINE_PK,A.VMID,A.HOST_NAME,A.VM_NAME,A.IP_ADDRESS,A.FQDN,A.NUM_CPUS,A.CPU_MIN,A.CPU_MAX,A.CPU_DESIRED,A.MEMORY_MIN,A.MEMORY_MAX,A.MEMORY_DESIRED,A.OPERATING_SYSTEM_NAME,A.OPERATING_SYSTEM_VERSION,A.MIDDLEWARE_NAME, A.MIDDLEWARE_VERSION,A.DATA_SOURCE,A.PHYSICAL_SERVER_PK,A.PS_HOST_NAME, B.WorkingSet, C.TAG_TYPE, C.TAG_NAME
FROM 
(SELECT 
VM.VIRTUAL_MACHINE_PK,
VM.VMID,      
VM.HOST_NAME,
VM.VM_NAME,
VM.IP_ADDRESS,
VM.FQDN,
VM.NUM_CPUS,
VM.CPU_MIN,
VM.CPU_MAX,
VM.CPU_DESIRED,
VM.MEMORY_MIN,
VM.MEMORY_MAX,
VM.MEMORY_DESIRED,
VM.OPERATING_SYSTEM_NAME,
VM.OPERATING_SYSTEM_VERSION,
VM.MIDDLEWARE_NAME, 
VM.MIDDLEWARE_VERSION,
VM.DATA_SOURCE,
PS.PHYSICAL_SERVER_PK,
PS.HOST_NAME AS PS_HOST_NAME
FROM CFG_VIRTUAL_MACHINE VM, CFG_PHYSICAL_SERVER PS
WHERE VM.PHYSICAL_SERVER_PK = PS.PHYSICAL_SERVER_PK) A
LEFT OUTER JOIN
(SELECT 
STM.PHYSICAL_SERVER_PK,
ST.TAG_NAME AS WorkingSet
FROM ANL_SERVER_TAGS ST, ANL_SERVER_TAG_MAP STM
WHERE
ST.SERVER_TAGS_PK=STM.SERVER_TAGS_PK
AND ST.TAG_TYPE = 'WorkingSet') B
ON A.PHYSICAL_SERVER_PK=B.PHYSICAL_SERVER_PK
LEFT OUTER JOIN
(SELECT VIRTUAL_MACHINE_PK, SERVER_TAGS_PK, TAG_TYPE, TAG_NAME
	FROM
	(SELECT Q.VIRTUAL_MACHINE_PK, P.SERVER_TAGS_PK, P.TAG_TYPE, P.TAG_NAME
		FROM
		(SELECT SERVER_TAGS_PK, TAG_TYPE, TAG_NAME FROM ANL_SERVER_TAGS WHERE TAG_TYPE <> 'WorkingSet') P
		LEFT OUTER JOIN
		(SELECT VIRTUAL_MACHINE_PK, SERVER_TAGS_PK FROM ANL_VIRTUAL_MACHINE_TAG_MAP) Q
		ON P.SERVER_TAGS_PK = Q.SERVER_TAGS_PK
	)
)C
ON A.VIRTUAL_MACHINE_PK = C.VIRTUAL_MACHINE_PK
@

CREATE VIEW ANL_VIRTUAL_MACHINE_UTILIZATION_V
(SERVER_PK,
HOST_NAME,
VM_NAME,
PHYSICAL_SERVER_PK,
PS_HOST_NAME,
RESOURCE_DEMAND_KEY,
CPU_DEMAND_PERCENTAGE,
CPU_DEMAND_BENCHMARK,
MEMORY_DEMAND_PERCENTAGE,
MEMORY_DEMAND_MB,
DISK_DEMAND_MBPS,
NETWORK_DEMAND_MBPS,
CPU_UTIL_TYPE,MEM_UTIL_TYPE,DISK_UTIL_TYPE,NETWORK_UTIL_TYPE,CPU_VAR,MEM_VAR,DISK_VAR,NETWORK_VAR,
TAG_TYPE,
TAG_NAME,
PS_CANDIDATE
)
AS
SELECT
VM.VIRTUAL_MACHINE_PK,
VM.HOST_NAME,
VM.VM_NAME,
VM.PHYSICAL_SERVER_PK,
VM.PS_HOST_NAME,
R.RESOURCE_DEMAND_KEY,
R.CPU_DEMAND_PERCENTAGE,
R.CPU_DEMAND_BENCHMARK,
R.MEMORY_DEMAND_PERCENTAGE,
R.MEMORY_DEMAND_MB,
R.DISK_DEMAND_MBPS,
R.NETWORK_DEMAND_MBPS,
R.CPU_UTIL_TYPE,R.MEM_UTIL_TYPE,R.DISK_UTIL_TYPE,R.NETWORK_UTIL_TYPE,R.CPU_VAR,R.MEM_VAR,R.DISK_VAR,R.NETWORK_VAR,
VM.TAG_TYPE,
VM.TAG_NAME,
VM.PS_CANDIDATE
FROM
(SELECT V.VIRTUAL_MACHINE_PK, V.HOST_NAME, V.VM_NAME, V.PHYSICAL_SERVER_PK, V.PS_HOST_NAME, V.TAG_TYPE, V.TAG_NAME, T.TAG_NAME AS PS_CANDIDATE
        FROM ANL_VIRTUAL_MACHINE_INVENTORY_V V, ANL_SERVER_TAGS T, ANL_SERVER_TAG_MAP TM
        WHERE 
        T.TAG_TYPE = 'Type'
        AND T.SERVER_TAGS_PK=TM.SERVER_TAGS_PK
        AND TM.PHYSICAL_SERVER_PK = V.PHYSICAL_SERVER_PK
        AND V.WORKINGSET='TRUE' ORDER BY VIRTUAL_MACHINE_PK
)VM
LEFT OUTER JOIN (
SELECT RESOURCE_DEMAND_KEY, CPU_DEMAND_PERCENTAGE AS CPU_DEMAND_PERCENTAGE, CPU_DEMAND_BENCHMARK AS CPU_DEMAND_BENCHMARK, MEMORY_DEMAND_PERCENTAGE AS MEMORY_DEMAND_PERCENTAGE, MEMORY_DEMAND_MB AS MEMORY_DEMAND_MB, DISK_DEMAND_MBPS AS DISK_DEMAND_MBPS, NETWORK_DEMAND_MBPS AS NETWORK_DEMAND_MBPS, SERVER_PK as SERVER_PK, CPU_UTIL_TYPE,MEM_UTIL_TYPE,DISK_UTIL_TYPE,NETWORK_UTIL_TYPE,CPU_VAR,MEM_VAR,DISK_VAR,NETWORK_VAR
FROM ANL_RESOURCE_DEMAND where DEVICE_TYPE='VM' ORDER BY SERVER_PK) R ON VM.VIRTUAL_MACHINE_PK = R.SERVER_PK@

CREATE VIEW SourceView AS (SELECT PHYSICAL_SERVER_PK, GUID, HOST_NAME, IP_ADDRESS, FQDN, SERVER_POOL_NAME, DATA_CENTER_NAME, NUM_CPUS, CPU_SPEED, CPU_CORES_INSTALLED, CPU_CORES_ENABLED, MEMORY_LIMIT, MEMORY_INSTALLED, MANUFACTURER, MODEL, SERIAL_NUMBER, SIGNATURE, ARCHITECTURE, SYSTEM_SHORT_NAME, MANAGED_SYSTEM_NAME, MAX_POWER, TIMEZONE, HYPERVISOR_TYPE, HYPERVISOR_VERSION, HYPER_THREADING_CAPABLE, HYPER_THREADING_ENABLED, IS_VIRTUALIZED, BIOS_DATE, DATA_SOURCE, LAST_EDIT_TIMESTAMP, OPERATING_SYSTEM_VERSION, OPERATING_SYSTEM_NAME, ENCLOSURE_PK, MATCHED_SERVER_CATALOG_PK, NUMBER_OF_NICS, DISPLAY_NAME, NUMBER_OF_VMS FROM TADFDC.CFG_PHYSICAL_SERVER WHERE PHYSICAL_SERVER_PK IN (SELECT DISTINCT PHYSICAL_SERVER_PK FROM TADFDC.ANL_SERVER_TAG_MAP WHERE SERVER_TAGS_PK IN (SELECT SERVER_TAGS_PK FROM TADFDC.ANL_SERVER_TAGS WHERE (TAG_TYPE = 'Type' AND TAG_NAME = 'Source') OR (TAG_TYPE = 'Type' AND TAG_NAME = 'Both'))))@

--CREATE VIEW TargetView AS (SELECT PHYSICAL_SERVER_PK, GUID, HOST_NAME, IP_ADDRESS, FQDN, SERVER_POOL_NAME, DATA_CENTER_NAME, NUM_CPUS, CPU_SPEED, CPU_CORES_INSTALLED, CPU_CORES_ENABLED, MEMORY_LIMIT, MEMORY_INSTALLED, MANUFACTURER, MODEL, SERIAL_NUMBER, SIGNATURE, ARCHITECTURE, SYSTEM_SHORT_NAME, MANAGED_SYSTEM_NAME, MAX_POWER, TIMEZONE, HYPERVISOR_TYPE, HYPERVISOR_VERSION, HYPER_THREADING_CAPABLE, HYPER_THREADING_ENABLED, IS_VIRTUALIZED, BIOS_DATE, DATA_SOURCE, LAST_EDIT_TIMESTAMP, OPERATING_SYSTEM_VERSION, OPERATING_SYSTEM_NAME, ENCLOSURE_PK, MATCHED_SERVER_CATALOG_PK, NUMBER_OF_NICS, DISPLAY_NAME, NUMBER_OF_VMS  FROM TADFDC.CFG_PHYSICAL_SERVER WHERE PHYSICAL_SERVER_PK IN (SELECT DISTINCT PHYSICAL_SERVER_PK FROM TADFDC.ANL_SERVER_TAG_MAP WHERE SERVER_TAGS_PK IN (SELECT SERVER_TAGS_PK FROM TADFDC.ANL_SERVER_TAGS WHERE (TAG_TYPE = 'Type' AND TAG_NAME = 'Target') OR (TAG_TYPE = 'Type' AND TAG_NAME = 'Both'))))@

CREATE VIEW TargetView AS (SELECT PHYSICAL_SERVER_PK, GUID, HOST_NAME, IP_ADDRESS, FQDN, SERVER_POOL_NAME, DATA_CENTER_NAME, NUM_CPUS, CPU_SPEED, CPU_CORES_INSTALLED, CPU_CORES_ENABLED, MEMORY_LIMIT, MEMORY_INSTALLED, MANUFACTURER, MODEL, SERIAL_NUMBER, SIGNATURE, ARCHITECTURE, SYSTEM_SHORT_NAME, MANAGED_SYSTEM_NAME, MAX_POWER, TIMEZONE, HYPERVISOR_TYPE, HYPERVISOR_VERSION, HYPER_THREADING_CAPABLE, HYPER_THREADING_ENABLED, IS_VIRTUALIZED, BIOS_DATE, DATA_SOURCE, LAST_EDIT_TIMESTAMP, OPERATING_SYSTEM_VERSION, OPERATING_SYSTEM_NAME, ENCLOSURE_PK, MATCHED_SERVER_CATALOG_PK, NUMBER_OF_NICS, DISPLAY_NAME, NUMBER_OF_VMS
FROM TADFDC.CFG_PHYSICAL_SERVER WHERE PHYSICAL_SERVER_PK IN
(
(SELECT DISTINCT PHYSICAL_SERVER_PK FROM TADFDC.ANL_SERVER_TAG_MAP WHERE SERVER_TAGS_PK IN (SELECT SERVER_TAGS_PK FROM TADFDC.ANL_SERVER_TAGS WHERE (TAG_TYPE = 'Type' AND TAG_NAME = 'Target') OR (TAG_TYPE = 'Type' AND TAG_NAME = 'Both')))

INTERSECT
(SELECT DISTINCT Physical_Server_PK  FROM TADFDC.ANL_Server_Tag_Map  WHERE Server_Tags_PK IN (SELECT Server_Tags_PK FROM TADFDC.ANL_Server_Tags WHERE (Tag_Type = 'WorkingSet' AND Tag_Name = 'TRUE')))
)
)
@

CREATE VIEW ANL_VM_PLACEMENT_SET_V AS
(SELECT VIRTUAL_MACHINE_PK, VM_NAME AS HOST_NAME, IP_ADDRESS, FQDN, NUM_CPUS, MEMORY_MAX AS MEMORY_LIMIT, OPERATING_SYSTEM_NAME, OPERATING_SYSTEM_VERSION, SYSTEM_SHORT_NAME, MANAGED_SYSTEM_NAME
        FROM CFG_VIRTUAL_MACHINE
        WHERE VIRTUAL_MACHINE_PK IN
				(SELECT DISTINCT A.VIRTUAL_MACHINE_PK FROM 
					(SELECT VIRTUAL_MACHINE_PK, PHYSICAL_SERVER_PK FROM CFG_VIRTUAL_MACHINE 
						UNION
					SELECT SOURCE_SERVER_ID AS VIRTUAL_MACHINE_PK, TARGET_SERVER_ID AS PHYSICAL_SERVER_PK FROM ANL_TARGET_DESIGN) A
				INNER JOIN
		(SELECT X.PHYSICAL_SERVER_PK
	                        FROM
	                                (SELECT DISTINCT  PHYSICAL_SERVER_PK
	                                FROM ANL_SERVER_TAG_MAP
	                                WHERE SERVER_TAGS_PK = (SELECT SERVER_TAGS_PK FROM ANL_SERVER_TAGS WHERE (TAG_TYPE = 'WorkingSet' AND TAG_NAME = 'TRUE'))                                	
	                                ) X
	                        INNER JOIN
	                                (SELECT DISTINCT PHYSICAL_SERVER_PK
	                                FROM ANL_SERVER_TAG_MAP
	                                WHERE SERVER_TAGS_PK IN (SELECT SERVER_TAGS_PK FROM ANL_SERVER_TAGS WHERE(Tag_Type = 'Type' AND (Tag_Name = 'Source' OR Tag_Name = 'Target')))
	                                ) U
	
	                        ON X.PHYSICAL_SERVER_PK = U.PHYSICAL_SERVER_PK) B
		ON A.PHYSICAL_SERVER_PK = B.PHYSICAL_SERVER_PK)
)
@

-- Percentile calculations
CREATE VIEW MES_PERCENTILE_CPU_H_V (VM_KEY, VM_NAME, WRITETIME, AVG_CPU_UTILIZATION)
AS
(
SELECT VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME, MES.AVG_CPU_UTILIZATION
FROM
	MES_VM_CPU_H AS MES
	, ANL_WORKING_SET_V AS WORKINGSET
	, ANL_TIME_DIM AS TIME
	, CFG_USER_CONFIGURATION AS USER_CONFIG
	, CFG_VIRTUAL_MACHINE AS VM
WHERE
	MES.VM_NAME = VM.VM_NAME
	AND VM.PHYSICAL_SERVER_PK = WORKINGSET.PHYSICAL_SERVER_PK
	AND MES.WRITETIME = TIME.CANDLETIMESTAMP
	AND TIME.TIME_RANGE_START BETWEEN USER_CONFIG.START_TIME AND USER_CONFIG.END_TIME
	AND MES.AVG_CPU_UTILIZATION >=0
)
@

CREATE VIEW MES_PERCENTILE_DISK_H_V (VM_KEY, VM_NAME, WRITETIME, AVG_TOTAL_IO)
AS
(
SELECT VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME, SUM(MES.AVG_TOTAL_IO)
FROM
	MES_VM_DATA_STORE_H AS MES
	, ANL_WORKING_SET_V AS WORKINGSET
	, ANL_TIME_DIM AS TIME
	, CFG_USER_CONFIGURATION AS USER_CONFIG
	, CFG_VIRTUAL_MACHINE AS VM
WHERE
	MES.VM_NAME = VM.VM_NAME
	AND VM.PHYSICAL_SERVER_PK = WORKINGSET.PHYSICAL_SERVER_PK
	AND MES.WRITETIME = TIME.CANDLETIMESTAMP
	AND TIME.TIME_RANGE_START BETWEEN USER_CONFIG.START_TIME AND USER_CONFIG.END_TIME
	AND MES.AVG_TOTAL_IO >=0
	GROUP BY VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME
)
@

CREATE VIEW MES_PERCENTILE_MEM_H_V (VM_KEY, VM_NAME, WRITETIME, AVG_GUEST_UTILIZATION)
AS
(
SELECT VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME, MES.AVG_GUEST_UTILIZATION
FROM
	MES_VM_MEM_H AS MES
	, ANL_WORKING_SET_V AS WORKINGSET
	, ANL_TIME_DIM AS TIME
	, CFG_USER_CONFIGURATION AS USER_CONFIG
	, CFG_VIRTUAL_MACHINE AS VM
WHERE
	MES.VM_NAME = VM.VM_NAME
	AND VM.PHYSICAL_SERVER_PK = WORKINGSET.PHYSICAL_SERVER_PK
	AND MES.WRITETIME = TIME.CANDLETIMESTAMP
	AND TIME.TIME_RANGE_START BETWEEN USER_CONFIG.START_TIME AND USER_CONFIG.END_TIME
	AND MES.AVG_GUEST_UTILIZATION >=0
)
@

CREATE VIEW MES_PERCENTILE_NW_H_V (VM_KEY, VM_NAME, WRITETIME, AVG_TOTAL_KBPS)
AS
(
SELECT VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME, SUM(MES.AVG_RECEIVED_KBPS + MES.AVG_TRANSMITTED_KBPS)
FROM
	MES_VM_NETWORK_H AS MES
	, ANL_WORKING_SET_V AS WORKINGSET
	, ANL_TIME_DIM AS TIME
	, CFG_USER_CONFIGURATION AS USER_CONFIG
	, CFG_VIRTUAL_MACHINE AS VM
WHERE
	MES.VM_NAME = VM.VM_NAME
	AND VM.PHYSICAL_SERVER_PK = WORKINGSET.PHYSICAL_SERVER_PK
	AND MES.WRITETIME = TIME.CANDLETIMESTAMP
	AND TIME.TIME_RANGE_START BETWEEN USER_CONFIG.START_TIME AND USER_CONFIG.END_TIME
	AND MES.AVG_RECEIVED_KBPS >=0
	AND MES.AVG_TRANSMITTED_KBPS >=0
	GROUP BY VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME
)
@

CREATE INDEX IDX_CFG_PHYSICAL_SERVER_HOST ON CFG_PHYSICAL_SERVER(HOST_NAME)@

CREATE INDEX IDX_CFG_VIRTUAL_MACHINE_VM ON CFG_VIRTUAL_MACHINE(VM_NAME)@

CREATE INDEX IDX_CFG_VIRTUAL_MACHINE_OS ON CFG_VIRTUAL_MACHINE(OPERATING_SYSTEM_NAME)@

CREATE INDEX IDX_CFG_VIRTUAL_MACHINE_MW ON CFG_VIRTUAL_MACHINE(MIDDLEWARE_NAME)@

CREATE INDEX IDX_ANL_RESOURCE_DEMAND_CPU ON ANL_RESOURCE_DEMAND(CPU_UTIL_TYPE)@

CREATE INDEX IDX_ANL_RESOURCE_DEMAND_MEM ON ANL_RESOURCE_DEMAND(MEM_UTIL_TYPE)@

CREATE INDEX IDX_ANL_RESOURCE_DEMAND_DISK ON ANL_RESOURCE_DEMAND(DISK_UTIL_TYPE)@

CREATE INDEX IDX_ANL_RESOURCE_DEMAND_NET ON ANL_RESOURCE_DEMAND(NETWORK_UTIL_TYPE)@

CREATE INDEX IDX_CAPACITY_VIOLATION_SVR ON CAPACITY_VIOLATION(SERVER_ID)@

CREATE INDEX IDX_ANL_TARGET_DESIGN_SRC ON ANL_TARGET_DESIGN(SOURCE_SERVER_ID)@

CREATE INDEX IDX_ANL_TARGET_DESIGN_TAR ON ANL_TARGET_DESIGN(TARGET_SERVER_ID)@

CREATE INDEX IDX_CFG_DATA_STORE_TO_VIRTUAL_MACHINE_MAP_VM_DS ON CFG_DATA_STORE_TO_VIRTUAL_MACHINE_MAP(VIRTUAL_MACHINE_PK ASC,DATA_STORE_PK ASC) COMPRESS NO ALLOW REVERSE SCANS@

CREATE INDEX IDX_CFG_DATA_STORE_TO_STORAGE_VOLUME_MAP_SVK_DSPK ON CFG_DATA_STORE_TO_STORAGE_VOLUME_MAP(STORAGE_VOLUME_KEY ASC,DATA_STORE_PK ASC) COMPRESS NO ALLOW REVERSE SCANS@

CREATE INDEX IDX_CFG_VIRTUAL_MACHINE_HN ON CFG_VIRTUAL_MACHINE(HOST_NAME ASC) COMPRESS NO ALLOW REVERSE SCANS@

CREATE INDEX IDX_CFG_VIRTUAL_MACHINE_DN ON CFG_VIRTUAL_MACHINE(DISPLAY_NAME ASC) COMPRESS NO ALLOW REVERSE SCANS@

CREATE INDEX IDX_CFG_VIRTUAL_MACHINE_PSPK  ON CFG_VIRTUAL_MACHINE(PHYSICAL_SERVER_PK ASC)COMPRESS NO ALLOW REVERSE SCANS@

COMMENT ON TABLE KBS_FP_CUSTOMER_SPECIFIC IS 'Customer specific financial parameters'@

COMMENT ON TABLE KBS_FP_HYPERVISOR IS 'This table stores details about the hypervisors'@

COMMENT ON TABLE KBS_FP_PVU IS 'This table stores financial data for matched server models'@

COMMENT ON TABLE KBS_VIRTUALIZATION_OVERHEAD IS 'This table corrects benchmark values based on hyper-visor overheads. It also reserves headroom for peaks.'@

COMMENT ON TABLE ANL_MATCHED_SERVER_CATALOG IS 'Generic table for matched servers with used benchmark'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.GUID IS 'Unique identification data for a physical server'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.HOST_NAME IS 'Primary Host Name of a physical server'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.IP_ADDRESS IS 'Primary IP address of a physical server'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.FQDN IS 'Fully Qualified Domain Name'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.SERVER_POOL_NAME IS 'Server Pool Name of a physical server. This is related to High Availability.'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.DATA_CENTER_NAME IS 'Name of the data center in which physical server is situated. This could be mapped with SITE name.'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.NUM_CPUS IS 'Number of CPU cores present'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.CPU_SPEED IS 'CPU speed in MHz'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.CPU_CORES_INSTALLED IS 'CPU cores installed on a physical server'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.CPU_CORES_ENABLED IS 'Number of CPU cores enabled ( <= CPU_CORES_INSTALLED)'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.MEMORY_LIMIT IS 'Maximum amount of memory that can be installed on a physical server (in MB)'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.MEMORY_INSTALLED IS 'Actual amount of memory installed on a physical server'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.MANUFACTURER IS 'Name of the manufacturer'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.MODEL IS 'Company specific model name of a physical server'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.SERIAL_NUMBER IS 'Company specific unique serial number of a physical server'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.SIGNATURE IS 'Unique string for a physical server'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.ARCHITECTURE IS 'Processor family information'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.SYSTEM_SHORT_NAME IS 'System short name (not necessorily unique)'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.MANAGED_SYSTEM_NAME IS 'System name on which data collection agent is installed'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.MAX_POWER IS 'Maximum power rating'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.TIMEZONE IS 'String representing time zone of a physical server'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.HYPERVISOR_TYPE IS 'Hypervisor type'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.HYPERVISOR_VERSION IS 'Hypervisor version'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.HYPER_THREADING_CAPABLE IS 'Flag value indicating hyperthreading capability of a physical server. Possible values are Y or N.'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.HYPER_THREADING_ENABLED IS 'Flag value indicating hyperthreading enablement of a physical server. Possible values are Y or N.'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.IS_VIRTUALIZED IS 'Flag indicating whether a physical server is stand alone or hosting Virual Machine'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.DATA_SOURCE IS 'Name of the data source like ''Discovery'', ''Knowledge Base'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.LAST_EDIT_TIMESTAMP IS 'Auto generated timestamp for last edit of this table (DBMS will populate this value)'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.OPERATING_SYSTEM_VERSION IS 'Hypervisor version'@

COMMENT ON COLUMN CFG_PHYSICAL_SERVER.OPERATING_SYSTEM_NAME IS 'Hypervisor type'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.VMID IS 'Unique ID for each virtual machine'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.HOST_NAME IS 'Primary host name of a virtual machine'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.IP_ADDRESS IS 'Primary IP address of a virtual machine'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.FQDN IS 'Fully Qualified Host Name'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.CPU_MIN IS 'Miniimum number of CPUs which must be alloted to a virtual machine'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.CPU_MAX IS 'Maximum number of CPUs that can be alloted to a virtual machine'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.CPU_DESIRED IS 'Desired number of CPUs for a virtual machine '@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.MEMORY_MIN IS 'Mimimum amount of memory that must be alloted'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.MEMORY_MAX IS 'Maximum amount of memory that can be alloted'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.MEMORY_DESIRED IS 'Desired amount of memory for a virtual machine '@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.OPERATING_SYSTEM_NAME IS 'OS name'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.OPERATING_SYSTEM_VERSION IS 'OS version'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.MIDDLEWARE_NAME IS 'Name of the Application server/ Middleware installed on the machine'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.MIDDLEWARE_VERSION IS 'Version of the application server/ middleware installed on a virtual machine'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.SYSTEM_SHORT_NAME IS 'System short name (Not necessarily unique)'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.MANAGED_SYSTEM_NAME IS 'System name on which data collection agent is installed '@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.DATA_SOURCE IS 'Data collection source (Discovery, Knowledge base)'@

COMMENT ON COLUMN CFG_VIRTUAL_MACHINE.LAST_EDIT_TIMESTAMP IS 'Auto generated timestamp indicating last write to this table (DBMS generated)'@

COMMENT ON COLUMN CFG_IP_INTERFACE.GUID IS 'Unique identification string for a physical server/ virtual machine'@

COMMENT ON COLUMN CFG_IP_INTERFACE.IS_PRIMARY IS 'Flag to specify whether host_name/ ip_address is primary or not'@

COMMENT ON COLUMN KBS_FP_CUSTOMER_SPECIFIC.COOLING_COST_SOURCE IS 'Float value In USD/KwH'@

COMMENT ON COLUMN KBS_FP_CUSTOMER_SPECIFIC.COOLING_COST_TARGET IS 'Float value In USD/KwH'@

COMMENT ON COLUMN KBS_FP_CUSTOMER_SPECIFIC.POWER_COST_SOURCE IS 'Float value In USD/KwH'@

COMMENT ON COLUMN KBS_FP_CUSTOMER_SPECIFIC.POWER_COST_TARGET IS 'Float value In USD/KwH'@

COMMENT ON COLUMN KBS_FP_CUSTOMER_SPECIFIC.RACK_HEIGHT_U IS 'Height of a rack (in U)'@

COMMENT ON COLUMN KBS_FP_CUSTOMER_SPECIFIC.SQUAREFEET_PER_RACK IS 'Space taken by rack (including wastage)'@

COMMENT ON COLUMN KBS_FP_CUSTOMER_SPECIFIC.FLOORSPACE_COST_SOURCE IS 'USD/sqft/month space cost for source site'@

COMMENT ON COLUMN KBS_FP_CUSTOMER_SPECIFIC.FLOORSPACE_COST_TARGET IS 'USD/sqft/month space cost for target site'@

COMMENT ON COLUMN KBS_FP_CUSTOMER_SPECIFIC.RACK_OCCUPANCY_SOURCE IS 'Usable portion of the rack (in %)'@

COMMENT ON COLUMN KBS_FP_CUSTOMER_SPECIFIC.RACK_OCCUPANCY_TARGET IS 'Usable portion of the rack (in %)'@

COMMENT ON COLUMN KBS_FP_HYPERVISOR.HYPERVISOR_COST_PER_PROCESSOR IS 'Cost in USD '@

COMMENT ON COLUMN KBS_FP_HYPERVISOR.HYPERVISOR_COST_PER_PVU IS 'Cost in USD '@

COMMENT ON COLUMN KBS_FP_HYPERVISOR.ANNUAL_MAINTENANCE IS 'Cost in USD per PVU/Processor (depending on which of the above two columns have valid data)'@

COMMENT ON COLUMN KBS_FP_PVU.VENDOR IS 'Vendor Code, e.g., IBM, HPQ'@

COMMENT ON COLUMN KBS_FP_PVU.SERVER_DESCRIPTION IS 'Server description  model name/processor type/clock/cache/#chips/#cores'@

COMMENT ON COLUMN KBS_FP_PVU.MODEL IS 'Name of server model, e.g.,''System x 3950'@

COMMENT ON COLUMN KBS_FP_PVU.FAMILY IS 'Name of Server Family, e.g., ''System X'@

COMMENT ON COLUMN KBS_FP_PVU.PROCESSOR IS 'Processor description  type, clock speed and maximum cache size'@

COMMENT ON COLUMN KBS_FP_PVU.PROCESSOR_SPEED_MHZ IS 'Processor frequency in MHz'@

COMMENT ON COLUMN KBS_FP_PVU.PROCESSOR_CHIPS IS 'Number of active processor chips'@

COMMENT ON COLUMN KBS_FP_PVU.PROCESSOR_CORES IS 'Number of active processor cores'@

COMMENT ON COLUMN KBS_FP_PVU.PVUS_PER_CORE IS 'PVU per core on the server'@

COMMENT ON COLUMN KBS_FP_PVU.SERVER_COST IS 'Server Cost in USD'@

COMMENT ON COLUMN KBS_FP_PVU.ANNUAL_MAINTENANCE_COST IS 'Annual Maintenance Cost in USD'@

COMMENT ON COLUMN KBS_FP_PVU.MEMORY_STANDARD IS 'Memory in GB (std. config)'@

COMMENT ON COLUMN KBS_FP_PVU.MEM_PRICE_PER_GB IS 'In USD'@

COMMENT ON COLUMN KBS_FP_PVU.LIFE_CYCLE IS 'In years'@

COMMENT ON COLUMN KBS_FP_PVU.NOTES IS 'Additional information'@

COMMENT ON COLUMN KBS_VIRTUALIZATION_OVERHEAD.HYPERVISOR_TYPE IS 'Type of the hypervisor, Example VMWare, ESX, PowerVM'@

COMMENT ON COLUMN KBS_VIRTUALIZATION_OVERHEAD.HYPERVISOR_VERSION IS 'Version of the hypervisor used'@

COMMENT ON COLUMN KBS_VIRTUALIZATION_OVERHEAD.CPU_CORES_RANGE_LOWER IS 'The lower end of the range for number of cores in the target server'@

COMMENT ON COLUMN KBS_VIRTUALIZATION_OVERHEAD.CPU_CORES_RANGE_UPPER IS 'The upper end of the range for number of cores in the target server'@

COMMENT ON COLUMN KBS_VIRTUALIZATION_OVERHEAD.PERCENTAGE_CPU_OVERHEAD IS '%CPU overhead for virtualization and reserved as headroom for peaks'@

COMMENT ON COLUMN KBS_VIRTUALIZATION_OVERHEAD.PERCENTAGE_MEMORY_OVERHEAD IS '%Memory consumed by virtualization layer and reserved for peaks'@

COMMENT ON COLUMN KBS_VIRTUALIZATION_OVERHEAD.PERCENTAGE_NETWORK_OVERHEAD IS '%Network consumed by virtualization layer'@

COMMENT ON COLUMN KBS_VIRTUALIZATION_OVERHEAD.PERCENTAGE_INTERNAL_DISK_OVERHEAD IS '%Internal Disk consumed by virtualization layer '@

COMMENT ON COLUMN KBS_VIRTUALIZATION_OVERHEAD.PERCENTAGE_DISK_IO_OVERHEAD IS '%SAN Disk I/O bandwidth consumed by virtualization layer'@

COMMENT ON COLUMN KBS_VIRTUALIZATION_OVERHEAD.APPLICATION_TYPE IS 'Application characteristics, e.g., cpu_intensive, mem_intensive ertc.'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.VENDOR IS 'Vendor Code, e.g., IBM, HPQ'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.SERVER_DESCRIPTION IS 'Server description  model name/processor type/clock/cache/#chips/#cores'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.MODEL IS 'Name of server model, e.g.,''System x 3950'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.FAMILY IS 'Name of Server Family, e.g., ''System X'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.PROCESSOR IS 'Processor description  type, clock speed and maximum cache size'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.PROCESSOR_SPEED_MHZ IS 'Processor frequency in MHz'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.PROCESSOR_CHIPS IS 'Number of active processor chips'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.PROCESSOR_CORES IS 'Number of active processor cores'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.RPE2 IS 'IDEAS multi-component performance estimate value'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.OLTP_RPE IS 'IDEAS previous OLTP Relative Performance Estimate value'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.OS IS 'Supported Operating Systems'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.DATE IS 'Date of introduction'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.UVALUES IS 'Rack U values '@

COMMENT ON COLUMN KBS_IDEAS_OTHER.HEIGHT_MM IS 'Height of the Server in mm'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.WIDTH_MM IS 'Width of the Server in mm'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.DEPTH_MM IS 'Depth of the Server in mm '@

COMMENT ON COLUMN KBS_IDEAS_OTHER.MAX_HEAT_MBTU IS 'Maximum heat generation in MBTU'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.MAX_POWER_WATTS IS 'Maximum power consumption in Watts'@

COMMENT ON COLUMN KBS_IDEAS_OTHER.NOTES IS 'Additional information'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.VENDOR IS 'Vendor Code, e.g., IBM, HPQ'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.SERVER_DESCRIPTION IS 'Server description  model name/processor type/clock/cache/#chips/#cores'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.MODEL IS 'Name of server model, e.g.,''System x 3950'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.FAMILY IS 'Name of Server Family, e.g., ''System X'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.PROCESSOR IS 'Processor description  type, clock speed and maximum cache size'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.PROCESSOR_SPEED_MHZ IS 'Processor frequency in MHz'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.PROCESSOR_CHIPS IS 'Number of active processor chips'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.PROCESSOR_CORES IS 'Number of active processor cores'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.RPE2 IS 'IDEAS multi-component performance estimate value'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.OLTP_RPE IS 'IDEAS previous OLTP Relative Performance Estimate value'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.OS IS 'Supported Operating Systems'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.DATE IS 'Date of introduction'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.UVALUES IS 'Rack U values '@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.HEIGHT_MM IS 'Height of the Server in mm'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.WIDTH_MM IS 'Width of the Server in mm'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.DEPTH_MM IS 'Depth of the Server in mm'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.MAX_HEAT_MBTU IS 'Maximum heat generation in MBTU'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.MAX_POWER_WATTS IS 'Maximum power consumption in Watts'@

COMMENT ON COLUMN KBS_IDEAS_RISC_IPF.NOTES IS 'Additional information'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.VENDOR IS 'Vendor Code, e.g., IBM, HPQ'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.SERVER_DESCRIPTION IS 'Server description  model name/processor type/clock/cache/#chips/#cores'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.MODEL IS 'Name of server model, e.g.,''System x 3950'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.FAMILY IS 'Name of Server Family, e.g., ''System X'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.PROCESSOR IS 'Processor description  type, clock speed and maximum cache size'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.PROCESSOR_SPEED_MHZ IS 'Processor frequency in MHz'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.PROCESSOR_CHIPS IS 'Number of active processor chips'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.PROCESSOR_CORES IS 'Number of active processor cores'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.RPE2 IS 'IDEAS multi-component performance estimate value'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.OLTP_RPE IS 'IDEAS previous OLTP Relative Performance Estimate value'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.OS IS 'Supported Operating Systems'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.DATE IS 'Date of introduction'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.UVALUES IS 'Rack U values '@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.HEIGHT_MM IS 'Height of the Server in mm'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.WIDTH_MM IS 'Width of the Server in mm'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.DEPTH_MM IS 'Depth of the Server in mm'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.MAX_HEAT_MBTU IS 'Maximum heat generation in MBTU'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.MAX_POWER_WATTS IS 'Maximum power consumption in Watts'@

COMMENT ON COLUMN KBS_IDEAS_X86_IPF.NOTES IS 'Additional information'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.VENDOR IS 'Vendor Code, e.g., IBM, HPQ'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.SERVER_DESCRIPTION IS 'Server description  model name/processor type/clock/cache/#chips/#cores'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.MODEL IS 'Name of server model, e.g.,''System x 3950'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.FAMILY IS 'Name of Server Family, e.g., ''System X'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.PROCESSOR IS 'Processor description  type, clock speed and maximum cache size'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.PROCESSOR_SPEED_MHZ IS 'Processor frequency in MHz'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.PROCESSOR_CHIPS IS 'Number of active processor chips'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.PROCESSOR_CORES IS 'Number of active processor cores'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.MIPS IS 'Millions of Instructions Per Second'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.MSU IS 'Millions of Service Units(MSU) ratings'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.OS IS 'Supported Operating Systems'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.DATE IS 'Date of introduction'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.UVALUES IS 'Rack U values '@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.HEIGHT_MM IS 'Height of the Server in mm'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.WIDTH_MM IS 'Width of the Server in mm'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.DEPTH_MM IS 'Depth of the Server in mm'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.MAX_HEAT_MBTU IS 'Maximum heat generation in MBTU'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.MAX_POWER_WATTS IS 'Maximum power consumption in Watts'@

COMMENT ON COLUMN KBS_ZSERIES_MIPS.NOTES IS 'Additional information'@

COMMENT ON COLUMN CFG_SOFTWARE.IS_ROOT IS 'Application stacking'@



-- Stored Procedures

CREATE PROCEDURE ANL_TIME_DIMENSION (IN startDate VARCHAR(32), IN endDate VARCHAR(32),
IN granularity SMALLINT)
LANGUAGE SQL
BEGIN
DECLARE loaddate TIMESTAMP;
DECLARE endloaddate TIMESTAMP;
DECLARE v_endDate TIMESTAMP;
DECLARE v_duplicateKey INTEGER;
-- duplicate key SQLSTATE
DECLARE duplicate_key CONDITION FOR SQLSTATE '23505';
-- Continue to the next row if we receive this error
DECLARE CONTINUE HANDLER FOR duplicate_key
-- The row insertion failed
SET v_duplicateKey = 1;
SET v_duplicateKey = 0;
SET loaddate = TIMESTAMP(startDate);
SET v_endDate = TIMESTAMP(endDate);
time_loop:
LOOP
SET loaddate = loaddate + granularity minutes;
SET endloaddate = loaddate + (granularity - 1) minutes;
INSERT into TADFDC.ANL_TIME_DIM (
CANDLETIMESTAMP,
END_CANDLETIMESTAMP,
TIME_RANGE_START,
TIME_RANGE_END,
HOUR_KEY,
DAY_KEY,
WEEK_KEY,
MONTH_KEY,
QUARTER_KEY,
YEAR_KEY,
CURRENT_DATE,
CURRENT_MINUTE,
CURRENT_HOUR,
CURRENT_DAY,
CURRENT_WEEK,
CURRENT_MONTH,
CURRENT_QUARTER,
CURRENT_YEAR,
DAY_OF_WEEK,
DAYS_IN_MONTH,
DAY_OF_YEAR,
WEEK_OF_MONTH,
WEEK_OF_QUARTER,
TIME_PK 
)
VALUES
(
concat(concat(rtrim(char((YEAR(loaddate) - 1900)*1000000 + MONTH(loaddate)*10000 + DAY(loaddate)* 100 + HOUR(loaddate))),
rtrim(substr(char(100+ MINUTE(loaddate)),2,2))),'00000'),
concat(concat(rtrim(char((YEAR(endloaddate) - 1900)*1000000 + MONTH(endloaddate)*10000 + DAY(endloaddate)* 100 + HOUR(endloaddate))),
rtrim(substr(char(100+ MINUTE(endloaddate)),2,2))),'59999'),
loaddate - second(loaddate) seconds - microsecond (loaddate) microseconds,
endloaddate + 59 seconds + 999 microseconds,
loaddate - minute(loaddate) minutes - second(loaddate) seconds - microsecond (loaddate) microseconds,
loaddate - hour(loaddate) hours - minute(loaddate) minutes - second(loaddate) seconds - microsecond (loaddate) microseconds,
loaddate -(DAYOFWEEK(loaddate)-1) days - hour(loaddate) hours - minute(loaddate) minutes - second(loaddate) seconds - microsecond (loaddate) microseconds,
loaddate - (day(loaddate) -1 )days - hour(loaddate) hours - minute(loaddate) minutes - second(loaddate) seconds - microsecond (loaddate) microseconds,
timestamp(concat(concat(concat(rtrim(char(year(loaddate))), '-'),
rtrim(char(quarter(loaddate)*3-2))),'-1 00:00:00.0')),
loaddate - (month(loaddate) - 1) months - (day(loaddate) -1 )days - hour(loaddate) hours - minute(loaddate) minutes - second(loaddate) seconds - microsecond (loaddate) microseconds,
DATE(loaddate),
MINUTE(loaddate),
HOUR(loaddate),
DAY(loaddate),
WEEK(loaddate),
MONTH(loaddate),
QUARTER(loaddate),
YEAR(loaddate),
DAYOFWEEK(loaddate),
DAY((loaddate + 1 MONTH) - DAY(loaddate +1 MONTH) DAYS),
DAYOFYEAR(loaddate),
(DAY(loaddate)/7)+1,
WEEK(loaddate) - (QUARTER(loaddate) -1)*13,
(((((YEAR(loaddate)*100)+MONTH(loaddate))*100)+DAY(loaddate))*100)+HOUR(loaddate)
);
IF (loaddate >= v_endDate)
THEN LEAVE time_loop;
END IF;
END LOOP time_loop;
commit;
END
@

-- Variance calculation
CREATE PROCEDURE ANL_VARIANCE ( IN MEASUREMENTTYPE_C VARCHAR(25),IN MEASUREMENTTYPE_M VARCHAR(25),IN MEASUREMENTTYPE_D VARCHAR(25),
IN MEASUREMENTTYPE_N VARCHAR(25) )
	DYNAMIC RESULT SETS 1
------------------------------------------------------------------------
-- SQL Stored Procedure 
------------------------------------------------------------------------
P1: BEGIN

DECLARE V_STMT_C VARCHAR(2048);
DECLARE V_STMT_M VARCHAR(2048);
DECLARE V_STMT_D VARCHAR(2048);
DECLARE V_STMT_N VARCHAR(2048);
DECLARE V_VARIANCE_TYPE VARCHAR(32) DEFAULT '';
DECLARE V_HOST_NAME VARCHAR(256);
DECLARE V_HOST_KEY BIGINT;
DECLARE V_SERVER_KEY BIGINT;
DECLARE V_MEAN_VALUE DOUBLE;
DECLARE V_STDDEV_VALUE DOUBLE;
DECLARE V_VAR_VALUE DOUBLE;
DECLARE STARTTIMESTAMP VARCHAR(26);
DECLARE ENDTIMESTAMP VARCHAR(26);
DECLARE SQLCODE INTEGER DEFAULT 0 ;
DECLARE C_CPU CURSOR WITH HOLD FOR V_CPU;
DECLARE C_MEM CURSOR WITH HOLD FOR V_MEM;
DECLARE C_NET CURSOR WITH HOLD FOR V_NET;
DECLARE C_DISK CURSOR WITH HOLD FOR V_DISK;
-- Declare cursor
DECLARE ANL_VARIANCE CURSOR WITH RETURN FOR
SELECT * FROM TADFDC.ANL_RESOURCE_DEMAND;
SET CURRENT SCHEMA = TADFDC;
SET STARTTIMESTAMP = (SELECT START_TIME FROM TADFDC.CFG_USER_CONFIGURATION);
SET ENDTIMESTAMP = (SELECT END_TIME FROM TADFDC.CFG_USER_CONFIGURATION);



--CPU UTILIZATION
SET V_STMT_C=
'SELECT WORKINGSET.PHYSICAL_SERVER_PK,VM.VM_NAME,VM.VIRTUAL_MACHINE_PK, ' CONCAT 'AVG (DECFLOAT(UTIL.' CONCAT MEASUREMENTTYPE_C CONCAT
 '_CPU_UTILIZATION)), ' CONCAT 'STDDEV' CONCAT '(UTIL.' CONCAT MEASUREMENTTYPE_C CONCAT
 '_CPU_UTILIZATION)' CONCAT ' FROM TADFDC.MES_VM_CPU_' CONCAT 'H' CONCAT ' AS UTIL,TADFDC.ANL_TIME_DIM AS TIME,'
 CONCAT' TADFDC.ANL_WORKING_SET_V AS WORKINGSET , TADFDC.CFG_VIRTUAL_MACHINE VM WHERE '
CONCAT 'UTIL.WRITETIME=TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN' CONCAT '''' CONCAT STARTTIMESTAMP CONCAT ''''
CONCAT ' AND ' CONCAT '''' CONCAT ENDTIMESTAMP CONCAT '''' CONCAT 
' AND UTIL.' CONCAT MEASUREMENTTYPE_C CONCAT '_CPU_UTILIZATION >= 0' CONCAT
' AND UTIL.HOST_NAME=VM.VM_NAME AND '
CONCAT 'VM.PHYSICAL_SERVER_PK=WORKINGSET.PHYSICAL_SERVER_PK' CONCAT ' GROUP BY '
CONCAT 'WORKINGSET.PHYSICAL_SERVER_PK,VM.VM_NAME,VM.VIRTUAL_MACHINE_PK';

--MEMORY UTILIZATION
SET V_STMT_M=
'SELECT WORKINGSET.PHYSICAL_SERVER_PK,VM.VM_NAME,VM.VIRTUAL_MACHINE_PK,  ' CONCAT 'AVG (DECFLOAT(UTIL.' CONCAT MEASUREMENTTYPE_M CONCAT
 '_GUEST_UTILIZATION)), STDDEV(' CONCAT MEASUREMENTTYPE_M CONCAT '_GUEST_UTILIZATION) 'CONCAT 'FROM TADFDC.MES_VM_MEM_' CONCAT 'H' CONCAT ' AS UTIL,TADFDC.ANL_TIME_DIM AS TIME,'
 CONCAT' TADFDC.ANL_WORKING_SET_V AS WORKINGSET , TADFDC.CFG_VIRTUAL_MACHINE VM WHERE '
CONCAT 'UTIL.WRITETIME=TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN' CONCAT '''' CONCAT STARTTIMESTAMP CONCAT ''''
CONCAT ' AND ' CONCAT '''' CONCAT ENDTIMESTAMP CONCAT '''' 
CONCAT ' AND UTIL.' CONCAT MEASUREMENTTYPE_M CONCAT '_GUEST_UTILIZATION >= 0'
CONCAT ' AND UTIL.HOST_NAME=VM.VM_NAME AND '
CONCAT 'VM.PHYSICAL_SERVER_PK=WORKINGSET.PHYSICAL_SERVER_PK' CONCAT ' GROUP BY '
CONCAT 'WORKINGSET.PHYSICAL_SERVER_PK,VM.VM_NAME,VM.VIRTUAL_MACHINE_PK';

--NETWORK UTILIZATION
SET V_STMT_N=
'SELECT AGG.PHYSICAL_SERVER_PK,AGG.VM_NAME,AGG.VIRTUAL_MACHINE_PK,  ' CONCAT 'AVG (DECFLOAT(AGG.TOTAL_TRANS)),' CONCAT 'STDDEV' CONCAT '(AGG.TOTAL_TRANS) ' CONCAT
 'FROM (SELECT WORKINGSET.PHYSICAL_SERVER_PK,VM.VM_NAME,VM.VIRTUAL_MACHINE_PK,  ' CONCAT 'SUM' CONCAT '((UTIL.' CONCAT MEASUREMENTTYPE_N CONCAT
 '_RECEIVED_KBPS+' CONCAT 'UTIL.' CONCAT MEASUREMENTTYPE_N CONCAT '_TRANSMITTED_KBPS)) AS TOTAL_TRANS' CONCAT ' FROM TADFDC.MES_VM_NETWORK_' CONCAT 'H' CONCAT ' AS UTIL,TADFDC.ANL_TIME_DIM AS TIME,'
 CONCAT' TADFDC.ANL_WORKING_SET_V AS WORKINGSET , TADFDC.CFG_VIRTUAL_MACHINE VM WHERE '
CONCAT 'UTIL.WRITETIME=TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN' CONCAT '''' CONCAT STARTTIMESTAMP CONCAT ''''
CONCAT ' AND ' CONCAT '''' CONCAT ENDTIMESTAMP CONCAT '''' 
CONCAT ' AND ((UTIL.' CONCAT MEASUREMENTTYPE_N CONCAT '_RECEIVED_KBPS >= 0)OR(UTIL.'
CONCAT MEASUREMENTTYPE_N CONCAT '_TRANSMITTED_KBPS >= 0))'
CONCAT ' AND UTIL.HOST_NAME=VM.VM_NAME AND '
CONCAT 'VM.PHYSICAL_SERVER_PK=WORKINGSET.PHYSICAL_SERVER_PK' CONCAT ' GROUP BY '
CONCAT 'WORKINGSET.PHYSICAL_SERVER_PK,VM.VM_NAME,VM.VIRTUAL_MACHINE_PK,UTIL.WRITETIME' CONCAT ') AS AGG GROUP BY AGG.PHYSICAL_SERVER_PK,AGG.VM_NAME,AGG.VIRTUAL_MACHINE_PK';

--DISK UTILIZATION
SET V_STMT_D=
'SELECT AGG.PHYSICAL_SERVER_PK,AGG.VM_NAME,AGG.VIRTUAL_MACHINE_PK,' CONCAT 'AVG (DECFLOAT(AGG.SUM_TOTAL_IO)),' CONCAT 'STDDEV' CONCAT '(AGG.SUM_TOTAL_IO) ' CONCAT
 'FROM (SELECT WORKINGSET.PHYSICAL_SERVER_PK,VM.VM_NAME,VM.VIRTUAL_MACHINE_PK,' CONCAT 'SUM' CONCAT '(UTIL.' CONCAT MEASUREMENTTYPE_D CONCAT
 '_TOTAL_IO) AS SUM_TOTAL_IO FROM TADFDC.MES_VM_DATA_STORE_' CONCAT 'H' CONCAT ' AS UTIL,TADFDC.ANL_TIME_DIM AS TIME,' CONCAT 
 ' TADFDC.ANL_WORKING_SET_V AS WORKINGSET ,TADFDC.CFG_VIRTUAL_MACHINE VM WHERE ' 
CONCAT 'UTIL.WRITETIME=TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN' CONCAT '''' CONCAT STARTTIMESTAMP CONCAT ''''
CONCAT ' AND ' CONCAT '''' CONCAT ENDTIMESTAMP CONCAT '''' 
CONCAT ' AND UTIL.' CONCAT MEASUREMENTTYPE_D CONCAT '_TOTAL_IO >= 0'
CONCAT ' AND UTIL.HOST_NAME=VM.VM_NAME AND '
CONCAT 'VM.PHYSICAL_SERVER_PK=WORKINGSET.PHYSICAL_SERVER_PK' CONCAT ' GROUP BY '
CONCAT 'WORKINGSET.PHYSICAL_SERVER_PK,VM.VM_NAME,VM.VIRTUAL_MACHINE_PK,UTIL.WRITETIME' CONCAT ') AS AGG GROUP BY AGG.PHYSICAL_SERVER_PK,AGG.VM_NAME,AGG.VIRTUAL_MACHINE_PK';

--CALCULATE CPU VARIATION AND INSERT IN RESOURCE DEMAND
PREPARE V_CPU FROM V_STMT_C;
OPEN C_CPU;
FETCH C_CPU INTO V_SERVER_KEY,V_HOST_NAME,V_HOST_KEY,V_MEAN_VALUE,V_STDDEV_VALUE;
WHILE SQLCODE=0 DO

CASE
WHEN (V_MEAN_VALUE=0 AND V_STDDEV_VALUE<>0) THEN
	SET V_VARIANCE_TYPE = 'UNSTABLE';
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.CPU_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
WHEN (V_MEAN_VALUE<>0 AND V_STDDEV_VALUE=0) THEN
	SET V_VARIANCE_TYPE = 'STABLE';
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.CPU_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
WHEN (V_MEAN_VALUE<>0 AND V_STDDEV_VALUE<>0) THEN
	SET V_VAR_VALUE = CEIL((V_STDDEV_VALUE*(100/V_MEAN_VALUE)));
	SET V_VARIANCE_TYPE = 
		(SELECT DESC_VAR FROM TADFDC.ANL_THRESHOLDS
		WHERE V_VAR_VALUE BETWEEN CPU_VAR_LOW AND CPU_VAR_HIGH);
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.CPU_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
ELSE
	SET V_VARIANCE_TYPE = 'STABLE';
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.CPU_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
END CASE;
COMMIT;
FETCH C_CPU INTO V_SERVER_KEY,V_HOST_NAME,V_HOST_KEY,V_MEAN_VALUE,V_STDDEV_VALUE;
END WHILE;
CLOSE C_CPU;

--CALCULATE MEMORY VARIATION AND INSERT IN RESOURCE DEMAND
PREPARE V_MEM FROM V_STMT_M;
OPEN C_MEM;
FETCH C_MEM INTO V_SERVER_KEY,V_HOST_NAME,V_HOST_KEY,V_MEAN_VALUE,V_STDDEV_VALUE;
WHILE SQLCODE=0 DO
CASE
	WHEN (V_MEAN_VALUE=0 AND V_STDDEV_VALUE<>0) THEN
	SET V_VARIANCE_TYPE = 'UNSTABLE';
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.MEM_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
WHEN (V_MEAN_VALUE<>0 AND V_STDDEV_VALUE=0) THEN
	SET V_VARIANCE_TYPE = 'STABLE';
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.MEM_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
WHEN (V_MEAN_VALUE<>0 AND V_STDDEV_VALUE<>0) THEN
	SET V_VAR_VALUE = CEIL((V_STDDEV_VALUE*(100/V_MEAN_VALUE)));
	SET V_VARIANCE_TYPE = 
		(SELECT DESC_VAR FROM TADFDC.ANL_THRESHOLDS
		WHERE V_VAR_VALUE BETWEEN MEM_VAR_LOW AND MEM_VAR_HIGH);
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.MEM_VAR = V_VARIANCE_TYPE
		WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
ELSE
SET V_VARIANCE_TYPE = 'STABLE';
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.MEM_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
END CASE;

COMMIT;
FETCH C_MEM INTO V_SERVER_KEY,V_HOST_NAME,V_HOST_KEY,V_MEAN_VALUE,V_STDDEV_VALUE;
END WHILE;
CLOSE C_MEM;


--CALCULATE NETWORK VARIATION AND INSERT IN RESOURCE DEMAND
PREPARE V_NET FROM V_STMT_N;
OPEN C_NET;
FETCH C_NET INTO V_SERVER_KEY,V_HOST_NAME,V_HOST_KEY,V_MEAN_VALUE,V_STDDEV_VALUE;
WHILE SQLCODE=0 DO
CASE
WHEN (V_MEAN_VALUE=0 AND V_STDDEV_VALUE<>0) THEN
	SET V_VARIANCE_TYPE = 'UNSTABLE';
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.NETWORK_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
WHEN (V_MEAN_VALUE<>0 AND V_STDDEV_VALUE=0) THEN
	SET V_VARIANCE_TYPE = 'STABLE';
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.NETWORK_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
WHEN (V_MEAN_VALUE<>0 AND V_STDDEV_VALUE<>0) THEN
	SET V_VAR_VALUE = CEIL((V_STDDEV_VALUE*(100/V_MEAN_VALUE)));
	SET V_VARIANCE_TYPE = 
		(SELECT DESC_VAR FROM TADFDC.ANL_THRESHOLDS
		WHERE V_VAR_VALUE BETWEEN NETWORK_VAR_LOW AND NETWORK_VAR_HIGH);
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.NETWORK_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
ELSE
	SET V_VARIANCE_TYPE = 'STABLE';
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.NETWORK_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
END CASE;
COMMIT;
FETCH C_NET INTO V_SERVER_KEY,V_HOST_NAME,V_HOST_KEY,V_MEAN_VALUE,V_STDDEV_VALUE;
END WHILE;
CLOSE C_NET;

--CALCULATE DISK VARIATION AND INSERT IN RESOURCE DEMAND
PREPARE V_DISK FROM V_STMT_D;
OPEN C_DISK;
FETCH C_DISK INTO V_SERVER_KEY,V_HOST_NAME,V_HOST_KEY,V_MEAN_VALUE,V_STDDEV_VALUE;
WHILE SQLCODE=0 DO
CASE
WHEN (V_MEAN_VALUE=0 AND V_STDDEV_VALUE<>0) THEN
	SET V_VARIANCE_TYPE = 'UNSTABLE';
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.DISK_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
WHEN (V_MEAN_VALUE<>0 AND V_STDDEV_VALUE=0) THEN
	SET V_VARIANCE_TYPE = 'STABLE';
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.DISK_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
WHEN (V_MEAN_VALUE<>0 AND V_STDDEV_VALUE<>0) THEN
	SET V_VAR_VALUE = CEIL((V_STDDEV_VALUE*(100/V_MEAN_VALUE)));
	SET V_VARIANCE_TYPE = 
		(SELECT DESC_VAR FROM TADFDC.ANL_THRESHOLDS
		WHERE V_VAR_VALUE BETWEEN DISK_VAR_LOW AND DISK_VAR_HIGH);
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.DISK_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
ELSE
	SET V_VARIANCE_TYPE = 'STABLE';
	UPDATE TADFDC.ANL_RESOURCE_DEMAND SET TADFDC.ANL_RESOURCE_DEMAND.DISK_VAR = V_VARIANCE_TYPE
	WHERE TADFDC.ANL_RESOURCE_DEMAND.SERVER_PK=V_HOST_KEY;
END CASE;
COMMIT;
FETCH C_DISK INTO V_SERVER_KEY,V_HOST_NAME,V_HOST_KEY,V_MEAN_VALUE,V_STDDEV_VALUE;
END WHILE;
CLOSE C_DISK;
-- Cursor left open for client application
OPEN ANL_VARIANCE;
END P1
@

-- Workload sizing
CREATE PROCEDURE ANL_WORKLOAD_SIZING (IN GRANULARITY_C VARCHAR(25),IN GRANULARITY_M VARCHAR(25),
IN GRANULARITY_D VARCHAR(25),IN GRANULARITY_N VARCHAR(25),IN AGGREGATIONTYPE_C VARCHAR(25),
IN AGGREGATIONTYPE_M VARCHAR(25),
IN AGGREGATIONTYPE_D VARCHAR(25),
IN AGGREGATIONTYPE_N VARCHAR(25),
IN MEASUREMENTTYPE_C VARCHAR(25),IN MEASUREMENTTYPE_M VARCHAR(25),IN MEASUREMENTTYPE_D VARCHAR(25),
IN MEASUREMENTTYPE_N VARCHAR(25), IN NC DOUBLE, IN NM DOUBLE, IN NT DOUBLE, IN ND DOUBLE )
	DYNAMIC RESULT SETS 1
------------------------------------------------------------------------
-- SQL Stored Procedure 
------------------------------------------------------------------------
P1: BEGIN

--VARIABLES
DECLARE STARTTIMESTAMP VARCHAR(26);
DECLARE ENDTIMESTAMP VARCHAR(26);
DECLARE V_LOOP_INDEX INTEGER DEFAULT 1;
DECLARE V_TABLE_NAME VARCHAR (32);
DECLARE V_COLUMN_NAME VARCHAR (64);
DECLARE V_SUMMARY VARCHAR (32);
DECLARE V_STMT VARCHAR(2048);
DECLARE V_SERVER_PK BIGINT;
DECLARE V_UTIL_VALUE DOUBLE;
DECLARE V_UTIL_TYPE VARCHAR(32);
DECLARE SQLCODE INTEGER DEFAULT 0 ;

-- CURSORS
DECLARE C_STMT CURSOR WITH HOLD FOR CV_STMT;
DECLARE C_RESOURCE_DEMAND CURSOR WITH RETURN FOR
SELECT * FROM TADFDC.ANL_RESOURCE_DEMAND;

SET CURRENT SCHEMA = TADFDC;
SET STARTTIMESTAMP = (SELECT START_TIME FROM TADFDC.CFG_USER_CONFIGURATION);
SET ENDTIMESTAMP = (SELECT END_TIME FROM TADFDC.CFG_USER_CONFIGURATION);

 MAIN_LOOP:
  LOOP
   CASE 
    WHEN V_LOOP_INDEX = 1 THEN
       IF (AGGREGATIONTYPE_C='')THEN 
       GOTO PERCENTILE;
       END IF;
	   SET V_TABLE_NAME = 'TADFDC.MES_VM_CPU_' CONCAT GRANULARITY_C;
 	   SET V_COLUMN_NAME = 'UTIL.' CONCAT MEASUREMENTTYPE_C CONCAT '_CPU_UTILIZATION';
 	   SET V_SUMMARY = AGGREGATIONTYPE_C;
    WHEN V_LOOP_INDEX = 2 THEN
       IF (AGGREGATIONTYPE_M='')THEN
       GOTO PERCENTILE;
       END IF;	
	   SET V_TABLE_NAME = 'TADFDC.MES_VM_MEM_' CONCAT GRANULARITY_M;
	   SET V_COLUMN_NAME = 'UTIL.' CONCAT MEASUREMENTTYPE_M CONCAT '_GUEST_UTILIZATION';
	   SET V_SUMMARY = AGGREGATIONTYPE_M;
    WHEN V_LOOP_INDEX = 3 THEN
      IF (AGGREGATIONTYPE_D='')THEN
      GOTO PERCENTILE;
      END IF;
  	  SET V_TABLE_NAME = 'TADFDC.MES_VM_DATA_STORE_' CONCAT GRANULARITY_D;
	  SET V_COLUMN_NAME = 'UTIL.' CONCAT MEASUREMENTTYPE_D CONCAT '_TOTAL_IO';
	  SET V_SUMMARY = AGGREGATIONTYPE_D;
    ELSE
      IF (AGGREGATIONTYPE_N='')THEN
      GOTO PERCENTILE;
      END IF;
  	  SET V_TABLE_NAME = 'TADFDC.MES_VM_NETWORK_' CONCAT GRANULARITY_N;
	  SET V_COLUMN_NAME = 'UTIL.' CONCAT MEASUREMENTTYPE_N CONCAT '_RECEIVED_KBPS+' CONCAT 'UTIL.' CONCAT MEASUREMENTTYPE_N CONCAT '_TRANSMITTED_KBPS';
	  SET V_SUMMARY = AGGREGATIONTYPE_N;
    END CASE;

  SET V_STMT = 
	'SELECT VM.VIRTUAL_MACHINE_PK,CEIL( ' CONCAT V_SUMMARY CONCAT '(' CONCAT V_COLUMN_NAME CONCAT
	')) ' CONCAT 'FROM ' CONCAT V_TABLE_NAME CONCAT ' AS UTIL 'CONCAT ' ,TADFDC.ANL_TIME_DIM AS TIME,'
 	CONCAT' TADFDC.ANL_WORKING_SET_V AS WORKINGSET , TADFDC.CFG_VIRTUAL_MACHINE AS VM WHERE '
	CONCAT 'UTIL.' CONCAT 'WRITETIME=TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START >= ' CONCAT '''' CONCAT STARTTIMESTAMP CONCAT ''''
	CONCAT ' AND TIME.TIME_RANGE_START <= ' CONCAT '''' CONCAT ENDTIMESTAMP CONCAT '''' CONCAT ' AND '  
	CONCAT V_COLUMN_NAME CONCAT ' >= 0' CONCAT ' AND UTIL.HOST_NAME=VM.VM_NAME AND '
	CONCAT 'VM.PHYSICAL_SERVER_PK=WORKINGSET.PHYSICAL_SERVER_PK' CONCAT ' GROUP BY '
	CONCAT 'VM.VIRTUAL_MACHINE_PK';
 
  PREPARE CV_STMT FROM V_STMT;
	OPEN C_STMT;
	FETCH C_STMT INTO V_SERVER_PK,V_UTIL_VALUE;
	WHILE SQLCODE=0 DO
  		IF EXISTS (SELECT * FROM TADFDC.ANL_RESOURCE_DEMAND WHERE SERVER_PK = V_SERVER_PK) THEN
  			CASE 
    			WHEN V_LOOP_INDEX = 1 THEN
	  					  				
	  				SET V_UTIL_TYPE = 
	  				(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
	  				WHERE V_UTIL_VALUE >= THRESHOLDS.CPU_UTIL_LOW
	  				AND V_UTIL_VALUE <= THRESHOLDS.CPU_UTIL_HIGH);
	  				
	  				UPDATE TADFDC.ANL_RESOURCE_DEMAND SET 
	  				CPU_DEMAND_PERCENTAGE = V_UTIL_VALUE
	  				WHERE SERVER_PK = V_SERVER_PK;
	  				
	  				UPDATE TADFDC.ANL_RESOURCE_DEMAND SET 
	  				CPU_UTIL_TYPE = V_UTIL_TYPE
	  				WHERE SERVER_PK = V_SERVER_PK;
	  				
	  				
	  				
    			WHEN V_LOOP_INDEX = 2 THEN
	 		  		
	 		  		SET V_UTIL_TYPE = 
	  				(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
	  				WHERE V_UTIL_VALUE >= THRESHOLDS.MEM_UTIL_LOW
	  				AND V_UTIL_VALUE <= THRESHOLDS.MEM_UTIL_HIGH);
	  				
	 		  		UPDATE TADFDC.ANL_RESOURCE_DEMAND SET 
	  				MEMORY_DEMAND_PERCENTAGE = V_UTIL_VALUE
	  				WHERE SERVER_PK = V_SERVER_PK;
	  				
	  				UPDATE TADFDC.ANL_RESOURCE_DEMAND SET 
	  				MEM_UTIL_TYPE = V_UTIL_TYPE
	  				WHERE SERVER_PK = V_SERVER_PK;
	  				
	  				
   		 		WHEN V_LOOP_INDEX = 3 THEN
   		 		
   		 			SET V_UTIL_TYPE = 
	  				(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
	  				WHERE V_UTIL_VALUE >= THRESHOLDS.DISK_UTIL_LOW
	  				AND V_UTIL_VALUE <= THRESHOLDS.DISK_UTIL_HIGH);
	  				
  					UPDATE TADFDC.ANL_RESOURCE_DEMAND SET 
	  				DISK_DEMAND_MBPS = V_UTIL_VALUE
	  				WHERE SERVER_PK = V_SERVER_PK;
	  				
	  				UPDATE TADFDC.ANL_RESOURCE_DEMAND SET 
	  				DISK_UTIL_TYPE = V_UTIL_TYPE
	  				WHERE SERVER_PK = V_SERVER_PK;
	  				
   		 		ELSE
   		 		
   		 			SET V_UTIL_TYPE = 
	  				(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
	  				WHERE V_UTIL_VALUE >= THRESHOLDS.NETWORK_UTIL_LOW
	  				AND V_UTIL_VALUE <= THRESHOLDS.NETWORK_UTIL_HIGH);
   		 			
  	  				UPDATE TADFDC.ANL_RESOURCE_DEMAND SET 
	  				NETWORK_DEMAND_MBPS = V_UTIL_VALUE
	  				WHERE SERVER_PK = V_SERVER_PK;
	  				
	  				UPDATE TADFDC.ANL_RESOURCE_DEMAND SET 
	  				NETWORK_UTIL_TYPE = V_UTIL_TYPE
	  				WHERE SERVER_PK = V_SERVER_PK;
	  				
    		END CASE; 
  		ELSE
  			CASE 
    			WHEN V_LOOP_INDEX = 1 THEN
    			
    				SET V_UTIL_TYPE = 
	  				(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
	  				WHERE V_UTIL_VALUE >= THRESHOLDS.CPU_UTIL_LOW
	  				AND V_UTIL_VALUE <= THRESHOLDS.CPU_UTIL_HIGH);
	  				
	  				INSERT INTO TADFDC.ANL_RESOURCE_DEMAND
	  				(SERVER_PK,CPU_DEMAND_PERCENTAGE,CPU_UTIL_TYPE) VALUES
	  				(V_SERVER_PK,V_UTIL_VALUE,V_UTIL_TYPE);
	  				
	  				
    			WHEN V_LOOP_INDEX = 2 THEN
    				
    				SET V_UTIL_TYPE = 
	  				(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
	  				WHERE V_UTIL_VALUE >= THRESHOLDS.MEM_UTIL_LOW
	  				AND V_UTIL_VALUE <= THRESHOLDS.MEM_UTIL_HIGH);
	  				
	 		  		INSERT INTO TADFDC.ANL_RESOURCE_DEMAND
	 		  		(SERVER_PK,MEMORY_DEMAND_PERCENTAGE,MEM_UTIL_TYPE) VALUES
	  				(V_SERVER_PK,V_UTIL_VALUE,V_UTIL_TYPE);
	  				
	  				
   		 		WHEN V_LOOP_INDEX = 3 THEN
   		 			
   		 			SET V_UTIL_TYPE = 
	  				(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
	  				WHERE V_UTIL_VALUE >= THRESHOLDS.DISK_UTIL_LOW
	  				AND V_UTIL_VALUE <= THRESHOLDS.DISK_UTIL_HIGH);
	  				
  					INSERT INTO TADFDC.ANL_RESOURCE_DEMAND
  					(SERVER_PK,DISK_DEMAND_MBPS,DISK_UTIL_TYPE) VALUES
	  				(V_SERVER_PK,V_UTIL_VALUE,V_UTIL_TYPE);
	  				
	  				
   		 		ELSE
   		 		
   		 			SET V_UTIL_TYPE = 
	  				(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
	  				WHERE V_UTIL_VALUE >= THRESHOLDS.NETWORK_UTIL_LOW
	  				AND V_UTIL_VALUE <= THRESHOLDS.NETWORK_UTIL_HIGH);
	  				
  	  				INSERT INTO TADFDC.ANL_RESOURCE_DEMAND
  	  				(SERVER_PK,NETWORK_DEMAND_MBPS,NETWORK_UTIL_TYPE) VALUES
	  				(V_SERVER_PK,V_UTIL_VALUE,V_UTIL_TYPE);
	  				
	  				
    		END CASE;
    	END IF;
  	COMMIT;	
  	FETCH C_STMT INTO V_SERVER_PK,V_UTIL_VALUE;	
    END WHILE;
    CLOSE C_STMT;
    SET SQLCODE=0;
PERCENTILE:	
	SET V_LOOP_INDEX = V_LOOP_INDEX + 1;
	SET V_UTIL_TYPE = '';
	SET V_UTIL_VALUE = 0;
	
   IF V_LOOP_INDEX > 4 THEN
		LEAVE MAIN_LOOP;
		END IF;
		
  END LOOP MAIN_LOOP;
UPDATE TADFDC.ANL_RESOURCE_DEMAND SET MEMORY_DEMAND_MB = MEMORY_DEMAND_PERCENTAGE;
UPDATE TADFDC.ANL_RESOURCE_DEMAND SET DEVICE_TYPE = 'VM';
COMMIT;
-- CURSOR LEFT OPEN FOR CLIENT APPLICATION
OPEN C_RESOURCE_DEMAND;
END P1
@

-- Workload Sizing with Time Selector
CREATE PROCEDURE ANL_WORKLOAD_SIZING_TIME_SHIFT (IN GRANULARITY_C VARCHAR(25),IN GRANULARITY_M VARCHAR(25),
IN GRANULARITY_D VARCHAR(25),IN GRANULARITY_N VARCHAR(25),IN AGGREGATIONTYPE_C VARCHAR(25),
IN AGGREGATIONTYPE_M VARCHAR(25),
IN AGGREGATIONTYPE_D VARCHAR(25),
IN AGGREGATIONTYPE_N VARCHAR(25),
IN MEASUREMENTTYPE_C VARCHAR(25),IN MEASUREMENTTYPE_M VARCHAR(25),IN MEASUREMENTTYPE_D VARCHAR(25),
IN MEASUREMENTTYPE_N VARCHAR(25),IN DURATION_C VARCHAR(1000),IN DURATION_M VARCHAR(1000),IN DURATION_D VARCHAR(1000),IN DURATION_N VARCHAR(1000),IN NC DOUBLE, IN NM DOUBLE, IN NT DOUBLE, IN ND DOUBLE )
DYNAMIC RESULT SETS 1
P1: BEGIN

DECLARE STARTTIMESTAMP VARCHAR(26);
DECLARE ENDTIMESTAMP VARCHAR(26);
DECLARE V_LOOP_INDEX INTEGER DEFAULT 1;
DECLARE V_TABLE_NAME VARCHAR (32);
DECLARE V_COLUMN_NAME VARCHAR (64);
DECLARE V_COLUMN_NAME_1 VARCHAR (150);
DECLARE V_SUMMARY VARCHAR (32);
DECLARE V_STMT VARCHAR(2048);
DECLARE V_SERVER_PK BIGINT;
DECLARE V_UTIL_VALUE DOUBLE;
DECLARE V_UTIL_TYPE VARCHAR(32);
DECLARE SQLCODE INTEGER DEFAULT 0 ;
DECLARE FILTERING_CONDITION VARCHAR(1000);

DECLARE C_STMT CURSOR WITH HOLD FOR CV_STMT;
DECLARE C_RESOURCE_DEMAND CURSOR WITH RETURN FOR
SELECT * FROM TADFDC.ANL_RESOURCE_DEMAND;

SET CURRENT SCHEMA = TADFDC;
SET STARTTIMESTAMP = (SELECT START_TIME FROM TADFDC.CFG_USER_CONFIGURATION);
SET ENDTIMESTAMP = (SELECT END_TIME FROM TADFDC.CFG_USER_CONFIGURATION);


MAIN_LOOP:
LOOP
CASE
WHEN V_LOOP_INDEX = 1 THEN
IF (AGGREGATIONTYPE_C='')THEN
GOTO PERCENTILE;
END IF;
SET V_TABLE_NAME = 'TADFDC.MES_VM_CPU_' CONCAT GRANULARITY_C;
SET V_COLUMN_NAME = 'UTIL.' CONCAT MEASUREMENTTYPE_C CONCAT '_CPU_UTILIZATION';
SET V_SUMMARY = AGGREGATIONTYPE_C;
SET FILTERING_CONDITION = DURATION_C;

WHEN V_LOOP_INDEX = 2 THEN
IF (AGGREGATIONTYPE_M='')THEN
GOTO PERCENTILE;
END IF;
SET V_TABLE_NAME = 'TADFDC.MES_VM_MEM_' CONCAT GRANULARITY_M;
SET V_COLUMN_NAME = 'UTIL.' CONCAT MEASUREMENTTYPE_M CONCAT '_GUEST_UTILIZATION';
SET V_SUMMARY = AGGREGATIONTYPE_M;
SET FILTERING_CONDITION = DURATION_M;

WHEN V_LOOP_INDEX = 3 THEN
IF (AGGREGATIONTYPE_D='')THEN
GOTO PERCENTILE;
END IF;
SET V_TABLE_NAME = 'TADFDC.MES_VM_DATA_STORE_' CONCAT GRANULARITY_D;
SET V_COLUMN_NAME = 'UTIL.' CONCAT MEASUREMENTTYPE_D CONCAT '_TOTAL_IO';
SET V_COLUMN_NAME_1= 'SUM( UTIL.' CONCAT MEASUREMENTTYPE_D CONCAT '_TOTAL_IO ) AS TOTAL_IO';
SET V_SUMMARY = AGGREGATIONTYPE_D;
SET FILTERING_CONDITION = DURATION_D;
SET V_STMT =
'SELECT TEMP.VIRTUAL_MACHINE_PK, CEIL(' CONCAT V_SUMMARY CONCAT '( TEMP.TOTAL_IO)) FROM (SELECT VIRTUAL_MACHINE_PK,' CONCAT V_COLUMN_NAME_1 CONCAT ' FROM ' CONCAT V_TABLE_NAME CONCAT ' AS UTIL 'CONCAT ' ,TADFDC.ANL_TIME_DIM AS TIME,'
CONCAT' TADFDC.ANL_WORKING_SET_V AS WORKINGSET , TADFDC.CFG_VIRTUAL_MACHINE AS VM WHERE '
CONCAT 'UTIL.' CONCAT 'WRITETIME=TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN ' CONCAT '''' CONCAT STARTTIMESTAMP CONCAT ''''
CONCAT ' AND ' CONCAT '''' CONCAT ENDTIMESTAMP CONCAT ''''
CONCAT FILTERING_CONDITION CONCAT ' AND '
CONCAT V_COLUMN_NAME CONCAT ' >= 0' CONCAT ' AND UTIL.HOST_NAME=VM.VM_NAME AND '
CONCAT 'VM.PHYSICAL_SERVER_PK=WORKINGSET.PHYSICAL_SERVER_PK' CONCAT ' GROUP BY '
CONCAT 'VM.VIRTUAL_MACHINE_PK, UTIL.WRITETIME) AS TEMP GROUP BY TEMP.VIRTUAL_MACHINE_PK';
GOTO NETWORK;

ELSE
IF (AGGREGATIONTYPE_N='')THEN
GOTO PERCENTILE;
END IF;
SET V_TABLE_NAME = 'TADFDC.MES_VM_NETWORK_' CONCAT GRANULARITY_N;
SET V_COLUMN_NAME= 'UTIL.' CONCAT MEASUREMENTTYPE_N CONCAT '_RECEIVED_KBPS+' CONCAT 'UTIL.' CONCAT MEASUREMENTTYPE_N CONCAT '_TRANSMITTED_KBPS';
SET V_COLUMN_NAME_1 = 'SUM (UTIL.' CONCAT MEASUREMENTTYPE_N CONCAT '_RECEIVED_KBPS+' CONCAT 'UTIL.' CONCAT MEASUREMENTTYPE_N CONCAT '_TRANSMITTED_KBPS) AS TRANSFER_RATE';
SET V_SUMMARY = AGGREGATIONTYPE_N;
SET FILTERING_CONDITION = DURATION_N;
SET V_STMT =
'SELECT TEMP.VIRTUAL_MACHINE_PK, CEIL(' CONCAT V_SUMMARY CONCAT '( TEMP.TRANSFER_RATE)) FROM (SELECT VIRTUAL_MACHINE_PK,' CONCAT V_COLUMN_NAME_1 CONCAT ' FROM ' CONCAT V_TABLE_NAME CONCAT ' AS UTIL 'CONCAT ' ,TADFDC.ANL_TIME_DIM AS TIME,'
CONCAT' TADFDC.ANL_WORKING_SET_V AS WORKINGSET , TADFDC.CFG_VIRTUAL_MACHINE AS VM WHERE '
CONCAT 'UTIL.' CONCAT 'WRITETIME=TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN ' CONCAT '''' CONCAT STARTTIMESTAMP CONCAT ''''
CONCAT ' AND ' CONCAT '''' CONCAT ENDTIMESTAMP CONCAT ''''
CONCAT FILTERING_CONDITION CONCAT ' AND '
CONCAT V_COLUMN_NAME CONCAT ' >= 0 AND UTIL.' CONCAT MEASUREMENTTYPE_N CONCAT '_RECEIVED_KBPS >= 0 AND UTIL.'CONCAT MEASUREMENTTYPE_N CONCAT '_TRANSMITTED_KBPS >= 0 'CONCAT ' AND UTIL.HOST_NAME=VM.VM_NAME AND '
CONCAT 'VM.PHYSICAL_SERVER_PK=WORKINGSET.PHYSICAL_SERVER_PK' CONCAT ' GROUP BY '
CONCAT 'VM.VIRTUAL_MACHINE_PK, UTIL.WRITETIME) AS TEMP GROUP BY TEMP.VIRTUAL_MACHINE_PK';
GOTO NETWORK;
END CASE;


SET V_STMT =
'SELECT VM.VIRTUAL_MACHINE_PK,CEIL( ' CONCAT V_SUMMARY CONCAT '(' CONCAT V_COLUMN_NAME CONCAT
')) ' CONCAT 'FROM ' CONCAT V_TABLE_NAME CONCAT ' AS UTIL 'CONCAT ' ,TADFDC.ANL_TIME_DIM AS TIME,'
CONCAT' TADFDC.ANL_WORKING_SET_V AS WORKINGSET , TADFDC.CFG_VIRTUAL_MACHINE AS VM WHERE '
CONCAT 'UTIL.' CONCAT 'WRITETIME=TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN ' CONCAT '''' CONCAT STARTTIMESTAMP CONCAT ''''
CONCAT ' AND ' CONCAT '''' CONCAT ENDTIMESTAMP CONCAT ''''
CONCAT FILTERING_CONDITION CONCAT ' AND '
CONCAT V_COLUMN_NAME CONCAT ' >= 0' CONCAT ' AND UTIL.HOST_NAME=VM.VM_NAME AND '
CONCAT 'VM.PHYSICAL_SERVER_PK=WORKINGSET.PHYSICAL_SERVER_PK' CONCAT ' GROUP BY '
CONCAT 'VM.VIRTUAL_MACHINE_PK';

NETWORK:
PREPARE CV_STMT FROM V_STMT;
OPEN C_STMT;
FETCH C_STMT INTO V_SERVER_PK,V_UTIL_VALUE;
WHILE SQLCODE=0 DO
IF EXISTS (SELECT * FROM TADFDC.ANL_RESOURCE_DEMAND WHERE SERVER_PK = V_SERVER_PK) THEN
CASE
WHEN V_LOOP_INDEX = 1 THEN

SET V_UTIL_TYPE =
(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
WHERE V_UTIL_VALUE BETWEEN THRESHOLDS.CPU_UTIL_LOW
AND THRESHOLDS.CPU_UTIL_HIGH);

UPDATE TADFDC.ANL_RESOURCE_DEMAND SET
CPU_DEMAND_PERCENTAGE = V_UTIL_VALUE
WHERE SERVER_PK = V_SERVER_PK;

UPDATE TADFDC.ANL_RESOURCE_DEMAND SET
CPU_UTIL_TYPE = V_UTIL_TYPE
WHERE SERVER_PK = V_SERVER_PK;



WHEN V_LOOP_INDEX = 2 THEN

SET V_UTIL_TYPE =
(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
WHERE V_UTIL_VALUE BETWEEN THRESHOLDS.MEM_UTIL_LOW
AND THRESHOLDS.MEM_UTIL_HIGH);

UPDATE TADFDC.ANL_RESOURCE_DEMAND SET
MEMORY_DEMAND_PERCENTAGE = V_UTIL_VALUE
WHERE SERVER_PK = V_SERVER_PK;

UPDATE TADFDC.ANL_RESOURCE_DEMAND SET
MEM_UTIL_TYPE = V_UTIL_TYPE
WHERE SERVER_PK = V_SERVER_PK;


WHEN V_LOOP_INDEX = 3 THEN

SET V_UTIL_TYPE =
(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
WHERE V_UTIL_VALUE BETWEEN THRESHOLDS.DISK_UTIL_LOW
AND THRESHOLDS.DISK_UTIL_HIGH);

UPDATE TADFDC.ANL_RESOURCE_DEMAND SET
DISK_DEMAND_MBPS = V_UTIL_VALUE
WHERE SERVER_PK = V_SERVER_PK;

UPDATE TADFDC.ANL_RESOURCE_DEMAND SET
DISK_UTIL_TYPE = V_UTIL_TYPE
WHERE SERVER_PK = V_SERVER_PK;

ELSE

SET V_UTIL_TYPE =
(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
WHERE V_UTIL_VALUE BETWEEN THRESHOLDS.NETWORK_UTIL_LOW
AND THRESHOLDS.NETWORK_UTIL_HIGH);

UPDATE TADFDC.ANL_RESOURCE_DEMAND SET
NETWORK_DEMAND_MBPS = V_UTIL_VALUE
WHERE SERVER_PK = V_SERVER_PK;

UPDATE TADFDC.ANL_RESOURCE_DEMAND SET
NETWORK_UTIL_TYPE = V_UTIL_TYPE
WHERE SERVER_PK = V_SERVER_PK;

END CASE;
ELSE
CASE
WHEN V_LOOP_INDEX = 1 THEN

SET V_UTIL_TYPE =
(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
WHERE V_UTIL_VALUE BETWEEN THRESHOLDS.CPU_UTIL_LOW
AND THRESHOLDS.CPU_UTIL_HIGH);

INSERT INTO TADFDC.ANL_RESOURCE_DEMAND
(SERVER_PK,CPU_DEMAND_PERCENTAGE,CPU_UTIL_TYPE) VALUES
(V_SERVER_PK,V_UTIL_VALUE,V_UTIL_TYPE);


WHEN V_LOOP_INDEX = 2 THEN

SET V_UTIL_TYPE =
(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
WHERE V_UTIL_VALUE BETWEEN THRESHOLDS.MEM_UTIL_LOW
AND THRESHOLDS.MEM_UTIL_HIGH);

INSERT INTO TADFDC.ANL_RESOURCE_DEMAND
(SERVER_PK,MEMORY_DEMAND_PERCENTAGE,MEM_UTIL_TYPE) VALUES
(V_SERVER_PK,V_UTIL_VALUE,V_UTIL_TYPE);


WHEN V_LOOP_INDEX = 3 THEN

SET V_UTIL_TYPE =
(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
WHERE V_UTIL_VALUE BETWEEN THRESHOLDS.DISK_UTIL_LOW
AND THRESHOLDS.MEM_UTIL_HIGH);

INSERT INTO TADFDC.ANL_RESOURCE_DEMAND
(SERVER_PK,DISK_DEMAND_MBPS,DISK_UTIL_TYPE) VALUES
(V_SERVER_PK,V_UTIL_VALUE,V_UTIL_TYPE);


ELSE

SET V_UTIL_TYPE =
(SELECT DESC FROM TADFDC.ANL_THRESHOLDS AS THRESHOLDS
WHERE V_UTIL_VALUE BETWEEN THRESHOLDS.NETWORK_UTIL_LOW
AND THRESHOLDS.NETWORK_UTIL_HIGH);

INSERT INTO TADFDC.ANL_RESOURCE_DEMAND
(SERVER_PK,NETWORK_DEMAND_MBPS,NETWORK_UTIL_TYPE) VALUES
(V_SERVER_PK,V_UTIL_VALUE,V_UTIL_TYPE);


END CASE;
END IF;
COMMIT;
FETCH C_STMT INTO V_SERVER_PK,V_UTIL_VALUE;
END WHILE;
CLOSE C_STMT;
SET SQLCODE=0;
PERCENTILE:
SET V_LOOP_INDEX = V_LOOP_INDEX + 1;
SET V_UTIL_TYPE = '';
SET V_UTIL_VALUE = 0;

IF V_LOOP_INDEX > 4 THEN
LEAVE MAIN_LOOP;
END IF;

END LOOP MAIN_LOOP;
UPDATE TADFDC.ANL_RESOURCE_DEMAND SET MEMORY_DEMAND_MB = MEMORY_DEMAND_PERCENTAGE;
UPDATE TADFDC.ANL_RESOURCE_DEMAND SET DEVICE_TYPE = 'VM';
COMMIT;
OPEN C_RESOURCE_DEMAND;
END P1 
@

-- Function for computing percentile values on CPU measurements 

CREATE PROCEDURE ANL_PERCENTILE_CPU_SIZING (IN PVALUE INTEGER, IN FILTERING_CLAUSE VARCHAR(1000))
-- Input argument to specify what percentile value to calculate

DYNAMIC RESULT SETS 1

P1: BEGIN

-- VARIABLES
DECLARE STMT VARCHAR(2048);
DECLARE VM_PK INTEGER;
DECLARE UTIL_VALUE DOUBLE;
DECLARE UTIL_TYPE VARCHAR(32);
DECLARE SQLCODE INTEGER DEFAULT 0;
DECLARE TR_VAL BIGINT;

-- CURSORS
DECLARE C_STMT CURSOR WITH HOLD FOR P_STMT;
SET CURRENT SCHEMA = TADFDC;

-- Query to compute percentile
-- Partition data in view (MES_PERCENTILE_CPU_H_V) by VM_KEY, order by average cpu utilization, and get row number for each entry
-- Divde the row number by total number of observations to compute bucket into which the observation falls
-- Get percentile value for each bucket by finding the maximum cpu utilization for that bucket
-- Select the percentile based on the argument supplied
SET STMT = 
	'SELECT VM_KEY, PMES FROM
	(
	SELECT VM_KEY, INTEGER(FRACTION)*10 AS PERCENTILE, MAX(AVG_CPU_UTILIZATION) AS PMES FROM
		(SELECT CEIL(ROW_NUMBER() OVER (PARTITION BY VM_KEY ORDER BY AVG_CPU_UTILIZATION)*10
		/ FLOAT(COUNT(1) OVER(PARTITION BY VM_KEY))) AS FRACTION,
		VM_KEY, AVG_CPU_UTILIZATION FROM MES_PERCENTILE_CPU_H_V ' CONCAT FILTERING_CLAUSE CONCAT ')
	GROUP BY VM_KEY, FRACTION
	ORDER BY VM_KEY, FRACTION
	)
	WHERE PERCENTILE=' || CAST(PVALUE AS CHAR(2));
-- Casting the integer value into char above since db2, 9.5 does not support conctenation of integer to string

PREPARE P_STMT FROM STMT;

OPEN C_STMT;
FETCH C_STMT INTO VM_PK, UTIL_VALUE;
-- Go through each entry (VM key and Percentile) in the ResultSet

	WHILE SQLCODE = 0 DO
	SET TR_VAL = CEIL(UTIL_VALUE);
		IF EXISTS (SELECT * FROM ANL_RESOURCE_DEMAND WHERE SERVER_PK = VM_PK) THEN
			-- Compute the Utilization type by comparing with thresholds
			SET UTIL_TYPE = 
  				(SELECT DESC FROM ANL_THRESHOLDS AS THRESHOLDS
				WHERE TR_VAL >= THRESHOLDS.CPU_UTIL_LOW 
				AND TR_VAL <= THRESHOLDS.CPU_UTIL_HIGH);

				-- Update resource demand table with percentile vlaue
  				UPDATE ANL_RESOURCE_DEMAND 
				SET CPU_DEMAND_PERCENTAGE = TR_VAL
  				WHERE SERVER_PK = VM_PK;
	  				
				-- Update resource demand table with utilization type
  				UPDATE ANL_RESOURCE_DEMAND 
				SET CPU_UTIL_TYPE = UTIL_TYPE
  				WHERE SERVER_PK = VM_PK;
  		ELSE
			-- Compute the Utilization type by comparing with thresholds
			SET UTIL_TYPE = 
  				(SELECT DESC FROM ANL_THRESHOLDS AS THRESHOLDS
				WHERE TR_VAL >= THRESHOLDS.CPU_UTIL_LOW
				AND TR_VAL <= THRESHOLDS.CPU_UTIL_HIGH);

				-- Insert percentile and utilization type into the resource demand table
  				INSERT INTO ANL_RESOURCE_DEMAND
  				(SERVER_PK, CPU_DEMAND_PERCENTAGE, CPU_UTIL_TYPE) VALUES
  				(VM_PK, TR_VAL, UTIL_TYPE);
		END IF;
	  	COMMIT;	
		FETCH C_STMT INTO VM_PK, UTIL_VALUE;	
	END WHILE;

	CLOSE C_STMT;
	
UPDATE ANL_RESOURCE_DEMAND SET DEVICE_TYPE = 'VM';
COMMIT;
END P1
@
-- Function for computing percentile values on Memory measurements 

CREATE PROCEDURE ANL_PERCENTILE_MEM_SIZING (IN PVALUE INTEGER, IN FILTERING_CLAUSE VARCHAR(1000))
-- Input argument to specify what percentile value to calculate

DYNAMIC RESULT SETS 1

P1: BEGIN

-- VARIABLES
DECLARE STMT VARCHAR(2048);
DECLARE VM_PK INTEGER;
DECLARE UTIL_VALUE DOUBLE;
DECLARE UTIL_TYPE VARCHAR(32);
DECLARE SQLCODE INTEGER DEFAULT 0;
DECLARE TR_VAL BIGINT;

-- CURSORS
DECLARE C_STMT CURSOR WITH HOLD FOR P_STMT;
SET CURRENT SCHEMA = TADFDC;

-- Query to compute percentile
-- Partition data in view (MES_PERCENTILE_MEM_H_V) by VM_KEY, order by average guest utilization, and get row number for each entry
-- Divde the row number by total number of observations to compute bucket into which the observation falls
-- Get percentile value for each bucket by finding the maximum guest utilization for that bucket
-- Select the percentile based on the argument supplied
SET STMT =
	'SELECT VM_KEY, PMES FROM
	(
	SELECT VM_KEY, INTEGER(FRACTION)*10 AS PERCENTILE, MAX(AVG_GUEST_UTILIZATION) AS PMES FROM
		(SELECT CEIL(ROW_NUMBER() OVER (PARTITION BY VM_KEY ORDER BY AVG_GUEST_UTILIZATION)*10
		/ FLOAT(COUNT(1) OVER(PARTITION BY VM_KEY))) AS FRACTION,
		VM_KEY, AVG_GUEST_UTILIZATION FROM MES_PERCENTILE_MEM_H_V ' CONCAT FILTERING_CLAUSE CONCAT ')
	GROUP BY VM_KEY, FRACTION
	ORDER BY VM_KEY, FRACTION
	)
	WHERE PERCENTILE=' || CAST(PVALUE AS CHAR(2));
-- Casting the integer value into char above since db2, 9.5 does not support conctenation of integer to string

PREPARE P_STMT FROM STMT;

OPEN C_STMT;
FETCH C_STMT INTO VM_PK, UTIL_VALUE;
-- Go through each entry (VM key and Percentile) in the ResultSet

	WHILE SQLCODE = 0 DO
	SET TR_VAL = CEIL(UTIL_VALUE);
		IF EXISTS (SELECT * FROM ANL_RESOURCE_DEMAND WHERE SERVER_PK = VM_PK) THEN
			-- Compute the Utilization type by comparing with threshold
			SET UTIL_TYPE = 
  				(SELECT DESC FROM ANL_THRESHOLDS AS THRESHOLDS
				WHERE TR_VAL >= THRESHOLDS.MEM_UTIL_LOW 
				AND TR_VAL <= THRESHOLDS.MEM_UTIL_HIGH);

				-- Update resource demand table with percentile vlaue
  				UPDATE ANL_RESOURCE_DEMAND 
				SET MEMORY_DEMAND_PERCENTAGE = TR_VAL
  				WHERE SERVER_PK = VM_PK;
	  				
				-- Update resource demand table with utilization type
  				UPDATE ANL_RESOURCE_DEMAND 
				SET MEM_UTIL_TYPE = UTIL_TYPE
  				WHERE SERVER_PK = VM_PK;
  		ELSE
			-- Compute the Utilization type by comparing with threshold
			SET UTIL_TYPE = 
  				(SELECT DESC FROM ANL_THRESHOLDS AS THRESHOLDS
				WHERE TR_VAL >= THRESHOLDS.MEM_UTIL_LOW
				AND TR_VAL <= THRESHOLDS.MEM_UTIL_HIGH);

				-- Insert percentile and utilization type into the resource demand table
  				INSERT INTO ANL_RESOURCE_DEMAND
  				(SERVER_PK, MEMORY_DEMAND_PERCENTAGE, MEM_UTIL_TYPE) VALUES
  				(VM_PK, TR_VAL, UTIL_TYPE);
		END IF;
	  	COMMIT;	
		FETCH C_STMT INTO VM_PK, UTIL_VALUE;	
	END WHILE;

	CLOSE C_STMT;
	
UPDATE ANL_RESOURCE_DEMAND SET MEMORY_DEMAND_MB = MEMORY_DEMAND_PERCENTAGE;
UPDATE ANL_RESOURCE_DEMAND SET DEVICE_TYPE = 'VM';
COMMIT;
END P1
@
-- Function for computing percentile on disk measurements

CREATE PROCEDURE ANL_PERCENTILE_DISK_SIZING (IN PVALUE INTEGER, IN FILTERING_CLAUSE VARCHAR(1000))
-- Input argument to specify what percentile value to calculate

DYNAMIC RESULT SETS 1

P1: BEGIN

-- VARIABLES
DECLARE STMT VARCHAR(2048);
DECLARE VM_PK INTEGER;
DECLARE UTIL_VALUE DOUBLE;
DECLARE UTIL_TYPE VARCHAR(32);
DECLARE SQLCODE INTEGER DEFAULT 0;
DECLARE TR_VAL BIGINT;

-- CURSORS
DECLARE C_STMT CURSOR WITH HOLD FOR P_STMT;
SET CURRENT SCHEMA = TADFDC;

-- Query to compute percentile
-- Partition data in view (MES_PERCENTILE_DISK_H_V) by VM_KEY, order by average total io, and get row number for each entry
-- Divde the row number by total number of observations to compute bucket into which the observation falls
-- Get percentile value for each bucket by finding the average total io for that bucket
-- Select the percentile based on the argument supplied
SET STMT =
	'SELECT VM_KEY, PMES FROM
	(
	SELECT VM_KEY, INTEGER(FRACTION)*10 AS PERCENTILE, MAX(AVG_TOTAL_IO) AS PMES FROM
		(SELECT CEIL(ROW_NUMBER() OVER (PARTITION BY VM_KEY ORDER BY AVG_TOTAL_IO)*10
		/ FLOAT(COUNT(1) OVER(PARTITION BY VM_KEY))) AS FRACTION,
		VM_KEY, AVG_TOTAL_IO FROM MES_PERCENTILE_DISK_H_V ' CONCAT FILTERING_CLAUSE CONCAT ')
	GROUP BY VM_KEY, FRACTION
	ORDER BY VM_KEY, FRACTION
	)
	WHERE PERCENTILE=' || CAST(PVALUE AS CHAR(2));
-- Casting the integer value into char above since db2, 9.5 does not support conctenation of integer to string

PREPARE P_STMT FROM STMT;

OPEN C_STMT;
FETCH C_STMT INTO VM_PK, UTIL_VALUE;
-- Go through each entry (VM key and Percentile) in the ResultSet

	WHILE SQLCODE = 0 DO
	SET TR_VAL = CEIL(UTIL_VALUE);
		IF EXISTS (SELECT * FROM ANL_RESOURCE_DEMAND WHERE SERVER_PK = VM_PK) THEN
			-- Compute the Utilization type by comparing with thresholds
			SET UTIL_TYPE = 
  				(SELECT DESC FROM ANL_THRESHOLDS AS THRESHOLDS
				WHERE TR_VAL >= THRESHOLDS.DISK_UTIL_LOW 
				AND TR_VAL <= THRESHOLDS.DISK_UTIL_HIGH);

				-- Update resource demand table with percentile vlaue
  				UPDATE ANL_RESOURCE_DEMAND 
				SET DISK_DEMAND_MBPS = TR_VAL
  				WHERE SERVER_PK = VM_PK;
	  				
				-- Update resource demand table with utilization type
  				UPDATE ANL_RESOURCE_DEMAND 
				SET DISK_UTIL_TYPE = UTIL_TYPE
  				WHERE SERVER_PK = VM_PK;
  		ELSE
			-- Compute the Utilization type by comparing with thresholds
			SET UTIL_TYPE = 
  				(SELECT DESC FROM ANL_THRESHOLDS AS THRESHOLDS
				WHERE TR_VAL >= THRESHOLDS.DISK_UTIL_LOW
				AND TR_VAL <= THRESHOLDS.DISK_UTIL_HIGH);

				-- Insert percentile and utilization type into the resource demand table
  				INSERT INTO ANL_RESOURCE_DEMAND
  				(SERVER_PK, DISK_DEMAND_MBPS, DISK_UTIL_TYPE) VALUES
  				(VM_PK, TR_VAL, UTIL_TYPE);
		END IF;
	  	COMMIT;	
		FETCH C_STMT INTO VM_PK, UTIL_VALUE;	
	END WHILE;

	CLOSE C_STMT;
	
UPDATE ANL_RESOURCE_DEMAND SET DEVICE_TYPE = 'VM';
COMMIT;
END P1
@
-- Function for computing percentile on NW measurements

CREATE PROCEDURE ANL_PERCENTILE_NW_SIZING (IN PVALUE INTEGER, IN FILTERING_CLAUSE VARCHAR(1000))
-- Input argument to specify what percentile value to calculate

DYNAMIC RESULT SETS 1

P1: BEGIN

-- VARIABLES
DECLARE STMT VARCHAR(2048);
DECLARE VM_PK INTEGER;
DECLARE UTIL_VALUE DOUBLE;
DECLARE UTIL_TYPE VARCHAR(32);
DECLARE SQLCODE INTEGER DEFAULT 0;
DECLARE TR_VAL BIGINT;

-- CURSORS
DECLARE C_STMT CURSOR WITH HOLD FOR P_STMT;
SET CURRENT SCHEMA = TADFDC;

-- Query to compute percentile
-- Partition data in view (MES_PERCENTILE_NW_H_V) by VM_KEY, order by the average total kbps, and get row number for each entry
-- Divde the row number by total number of observations to compute bucket into which the observation falls
-- Get percentile value for each bucket by finding the maximum average total kbps for that bucket
-- Select the percentile based on the argument supplied
SET STMT =
	'SELECT VM_KEY, PMES FROM
	(
	SELECT VM_KEY, INTEGER(FRACTION)*10 AS PERCENTILE, MAX(AVG_TOTAL_KBPS) AS PMES FROM
		(SELECT CEIL(ROW_NUMBER() OVER (PARTITION BY VM_KEY ORDER BY AVG_TOTAL_KBPS)*10
		/ FLOAT(COUNT(1) OVER(PARTITION BY VM_KEY))) AS FRACTION,
		VM_KEY, AVG_TOTAL_KBPS FROM MES_PERCENTILE_NW_H_V ' CONCAT FILTERING_CLAUSE CONCAT ')
	GROUP BY VM_KEY, FRACTION
	ORDER BY VM_KEY, FRACTION
	)
	WHERE PERCENTILE=' || CAST(PVALUE AS CHAR(2));
-- Casting the integer value into char above since db2, 9.5 does not support conctenation of integer to string

PREPARE P_STMT FROM STMT;

OPEN C_STMT;
FETCH C_STMT INTO VM_PK, UTIL_VALUE;
-- Go through each entry (VM key and Percentile) in the ResultSet

	WHILE SQLCODE = 0 DO
	SET TR_VAL = CEIL(UTIL_VALUE);
		IF EXISTS (SELECT * FROM ANL_RESOURCE_DEMAND WHERE SERVER_PK = VM_PK) THEN
			-- Compute the Utilization type by comparing with thresholds
			SET UTIL_TYPE = 
  				(SELECT DESC FROM ANL_THRESHOLDS AS THRESHOLDS
				WHERE TR_VAL >= THRESHOLDS.NETWORK_UTIL_LOW 
				AND TR_VAL <= THRESHOLDS.NETWORK_UTIL_HIGH);

				-- Update resource demand table with percentile vlaue
  				UPDATE ANL_RESOURCE_DEMAND 
				SET NETWORK_DEMAND_MBPS = TR_VAL
  				WHERE SERVER_PK = VM_PK;

				-- Update resource demand table with utilization type
  				UPDATE ANL_RESOURCE_DEMAND 
				SET NETWORK_UTIL_TYPE = UTIL_TYPE
  				WHERE SERVER_PK = VM_PK;
  		ELSE
			-- Compute the Utilization type by comparing with thresholds
			SET UTIL_TYPE = 
  				(SELECT DESC FROM ANL_THRESHOLDS AS THRESHOLDS
				WHERE TR_VAL >= THRESHOLDS.NETWORK_UTIL_LOW
				AND TR_VAL <= THRESHOLDS.NETWORK_UTIL_HIGH);

				-- Insert percentile and utilization type into the resource demand table
  				INSERT INTO ANL_RESOURCE_DEMAND
  				(SERVER_PK, NETWORK_DEMAND_MBPS, NETWORK_UTIL_TYPE) VALUES
  				(VM_PK, TR_VAL, UTIL_TYPE);
		END IF;
	  	COMMIT;	
		FETCH C_STMT INTO VM_PK, UTIL_VALUE;	
	END WHILE;

	CLOSE C_STMT;
	
UPDATE ANL_RESOURCE_DEMAND SET DEVICE_TYPE = 'VM';
COMMIT;
END P1
@
