@ECHO OFF

SETLOCAL EnableDelayedExpansion
SET JAVA=java
SET CLASSNAME=com.ibm.sunset.common.globalization.Server.MessageRetrieval
SET CLASSPATH=.\MessageRetrieval.jar;.\lib\log4j-1.2.15.jar;.\lib\db2jcc.jar;.\lib\db2jcc_license_cu.jar;%CLASSPATH%

SET PROG_NAME=%0

SET /A ARGS_CNT=0
SET ARGUMENTS=

SET DB2=db2

SET TMP_F_NAME=sql.tmp
SET TMP_DDL_FILE_NAME=federationqueries.ddl
SET LOG_F_NAME=
SET SUCCESS_VIEW=
SET VIEW_NAME=
SET SPACE=
SET DB2_CMD_SEPARATOR=@

SET ARGUMENTS_ALL=0
SET IS_CONNECTED=0
SET /A ERROR_COUNT=0

SET TDW_SCHEMA_NAME=ITMUSER

SET SQL_CREATE_NICKNAME=CREATE OR REPLACE NICKNAME
SET SQL_DROP_NICKNAME=DROP NICKNAME
SET SQL_CREATE_VIEW=CREATE OR REPLACE VIEW
SET SQL_DROP_VIEW=DROP VIEW

SET SQL_CREATE_TABLE=CREATE TABLE

SET RESULT=
SET RESULT_ERROR=0
SET RESULT_OK=1
SET WRAPPER_NAME=
SET ON_ERROR_DROP_NICKNAMES=

SET QC="
SET TRANSMITTED_PKTS_COL_NAME=TPACKPS
SET SEPARATOR=................................................................................

REM ############################################################################
REM List of supported federated metrices.
REM ############################################################################
SET ALL_SUPPORTED=PS_CPU PS_CPU_H PS_CPU_D PS_CPU_W PS_CPU_M PS_CPU_Q PS_CPU_Y PS_MEM PS_MEM_H PS_MEM_D PS_MEM_W PS_MEM_M PS_MEM_Q PS_MEM_Y PS_IO PS_IO_H PS_IO_D PS_IO_W PS_IO_M PS_IO_Q PS_IO_Y PS_NET PS_NET_H PS_NET_D PS_NET_W PS_NET_M PS_NET_Q PS_NET_Y VM_CPU VM_CPU_H VM_CPU_D VM_CPU_W VM_CPU_M VM_CPU_Q VM_CPU_Y VM_MEM VM_MEM_H VM_MEM_D VM_MEM_W VM_MEM_M VM_MEM_Q VM_MEM_Y VM_NET VM_NET_H VM_NET_D VM_NET_W VM_NET_M VM_NET_Q VM_NET_Y VM_DS VM_DS_H VM_DS_D VM_DS_W VM_DS_M VM_DS_Q VM_DS_Y

REM ############################################################################REM List of percentile views.
REM ############################################################################

SET VIEW_PERC_CPU_H_V=MES_PERCENTILE_CPU_H_V (VM_KEY, VM_NAME, WRITETIME, AVG_CPU_UTILIZATION) AS (SELECT VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME, MES.AVG_CPU_UTILIZATION FROM MES_VM_CPU_H AS MES, ANL_WORKING_SET_V AS WORKINGSET, ANL_TIME_DIM AS TIME, CFG_USER_CONFIGURATION AS USER_CONFIG, CFG_VIRTUAL_MACHINE AS VM WHERE MES.VM_NAME = VM.VM_NAME AND VM.PHYSICAL_SERVER_PK = WORKINGSET.PHYSICAL_SERVER_PK AND MES.WRITETIME = TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN USER_CONFIG.START_TIME AND USER_CONFIG.END_TIME AND MES.AVG_CPU_UTILIZATION ^>=0)

SET VIEW_PERC_DISK_H_V=MES_PERCENTILE_DISK_H_V (VM_KEY, VM_NAME, WRITETIME, AVG_TOTAL_IO) AS ( SELECT VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME, MES.AVG_TOTAL_IO FROM MES_VM_DATA_STORE_H AS MES , ANL_WORKING_SET_V AS WORKINGSET , ANL_TIME_DIM AS TIME , CFG_USER_CONFIGURATION AS USER_CONFIG , CFG_VIRTUAL_MACHINE AS VM WHERE MES.VM_NAME = VM.VM_NAME AND VM.PHYSICAL_SERVER_PK = WORKINGSET.PHYSICAL_SERVER_PK AND MES.WRITETIME = TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN USER_CONFIG.START_TIME AND USER_CONFIG.END_TIME AND MES.AVG_TOTAL_IO ^>=0)

SET VIEW_PERC_MEM_H_V=MES_PERCENTILE_MEM_H_V (VM_KEY, VM_NAME, WRITETIME, AVG_GUEST_UTILIZATION) AS ( SELECT VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME, MES.AVG_GUEST_UTILIZATION FROM MES_VM_MEM_H AS MES , ANL_WORKING_SET_V AS WORKINGSET , ANL_TIME_DIM AS TIME , CFG_USER_CONFIGURATION AS USER_CONFIG , CFG_VIRTUAL_MACHINE AS VM WHERE MES.VM_NAME = VM.VM_NAME AND VM.PHYSICAL_SERVER_PK = WORKINGSET.PHYSICAL_SERVER_PK AND MES.WRITETIME = TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN USER_CONFIG.START_TIME AND USER_CONFIG.END_TIME AND MES.AVG_GUEST_UTILIZATION ^>=0)

SET VIEW_PERC_NW_H_V=MES_PERCENTILE_NW_H_V (VM_KEY, VM_NAME, WRITETIME, AVG_TOTAL_KBPS) AS ( SELECT VM.VIRTUAL_MACHINE_PK, MES.VM_NAME, MES.WRITETIME, (MES.AVG_RECEIVED_KBPS + MES.AVG_TRANSMITTED_KBPS) FROM MES_VM_NETWORK_H AS MES , ANL_WORKING_SET_V AS WORKINGSET , ANL_TIME_DIM AS TIME , CFG_USER_CONFIGURATION AS USER_CONFIG , CFG_VIRTUAL_MACHINE AS VM WHERE MES.VM_NAME = VM.VM_NAME AND VM.PHYSICAL_SERVER_PK = WORKINGSET.PHYSICAL_SERVER_PK AND MES.WRITETIME = TIME.CANDLETIMESTAMP AND TIME.TIME_RANGE_START BETWEEN USER_CONFIG.START_TIME AND USER_CONFIG.END_TIME AND MES.AVG_RECEIVED_KBPS ^>=0 AND MES.AVG_TRANSMITTED_KBPS ^>=0)

REM ############################################################################
REM List of SQL statements forming bodies of the metric tables.
REM ############################################################################
SET TABLE_BODY_SERVER_CPU=( 		PS_CPU_PK BIGINT NOT NULL, 		HOST_NAME VARCHAR(256), 		CPU_NUMBER INTEGER, 		CPU_UTILIZATION BIGINT, 		PHYSICAL_SERVER_PK BIGINT, 		TIMESTAMP TIMESTAMP 	)

SET TABLE_BODY_SERVER_CPU_AGG=( 		PS_CPU_PK BIGINT NOT NULL, 		HOST_NAME VARCHAR(256), 		CPU_NUMBER INTEGER, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_SERVER_MEM=( 		PS_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		PHYSICAL_MEMORY BIGINT, 		MEMORY_USAGE BIGINT, 		MEMORY_UTILIZATION BIGINT, 		ACTIVE_MEMORY BIGINT, 		GRANTED_MEMORY BIGINT, 		SWAP_USED BIGINT, 		FREE_MEM BIGINT, 		BALLOON_USED BIGINT, 		SWAP_IN_RATE BIGINT, 		SWAP_OUT_RATE BIGINT, 		SWAP_TOTAL_RATE BIGINT, 		PHYSICAL_SERVER_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_SERVER_MEM_AGG=( 		PS_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		PHYSICAL_MEMORY BIGINT, 		MIN_MEMORY_USAGE BIGINT, 		MAX_MEMORY_USAGE BIGINT, 		SUM_MEMORY_USAGE BIGINT, 		AVG_MEMORY_USAGE BIGINT, 		MIN_MEMORY_UTILIZATION BIGINT, 		MAX_MEMORY_UTILIZATION BIGINT, 		SUM_MEMORY_UTILIZATION BIGINT, 		AVG_MEMORY_UTILIZATION BIGINT, 		MIN_ACTIVE_MEMORY BIGINT, 		MAX_ACTIVE_MEMORY BIGINT, 		SUM_ACTIVE_MEMORY BIGINT, 		AVG_ACTIVE_MEMORY BIGINT, 		MIN_GRANTED_MEMORY BIGINT, 		MAX_GRANTED_MEMORY BIGINT, 		SUM_GRANTED_MEMORY BIGINT, 		AVG_GRANTED_MEMORY BIGINT, 		MIN_SWAP_USED BIGINT, 		MAX_SWAP_USED BIGINT, 		SUM_SWAP_USED BIGINT, 		AVG_SWAP_USED BIGINT, 		MIN_FREE_MEM BIGINT, 		MAX_FREE_MEM BIGINT, 		SUM_FREE_MEM BIGINT, 		AVG_FREE_MEM BIGINT, 		MIN_BALLOON_USED BIGINT, 		MAX_BALLOON_USED BIGINT, 		SUM_BALLOON_USED BIGINT, 		AVG_BALLOON_USED BIGINT, 		MIN_SWAP_IN_RATE BIGINT, 		MAX_SWAP_IN_RATE BIGINT, 		SUM_SWAP_IN_RATE BIGINT, 		AVG_SWAP_IN_RATE BIGINT, 		MIN_SWAP_OUT_RATE BIGINT, 		MAX_SWAP_OUT_RATE BIGINT, 		SUM_SWAP_OUT_RATE BIGINT, 		AVG_SWAP_OUT_RATE BIGINT, 		MIN_SWAP_TOTAL_RATE BIGINT, 		MAX_SWAP_TOTAL_RATE BIGINT, 		SUM_SWAP_TOTAL_RATE BIGINT, 		AVG_SWAP_TOTAL_RATE BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_SERVER_DISK=( 		HOST_NAME VARCHAR(256), 		PS_DISK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DISK_NAME VARCHAR(256), 		DATA_STORE_NAME VARCHAR(256), 		READ_KBPS BIGINT, 		WRITE_KBPS BIGINT, 		READ_COUNT BIGINT, 		WRITE_COUNT BIGINT, 		BUS_RESET BIGINT, 		COMMANDS_COUNT BIGINT, 		COMMANDS_ABORTED_COUNT BIGINT, 		DEVICE_READ_LATENCY BIGINT, 		DEVICE_WRITE_LATENCY BIGINT, 		DEVICE_TOTAL_LATENCY BIGINT, 		DEVICE_LATENCY BIGINT, 		PHYSICAL_SERVER_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_SERVER_DISK_AGG=( 		HOST_NAME VARCHAR(256), 		PS_DISK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DISK_NAME VARCHAR(256), 		DATA_STORE_NAME VARCHAR(256), 		MIN_READ_KBPS BIGINT, 		MAX_READ_KBPS BIGINT, 		SUM_READ_KBPS BIGINT, 		AVG_READ_KBPS BIGINT, 		MIN_WRITE_KBPS BIGINT, 		MAX_WRITE_KBPS BIGINT, 		SUM_WRITE_KBPS BIGINT, 		AVG_WRITE_KBPS BIGINT, 		MIN_READ_COUNT BIGINT, 		MAX_READ_COUNT BIGINT, 		SUM_READ_COUNT BIGINT, 		AVG_READ_COUNT BIGINT, 		MIN_WRITE_COUNT BIGINT, 		MAX_WRITE_COUNT BIGINT, 		SUM_WRITE_COUNT BIGINT, 		AVG_WRITE_COUNT BIGINT, 		MIN_BUS_RESET BIGINT, 		MAX_BUS_RESET BIGINT, 		SUM_BUS_RESET BIGINT, 		AVG_BUS_RESET BIGINT, 		MIN_COMMANDS_COUNT BIGINT, 		MAX_COMMANDS_COUNT BIGINT, 		SUM_COMMANDS_COUNT BIGINT, 		AVG_COMMANDS_COUNT BIGINT, 		MIN_COMMANDS_ABORTED_COUNT BIGINT, 		MAX_COMMANDS_ABORTED_COUNT BIGINT, 		SUM_COMMANDS_ABORTED_COUNT BIGINT, 		AVG_COMMANDS_ABORTED_COUNT BIGINT, 		MIN_DEVICE_READ_LATENCY BIGINT, 		MAX_DEVICE_READ_LATENCY BIGINT, 		SUM_DEVICE_READ_LATENCY BIGINT, 		AVG_DEVICE_READ_LATENCY BIGINT, 		MIN_DEVICE_WRITE_LATENCY BIGINT, 		MAX_DEVICE_WRITE_LATENCY BIGINT, 		SUM_DEVICE_WRITE_LATENCY BIGINT, 		AVG_DEVICE_WRITE_LATENCY BIGINT, 		MIN_DEVICE_TOTAL_LATENCY BIGINT, 		MAX_DEVICE_TOTAL_LATENCY BIGINT, 		SUM_DEVICE_TOTAL_LATENCY BIGINT, 		AVG_DEVICE_TOTAL_LATENCY BIGINT, 		MIN_DEVICE_LATENCY BIGINT, 		MAX_DEVICE_LATENCY BIGINT, 		SUM_DEVICE_LATENCY BIGINT, 		AVG_DEVICE_LATENCY BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_SERVER_NET=( 		PS_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		USAGE BIGINT, 		TRANSMITTED_KBPS BIGINT, 		RECEIVED_KBPS BIGINT, 		PKTS_TRANSMITTED BIGINT, 		PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_SERVER_NET_AGG=( 		PS_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_CPU=( 		VM_CPU_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		VM_CPU_NUMBER INTEGER, 		WAIT_TIME BIGINT, 		USED_TIME BIGINT, 		READY_TIME BIGINT, 		SYS_TIME BIGINT, 		CPU_UTILIZATION BIGINT, 		PERCENT_READY INTEGER, 		USER_TIME BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_CPU_AGG=( 		VM_CPU_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		VM_CPU_NUMBER INTEGER, 		MIN_WAIT_TIME BIGINT, 		MAX_WAIT_TIME BIGINT, 		SUM_WAIT_TIME BIGINT, 		AVG_WAIT_TIME BIGINT, 		MIN_USED_TIME BIGINT, 		MAX_USED_TIME BIGINT, 		SUM_USED_TIME BIGINT, 		AVG_USED_TIME BIGINT, 		MIN_READY_TIME BIGINT, 		MAX_READY_TIME BIGINT, 		SUM_READY_TIME BIGINT, 		AVG_READY_TIME BIGINT, 		MIN_SYS_TIME BIGINT, 		MAX_SYS_TIME BIGINT, 		SUM_SYS_TIME BIGINT, 		AVG_SYS_TIME BIGINT, 		MIN_CPU_UTILIZATION BIGINT, 		MAX_CPU_UTILIZATION BIGINT, 		SUM_CPU_UTILIZATION BIGINT, 		AVG_CPU_UTILIZATION BIGINT, 		MIN_PERCENT_READY INTEGER, 		MAX_PERCENT_READY INTEGER, 		SUM_PERCENT_READY INTEGER, 		AVG_PERCENT_READY INTEGER, 		IN_USER_TIME BIGINT, 		MAX_USER_TIME BIGINT, 		SUM_USER_TIME BIGINT, 		AVG_USER_TIME BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_MEM=( 		VM_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		HOST_USAGE BIGINT, 		GUEST_USAGE BIGINT, 		HOST_UTILIZATION BIGINT, 		GUEST_UTILIZATION BIGINT, 		HOST_FREE BIGINT, 		GUEST_FREE BIGINT, 		BALLOON_USAGE BIGINT, 		SWAP_TO_FILE BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_MEM_AGG=( 		VM_MEM_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_HOST_USAGE BIGINT, 		MAX_HOST_USAGE BIGINT, 		SUM_HOST_USAGE BIGINT, 		AVG_HOST_USAGE BIGINT, 		MIN_GUEST_USAGE BIGINT, 		MAX_GUEST_USAGE BIGINT, 		SUM_GUEST_USAGE BIGINT, 		AVG_GUEST_USAGE BIGINT, 		MIN_HOST_UTILIZATION BIGINT, 		MAX_HOST_UTILIZATION BIGINT, 		SUM_HOST_UTILIZATION BIGINT, 		AVG_HOST_UTILIZATION BIGINT, 		MIN_GUEST_UTILIZATION BIGINT, 		MAX_GUEST_UTILIZATION BIGINT, 		SUM_GUEST_UTILIZATION BIGINT, 		AVG_GUEST_UTILIZATION BIGINT, 		MIN_HOST_FREE BIGINT, 		MAX_HOST_FREE BIGINT, 		SUM_HOST_FREE BIGINT, 		AVG_HOST_FREE BIGINT, 		MIN_GUEST_FREE BIGINT, 		MAX_GUEST_FREE BIGINT, 		SUM_GUEST_FREE BIGINT, 		AVG_GUEST_FREE BIGINT, 		MIN_BALLOON_USAGE BIGINT, 		MAX_BALLOON_USAGE BIGINT, 		SUM_BALLOON_USAGE BIGINT, 		AVG_BALLOON_USAGE BIGINT, 		MIN_SWAP_TO_FILE BIGINT, 		MAX_SWAP_TO_FILE BIGINT, 		SUM_SWAP_TO_FILE BIGINT, 		AVG_SWAP_TO_FILE BIGINT, 		VIRTUAL_MACHINE_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_NET=( 		VM_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		TRANSMITTED_KBPS BIGINT, 		RECEIVED_KBPS BIGINT, 		PKTS_TRANSMITTED BIGINT, 		PKTS_RECEIVED BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_NET_AGG=( 		VM_NETWORK_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		NIC_NAME VARCHAR(256), 		MIN_USAGE BIGINT, 		MAX_USAGE BIGINT, 		SUM_USAGE BIGINT, 		AVG_USAGE BIGINT, 		MIN_TRANSMITTED_KBPS BIGINT, 		MAX_TRANSMITTED_KBPS BIGINT, 		SUM_TRANSMITTED_KBPS BIGINT, 		AVG_TRANSMITTED_KBPS BIGINT, 		MIN_RECEIVED_KBPS BIGINT, 		MAX_RECEIVED_KBPS BIGINT, 		SUM_RECEIVED_KBPS BIGINT, 		AVG_RECEIVED_KBPS BIGINT, 		MIN_PKTS_TRANSMITTED BIGINT, 		MAX_PKTS_TRANSMITTED BIGINT, 		SUM_PKTS_TRANSMITTED BIGINT, 		AVG_PKTS_TRANSMITTED BIGINT, 		MIN_PKTS_RECEIVED BIGINT, 		MAX_PKTS_RECEIVED BIGINT, 		SUM_PKTS_RECEIVED BIGINT, 		AVG_PKTS_RECEIVED BIGINT, 		PHYSICAL_SERVER_PK BIGINT 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_DS=( 		VM_DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		TOTAL_READ BIGINT, 		TOTAL_WRITE BIGINT, 		TOTAL_IO BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

SET TABLE_BODY_VM_DS_AGG=( 		VM_DATA_STORE_PK BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY ( START WITH 1 INCREMENT BY 1 MINVALUE 1 MAXVALUE 9223372036854775807 NO CYCLE CACHE 20), 		DATA_STORE_NAME VARCHAR(256), 		VM_NAME VARCHAR(128), HOST_NAME VARCHAR(256), 		MIN_TOTAL_READ BIGINT, 		MAX_TOTAL_READ BIGINT, 		SUM_TOTAL_READ BIGINT, 		AVG_TOTAL_READ BIGINT, 		MIN_TOTAL_WRITE BIGINT, 		MAX_TOTAL_WRITE BIGINT, 		SUM_TOTAL_WRITE BIGINT, 		AVG_TOTAL_WRITE BIGINT, 		MIN_TOTAL_IO BIGINT, 		MAX_TOTAL_IO BIGINT, 		SUM_TOTAL_IO BIGINT, 		AVG_TOTAL_IO BIGINT, 		VIRTUAL_MACHINE_PK BIGINT, 		TIMESTAMP TIMESTAMP 	, WRITETIME CHAR(16))

REM ################################## -|- #####################################

REM ############################################################################
REM Entry point of the script.
REM ############################################################################
:MAIN
:: BEGIN {

    IF "%1" == "-CONFIGSERVER" (
        IF "%2" == "SET_AUTO_STATS_PROF_OFF" (
            GOTO :PROFOFF
        ) ELSE IF "%2" == "CREATE_WRAPPER" (
            GOTO :CREATE_WRAPPER
        ) ELSE IF "%2" == "CREATE_SERVER" (
            GOTO :CREATE_SERVER
        ) ELSE IF "%2" == "CREATE_USER_MAPPING" (
            GOTO :CREATE_USER_MAPPING
        ) ELSE IF "%2" == "UPDATE_USER_MAPPING" (
            GOTO :UPDATE_USER_MAPPING
        ) ELSE IF "%2" == "DROP_WRAPPER" (
            GOTO :DROP_WRAPPER
        )
    )
	GOTO :STEP_1
	
:: } END - MAIN

:PROFOFF
:: BEGIN {

	SET DB_NAME=%3
	SET USER_NAME=%4
	SET USER_PASSWORD=%5
	IF "%6" == "DBAMODE" (
	ECHO !DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD! >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! "update db cfg using AUTO_STATS_PROF OFF" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD!
	!DB2! "update db cfg using AUTO_STATS_PROF OFF"
	)
	SET STATUS=%ERRORLEVEL%
	IF "%6" == "DBAMODE" (
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! TERMINATE 2>&1 
	)
	
	GOTO :EXIT

:: } END - PROFOFF

:CREATE_WRAPPER
:: BEGIN {
	
	SET DB_NAME=%3
	SET USER_NAME=%4
	SET USER_PASSWORD=%5
	SET WRAPPER_NAME=%6
 IF "%7" == "DBAMODE" (
		ECHO !DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD! >> !TMP_DDL_FILE_NAME!
		ECHO !DB2! "CREATE WRAPPER !WRAPPER_NAME!" >> !TMP_DDL_FILE_NAME!
	 ) ELSE (	
		!DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD!
		!DB2! "CREATE WRAPPER !WRAPPER_NAME!"
	)
	SET STATUS=%ERRORLEVEL%
	IF "%7" == "DBAMODE" (
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! TERMINATE 2>&1 
	)
	GOTO :EXIT

:: } END - CREATE_WRAPPER

:DROP_WRAPPER
:: BEGIN {
	
	SET DB_NAME=%3
	SET USER_NAME=%4
	SET USER_PASSWORD=%5
	SET WRAPPER_NAME=%6
	IF "%7" == "DBAMODE" (
	ECHO !DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD! >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! "DROP WRAPPER !WRAPPER_NAME!" >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD!
	!DB2! "DROP WRAPPER !WRAPPER_NAME!"
	)
	SET STATUS=%ERRORLEVEL%
	IF "%7" == "DBAMODE" (
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! TERMINATE 2>&1 
	)
	GOTO :EXIT

:: } END - CREATE_WRAPPER

:CREATE_SERVER
:: BEGIN {
	
	SET CONN_STRING=%3
	call :indexOf delim_index %CONN_STRING% ":"

	set /A delim_index+=1
	set CONN_STRING=!CONN_STRING:~%delim_index%!
	call :indexOf delim_index %CONN_STRING% "/"
	set "DB_NAME=!CONN_STRING:~0,%delim_index%!"

	set /A delim_index+=1
	set "CONN_STRING=!CONN_STRING:~%delim_index%!"

	call :indexOf delim_index %CONN_STRING% "/"
	set USER_NAME=!CONN_STRING:~0,%delim_index%!

	set /A delim_index+=1
	set "CONN_STRING=!CONN_STRING:~%delim_index%!"
	set PASSWORD=!CONN_STRING:~0!

	SET SERVER_NAME=%4
	SET SERVER_TYPE=%5
	SET SERVER_VERSION=%6
	SET REMOTE_USER=%7
	SET REMOTE_PASSWORD=%8%
	
	SET REMOTE_DB_CONF_STRING=%9%
	SETLOCAL ENABLEEXTENSIONS
	SHIFT
	SET DBA_MODE=%9%
	call :indexOf delim_index %REMOTE_DB_CONF_STRING% "/"
	SET "WRAPPER_NAME=!REMOTE_DB_CONF_STRING:~0,%delim_index%!"
	
	set /A delim_index+=1
	set "REMOTE_DB_CONF_STRING=!REMOTE_DB_CONF_STRING:~%delim_index%!"
	call :indexOf delim_index %REMOTE_DB_CONF_STRING% "/"
	SET NODE_NAME=!REMOTE_DB_CONF_STRING:~0,%delim_index%!
	
	set /A delim_index+=1
	set "TDW_NAME=!REMOTE_DB_CONF_STRING:~%delim_index%!"
	
	IF NOT "!NODE_NAME!" == "" (
		SET OPTIONS=NODE '!NODE_NAME!'
	)
	
	IF NOT "!TDW_NAME!" == "" (
		if NOT "!OPTIONS!" == "" (
			SET "OPTIONS=!OPTIONS!, DBNAME '!TDW_NAME!'"
		) ELSE (
			SET "OPTIONS=DBNAME '!TDW_NAME!'"
		)
	)
	IF  "!DBA_MODE!" == "DBAMODE" (
		ECHO !DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !PASSWORD! >> !TMP_DDL_FILE_NAME!
		ECHO !DB2! "CREATE SERVER !SERVER_NAME! TYPE !SERVER_TYPE! VERSION !SERVER_VERSION! WRAPPER !WRAPPER_NAME! AUTHORIZATION \"!REMOTE_USER!\" PASSWORD \"!REMOTE_PASSWORD!\" OPTIONS (!OPTIONS!)" >> !TMP_DDL_FILE_NAME!
		) ELSE (
		!DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !PASSWORD!
		!DB2! "CREATE SERVER !SERVER_NAME! TYPE !SERVER_TYPE! VERSION !SERVER_VERSION! WRAPPER !WRAPPER_NAME! AUTHORIZATION \"!REMOTE_USER!\" PASSWORD \"!REMOTE_PASSWORD!\" OPTIONS (!OPTIONS!)"
	)
	SET STATUS=%ERRORLEVEL%
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! TERMINATE 2>&1 
	)
	GOTO :EXIT

:: } END - CREATE_SERVER

:CREATE_USER_MAPPING
:: BEGIN {

	SET DB_NAME=%3
	SET USER_NAME=%4
	SET USER_PASSWORD=%5
	SET SERVER_NAME=%6
	SET REMOTE_USER='%7'
	SET REMOTE_PASSWORD='%8'
	SET DBA_MODE=%9%
	IF  "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD! >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! "CREATE USER MAPPING FOR !USER_NAME! SERVER !SERVER_NAME! OPTIONS (REMOTE_AUTHID !REMOTE_USER!, REMOTE_PASSWORD !REMOTE_PASSWORD!)" >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! SET PASSTHRU !SERVER_NAME! >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD!
	!DB2! "CREATE USER MAPPING FOR !USER_NAME! SERVER !SERVER_NAME! OPTIONS (REMOTE_AUTHID !REMOTE_USER!, REMOTE_PASSWORD !REMOTE_PASSWORD!)"
	!DB2! SET PASSTHRU !SERVER_NAME!
	)
	SET STATUS=%ERRORLEVEL%
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! TERMINATE 2>&1 
	)
	GOTO :EXIT

:: } END - CREATE_USER_MAPPING

:UPDATE_USER_MAPPING
:: BEGIN {

	SET DB_NAME=%3
	SET USER_NAME=%4
	SET USER_PASSWORD=%5
	SET SERVER_NAME=%6
	SET REMOTE_USER='%7'
	SET REMOTE_PASSWORD='%8'
	SET DBA_MODE=%9
	IF  "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD! >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! "ALTER USER MAPPING FOR !USER_NAME! SERVER !SERVER_NAME! OPTIONS (SET REMOTE_AUTHID !REMOTE_USER!, SET REMOTE_PASSWORD !REMOTE_PASSWORD!)" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! CONNECT TO !DB_NAME! USER !USER_NAME! USING !USER_PASSWORD!
	!DB2! "ALTER USER MAPPING FOR !USER_NAME! SERVER !SERVER_NAME! OPTIONS (SET REMOTE_AUTHID !REMOTE_USER!, SET REMOTE_PASSWORD !REMOTE_PASSWORD!)"
	)
	SET STATUS=%ERRORLEVEL%
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! TERMINATE 2>&1 
	)
	GOTO :EXIT

:: } END - UPDATE_USER_MAPPING

:STEP_1
:: BEGIN {

	CALL :GET_WRAPPER_NAME_FOR_SERVER %*
    CALL :INIT_TABLE_DEFS
	
    FOR %%I IN (%*) DO (
        SET /A ARGS_CNT+=1
        IF !ARGS_CNT! GEQ 10 (
            SET ARGUMENTS=!ARGUMENTS! %%I
           )
    )

    IF %ARGS_CNT% EQU 0 (
        %JAVA% %CLASSNAME% "ANA01003I"
        GOTO :USAGE
    )

    IF %ARGS_CNT% EQU 1 (
        IF "%1" == "-help" (
            %JAVA% %CLASSNAME% "ANA01003I"
            GOTO :USAGE
        ) ELSE (
            %JAVA% %CLASSNAME% "ANA01002E"
            GOTO :USAGE
        )
    )

    GOTO :PARSE_ARGUMENTS

:: } END - STEP_1

:STEP_2
:: BEGIN {

    GOTO :INIT

:: } END - STEP_2

:STEP_3
:: BEGIN {

    GOTO :PROCESS_ARGUMENTS

:: } END - STEP_3

:STEP_4
:: BEGIN {

    GOTO :SHUT_DOWN

:: } END - STEP_4

:USAGE
:: BEGIN {

ECHO Usage: %PROG_NAME% -help
ECHO        %PROG_NAME% -server ^<SERVER_NAME^> ^-dm ^<DATABASE_NAME^>
ECHO           -dmschema ^<SCHEMA_NAME^> [-add ^| -delete]
ECHO           [ all ^| PS_CPU[_[H^|D^|W^|M^|Q^|Y]] PS_MEM[_[H^|D^|W^|M^|Q^|Y]]
ECHO           PS_IO[_[H^|D^|W^|M^|Q^|Y]] PS_NET[_[H^|D^|W^|M^|Q^|Y]]
ECHO           VM_CPU[_[H^|D^|W^|M^|Q^|Y]] VM_MEM[_[H^|D^|W^|M^|Q^|Y]]
ECHO           VM_NET[_[H^|D^|W^|M^|Q^|Y]] VM_DS[_[H^|D^|W^|M^|Q^|Y]] ]
ECHO where
ECHO        ^-server    : Name of the remote data source configured with
ECHO                     the DRDA wrapper using CREATE SERVER command
ECHO        ^-dm        : Name of the Capacity Planner database
ECHO        ^-dmschema  : Name of the Capacity Planner database schema
ECHO        ^-add       : Adds a federation link
ECHO        ^-delete    : Removes a federation link
ECHO.
ECHO Arguments are of the form MACHINE_COMPONENT[_AGGREGATION-LEVEL]
ECHO.
ECHO where
ECHO    MACHINE     : physical server ^(PS^) or virtual machine ^(VM^),
ECHO    COMPONENT   : CPU ^(CPU^), memory ^(MEM^), IO ^(IO^),
ECHO                  network ^(NET^) or datastore ^(DS^)
ECHO and
ECHO    AGGREGATION-LEVEL   : Hourly ^(_H^), Daily ^(_D^), Weekly ^(_W^),
ECHO                          Monthly ^(_M^), Quarterly ^(_Q^) or Yearly ^(_Y^)
ECHO Argument all adds or deletes all the required federation links.
ECHO.
ECHO Examples
ECHO.
ECHO ^(i^) Set up federation for Physical Server CPU Hourly utilization:
ECHO.
ECHO tadfdc_setup_fed.bat -server WHSERVER -dm TADFDCDB -dmschema TADFDC -add PS_CPU_H
ECHO.
ECHO ^(ii^) Set up federation for Virtual Machine Memory Daily utilization:
ECHO.
ECHO tadfdc_setup_fed.bat -server WHSERVER -dm TADFDCDB -dmschema TADFDC -add VM_MEM_D
ECHO.
ECHO ^(iii^) Set up federation for Physical Server Network Weekly utilization:
ECHO.
ECHO tadfdc_setup_fed.bat -server WHSERVER -dm TADFDCDB -dmschema TADFDC -add PS_NET_W
ECHO.
ECHO ^(iv^) Set up federation for all supported utilization metrics:
ECHO.
ECHO tadfdc_setup_fed.bat -server WHSERVER -dm TADFDCDB -dmschema TADFDC -add all
ECHO.
ECHO ^(v^) Remove federation for Virtual Machine Datastore Monthly utilization:
ECHO.
ECHO tadfdc_setup_fed.bat -server WHSERVER -dm TADFDCDB -dmschema TADFDC -delete VM_DS_M
ECHO.
ECHO ^(vi^) Remove federation for Physical Server Disk IO Quarterly utilization:
ECHO.
ECHO tadfdc_setup_fed.bat -server WHSERVER -dm TADFDCDB -dmschema TADFDC -delete PS_IO_Q


    GOTO :SHUT_DOWN

:: } END - USAGE

REM ############################################################################
REM Validates the input arguments to the script.
REM Arguments:  NONE
REM ############################################################################
:PARSE_ARGUMENTS
:: BEGIN {

    IF %ARGS_CNT% LSS 8 (
        %JAVA% %CLASSNAME% "ANA01002E"
        GOTO :USAGE
    )

    IF NOT "%1" == "-server" (
        %JAVA% %CLASSNAME% "ANA01002E"
        GOTO :USAGE
    )

    IF NOT "%3" == "-dm" (
        %JAVA% %CLASSNAME% "ANA01002E"
        GOTO :USAGE
    )

    IF NOT "%5" == "-dmschema" (
        %JAVA% %CLASSNAME% "ANA01002E"
        GOTO :USAGE
    )
	IF "%7" == "DBAMODE" (
	SET DBA_MODE="DBAMODE" 
	)
	SET TDW_SCHEMA_NAME=%8

    IF NOT "%9" == "-add" (
        IF NOT "%9" == "-delete" (
            %JAVA% %CLASSNAME% "ANA01002E"
            GOTO :USAGE
        )
    )
	REM TO GET THE 10TH ARGUMENT USING SHIFT COMMAND. THIS WILL CHANGE THE SEQUENCE IN INIT BLOCK TOO 
	SHIFT
	
    IF "%9" == "all" (
        SET ARGUMENTS_ALL=1
        SET ARGUMENTS=!ALL_SUPPORTED!
        GOTO :STEP_2
    )

    SET TMP_CNT=0
    FOR %%F IN (%*) DO (

        SET /A TMP_CNT+=1
        SET ARG=%%F
			
        IF !TMP_CNT! GEQ 10 (
		SET FOUND="0"
		FOR %%I IN ( PS_CPU PS_CPU_H PS_CPU_D PS_CPU_W PS_CPU_M PS_CPU_Q PS_CPU_Y PS_MEM PS_MEM_H PS_MEM_D PS_MEM_W PS_MEM_M PS_MEM_Q PS_MEM_Y PS_IO PS_IO_H PS_IO_D PS_IO_W PS_IO_M PS_IO_Q PS_IO_Y PS_NET PS_NET_H PS_NET_D PS_NET_W PS_NET_M PS_NET_Q PS_NET_Y VM_CPU VM_CPU_H VM_CPU_D VM_CPU_W VM_CPU_M VM_CPU_Q VM_CPU_Y VM_MEM VM_MEM_H VM_MEM_D VM_MEM_W VM_MEM_M VM_MEM_Q VM_MEM_Y VM_NET VM_NET_H VM_NET_D VM_NET_W VM_NET_M VM_NET_Q VM_NET_Y VM_DS VM_DS_H VM_DS_D VM_DS_W VM_DS_M VM_DS_Q VM_DS_Y ) DO (
			
            SET OPT=%%I
			
            IF "!ARG!" == "!OPT!" (
			    SET FOUND="1"
			)

        )

        IF !FOUND! == "0" (
            %JAVA% %CLASSNAME% "ANA01002E"
            GOTO :USAGE
        )

        )

    )

    GOTO :STEP_2

:: } END - PARSE_ARGUMENTS

REM ############################################################################
REM Initializes the work environment.
REM Arguments:  NONE
REM ############################################################################
:INIT
:: BEGIN {

    %JAVA% %CLASSNAME% "ANA01003I"
	REM WE DID SHIFT IN PARSE_ARGUMENTS BLOCK. THE ARGUMENTS WILL SHIFT 
    SET LOCAL_SERVER_NAME=%1
    SET DM_NAME=%3
    SET DM_SCHEMA_NAME=%5
    SET ACTION=%8
	SET DBA_MODE=%6
	SET TDW_SCHEMA_NAME=%7

    SET TDW_SCHEMA_PREFIX=%LOCAL_SERVER_NAME%.%TDW_SCHEMA_NAME%

    
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! CONNECT TO !DM_NAME! >> !TMP_DDL_FILE_NAME!
	) ELSE (
	ECHO Connecting to: !DM_NAME! ...
    !DB2! CONNECT TO !DM_NAME! 2>&1
	ECHO %ERRORLEVEL%
	IF ERRORLEVEL 1 (
	SET STATUS=4
	GOTO :EXIT
	)
	SET IS_CONNECTED=1
	)
	
    IF "!DBA_MODE!" == "DBAMODE" (
    ECHO !DB2! SET SCHEMA=!DM_SCHEMA_NAME! >> !TMP_DDL_FILE_NAME!
	) ELSE (
	ECHO !DB2! SET SCHEMA=!DM_SCHEMA_NAME! 
	!DB2! SET SCHEMA=!DM_SCHEMA_NAME! 2>&1 
	ECHO. 
	)
    
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! -x "SELECT SUBSTR(SERVICE_LEVEL,8,1) FROM SYSIBMADM.ENV_INST_INFO" >> !TMP_DDL_FILE_NAME!
	) ELSE (
    !DB2! -x "SELECT SUBSTR(SERVICE_LEVEL,8,1) FROM SYSIBMADM.ENV_INST_INFO" > !TMP_F_NAME!
	)

    FOR /F %%V IN (!TMP_F_NAME!) DO (
    SET VERSION=%%V
    SET DB2_VERSION=!VERSION!
    REM ECHO DB2 FULL VERSION:  !DB2_VERSION!
    )
	IF "!DBA_MODE!" == "DBAMODE" (
	SET /A DB2_VERSION = 7
	)
	
    IF %DB2_VERSION% == 5 (
		SET SQL_CREATE_NICKNAME=CREATE NICKNAME
		SET SQL_CREATE_VIEW=CREATE VIEW
    )
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! SET PASSTHRU !LOCAL_SERVER_NAME! >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! SET PASSTHRU !LOCAL_SERVER_NAME! 
	)
    REM Check if the ITM POWER environment has Linux OS agents activated.
    SET /A LINUX_ENV=0
	
	IF "!DBA_MODE!" == "DBAMODE" (
		SET WRAPPER_NAME=DRDA
		REM ECHO WRAPPER NAME IS !WRAPPER_NAME! >> !TMP_DDL_FILE_NAME!
		IF "!WRAPPER_NAME!" == "DRDA" (
		ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = 'KLZ_LPAR' AND TABSCHEMA = '!TDW_SCHEMA_NAME!' AND TYPE = 'T'" >> !TMP_DDL_FILE_NAME!
		) ELSE IF "!WRAPPER_NAME!" == "MSSQLODBC3" (
		ECHO !DB2! -x "select name from sys.objects where name = 'KLZ_LPAR' and type = 'U' and schema_name(schema_id) = '!TDW_SCHEMA_NAME!'" >> !TMP_DDL_FILE_NAME!
		) ELSE IF "!WRAPPER_NAME!" == "NET8" (
		ECHO !DB2! -x "select table_name from all_tables where table_name = 'KLZ_LPAR' and owner = '!TDW_SCHEMA_NAME!' " >> !TMP_DDL_FILE_NAME!
		)
	) ELSE (
		IF "!WRAPPER_NAME!" == "DRDA" (
			!DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = 'KLZ_LPAR' AND TABSCHEMA = '!TDW_SCHEMA_NAME!' AND TYPE = 'T'" > !TMP_F_NAME!
		) ELSE IF "!WRAPPER_NAME!" == "MSSQLODBC3" (
			!DB2! -x "select name from sys.objects where name = 'KLZ_LPAR' and type = 'U' and schema_name(schema_id) = '!TDW_SCHEMA_NAME!'" > !TMP_F_NAME!
		) ELSE IF "!WRAPPER_NAME!" == "NET8" (
			!DB2! -x "select table_name from all_tables where table_name = 'KLZ_LPAR' and owner = '!TDW_SCHEMA_NAME!' " > !TMP_F_NAME!
		)
	)
	FOR /F %%V IN (!TMP_F_NAME!) DO (
		IF "%%V" == "KLZ_LPAR" (
			SET /A LINUX_ENV=1
		)
	)
	IF "!DBA_MODE!" == "DBAMODE" (
	SET /A LINUX_ENV=1
	ECHO !DB2! SET PASSTHRU RESET  >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! SET PASSTHRU RESET
	)
    GOTO :STEP_3

:: } END - INIT

REM ############################################################################
REM Performs required tasks based on the inputs.
REM Arguments:  NONE
REM ############################################################################
:PROCESS_ARGUMENTS
:: BEGIN {
	IF NOT "!DBA_MODE!" == "DBAMODE" (
    ECHO !SEPARATOR!
    ECHO. 
	)

    FOR %%I IN (%ARGUMENTS%) DO (

        SET AN_ARG=%%I

        SET RESULT=!RESULT_OK!

        IF "!ACTION!" == "-add" (
            CALL :CREATE_A_VIEW !AN_ARG!
        ) ELSE (
            IF "!ACTION!" == "-delete" (
                CALL :DELETE_A_VIEW !AN_ARG!
            )
        )

        IF NOT !RESULT! == !RESULT_OK! (
            SET /A ERROR_COUNT+=1
        )
		IF NOT "!DBA_MODE!" == "DBAMODE" (
        ECHO !SEPARATOR!
        ECHO. 
		)
    )

    GOTO :STEP_4

:: } END - PROCESS_ARGUMENTS

REM ############################################################################
REM Establishes views in the database as directed by the input.
REM Arguments:
REM     %1  :   Utilization metrics view
REM             [PS|VM]_[CPU|MEM|DS/IO|NET]_[H|D|W|M|Q|Y]
REM ############################################################################
:CREATE_A_VIEW

    SET L_OPT=%1

    IF "!L_OPT:~0,6!" == "PS_CPU" (
        CALL :CREATE_COMMON !L_OPT! KPH_SERVER_DETAILS "!VIEW_BODY_SERVER_CPU!" "!VIEW_BODY_SERVER_CPU_AGG!" RESULT VIEW_NAME
		SET SUCCESS_VIEW=!SUCCESS_VIEW!,!VIEW_NAME!
        GOTO :EOF
    )
    IF "!L_OPT:~0,6!" == "PS_MEM" (
        CALL :CREATE_PS_MEM !L_OPT! RESULT VIEW_NAME
		SET SUCCESS_VIEW=!SUCCESS_VIEW!,!VIEW_NAME!
        GOTO :EOF
    )
    IF "!L_OPT:~0,6!" == "PS_NET" (
        CALL :CREATE_COMMON !L_OPT! KVA_NETWORK_ADAPTERS_RATES "!VIEW_BODY_SERVER_NET!" "!VIEW_BODY_SERVER_NET_AGG!" RESULT VIEW_NAME
		SET SUCCESS_VIEW=!SUCCESS_VIEW!,!VIEW_NAME!
        GOTO :EOF
    )
    IF "!L_OPT:~0,5!" == "PS_IO" (
        CALL :CREATE_COMMON !L_OPT! KVA_DISKS "!VIEW_BODY_SERVER_DISK!" "!VIEW_BODY_SERVER_DISK_AGG!" RESULT VIEW_NAME
		SET SUCCESS_VIEW=!SUCCESS_VIEW!,!VIEW_NAME!
        GOTO :EOF
    )

    IF "!L_OPT:~0,6!" == "VM_CPU" (
        CALL :CREATE_COMMON !L_OPT! KPH_SERVER_LPARS "!VIEW_BODY_VM_CPU!" "!VIEW_BODY_VM_CPU_AGG!" RESULT VIEW_NAME
		SET SUCCESS_VIEW=!SUCCESS_VIEW!,!VIEW_NAME!
        GOTO :EOF
    )
    IF "!L_OPT:~0,6!" == "VM_MEM" (
        CALL :CREATE_VM_MEM !L_OPT! RESULT VIEW_NAME
		SET SUCCESS_VIEW=!SUCCESS_VIEW!,!VIEW_NAME!
        GOTO :EOF
    )
    IF "!L_OPT:~0,6!" == "VM_NET" (
        CALL :CREATE_VM_NET !L_OPT! RESULT VIEW_NAME
		SET SUCCESS_VIEW=!SUCCESS_VIEW!,!VIEW_NAME!
        GOTO :EOF
    )
    IF "!L_OPT:~0,5!" == "VM_DS" (
        CALL :CREATE_VM_DS !L_OPT! RESULT VIEW_NAME
		SET SUCCESS_VIEW=!SUCCESS_VIEW!,!VIEW_NAME!
        GOTO :EOF
    )

EXIT /B

REM ############################################################################
REM Encapsulates common logic to define and install required views.
REM Arguments:
REM     %1  :   Option to be federated
REM     %2  :   TDW table to be used for federation
REM     %3  :   Body of the view to be defined
REM     %4  :   Body of the aggregation view to be defined
REM ############################################################################
:CREATE_COMMON
SETLOCAL
    SET L_COMMON_OPT=%1
    SET L_TDW_TABLE=%2
    SET L_VIEW_BODY=%3
    SET L_VIEW_BODY_AGG=%4

    REM Strip off leading and trailing double quotes used to pass the command as
    REM an argument to this lable.
    SET L_VIEW_BODY=%L_VIEW_BODY:~1%
    SET L_VIEW_BODY=%L_VIEW_BODY:~0,-1%
    SET L_VIEW_BODY_AGG=%L_VIEW_BODY_AGG:~1%
    SET L_VIEW_BODY_AGG=%L_VIEW_BODY_AGG:~0,-1%

    SET L_VIEW_DEF=!L_VIEW_BODY!

    SET L_SUMM_LEVEL=
    IF "!L_COMMON_OPT:~-2,1!" == "_" (
        SET L_SUMM_LEVEL=!L_COMMON_OPT:~-2!
        SET L_VIEW_DEF=!L_VIEW_BODY_AGG!
    )

    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    REM In case of DB2 9.5, first drop the nicknames if they exist already. +
    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    IF %DB2_VERSION% == 5 (
        CALL :DropNickNameIfExists FED_!L_TDW_TABLE!_!L_COMMON_OPT! !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~5=%RESULT%" & GOTO :EOF
        )
    )
    CALL :CreateNickName FED_!L_TDW_TABLE!_!L_COMMON_OPT! !TDW_SCHEMA_PREFIX!."!L_TDW_TABLE!!L_SUMM_LEVEL!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~5=%RESULT%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_!L_TDW_TABLE!_!L_PCOMMON_OPT!

	CALL :DropMESTableIfExists MES_!L_COMMON_OPT! !DM_SCHEMA_NAME! RESULT
	IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~5=%RESULT%" & GOTO :EOF
    )
	
	REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    REM In case of DB2 9.5, first drop the view if it exists.               +
    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    IF %DB2_VERSION% == 5 (
        CALL :DropMESViewIfExists MES_!L_COMMON_OPT! !DM_SCHEMA_NAME!
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~5=%RESULT%" & GOTO :EOF
        )
    )
	
    SET DB2_CMD_DM_VIEW=!SQL_CREATE_VIEW! MES_!L_COMMON_OPT! AS !L_VIEW_DEF!
	SET FROM_TABLE=FROM !DM_SCHEMA_NAME!.FED_!L_TDW_TABLE!_!L_COMMON_OPT! T
    CALL :CreateMESView !DM_SCHEMA_NAME!.MES_!L_COMMON_OPT! "!DB2_CMD_DM_VIEW!" "XXX!FROM_TABLE!XXX" RESULT VIEW_NAME
	IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~5=%RESULT%" & GOTO :EOF
    )

    CALL :UpdatePercentileViews !L_COMMON_OPT! !DM_SCHEMA_NAME!
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~5=%RESULT%" & GOTO :EOF
    )
    

(ENDLOCAL
	SET %~5=%RESULT%
	SET %~6=%VIEW_NAME%
	EXIT /B
)


REM ############################################################################
REM Defines federated view for Physical Server Memory Utilization.
REM Arguments:
REM     %1  :   Option to establish federation for (PS_MEM[Summarization Level])
REM ############################################################################
:CREATE_PS_MEM
SETLOCAL
    SET L_PS_MEM_OPT=%1
	SET RET_CODE=0
    SET L_SUMM_LEVEL=
    IF "!L_PS_MEM_OPT:~-2,1!" == "_" (
        SET L_SUMM_LEVEL=!L_PS_MEM_OPT:~-2!
    )

    REM In case of DB2 9.5, first drop the nicknames if they exist already.
    IF %DB2_VERSION% == 5 (

        SET L_NICK_NAMES_LIST=FED_UNIX_MEMORY_!L_PS_MEM_OPT! FED_MACHINE_INFORMATION_!L_PS_MEM_OPT! FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT! FED_KVA_PHYSICAL_MEMORY_!L_PS_MEM_OPT! FED_KVA_TADDM_!L_PS_MEM_OPT!

        IF !LINUX_ENV! EQU 1 (
            SET L_NICK_NAMES_LIST=!L_NICK_NAMES_LIST! FED_KLZ_VM_STATS_!L_PS_MEM_OPT! FED_LINUX_MACHINE_INFORMATION_!L_PS_MEM_OPT!
        )

        FOR %%K IN ( %L_NICK_NAMES_LIST% ) DO (
            SET L_NICK=%%K
            CALL :DropNickNameIfExists !L_NICK! !DM_SCHEMA_NAME! RESULT
            IF NOT !RESULT! == !RESULT_OK! (
                ENDLOCAL & SET "%~2=%RESULT%" & GOTO :EOF
            )
        )

    )

    CALL :CreateNickName FED_UNIX_MEMORY_!L_PS_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!Unix_Memory!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RESULT%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_UNIX_MEMORY_!L_PS_MEM_OPT!

    CALL :CreateNickName FED_MACHINE_INFORMATION_!L_PS_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!Machine_Information!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RESULT%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_MACHINE_INFORMATION_!L_PS_MEM_OPT!

    CALL :CreateNickName FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!KPH_SERVER_LPARS!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RESULT%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT!

    CALL :CreateNickName FED_KVA_PHYSICAL_MEMORY_!L_PS_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!KVA_PHYSICAL_MEMORY!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RESULT%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KVA_PHYSICAL_MEMORY_!L_PS_MEM_OPT!

    CALL :CreateNickName FED_KVA_TADDM_!L_PS_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!KVA_TADDM!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RESULT%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KVA_TADDM_!L_PS_MEM_OPT!

    IF !LINUX_ENV! EQU 1 (
        CALL :CreateNickName FED_KLZ_VM_STATS_!L_PS_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!KLZ_VM_Stats!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RESULT%" & GOTO :EOF
        )
        SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KLZ_VM_STATS_!L_PS_MEM_OPT!

        CALL :CreateNickName FED_LINUX_MACHINE_INFORMATION_!L_PS_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!Linux_Machine_Information!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RESULT%" & GOTO :EOF
        )
        SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_LINUX_MACHINE_INFORMATION_!L_PS_MEM_OPT!
    )

    CALL :DropMESTableIfExists MES_!L_PS_MEM_OPT! !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RESULT%" & GOTO :EOF
    )

    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    REM In case of DB2 9.5, first drop the view if it already exists.       +
    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    IF %DB2_VERSION% == 5 (
        CALL :DropMESViewIfExists MES_!L_PS_MEM_OPT! !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RESULT%" & GOTO :EOF
        )
    )

    SET L_PS_MEM_VIEW_DEF="XXX( HOST_NAME, PHYSICAL_MEMORY, MEMORY_USAGE, MEMORY_UTILIZATION, ACTIVE_MEMORY, GRANTED_MEMORY, SWAP_USED, FREE_MEM, BALLOON_USED, SWAP_IN_RATE, SWAP_OUT_RATE, SWAP_TOTAL_RATE, TIMESTAMP, WRITETIME ) AS ( SELECT X.HOST_NAME, X.PHYSICAL_MEMORY, X.MEMORY_USAGE, (X.MEMORY_UTILIZATION + Z.MEMORY_UTILIZATION), X.ACTIVE_MEMORY, X.GRANTED_MEMORY, X.SWAP_USED, X.FREE_MEM, X.BALLOON_USED, X.SWAP_IN_RATE, X.SWAP_OUT_RATE, X.SWAP_TOTAL_RATE, X.TIMESTAMP, X.WRITETIME FROM (SELECT Q.!QC!CEC_name!QC! AS HOST_NAME, -1 AS PHYSICAL_MEMORY, -1 AS MEMORY_USAGE, P.!QC!USED_MEMORY_MB!QC! AS MEMORY_UTILIZATION, -1 AS ACTIVE_MEMORY, -1 AS GRANTED_MEMORY, -1 AS SWAP_USED, -1 AS FREE_MEM, -1 AS BALLOON_USED, -1 AS SWAP_IN_RATE, -1 AS SWAP_OUT_RATE, -1 AS SWAP_TOTAL_RATE, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! AS WRITETIME FROM (SELECT !QC!System_Name!QC!, !QC!WRITETIME!QC!, SUM(!QC!Used_Real_Mem_MB!QC!) AS USED_MEMORY_MB FROM FED_UNIX_MEMORY_!L_PS_MEM_OPT! GROUP BY !QC!System_Name!QC!, !QC!WRITETIME!QC!) P INNER JOIN (SELECT MI.!QC!System_Name!QC!, MI.!QC!WRITETIME!QC!, KSL.!QC!CEC_name!QC! FROM FED_MACHINE_INFORMATION_!L_PS_MEM_OPT! MI, FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT! KSL WHERE MI.!QC!Hardware_Model!QC! = KSL.!QC!CEC_Model!QC! AND SUBSTR(MI.!QC!Machine_Serial!QC!, 7) = KSL.!QC!CEC_SN!QC! AND MI.!QC!WRITETIME!QC! = KSL.!QC!WRITETIME!QC!) Q ON P.!QC!System_Name!QC! = Q.!QC!System_Name!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!) X, (SELECT Q.!QC!CEC_name!QC! AS HOST_NAME, -1 AS PHYSICAL_MEMORY, -1 AS MEMORY_USAGE, P.!QC!USED_MEMORY_MB!QC! AS MEMORY_UTILIZATION, -1 AS ACTIVE_MEMORY, -1 AS GRANTED_MEMORY, -1 AS SWAP_USED, -1 AS FREE_MEM, -1 AS BALLOON_USED, -1 AS SWAP_IN_RATE, -1 AS SWAP_OUT_RATE, -1 AS SWAP_TOTAL_RATE, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! AS WRITETIME FROM (SELECT !QC!Node!QC!, !QC!WRITETIME!QC!, !QC!Used_Memory_MB!QC! AS USED_MEMORY_MB FROM FED_KVA_PHYSICAL_MEMORY_!L_PS_MEM_OPT!) P INNER JOIN (SELECT KSL.!QC!CEC_name!QC!, KT.!QC!Node!QC!, KT.!QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT! KSL, FED_KVA_TADDM_!L_PS_MEM_OPT! KT WHERE KSL.!QC!CEC_Model!QC! = KT.!QC!CEC_Model!QC! AND KSL.!QC!CEC_SN!QC! = KT.!QC!CEC_SN!QC!) Q ON P.!QC!Node!QC! = Q.!QC!Node!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!) Z WHERE X.!QC!WRITETIME!QC! = Z.!QC!WRITETIME!QC!)XXX"

    SET L_PS_MEM_VIEW_DEF_AGG="XXX(HOST_NAME, PHYSICAL_MEMORY, MIN_MEMORY_USAGE, MAX_MEMORY_USAGE, AVG_MEMORY_USAGE, SUM_MEMORY_USAGE, MIN_MEMORY_UTILIZATION, MAX_MEMORY_UTILIZATION, AVG_MEMORY_UTILIZATION, SUM_MEMORY_UTILIZATION, MIN_ACTIVE_MEMORY, MAX_ACTIVE_MEMORY, SUM_ACTIVE_MEMORY, AVG_ACTIVE_MEMORY, MIN_GRANTED_MEMORY, MAX_GRANTED_MEMORY, AVG_GRANTED_MEMORY, SUM_GRANTED_MEMORY, MIN_SWAP_USED, MAX_SWAP_USED, AVG_SWAP_USED, SUM_SWAP_USED, MIN_FREE_MEM, MAX_FREE_MEM, SUM_FREE_MEM, AVG_FREE_MEM, MIN_BALLOON_USED, MAX_BALLOON_USED, AVG_BALLOON_USED, SUM_BALLOON_USED, MIN_SWAP_IN_RATE, MAX_SWAP_IN_RATE, AVG_SWAP_IN_RATE, SUM_SWAP_IN_RATE, MIN_SWAP_OUT_RATE, MAX_SWAP_OUT_RATE, AVG_SWAP_OUT_RATE, SUM_SWAP_OUT_RATE, MIN_SWAP_TOTAL_RATE, MAX_SWAP_TOTAL_RATE, AVG_SWAP_TOTAL_RATE, SUM_SWAP_TOTAL_RATE, TIMESTAMP, WRITETIME) AS (SELECT X.HOST_NAME, X.PHYSICAL_MEMORY, X.MIN_MEMORY_USAGE, X.MAX_MEMORY_USAGE, X.AVG_MEMORY_USAGE, X.SUM_MEMORY_USAGE, (X.MIN_MEMORY_UTILIZATION + Z.MIN_MEMORY_UTILIZATION), (X.MAX_MEMORY_UTILIZATION + Z.MAX_MEMORY_UTILIZATION), (X.AVG_MEMORY_UTILIZATION + Z.AVG_MEMORY_UTILIZATION), (X.SUM_MEMORY_UTILIZATION + Z.SUM_MEMORY_UTILIZATION), X.MIN_ACTIVE_MEMORY,  X.MAX_ACTIVE_MEMORY,  X.AVG_ACTIVE_MEMORY,  X.SUM_ACTIVE_MEMORY, X.MIN_GRANTED_MEMORY, X.MAX_GRANTED_MEMORY, X.AVG_GRANTED_MEMORY, X.SUM_GRANTED_MEMORY, X.MIN_SWAP_USED, X.MAX_SWAP_USED, X.AVG_SWAP_USED, X.SUM_SWAP_USED, X.MIN_FREE_MEM, X.MAX_FREE_MEM, X.AVG_FREE_MEM, X.SUM_FREE_MEM, X.MIN_BALLOON_USED, X.MAX_BALLOON_USED, X.AVG_BALLOON_USED, X.SUM_BALLOON_USED, X.MIN_SWAP_IN_RATE, X.MAX_SWAP_IN_RATE, X.AVG_SWAP_IN_RATE, X.SUM_SWAP_IN_RATE, X.MIN_SWAP_OUT_RATE, X.MAX_SWAP_OUT_RATE, X.AVG_SWAP_OUT_RATE, X.SUM_SWAP_OUT_RATE, X.MIN_SWAP_TOTAL_RATE, X.MAX_SWAP_TOTAL_RATE, X.AVG_SWAP_TOTAL_RATE, X.SUM_SWAP_TOTAL_RATE, X.TIMESTAMP, X.WRITETIME FROM (SELECT Q.!QC!LAT_CEC_name!QC! AS HOST_NAME, -1 AS PHYSICAL_MEMORY, -1 AS MIN_MEMORY_USAGE, -1 AS MAX_MEMORY_USAGE, -1 AS AVG_MEMORY_USAGE, -1 AS SUM_MEMORY_USAGE, P.!QC!MIN_USED_MEMORY_MB!QC! AS MIN_MEMORY_UTILIZATION, P.!QC!MAX_USED_MEMORY_MB!QC! AS MAX_MEMORY_UTILIZATION, P.!QC!AVG_USED_MEMORY_MB!QC! AS AVG_MEMORY_UTILIZATION, P.!QC!SUM_USED_MEMORY_MB!QC! AS SUM_MEMORY_UTILIZATION, -1 AS MIN_ACTIVE_MEMORY, -1 AS MAX_ACTIVE_MEMORY, -1 AS AVG_ACTIVE_MEMORY, -1 AS SUM_ACTIVE_MEMORY, -1 AS MIN_GRANTED_MEMORY, -1 AS MAX_GRANTED_MEMORY, -1 AS AVG_GRANTED_MEMORY, -1 AS SUM_GRANTED_MEMORY, -1 AS MIN_SWAP_USED, -1 AS MAX_SWAP_USED, -1 AS AVG_SWAP_USED, -1 AS SUM_SWAP_USED, -1 AS MIN_FREE_MEM, -1 AS MAX_FREE_MEM, -1 AS AVG_FREE_MEM, -1 AS SUM_FREE_MEM, -1 AS MIN_BALLOON_USED, -1 AS MAX_BALLOON_USED, -1 AS AVG_BALLOON_USED, -1 AS SUM_BALLOON_USED, -1 AS MIN_SWAP_IN_RATE, -1 AS MAX_SWAP_IN_RATE, -1 AS AVG_SWAP_IN_RATE, -1 AS SUM_SWAP_IN_RATE, -1 AS MIN_SWAP_OUT_RATE, -1 AS MAX_SWAP_OUT_RATE, -1 AS AVG_SWAP_OUT_RATE, -1 AS SUM_SWAP_OUT_RATE, -1 AS MIN_SWAP_TOTAL_RATE, -1 AS MAX_SWAP_TOTAL_RATE, -1 AS AVG_SWAP_TOTAL_RATE, -1 AS SUM_SWAP_TOTAL_RATE, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! AS WRITETIME FROM (SELECT !QC!System_Name!QC!, !QC!WRITETIME!QC!, SUM(!QC!MIN_Used_Real_Mem_MB!QC!) AS MIN_USED_MEMORY_MB, SUM(!QC!MAX_Used_Real_Mem_MB!QC!) AS MAX_USED_MEMORY_MB, SUM(!QC!AVG_Used_Real_Mem_MB!QC!) AS AVG_USED_MEMORY_MB, SUM(!QC!SUM_Used_Real_Mem_MB!QC!) AS SUM_USED_MEMORY_MB FROM FED_UNIX_MEMORY_!L_PS_MEM_OPT! GROUP BY !QC!System_Name!QC!, !QC!WRITETIME!QC!) P INNER JOIN (SELECT MI.!QC!System_Name!QC!, MI.!QC!WRITETIME!QC!, KSL.!QC!LAT_CEC_name!QC! FROM FED_MACHINE_INFORMATION_!L_PS_MEM_OPT! MI, FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT! KSL WHERE MI.!QC!LAT_Hardware_Model!QC! = KSL.!QC!CEC_Model!QC! AND SUBSTR(MI.!QC!LAT_Machine_Serial!QC!, 7) = KSL.!QC!CEC_SN!QC! AND MI.!QC!WRITETIME!QC! = KSL.!QC!WRITETIME!QC!) Q ON P.!QC!System_Name!QC! = Q.!QC!System_Name!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!) X, (SELECT Q.!QC!LAT_CEC_name!QC! AS HOST_NAME, -1 AS PHYSICAL_MEMORY, -1 AS MIN_MEMORY_USAGE, -1 AS MAX_MEMORY_USAGE, -1 AS AVG_MEMORY_USAGE, -1 AS SUM_MEMORY_USAGE, P.!QC!MIN_USED_MEMORY_MB!QC! AS MIN_MEMORY_UTILIZATION, P.!QC!MAX_USED_MEMORY_MB!QC! AS MAX_MEMORY_UTILIZATION, P.!QC!AVG_USED_MEMORY_MB!QC! AS AVG_MEMORY_UTILIZATION, P.!QC!SUM_USED_MEMORY_MB!QC! AS SUM_MEMORY_UTILIZATION, -1 AS MIN_ACTIVE_MEMORY, -1 AS MAX_ACTIVE_MEMORY, -1 AS AVG_ACTIVE_MEMORY, -1 AS SUM_ACTIVE_MEMORY, -1 AS MIN_GRANTED_MEMORY, -1 AS MAX_GRANTED_MEMORY, -1 AS AVG_GRANTED_MEMORY, -1 AS SUM_GRANTED_MEMORY, -1 AS MIN_SWAP_USED, -1 AS MAX_SWAP_USED, -1 AS AVG_SWAP_USED, -1 AS SUM_SWAP_USED, -1 AS MIN_FREE_MEM, -1 AS MAX_FREE_MEM, -1 AS AVG_FREE_MEM, -1 AS SUM_FREE_MEM, -1 AS MIN_BALLOON_USED, -1 AS MAX_BALLOON_USED, -1 AS AVG_BALLOON_USED, -1 AS SUM_BALLOON_USED, -1 AS MIN_SWAP_IN_RATE, -1 AS MAX_SWAP_IN_RATE, -1 AS AVG_SWAP_IN_RATE, -1 AS SUM_SWAP_IN_RATE, -1 AS MIN_SWAP_OUT_RATE, -1 AS MAX_SWAP_OUT_RATE, -1 AS AVG_SWAP_OUT_RATE, -1 AS SUM_SWAP_OUT_RATE, -1 AS MIN_SWAP_TOTAL_RATE, -1 AS MAX_SWAP_TOTAL_RATE, -1 AS AVG_SWAP_TOTAL_RATE, -1 AS SUM_SWAP_TOTAL_RATE, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! AS WRITETIME FROM (SELECT !QC!Node!QC!, !QC!WRITETIME!QC!, !QC!MIN_Used_Memory_MB!QC! AS MIN_USED_MEMORY_MB, !QC!MAX_Used_Memory_MB!QC! AS MAX_USED_MEMORY_MB, !QC!AVG_Used_Memory_MB!QC! AS AVG_USED_MEMORY_MB, !QC!SUM_Used_Memory_MB!QC! AS SUM_USED_MEMORY_MB FROM FED_KVA_PHYSICAL_MEMORY_!L_PS_MEM_OPT!) P INNER JOIN (SELECT KSL.!QC!LAT_CEC_name!QC!, KT.!QC!Node!QC!, KT.!QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT! KSL, FED_KVA_TADDM_!L_PS_MEM_OPT! KT WHERE KSL.!QC!CEC_Model!QC! = KT.!QC!LAT_CEC_Model!QC! AND KSL.!QC!CEC_SN!QC! = KT.!QC!LAT_CEC_SN!QC!) Q ON P.!QC!Node!QC! = Q.!QC!Node!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!) Z WHERE X.!QC!WRITETIME!QC! = Z.!QC!WRITETIME!QC!)XXX"

    
    IF !LINUX_ENV! EQU 1 (

        SET L_PS_MEM_VIEW_DEF="XXX(HOST_NAME, PHYSICAL_MEMORY, MEMORY_USAGE, MEMORY_UTILIZATION, ACTIVE_MEMORY, GRANTED_MEMORY, SWAP_USED, FREE_MEM, BALLOON_USED, SWAP_IN_RATE, SWAP_OUT_RATE, SWAP_TOTAL_RATE, TIMESTAMP, WRITETIME) AS ( SELECT X.HOST_NAME, X.PHYSICAL_MEMORY, X.MEMORY_USAGE, (X.MEMORY_UTILIZATION + Y.MEMORY_UTILIZATION + Z.MEMORY_UTILIZATION), X.ACTIVE_MEMORY, X.GRANTED_MEMORY, X.SWAP_USED, X.FREE_MEM, X.BALLOON_USED, X.SWAP_IN_RATE, X.SWAP_OUT_RATE, X.SWAP_TOTAL_RATE, X.TIMESTAMP, X.WRITETIME FROM (SELECT Q.!QC!CEC_name!QC! AS HOST_NAME, -1 AS PHYSICAL_MEMORY, -1 AS MEMORY_USAGE, P.!QC!USED_MEMORY_MB!QC! AS MEMORY_UTILIZATION, -1 AS ACTIVE_MEMORY, -1 AS GRANTED_MEMORY, -1 AS SWAP_USED, -1 AS FREE_MEM, -1 AS BALLOON_USED, -1 AS SWAP_IN_RATE, -1 AS SWAP_OUT_RATE, -1 AS SWAP_TOTAL_RATE, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! AS WRITETIME FROM (SELECT !QC!System_Name!QC!, !QC!WRITETIME!QC!, SUM(!QC!Used_Real_Mem_MB!QC!) AS USED_MEMORY_MB FROM FED_UNIX_MEMORY_!L_PS_MEM_OPT! GROUP BY !QC!System_Name!QC!, !QC!WRITETIME!QC!) P INNER JOIN (SELECT MI.!QC!System_Name!QC!, MI.!QC!WRITETIME!QC!, KSL.!QC!CEC_name!QC! FROM FED_MACHINE_INFORMATION_!L_PS_MEM_OPT! MI, FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT! KSL WHERE MI.!QC!Hardware_Model!QC! = KSL.!QC!CEC_Model!QC! AND SUBSTR(MI.!QC!Machine_Serial!QC!, 7) = KSL.!QC!CEC_SN!QC! AND MI.!QC!WRITETIME!QC! = KSL.!QC!WRITETIME!QC!) Q ON P.!QC!System_Name!QC! = Q.!QC!System_Name!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!) X, (SELECT Q.!QC!CEC_name!QC! AS HOST_NAME, -1 AS PHYSICAL_MEMORY, -1 AS MEMORY_USAGE, P.!QC!USED_MEMORY_MB!QC! AS MEMORY_UTILIZATION, -1 AS ACTIVE_MEMORY, -1 AS GRANTED_MEMORY, -1 AS SWAP_USED, -1 AS FREE_MEM, -1 AS BALLOON_USED, -1 AS SWAP_IN_RATE, -1 AS SWAP_OUT_RATE, -1 AS SWAP_TOTAL_RATE, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! AS WRITETIME FROM (SELECT !QC!System_Name!QC!, !QC!WRITETIME!QC!, SUM(!QC!Memory_Used!QC!) AS USED_MEMORY_MB FROM FED_KLZ_VM_STATS_!L_PS_MEM_OPT! GROUP BY !QC!System_Name!QC!, !QC!WRITETIME!QC!) P INNER JOIN (SELECT LMI.!QC!System_Name!QC!, LMI.!QC!WRITETIME!QC!, KSL.!QC!CEC_name!QC! FROM FED_LINUX_MACHINE_INFORMATION_!L_PS_MEM_OPT! LMI, FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT! KSL WHERE LMI.!QC!Hardware_Model!QC! = KSL.!QC!CEC_Model!QC! AND LMI.!QC!Machine_Serial!QC! = KSL.!QC!CEC_SN!QC! AND LMI.!QC!WRITETIME!QC! = KSL.!QC!WRITETIME!QC!) Q ON P.!QC!System_Name!QC! = Q.!QC!System_Name!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!) Y, (SELECT Q.!QC!CEC_name!QC! AS HOST_NAME, -1 AS PHYSICAL_MEMORY, -1 AS MEMORY_USAGE, P.!QC!USED_MEMORY_MB!QC! AS MEMORY_UTILIZATION, -1 AS ACTIVE_MEMORY, -1 AS GRANTED_MEMORY, -1 AS SWAP_USED, -1 AS FREE_MEM, -1 AS BALLOON_USED, -1 AS SWAP_IN_RATE, -1 AS SWAP_OUT_RATE, -1 AS SWAP_TOTAL_RATE, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! AS WRITETIME FROM (SELECT !QC!Node!QC!, !QC!WRITETIME!QC!, !QC!Used_Memory_MB!QC! AS USED_MEMORY_MB FROM FED_KVA_PHYSICAL_MEMORY_!L_PS_MEM_OPT!) P INNER JOIN (SELECT KSL.!QC!CEC_name!QC!, KT.!QC!Node!QC!, KT.!QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT! KSL, FED_KVA_TADDM_!L_PS_MEM_OPT! KT WHERE KSL.!QC!CEC_Model!QC! = KT.!QC!CEC_Model!QC! AND KSL.!QC!CEC_SN!QC! = KT.!QC!CEC_SN!QC!) Q ON P.!QC!Node!QC! = Q.!QC!Node!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!) Z WHERE X.!QC!WRITETIME!QC! = Y.!QC!WRITETIME!QC! AND Y.!QC!WRITETIME!QC! = Z.!QC!WRITETIME!QC!)XXX"
    SET L_PS_MEM_VIEW_DEF_AGG="XXX(HOST_NAME, PHYSICAL_MEMORY, MIN_MEMORY_USAGE, MAX_MEMORY_USAGE, AVG_MEMORY_USAGE, SUM_MEMORY_USAGE, MIN_MEMORY_UTILIZATION, MAX_MEMORY_UTILIZATION, AVG_MEMORY_UTILIZATION, SUM_MEMORY_UTILIZATION, MIN_ACTIVE_MEMORY, MAX_ACTIVE_MEMORY, SUM_ACTIVE_MEMORY, AVG_ACTIVE_MEMORY, MIN_GRANTED_MEMORY, MAX_GRANTED_MEMORY, AVG_GRANTED_MEMORY, SUM_GRANTED_MEMORY, MIN_SWAP_USED, MAX_SWAP_USED, AVG_SWAP_USED, SUM_SWAP_USED, MIN_FREE_MEM, MAX_FREE_MEM, SUM_FREE_MEM, AVG_FREE_MEM, MIN_BALLOON_USED, MAX_BALLOON_USED, AVG_BALLOON_USED, SUM_BALLOON_USED, MIN_SWAP_IN_RATE, MAX_SWAP_IN_RATE, AVG_SWAP_IN_RATE, SUM_SWAP_IN_RATE, MIN_SWAP_OUT_RATE, MAX_SWAP_OUT_RATE, AVG_SWAP_OUT_RATE, SUM_SWAP_OUT_RATE, MIN_SWAP_TOTAL_RATE, MAX_SWAP_TOTAL_RATE, AVG_SWAP_TOTAL_RATE, SUM_SWAP_TOTAL_RATE, TIMESTAMP, WRITETIME) AS (SELECT X.HOST_NAME, X.PHYSICAL_MEMORY, X.MIN_MEMORY_USAGE, X.MAX_MEMORY_USAGE, X.AVG_MEMORY_USAGE, X.SUM_MEMORY_USAGE, (X.MIN_MEMORY_UTILIZATION + Y.MIN_MEMORY_UTILIZATION + Z.MIN_MEMORY_UTILIZATION), (X.MAX_MEMORY_UTILIZATION + Y.MAX_MEMORY_UTILIZATION + Z.MAX_MEMORY_UTILIZATION), (X.AVG_MEMORY_UTILIZATION + Y.AVG_MEMORY_UTILIZATION + Z.AVG_MEMORY_UTILIZATION), (X.SUM_MEMORY_UTILIZATION + Y.SUM_MEMORY_UTILIZATION + Z.SUM_MEMORY_UTILIZATION), X.MIN_ACTIVE_MEMORY,  X.MAX_ACTIVE_MEMORY,  X.AVG_ACTIVE_MEMORY,  X.SUM_ACTIVE_MEMORY, X.MIN_GRANTED_MEMORY, X.MAX_GRANTED_MEMORY, X.AVG_GRANTED_MEMORY, X.SUM_GRANTED_MEMORY, X.MIN_SWAP_USED, X.MAX_SWAP_USED, X.AVG_SWAP_USED, X.SUM_SWAP_USED, X.MIN_FREE_MEM, X.MAX_FREE_MEM, X.AVG_FREE_MEM, X.SUM_FREE_MEM, X.MIN_BALLOON_USED, X.MAX_BALLOON_USED, X.AVG_BALLOON_USED, X.SUM_BALLOON_USED, X.MIN_SWAP_IN_RATE, X.MAX_SWAP_IN_RATE, X.AVG_SWAP_IN_RATE, X.SUM_SWAP_IN_RATE, X.MIN_SWAP_OUT_RATE, X.MAX_SWAP_OUT_RATE, X.AVG_SWAP_OUT_RATE, X.SUM_SWAP_OUT_RATE, X.MIN_SWAP_TOTAL_RATE, X.MAX_SWAP_TOTAL_RATE, X.AVG_SWAP_TOTAL_RATE, X.SUM_SWAP_TOTAL_RATE, X.TIMESTAMP, X.WRITETIME FROM (SELECT Q.!QC!LAT_CEC_name!QC! AS HOST_NAME, -1 AS PHYSICAL_MEMORY, -1 AS MIN_MEMORY_USAGE, -1 AS MAX_MEMORY_USAGE, -1 AS AVG_MEMORY_USAGE, -1 AS SUM_MEMORY_USAGE, P.!QC!MIN_USED_MEMORY_MB!QC! AS MIN_MEMORY_UTILIZATION, P.!QC!MAX_USED_MEMORY_MB!QC! AS MAX_MEMORY_UTILIZATION, P.!QC!AVG_USED_MEMORY_MB!QC! AS AVG_MEMORY_UTILIZATION, P.!QC!SUM_USED_MEMORY_MB!QC! AS SUM_MEMORY_UTILIZATION, -1 AS MIN_ACTIVE_MEMORY, -1 AS MAX_ACTIVE_MEMORY, -1 AS AVG_ACTIVE_MEMORY, -1 AS SUM_ACTIVE_MEMORY, -1 AS MIN_GRANTED_MEMORY, -1 AS MAX_GRANTED_MEMORY, -1 AS AVG_GRANTED_MEMORY, -1 AS SUM_GRANTED_MEMORY, -1 AS MIN_SWAP_USED, -1 AS MAX_SWAP_USED, -1 AS AVG_SWAP_USED, -1 AS SUM_SWAP_USED, -1 AS MIN_FREE_MEM, -1 AS MAX_FREE_MEM, -1 AS AVG_FREE_MEM, -1 AS SUM_FREE_MEM, -1 AS MIN_BALLOON_USED, -1 AS MAX_BALLOON_USED, -1 AS AVG_BALLOON_USED, -1 AS SUM_BALLOON_USED, -1 AS MIN_SWAP_IN_RATE, -1 AS MAX_SWAP_IN_RATE, -1 AS AVG_SWAP_IN_RATE, -1 AS SUM_SWAP_IN_RATE, -1 AS MIN_SWAP_OUT_RATE, -1 AS MAX_SWAP_OUT_RATE, -1 AS AVG_SWAP_OUT_RATE, -1 AS SUM_SWAP_OUT_RATE, -1 AS MIN_SWAP_TOTAL_RATE, -1 AS MAX_SWAP_TOTAL_RATE, -1 AS AVG_SWAP_TOTAL_RATE, -1 AS SUM_SWAP_TOTAL_RATE, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! AS WRITETIME FROM (SELECT !QC!System_Name!QC!, !QC!WRITETIME!QC!, SUM(!QC!MIN_Used_Real_Mem_MB!QC!) AS MIN_USED_MEMORY_MB, SUM(!QC!MAX_Used_Real_Mem_MB!QC!) AS MAX_USED_MEMORY_MB, SUM(!QC!AVG_Used_Real_Mem_MB!QC!) AS AVG_USED_MEMORY_MB, SUM(!QC!SUM_Used_Real_Mem_MB!QC!) AS SUM_USED_MEMORY_MB FROM FED_UNIX_MEMORY_!L_PS_MEM_OPT! GROUP BY !QC!System_Name!QC!, !QC!WRITETIME!QC!) P INNER JOIN (SELECT MI.!QC!System_Name!QC!, MI.!QC!WRITETIME!QC!, KSL.!QC!LAT_CEC_name!QC! FROM FED_MACHINE_INFORMATION_!L_PS_MEM_OPT! MI, FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT! KSL WHERE MI.!QC!LAT_Hardware_Model!QC! = KSL.!QC!CEC_Model!QC! AND SUBSTR(MI.!QC!LAT_Machine_Serial!QC!, 7) = KSL.!QC!CEC_SN!QC! AND MI.!QC!WRITETIME!QC! = KSL.!QC!WRITETIME!QC!) Q ON P.!QC!System_Name!QC! = Q.!QC!System_Name!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!) X, (SELECT Q.!QC!LAT_CEC_name!QC! AS HOST_NAME, -1 AS PHYSICAL_MEMORY, -1 AS MIN_MEMORY_USAGE, -1 AS MAX_MEMORY_USAGE, -1 AS AVG_MEMORY_USAGE, -1 AS SUM_MEMORY_USAGE, P.!QC!MIN_USED_MEMORY_MB!QC! AS MIN_MEMORY_UTILIZATION, P.!QC!MAX_USED_MEMORY_MB!QC! AS MAX_MEMORY_UTILIZATION, P.!QC!AVG_USED_MEMORY_MB!QC! AS AVG_MEMORY_UTILIZATION, P.!QC!SUM_USED_MEMORY_MB!QC! AS SUM_MEMORY_UTILIZATION, -1 AS MIN_ACTIVE_MEMORY, -1 AS MAX_ACTIVE_MEMORY, -1 AS AVG_ACTIVE_MEMORY, -1 AS SUM_ACTIVE_MEMORY, -1 AS MIN_GRANTED_MEMORY, -1 AS MAX_GRANTED_MEMORY, -1 AS AVG_GRANTED_MEMORY, -1 AS SUM_GRANTED_MEMORY, -1 AS MIN_SWAP_USED, -1 AS MAX_SWAP_USED, -1 AS AVG_SWAP_USED, -1 AS SUM_SWAP_USED, -1 AS MIN_FREE_MEM, -1 AS MAX_FREE_MEM, -1 AS AVG_FREE_MEM, -1 AS SUM_FREE_MEM, -1 AS MIN_BALLOON_USED, -1 AS MAX_BALLOON_USED, -1 AS AVG_BALLOON_USED, -1 AS SUM_BALLOON_USED, -1 AS MIN_SWAP_IN_RATE, -1 AS MAX_SWAP_IN_RATE, -1 AS AVG_SWAP_IN_RATE, -1 AS SUM_SWAP_IN_RATE, -1 AS MIN_SWAP_OUT_RATE, -1 AS MAX_SWAP_OUT_RATE, -1 AS AVG_SWAP_OUT_RATE, -1 AS SUM_SWAP_OUT_RATE, -1 AS MIN_SWAP_TOTAL_RATE, -1 AS MAX_SWAP_TOTAL_RATE, -1 AS AVG_SWAP_TOTAL_RATE, -1 AS SUM_SWAP_TOTAL_RATE, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! AS WRITETIME FROM (SELECT !QC!System_Name!QC!, !QC!WRITETIME!QC!, SUM(!QC!MIN_Memory_Used!QC!) AS MIN_USED_MEMORY_MB, SUM(!QC!MAX_Memory_Used!QC!) AS MAX_USED_MEMORY_MB, SUM(!QC!AVG_Memory_Used!QC!) AS AVG_USED_MEMORY_MB, SUM(!QC!SUM_Memory_Used!QC!) AS SUM_USED_MEMORY_MB FROM FED_KLZ_VM_STATS_!L_PS_MEM_OPT! GROUP BY !QC!System_Name!QC!, !QC!WRITETIME!QC!) P INNER JOIN (SELECT LMI.!QC!System_Name!QC!, LMI.!QC!WRITETIME!QC!, KSL.!QC!LAT_CEC_name!QC! FROM FED_LINUX_MACHINE_INFORMATION_!L_PS_MEM_OPT! LMI, FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT! KSL WHERE LMI.!QC!LAT_Hardware_Model!QC! = KSL.!QC!CEC_Model!QC! AND LMI.!QC!LAT_Machine_Serial!QC! = KSL.!QC!CEC_SN!QC! AND LMI.!QC!WRITETIME!QC! = KSL.!QC!WRITETIME!QC!) Q ON P.!QC!System_Name!QC! = Q.!QC!System_Name!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!) Y, (SELECT Q.!QC!LAT_CEC_name!QC! AS HOST_NAME, -1 AS PHYSICAL_MEMORY, -1 AS MIN_MEMORY_USAGE, -1 AS MAX_MEMORY_USAGE, -1 AS AVG_MEMORY_USAGE, -1 AS SUM_MEMORY_USAGE, P.!QC!MIN_USED_MEMORY_MB!QC! AS MIN_MEMORY_UTILIZATION, P.!QC!MAX_USED_MEMORY_MB!QC! AS MAX_MEMORY_UTILIZATION, P.!QC!AVG_USED_MEMORY_MB!QC! AS AVG_MEMORY_UTILIZATION, P.!QC!SUM_USED_MEMORY_MB!QC! AS SUM_MEMORY_UTILIZATION, -1 AS MIN_ACTIVE_MEMORY, -1 AS MAX_ACTIVE_MEMORY, -1 AS AVG_ACTIVE_MEMORY, -1 AS SUM_ACTIVE_MEMORY, -1 AS MIN_GRANTED_MEMORY, -1 AS MAX_GRANTED_MEMORY, -1 AS AVG_GRANTED_MEMORY, -1 AS SUM_GRANTED_MEMORY, -1 AS MIN_SWAP_USED, -1 AS MAX_SWAP_USED, -1 AS AVG_SWAP_USED, -1 AS SUM_SWAP_USED, -1 AS MIN_FREE_MEM, -1 AS MAX_FREE_MEM, -1 AS AVG_FREE_MEM, -1 AS SUM_FREE_MEM, -1 AS MIN_BALLOON_USED, -1 AS MAX_BALLOON_USED, -1 AS AVG_BALLOON_USED, -1 AS SUM_BALLOON_USED, -1 AS MIN_SWAP_IN_RATE, -1 AS MAX_SWAP_IN_RATE, -1 AS AVG_SWAP_IN_RATE, -1 AS SUM_SWAP_IN_RATE, -1 AS MIN_SWAP_OUT_RATE, -1 AS MAX_SWAP_OUT_RATE, -1 AS AVG_SWAP_OUT_RATE, -1 AS SUM_SWAP_OUT_RATE, -1 AS MIN_SWAP_TOTAL_RATE, -1 AS MAX_SWAP_TOTAL_RATE, -1 AS AVG_SWAP_TOTAL_RATE, -1 AS SUM_SWAP_TOTAL_RATE, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! AS WRITETIME FROM (SELECT !QC!Node!QC!, !QC!WRITETIME!QC!, !QC!MIN_Used_Memory_MB!QC! AS MIN_USED_MEMORY_MB, !QC!MAX_Used_Memory_MB!QC! AS MAX_USED_MEMORY_MB, !QC!AVG_Used_Memory_MB!QC! AS AVG_USED_MEMORY_MB, !QC!SUM_Used_Memory_MB!QC! AS SUM_USED_MEMORY_MB FROM FED_KVA_PHYSICAL_MEMORY_!L_PS_MEM_OPT!) P INNER JOIN (SELECT KSL.!QC!LAT_CEC_name!QC!, KT.!QC!Node!QC!, KT.!QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_PS_MEM_OPT! KSL, FED_KVA_TADDM_!L_PS_MEM_OPT! KT WHERE KSL.!QC!CEC_Model!QC! = KT.!QC!LAT_CEC_Model!QC! AND KSL.!QC!CEC_SN!QC! = KT.!QC!LAT_CEC_SN!QC!) Q ON P.!QC!Node!QC! = Q.!QC!Node!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!) Z WHERE X.!QC!WRITETIME!QC! = Z.!QC!WRITETIME!QC!)XXX"

    )

    SET L_VIEW_DEF=!L_PS_MEM_VIEW_DEF!
    IF NOT (!L_SUMM_LEVEL!) == () (
        SET L_VIEW_DEF=!L_PS_MEM_VIEW_DEF_AGG!
    )

    SET DB2_CMD_DM_VIEW=!SQL_CREATE_VIEW! !DM_SCHEMA_NAME!.MES_!L_PS_MEM_OPT!

    CALL :CreateMESView !DM_SCHEMA_NAME!.MES_!L_PS_MEM_OPT! "!DB2_CMD_DM_VIEW!"  !L_VIEW_DEF! RESULT VIEW_NAME
	IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RESULT%" & GOTO :EOF
    )

    CALL :UpdatePercentileViews !L_PS_MEM_OPT! !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RESULT%" & GOTO :EOF
    )
	SET RET_CODE=1
(ENDLOCAL
	SET "%~2=%RET_CODE%"
	SET "%~3=%VIEW_NAME%"
	EXIT /B
)
REM ############################################################################
REM Defines federated view for Virtual Machine Memory Utilization.
REM Arguments:
REM     %1  :   Option to establish federation for (VM_MEM[Summarization Level])
REM ############################################################################
:CREATE_VM_MEM
SETLOCAL
    SET L_VM_MEM_OPT=%1
	SET RET_CODE=0
    SET L_SUMM_LEVEL=
    IF "!L_VM_MEM_OPT:~-2,1!" == "_" (
        SET L_SUMM_LEVEL=!L_VM_MEM_OPT:~-2!
    )

    REM In case of DB2 9.5, first drop the nicknames if they exist already.
    IF %DB2_VERSION% == 5 (

        SET L_NICK_NAMES_LIST=FED_UNIX_MEMORY_!L_VM_MEM_OPT! FED_MACHINE_INFORMATION_!L_VM_MEM_OPT! FED_AIX_LPAR_!L_VM_MEM_OPT! FED_KPH_SERVER_LPARS_!L_VM_MEM_OPT! FED_KVA_PHYSICAL_MEMORY_!L_VM_MEM_OPT! FED_KVA_STORAGE_MAPPINGS_!L_VM_MEM_OPT! FED_KVA_TADDM_!L_VM_MEM_OPT!

        IF !LINUX_ENV! EQU 1 (
            SET L_NICK_NAMES_LIST=!L_NICK_NAMES_LIST! FED_KLZ_LPAR_!L_VM_MEM_OPT! FED_KLZ_VM_STATS_!L_VM_MEM_OPT! FED_LINUX_MACHINE_INFORMATION_!L_VM_MEM_OPT!
        )

        FOR %%K IN ( %L_NICK_NAMES_LIST% ) DO (
            SET L_NICK=%%K
            CALL :DropNickNameIfExists !L_NICK! !DM_SCHEMA_NAME! RESULT
            IF NOT !RESULT! == !RESULT_OK! (
                ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
            )
        )

    )

    CALL :CreateNickName FED_UNIX_MEMORY_!L_VM_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!Unix_Memory!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_UNIX_MEMORY_!L_VM_MEM_OPT!

    CALL :CreateNickName FED_MACHINE_INFORMATION_!L_VM_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!Machine_Information!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_MACHINE_INFORMATION_!L_VM_MEM_OPT!

    CALL :CreateNickName FED_AIX_LPAR_!L_VM_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!AIX_LPAR!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_AIX_LPAR_!L_VM_MEM_OPT!

    CALL :CreateNickName FED_KPH_SERVER_LPARS_!L_VM_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!KPH_SERVER_LPARS!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KPH_SERVER_LPARS_!L_VM_MEM_OPT!

    CALL :CreateNickName FED_KVA_PHYSICAL_MEMORY_!L_VM_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!KVA_PHYSICAL_MEMORY!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KVA_PHYSICAL_MEMORY_!L_VM_MEM_OPT!

    CALL :CreateNickName FED_KVA_STORAGE_MAPPINGS_!L_VM_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!KVA_STORAGE_MAPPINGS!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KVA_STORAGE_MAPPINGS_!L_VM_MEM_OPT!

    CALL :CreateNickName FED_KVA_TADDM_!L_VM_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!KVA_TADDM!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KVA_TADDM_!L_VM_MEM_OPT!

    IF !LINUX_ENV! EQU 1 (
        CALL :CreateNickName FED_KLZ_LPAR_!L_VM_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!KLZ_LPAR!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
        )
        SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KLZ_LPAR_!L_VM_MEM_OPT!

        CALL :CreateNickName FED_KLZ_VM_STATS_!L_VM_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!KLZ_VM_Stats!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
        )
        SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KLZ_VM_STATS_!L_VM_MEM_OPT!

        CALL :CreateNickName FED_LINUX_MACHINE_INFORMATION_!L_VM_MEM_OPT! !TDW_SCHEMA_PREFIX!."!QC!Linux_Machine_Information!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
        )
        SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_LINUX_MACHINE_INFORMATION_!L_VM_MEM_OPT!
    )

    CALL :DropMESTableIfExists MES_!L_VM_MEM_OPT! !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )

    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    REM In case of DB2 9.5, first drop the view if it already exists.       +
    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    IF %DB2_VERSION% == 5 (
        CALL :DropMESViewIfExists MES_!L_VM_MEM_OPT! !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
        )
    )

    SET L_VM_MEM_VIEW_DEF="XXX(HOST_NAME, VM_NAME, VM_SERVER_NAME, HOST_USAGE, GUEST_USAGE, HOST_UTILIZATION, GUEST_UTILIZATION, HOST_FREE, GUEST_FREE, BALLOON_USAGE, SWAP_TO_FILE, TIMESTAMP, WRITETIME) AS ( SELECT P.!QC!Hostname!QC! AS HOST_NAME, P.!QC!LPAR_Name!QC! AS VM_NAME, Q.!QC!CEC_name!QC! AS VM_SERVER_NAME, -1 AS HOST_NAME, -1 AS GUEST_USAGE, -1 AS HOST_UTILIZATION, P.!QC!Used_Real_Mem_MB!QC! AS GUEST_UTILIZATION, -1 AS HOST_FREE, -1 AS GUEST_FREE, -1 AS BALLOON_USAGE, -1 AS SWAP_TO_FILE, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! FROM (SELECT MI.!QC!Hostname!QC!, MI.!QC!Hardware_Model!QC!, MI.!QC!Machine_Serial!QC!, AL.!QC!LPAR_Name!QC!, UM.!QC!Used_Real_Mem_MB!QC!, UM.!QC!WRITETIME!QC! FROM FED_MACHINE_INFORMATION_!L_VM_MEM_OPT! MI, FED_AIX_LPAR_!L_VM_MEM_OPT! AL, FED_UNIX_MEMORY_!L_VM_MEM_OPT! UM WHERE MI.!QC!System_Name!QC! = AL.!QC!System_Name!QC! AND AL.!QC!System_Name!QC! = UM.!QC!System_Name!QC! AND MI.!QC!WRITETIME!QC! = AL.!QC!WRITETIME!QC! AND AL.!QC!WRITETIME!QC! = UM.!QC!WRITETIME!QC!) P INNER JOIN (SELECT !QC!CEC_name!QC!, !QC!CEC_Mfg!QC!, !QC!CEC_Model!QC!, !QC!CEC_SN!QC!, !QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_VM_MEM_OPT!) Q ON P.!QC!Hardware_Model!QC! = Q.!QC!CEC_Model!QC! AND SUBSTR(P.!QC!Machine_Serial!QC!, 7) = Q.!QC!CEC_SN!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!)  UNION ALL ( SELECT H.!QC!Hostname!QC! AS HOST_NAME, H.!QC!VIOS_Name!QC! AS VM_NAME, I.!QC!CEC_name!QC! AS VM_SERVER_NAME, -1 AS HOST_NAME, -1 AS GUEST_USAGE, -1 AS HOST_UTILIZATION, H.!QC!Used_Memory_MB!QC! AS GUEST_UTILIZATION, -1 AS HOST_FREE, -1 AS GUEST_FREE, -1 AS BALLOON_USAGE, -1 AS SWAP_TO_FILE, -1 AS TIMESTAMP, H.!QC!WRITETIME!QC! FROM (SELECT KPM.!QC!Node!QC!, KPM.!QC!Used_Memory_MB!QC!, KSM.!QC!Hostname!QC!, KSM.!QC!VIOS_Name!QC!, KPM.!QC!WRITETIME!QC! FROM FED_KVA_PHYSICAL_MEMORY_!L_VM_MEM_OPT! KPM, FED_KVA_STORAGE_MAPPINGS_!L_VM_MEM_OPT! KSM WHERE KPM.!QC!Node!QC! = KSM.!QC!Node!QC! AND KPM.!QC!WRITETIME!QC! = KSM.!QC!WRITETIME!QC!) H INNER JOIN (SELECT KSL.!QC!CEC_name!QC!, KT.!QC!Node!QC! FROM FED_KPH_SERVER_LPARS_!L_VM_MEM_OPT! KSL, FED_KVA_TADDM_!L_VM_MEM_OPT! KT WHERE KSL.!QC!CEC_Model!QC! = KT.!QC!CEC_Model!QC! AND KSL.!QC!CEC_SN!QC! = KT.!QC!CEC_SN!QC!) I ON H.!QC!Node!QC! = I.!QC!Node!QC!)XXX"
    SET L_VM_MEM_VIEW_DEF_AGG="XXX(    HOST_NAME,    VM_NAME,    VM_SERVER_NAME,    MIN_HOST_USAGE,    MAX_HOST_USAGE,    AVG_HOST_USAGE,    SUM_HOST_USAGE,    MIN_GUEST_USAGE,    MAX_GUEST_USAGE,    AVG_GUEST_USAGE,    SUM_GUEST_USAGE,    MIN_HOST_UTILIZATION,    MAX_HOST_UTILIZATION,    AVG_HOST_UTILIZATION,    SUM_HOST_UTILIZATION,    MIN_GUEST_UTILIZATION,    MAX_GUEST_UTILIZATION,    AVG_GUEST_UTILIZATION,    SUM_GUEST_UTILIZATION,    MIN_HOST_FREE,    MAX_HOST_FREE,    AVG_HOST_FREE,    SUM_HOST_FREE,    MIN_GUEST_FREE,    MAX_GUEST_FREE,    AVG_GUEST_FREE,    SUM_GUEST_FREE,    MIN_BALLOON_USAGE,    MAX_BALLOON_USAGE,    AVG_BALLOON_USAGE,    SUM_BALLOON_USAGE,    MIN_SWAP_TO_FILE,    MAX_SWAP_TO_FILE,    AVG_SWAP_TO_FILE,    SUM_SWAP_TO_FILE,    TIMESTAMP,    WRITETIME ) AS (    SELECT    P.!QC!LAT_Hostname!QC! AS HOST_NAME,    P.!QC!LAT_LPAR_Name!QC! AS VM_NAME,    Q.!QC!LAT_CEC_name!QC! AS VM_SERVER_NAME,    -1 AS MIN_HOST_USAGE,    -1 AS MAX_HOST_USAGE,    -1 AS AVG_HOST_USAGE,    -1 AS SUM_HOST_USAGE,    -1 AS MIN_GUEST_USAGE,    -1 AS MAX_GUEST_USAGE,    -1 AS AVG_GUEST_USAGE,    -1 AS SUM_GUEST_USAGE,    -1 AS MIN_HOST_UTILIZATION,    -1 AS MAX_HOST_UTILIZATION,    -1 AS AVG_HOST_UTILIZATION,    -1 AS SUM_HOST_UTILIZATION,    P.!QC!MIN_Used_Real_Mem_MB!QC! AS MIN_GUEST_UTILIZATION,    P.!QC!MAX_Used_Real_Mem_MB!QC! AS MAX_GUEST_UTILIZATION,    P.!QC!AVG_Used_Real_Mem_MB!QC! AS AVG_GUEST_UTILIZATION,    P.!QC!SUM_Used_Real_Mem_MB!QC! AS SUM_GUEST_UTILIZATION,    -1 AS MIN_HOST_FREE,    -1 AS MAX_HOST_FREE,    -1 AS AVG_HOST_FREE,    -1 AS SUM_HOST_FREE,    -1 AS MIN_GUEST_FREE,    -1 AS MAX_GUEST_FREE,    -1 AS AVG_GUEST_FREE,    -1 AS SUM_GUEST_FREE,    -1 AS MIN_BALLOON_USAGE,    -1 AS MAX_BALLOON_USED,    -1 AS AVG_BALLOON_USED,    -1 AS SUM_BALLOON_USED,    -1 AS MIN_SWAP_TO_FILE,    -1 AS MAX_SWAP_TO_FILE,    -1 AS AVG_SWAP_TO_FILE,    -1 AS SUM_SWAP_TO_FILE,    -1 AS TIMESTAMP,    P.!QC!WRITETIME!QC! 	FROM    (       SELECT       MI.!QC!LAT_Hostname!QC!,       MI.!QC!LAT_Hardware_Model!QC!,       MI.!QC!LAT_Machine_Serial!QC!,       AL.!QC!LAT_LPAR_Name!QC!,       UM.!QC!MIN_Used_Real_Mem_MB!QC!,       UM.!QC!MAX_Used_Real_Mem_MB!QC!,       UM.!QC!AVG_Used_Real_Mem_MB!QC!,       UM.!QC!SUM_Used_Real_Mem_MB!QC!,       UM.!QC!WRITETIME!QC!       FROM FED_Machine_Information_!L_VM_MEM_OPT! MI,       FED_AIX_LPAR_!L_VM_MEM_OPT! AL,       FED_Unix_Memory_!L_VM_MEM_OPT! UM       WHERE MI.!QC!System_Name!QC! = AL.!QC!System_Name!QC!       AND AL.!QC!System_Name!QC! = UM.!QC!System_Name!QC!       AND MI.!QC!WRITETIME!QC! = AL.!QC!WRITETIME!QC!       AND AL.!QC!WRITETIME!QC! = UM.!QC!WRITETIME!QC!    )    P    INNER JOIN    (       SELECT       !QC!LAT_LPAR_Name!QC!, !QC!LAT_CEC_name!QC!, !QC!CEC_Mfg!QC!, !QC!CEC_Model!QC!, !QC!CEC_SN!QC!, !QC!WRITETIME!QC!       FROM FED_KPH_SERVER_LPARS_!L_VM_MEM_OPT!    )    Q ON P.!QC!LAT_Hardware_Model!QC! = Q.!QC!CEC_Model!QC!    AND SUBSTR(P.!QC!LAT_Machine_Serial!QC!, 7) = Q.!QC!CEC_SN!QC!    AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!    AND P.!QC!LAT_LPAR_Name!QC! = Q.!QC!LAT_LPAR_Name!QC! ) UNION ALL (    SELECT    J.!QC!LAT_Hostname!QC! AS HOST_NAME,    J.!QC!LAT_VIOS_Name!QC! AS VM_NAME,    'DUMMY_SERVER_NAME' AS VM_SERVER_NAME,    -1 AS MIN_HOST_USAGE,    -1 AS MAX_HOST_USAGE,    -1 AS AVG_HOST_USAGE,    -1 AS SUM_HOST_USAGE,    -1 AS MIN_GUEST_USAGE,    -1 AS MAX_GUEST_USAGE,    -1 AS AVG_GUEST_USAGE,    -1 AS SUM_GUEST_USAGE,    -1 AS MIN_HOST_UTILIZATION,    -1 AS MAX_HOST_UTILIZATION,    -1 AS AVG_HOST_UTILIZATION,    -1 AS SUM_HOST_UTILIZATION,    H.!QC!MIN_Used_Memory_MB!QC! AS MIN_GUEST_UTILIZATION,    H.!QC!MAX_Used_Memory_MB!QC! AS MAX_GUEST_UTILIZAITON,    H.!QC!AVG_Used_Memory_MB!QC! AS AVG_GUEST_UTILIZATION,    H.!QC!SUM_Used_Memory_MB!QC! AS SUM_GUEST_UTILIZATION,    -1 AS MIN_HOST_FREE,    -1 AS MAX_HOST_FREE,    -1 AS AVG_HOST_FREE,    -1 AS SUM_HOST_FREE,    -1 AS MIN_GUEST_FREE,    -1 AS MAX_GUEST_FREE,    -1 AS AVG_GUEST_FREE,    -1 AS SUM_GUEST_FREE,    -1 AS MIN_BALLOON_USAGE,    -1 AS MAX_BALLOON_USAGE,    -1 AS AVG_BALLOON_USAGE,    -1 AS SUM_BALLOON_USAGE,    -1 AS MIN_SWAP_TO_FILE,    -1 AS MAX_SWAP_TO_FILE,    -1 AS AVG_SWAP_TO_FILE,    -1 AS SUM_SWAP_TO_FILE,    -1 AS TIMESTAMP,    H.!QC!WRITETIME!QC! FROM    (       SELECT       KPM.!QC!Node!QC!,       KPM.!QC!MIN_Used_Memory_MB!QC!,       KPM.!QC!MAX_Used_Memory_MB!QC!,       KPM.!QC!AVG_Used_Memory_MB!QC!,       KPM.!QC!SUM_Used_Memory_MB!QC!,       KPM.!QC!WRITETIME!QC!       FROM FED_KVA_PHYSICAL_MEMORY_!L_VM_MEM_OPT! KPM    )    H 	INNER JOIN 	( SELECT DISTINCT  	KSM.!QC!LAT_Hostname!QC!, 	KSM.!QC!LAT_VIOS_Name!QC!, 	KSM.!QC!Node!QC!    		FROM FED_KVA_STORAGE_MAPPINGS_!L_VM_MEM_OPT! KSM) J    ON    H.!QC!Node!QC! = J.!QC!Node!QC! )XXX"
	
    IF !LINUX_ENV! EQU 1 (

        SET L_VM_MEM_VIEW_DEF=!L_VM_MEM_VIEW_DEF!"XXX UNION ALL (SELECT H.!QC!Hostname!QC! AS HOST_NAME, H.!QC!LPAR_Name!QC! AS VM_NAME, I.!QC!CEC_name!QC! AS VM_SERVER_NAME, -1 AS HOST_NAME, -1 AS GUEST_USAGE, -1 AS HOST_UTILIZATION, H.!QC!Memory_Used!QC! AS GUEST_UTILIZATION, -1 AS HOST_FREE, -1 AS GUEST_FREE, -1 AS BALLOON_USAGE, -1 AS SWAP_TO_FILE, -1 AS TIMESTAMP, H.!QC!WRITETIME!QC! FROM (SELECT LMI.!QC!System_Name!QC!, LMI.!QC!Hostname!QC!, LMI.!QC!Hardware_Model!QC!, LMI.!QC!Machine_Serial!QC!, LMI.!QC!WRITETIME!QC!, KL.!QC!LPAR_Name!QC!, KVS.!QC!Memory_Used!QC! FROM FED_LINUX_MACHINE_INFORMATION_!L_VM_MEM_OPT! LMI, FED_KLZ_LPAR_!L_VM_MEM_OPT! KL, FED_KLZ_VM_STATS_!L_VM_MEM_OPT! KVS WHERE LMI.!QC!System_Name!QC! = KL.!QC!System_Name!QC! AND KL.!QC!System_Name!QC! = KVS.!QC!System_Name!QC! AND LMI.!QC!WRITETIME!QC! = KL.!QC!WRITETIME!QC! AND KL.!QC!WRITETIME!QC! = KVS.!QC!WRITETIME!QC!) H INNER JOIN (SELECT !QC!CEC_name!QC!, !QC!CEC_Mfg!QC!, !QC!CEC_Model!QC!, !QC!CEC_SN!QC!, !QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_VM_MEM_OPT!) I ON H.!QC!Hardware_Model!QC! = I.!QC!CEC_Model!QC! AND H.!QC!Machine_Serial!QC! = I.!QC!CEC_SN!QC! AND H.!QC!WRITETIME!QC! = I.!QC!WRITETIME!QC!)XXX"

        SET L_VM_MEM_VIEW_DEF_AGG=!L_VM_MEM_VIEW_DEF_AGG!"XXX UNION ALL (    SELECT    H.!QC!LAT_Hostname!QC! AS HOST_NAME,    H.!QC!LAT_LPAR_Name!QC! AS VM_NAME,    I.!QC!LAT_CEC_name!QC! AS VM_SERVER_NAME,    -1 AS MIN_HOST_USAGE,    -1 AS MAX_HOST_USAGE,    -1 AS AVG_HOST_USAGE,    -1 AS SUM_HOST_USAGE,    -1 AS MIN_GUEST_USAGE,    -1 AS MAX_GUEST_USAGE,    -1 AS AVG_GUEST_USAGE,    -1 AS SUM_GUEST_USAGE,    -1 AS MIN_HOST_UTILIZATION,    -1 AS MAX_HOST_UTILIZATION,    -1 AS AVG_HOST_UTILIZATION,    -1 AS SUM_HOST_UTILIZATION,    H.!QC!MIN_Memory_Used!QC! AS MIN_GUEST_UTILIZATION,    H.!QC!MAX_Memory_Used!QC! AS MAX_GUEST_UTILIZATION,    H.!QC!AVG_Memory_Used!QC! AS AVG_GUEST_UTILIZATION,    H.!QC!SUM_Memory_Used!QC! AS SUM_GUEST_UTILIZATION,    -1 AS MIN_HOST_FREE,    -1 AS MAX_HOST_FREE,    -1 AS AVG_HOST_FREE,    -1 AS SUM_HOST_FREE,    -1 AS MIN_GUEST_FREE,    -1 AS MAX_GUEST_FREE,    -1 AS AVG_GUEST_FREE,    -1 AS SUM_GUEST_FREE,    -1 AS MIN_BALLOON_USAGE,    -1 AS MAX_BALLOON_USED,    -1 AS AVG_BALLOON_USED,    -1 AS SUM_BALLOON_USED,    -1 AS MIN_SWAP_TO_FILE,    -1 AS MAX_SWAP_TO_FILE,    -1 AS AVG_SWAP_TO_FILE,    -1 AS SUM_SWAP_TO_FILE,    -1 AS TIMESTAMP,    H.!QC!WRITETIME!QC!   FROM    (       SELECT       LMI.!QC!System_Name!QC!,       LMI.!QC!LAT_Hostname!QC!,       LMI.!QC!LAT_Hardware_Model!QC!,       LMI.!QC!LAT_Machine_Serial!QC!,       LMI.!QC!WRITETIME!QC!,       KL.!QC!LAT_LPAR_Name!QC!,       KVS.!QC!MIN_Memory_Used!QC!,       KVS.!QC!MAX_Memory_Used!QC!,       KVS.!QC!AVG_Memory_Used!QC!,       KVS.!QC!SUM_Memory_Used!QC!       FROM FED_Linux_Machine_Information_!L_VM_MEM_OPT! LMI,       FED_KLZ_LPAR_!L_VM_MEM_OPT! KL,       FED_KLZ_VM_Stats_!L_VM_MEM_OPT! KVS       WHERE LMI.!QC!System_Name!QC! = KL.!QC!System_Name!QC!       AND KL.!QC!System_Name!QC! = KVS.!QC!System_Name!QC!       AND LMI.!QC!WRITETIME!QC! = KL.!QC!WRITETIME!QC!       AND KL.!QC!WRITETIME!QC! = KVS.!QC!WRITETIME!QC!    )    H    INNER JOIN    (       SELECT       !QC!LAT_LPAR_Name!QC!,!QC!LAT_CEC_name!QC!, !QC!CEC_Mfg!QC!, !QC!CEC_Model!QC!, !QC!CEC_SN!QC!, !QC!WRITETIME!QC!       FROM FED_KPH_SERVER_LPARS_!L_VM_MEM_OPT!    )    I ON H.!QC!LAT_Hardware_Model!QC! = I.!QC!CEC_Model!QC!    AND H.!QC!LAT_Machine_Serial!QC! = I.!QC!CEC_SN!QC!    AND H.!QC!WRITETIME!QC! = I.!QC!WRITETIME!QC!    AND H.!QC!LAT_LPAR_Name!QC! = I.!QC!LAT_LPAR_Name!QC! )XXX"

    )

    SET L_VIEW_DEF=!L_VM_MEM_VIEW_DEF!
    IF NOT (!L_SUMM_LEVEL!) == () (
        SET L_VIEW_DEF=!L_VM_MEM_VIEW_DEF_AGG!
    )

    SET DB2_CMD_DM_VIEW=!SQL_CREATE_VIEW! !DM_SCHEMA_NAME!.MES_!L_VM_MEM_OPT!

    CALL :CreateMESView !DM_SCHEMA_NAME!.MES_!L_VM_MEM_OPT! "!DB2_CMD_DM_VIEW!" !L_VIEW_DEF! RESULT VIEW_NAME
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )

    CALL :UpdatePercentileViews !L_VM_MEM_OPT! !DM_SCHEMA_NAME!
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )

	SET RET_CODE=1
(ENDLOCAL
SET "%~2=%RET_CODE%"
SET "%~3=%VIEW_NAME%"
EXIT /B
)

REM ############################################################################
REM Defines federated view for Virtual Machine Network Utilization.
REM Arguments:
REM     %1  :   Option to establish federation for (VM_NET[Summarization Level])
REM ############################################################################
:CREATE_VM_NET
SETLOCAL
    SET L_VM_NET_OPT=%1
	SET RET_CODE=0
    SET L_SUMM_LEVEL=
    IF "!L_VM_NET_OPT:~-2,1!" == "_" (
        SET L_SUMM_LEVEL=!L_VM_NET_OPT:~-2!
    )

    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    REM In case of DB2 9.5, first drop the nicknames if they exist already. +
    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    IF %DB2_VERSION% == 5 (

        SET L_NICK_NAMES_LIST=FED_NETWORK_!L_VM_NET_OPT! FED_MACHINE_INFORMATION_!L_VM_NET_OPT! FED_AIX_LPAR_!L_VM_NET_OPT! FED_KPH_SERVER_LPARS_!L_VM_NET_OPT!

        IF !LINUX_ENV! EQU 1 (
            SET L_NICK_NAMES_LIST=!L_NICK_NAMES_LIST! FED_KLZ_LPAR_!L_VM_NET_OPT! FED_KLZ_NETWORK_!L_VM_NET_OPT! FED_LINUX_MACHINE_INFORMATION_!L_VM_NET_OPT!
        )

        FOR %%K IN ( %L_NICK_NAMES_LIST% ) DO (
            SET L_NICK=%%K
            CALL :DropNickNameIfExists !L_NICK! !DM_SCHEMA_NAME! RESULT
            IF NOT !RESULT! == !RESULT_OK! (
                ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
            )
        )

    )

    CALL :CreateNickName FED_NETWORK_!L_VM_NET_OPT! !TDW_SCHEMA_PREFIX!."!QC!Network!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_NETWORK_!L_VM_NET_OPT!

    CALL :CreateNickName FED_MACHINE_INFORMATION_!L_VM_NET_OPT! !TDW_SCHEMA_PREFIX!."!QC!Machine_Information!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF 
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_MACHINE_INFORMATION_!L_VM_NET_OPT!

    CALL :CreateNickName FED_AIX_LPAR_!L_VM_NET_OPT! !TDW_SCHEMA_PREFIX!."!QC!AIX_LPAR!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_AIX_LPAR_!L_VM_NET_OPT!

    CALL :CreateNickName FED_KPH_SERVER_LPARS_!L_VM_NET_OPT! !TDW_SCHEMA_PREFIX!."!QC!KPH_SERVER_LPARS!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KPH_SERVER_LPARS_!L_VM_NET_OPT!

    IF !LINUX_ENV! EQU 1 (
        CALL :CreateNickName FED_KLZ_LPAR_!L_VM_NET_OPT! !TDW_SCHEMA_PREFIX!."!QC!KLZ_LPAR!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
        )
        SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KLZ_LPAR_!L_VM_NET_OPT!

        CALL :CreateNickName FED_KLZ_NETWORK_!L_VM_NET_OPT! !TDW_SCHEMA_PREFIX!."!QC!KLZ_Network!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
        )
        SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KLZ_NETWORK_!L_VM_NET_OPT!

        CALL :CreateNickName FED_LINUX_MACHINE_INFORMATION_!L_VM_NET_OPT! !TDW_SCHEMA_PREFIX!."!QC!Linux_Machine_Information!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
        )
        SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_LINUX_MACHINE_INFORMATION_!L_VM_NET_OPT!
    )

    CALL :DropMESTableIfExists MES_VM_NETWORK!L_SUMM_LEVEL! !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )

    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    REM In case of DB2 9.5, first drop the view if it already exists.       +
    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    IF %DB2_VERSION% == 5 (
        CALL :DropMESViewIfExists MES_VM_NETWORK!L_SUMM_LEVEL! !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
        )
    )

    SET L_VM_NET_VIEW_DEF="XXX(HOST_NAME, VM_NAME, VM_SERVER_NAME, TRANSMITTED_KBPS, RECEIVED_KBPS, PKTS_TRANSMITTED, PKTS_RECEIVED, TIMESTAMP, WRITETIME) AS ( SELECT P.!QC!Hostname!QC! AS HOST_NAME, P.!QC!LPAR_Name!QC! AS VM_NAME, Q.!QC!CEC_name!QC! AS VM_SERVER_NAME, (P.!QC!Transmitted_MB!QC!/1000) AS TRANSMITTED_KBPS, (P.!QC!Received_MB!QC!/1000) AS RECEIVED_KBPS, P.!QC!Transmitted_Count_64!QC! AS PKTS_TRANSMITTED, P.!QC!Received_Count_64!QC! AS PKTS_RECEIVED, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! FROM (SELECT MI.!QC!Hostname!QC!, MI.!QC!Hardware_Model!QC!, MI.!QC!Machine_Serial!QC!, AL.!QC!LPAR_Name!QC!, NET.!QC!Transmitted_MB!QC!, NET.!QC!Received_MB!QC!, NET.!QC!Transmitted_Count_64!QC!, NET.!QC!Received_Count_64!QC!, NET.!QC!WRITETIME!QC! FROM FED_MACHINE_INFORMATION_!L_VM_NET_OPT! MI, FED_AIX_LPAR_!L_VM_NET_OPT! AL, FED_NETWORK_!L_VM_NET_OPT! NET WHERE NET.!QC!Network_Interface_Name!QC! <> 'Aggregate' AND NET.!QC!System_Name!QC! = MI.!QC!System_Name!QC! AND MI.!QC!System_Name!QC! =  AL.!QC!System_Name!QC! AND NET.!QC!WRITETIME!QC! = MI.!QC!WRITETIME!QC! AND MI.!QC!WRITETIME!QC! = AL.!QC!WRITETIME!QC!) P INNER JOIN (SELECT !QC!CEC_name!QC!, !QC!CEC_Mfg!QC!, !QC!CEC_Model!QC!, !QC!CEC_SN!QC!, !QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_VM_NET_OPT!) Q ON P.!QC!Hardware_Model!QC! = Q.!QC!CEC_Model!QC! AND SUBSTR(P.!QC!Machine_Serial!QC!, 7) = Q.!QC!CEC_SN!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!)XXX"

    SET L_VM_NET_VIEW_DEF_AGG="XXX(HOST_NAME, VM_NAME, VM_SERVER_NAME, MIN_TRANSMITTED_KBPS, MAX_TRANSMITTED_KBPS, AVG_TRANSMITTED_KBPS, SUM_TRANSMITTED_KBPS, MIN_RECEIVED_KBPS, MAX_RECEIVED_KBPS, AVG_RECEIVED_KBPS, SUM_RECEIVED_KBPS, MIN_PKTS_TRANSMITTED, MAX_PKTS_TRANSMITTED, AVG_PKTS_TRANSMITTED, SUM_PKTS_TRANSMITTED, MIN_PKTS_RECEIVED, MAX_PKTS_RECEIVED, AVG_PKTS_RECEIVED, SUM_PKTS_RECEIVED, TIMESTAMP, WRITETIME) AS ( SELECT P.!QC!LAT_Hostname!QC! AS HOST_NAME, P.!QC!LAT_LPAR_Name!QC! AS VM_NAME, Q.!QC!LAT_CEC_name!QC! AS VM_SERVER_NAME, (P.!QC!MIN_Transmitted_MB!QC!*1000) AS MIN_TRANSMITTED_KBPS, (P.!QC!MAX_Transmitted_MB!QC!*1000) AS MAX_TRANSMITTED_KBPS, (P.!QC!AVG_Transmitted_MB!QC!*1000) AS AVG_TRANSMITTED_KBPS, (P.!QC!SUM_Transmitted_MB!QC!*1000) AS SUM_TRANSMITTED_KBPS, (P.!QC!MIN_Received_MB!QC!*1000) AS MIN_RECEIVED_KBPS, (P.!QC!MAX_Received_MB!QC!*1000) AS MAX_RECEIVED_KBPS, (P.!QC!AVG_Received_MB!QC!*1000) AS AVG_RECEIVED_KBPS, (P.!QC!SUM_Received_MB!QC!*1000) AS SUM_RECEIVED_KBPS, P.!QC!MIN_Frames_Transmitted_per_sec!QC! AS MIN_PKTS_TRANSMITTED, P.!QC!MAX_Frames_Transmitted_per_sec!QC! AS MAX_PKTS_TRANSMITTED, P.!QC!AVG_Frames_Transmitted_per_sec!QC! AS AVG_PKTS_TRANSMITTED, P.!QC!SUM_Frames_Transmitted_per_sec!QC! AS SUM_PKTS_TRANSMITTED, P.!QC!MIN_Frames_Received_per_sec!QC! AS MIN_PKTS_RECEIVED, P.!QC!MAX_Frames_Received_per_sec!QC! AS MAX_PKTS_RECEIVED, P.!QC!AVG_Frames_Received_per_sec!QC! AS AVG_PKTS_RECEIVED, P.!QC!SUM_Frames_Received_per_sec!QC! AS SUM_PKTS_RECEIVED, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! FROM (SELECT MI.!QC!LAT_Hostname!QC!, MI.!QC!LAT_Hardware_Model!QC!, MI.!QC!LAT_Machine_Serial!QC!, AL.!QC!LAT_LPAR_Name!QC!, NET.!QC!MIN_Transmitted_MB!QC!, NET.!QC!MAX_Transmitted_MB!QC!, NET.!QC!AVG_Transmitted_MB!QC!, NET.!QC!SUM_Transmitted_MB!QC!, NET.!QC!MIN_Received_MB!QC!, NET.!QC!MAX_Received_MB!QC!, NET.!QC!AVG_Received_MB!QC!, NET.!QC!SUM_Received_MB!QC!, NET.!QC!MIN_Frames_Transmitted_per_sec!QC!, NET.!QC!MAX_Frames_Transmitted_per_sec!QC!, NET.!QC!AVG_Frames_Transmitted_per_sec!QC!, NET.!QC!SUM_Frames_Transmitted_per_sec!QC!, NET.!QC!MIN_Frames_Received_per_sec!QC!, NET.!QC!MAX_Frames_Received_per_sec!QC!, NET.!QC!AVG_Frames_Received_per_sec!QC!, NET.!QC!SUM_Frames_Received_per_sec!QC!, NET.!QC!WRITETIME!QC! FROM FED_MACHINE_INFORMATION_!L_VM_NET_OPT! MI, FED_AIX_LPAR_!L_VM_NET_OPT! AL, FED_NETWORK_!L_VM_NET_OPT! NET WHERE NET.!QC!Network_Interface_Name!QC! <> 'Aggregate' AND NET.!QC!System_Name!QC! = MI.!QC!System_Name!QC! AND MI.!QC!System_Name!QC! = AL.!QC!System_Name!QC! AND NET.!QC!WRITETIME!QC! = MI.!QC!WRITETIME!QC! AND MI.!QC!WRITETIME!QC! = AL.!QC!WRITETIME!QC!) P INNER JOIN (SELECT !QC!LAT_CEC_name!QC!, !QC!CEC_Mfg!QC!, !QC!CEC_Model!QC!, !QC!CEC_SN!QC!, !QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_VM_NET_OPT!) Q ON P.!QC!LAT_Hardware_Model!QC! = Q.!QC!CEC_Model!QC! AND SUBSTR(P.!QC!LAT_Machine_Serial!QC!, 7) = Q.!QC!CEC_SN!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!)XXX"
    
    IF !LINUX_ENV! EQU 1 (

		SET L_VM_NET_VIEW_DEF=!L_VM_NET_VIEW_DEF!"XXX UNION ( SELECT P.!QC!Hostname!QC! AS HOST_NAME, P.!QC!LPAR_Name!QC! AS VM_NAME, Q.!QC!CEC_name!QC! AS VM_SERVER_NAME, P.!QC!KBytes_Transmitted_Count!QC! AS TRANSMITTED_KBPS, P.!QC!KBytes_Received_Count!QC! AS RECEIVED_KBPS, P.!QC!Packets_Transmitted!QC! AS PKTS_TRANSMITTED, P.!QC!Packets_Received_Count!QC! AS PKTS_RECEIVED, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! FROM (SELECT LMI.!QC!Hostname!QC!, LMI.!QC!Hardware_Model!QC!, LMI.!QC!Machine_Serial!QC!, KN.!QC!WRITETIME!QC!, KL.!QC!LPAR_Name!QC!, KN.!QC!KBytes_Transmitted_Count!QC!, KN.!QC!KBytes_Received_Count!QC!, KN.!QC!Packets_Transmitted!QC!, KN.!QC!Packets_Received_Count!QC! FROM FED_LINUX_MACHINE_INFORMATION_!L_VM_NET_OPT! LMI, FED_KLZ_LPAR_!L_VM_NET_OPT! KL, FED_KLZ_NETWORK_!L_VM_NET_OPT! KN WHERE KN.!QC!Network_Interface_Name!QC! <> 'Aggregate' AND KN.!QC!System_Name!QC! = LMI.!QC!System_Name!QC! AND LMI.!QC!System_Name!QC! = KL.!QC!System_Name!QC! AND KN.!QC!WRITETIME!QC! = LMI.!QC!WRITETIME!QC! AND LMI.!QC!WRITETIME!QC! = KL.!QC!WRITETIME!QC!) P INNER JOIN (SELECT !QC!CEC_name!QC!, !QC!CEC_Mfg!QC!, !QC!CEC_Model!QC!, !QC!CEC_SN!QC!, !QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_VM_NET_OPT!) Q ON P.!QC!Hardware_Model!QC! = Q.!QC!CEC_Model!QC! AND P.!QC!Machine_Serial!QC! = Q.!QC!CEC_SN!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!)XXX"

		SET L_VM_NET_VIEW_DEF_AGG=!L_VM_NET_VIEW_DEF_AGG!"XXX UNION (SELECT P.!QC!LAT_Hostname!QC! AS HOST_NAME, P.!QC!LAT_LPAR_Name!QC! AS VM_NAME, Q.!QC!LAT_CEC_name!QC! AS VM_SERVER_NAME, P.!QC!MIN_Bytes_Transmitted_per_sec!QC!/1000 AS MIN_TRANSMITTED_KBPS, P.!QC!MAX_Bytes_Transmitted_per_sec!QC!/1000 AS MAX_TRANSMITTED_KBPS, P.!QC!AVG_Bytes_Transmitted_per_sec!QC!/1000 AS AVG_TRANSMITTED_KBPS, P.!QC!SUM_Bytes_Transmitted_per_sec!QC!/1000 AS SUM_TRANSMITTED_KBPS, P.!QC!MIN_Bytes_Received_per_sec!QC!/1000 AS MIN_RECEIVED_KBPS, P.!QC!MAX_Bytes_Received_per_sec!QC!/1000 AS MAX_RECEIVED_KBPS, P.!QC!AVG_Bytes_Received_per_sec!QC!/1000 AS AVG_RECEIVED_KBPS, P.!QC!SUM_Bytes_Received_per_sec!QC!/1000 AS SUM_RECEIVED_KBPS, P.!QC!MIN_!TRANSMITTED_PKTS_COL_NAME!!QC! AS MIN_PKTS_TRANSMITTED, P.!QC!MAX_!TRANSMITTED_PKTS_COL_NAME!!QC! AS MAX_PKTS_TRANSMITTED, P.!QC!AVG_!TRANSMITTED_PKTS_COL_NAME!!QC! AS AVG_PKTS_TRANSMITTED, P.!QC!SUM_!TRANSMITTED_PKTS_COL_NAME!!QC! AS SUM_PKTS_TRANSMITTED, P.!QC!MIN_Packets_Received_per_sec!QC! AS MIN_PKTS_RECEIVED, P.!QC!MAX_Packets_Received_per_sec!QC! AS MAX_PKTS_RECEIVED, P.!QC!AVG_Packets_Received_per_sec!QC! AS AVG_PKTS_RECEIVED, P.!QC!SUM_Packets_Received_per_sec!QC! AS SUM_PKTS_RECEIVED, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! FROM (SELECT LMI.!QC!LAT_Hostname!QC!, LMI.!QC!LAT_Hardware_Model!QC!, LMI.!QC!LAT_Machine_Serial!QC!, KN.!QC!WRITETIME!QC!, KL.!QC!LAT_LPAR_Name!QC!, KN.!QC!MIN_Bytes_Transmitted_per_sec!QC!, KN.!QC!MAX_Bytes_Transmitted_per_sec!QC!, KN.!QC!AVG_Bytes_Transmitted_per_sec!QC!, KN.!QC!SUM_Bytes_Transmitted_per_sec!QC!, KN.!QC!MIN_Bytes_Received_per_sec!QC!, KN.!QC!MAX_Bytes_Received_per_sec!QC!, KN.!QC!AVG_Bytes_Received_per_sec!QC!, KN.!QC!SUM_Bytes_Received_per_sec!QC!, KN.!QC!MIN_!TRANSMITTED_PKTS_COL_NAME!!QC!, KN.!QC!MAX_!TRANSMITTED_PKTS_COL_NAME!!QC!, KN.!QC!AVG_!TRANSMITTED_PKTS_COL_NAME!!QC!, KN.!QC!SUM_!TRANSMITTED_PKTS_COL_NAME!!QC!, KN.!QC!MIN_Packets_Received_per_sec!QC!, KN.!QC!MAX_Packets_Received_per_sec!QC!, KN.!QC!AVG_Packets_Received_per_sec!QC!, KN.!QC!SUM_Packets_Received_per_sec!QC! FROM FED_LINUX_MACHINE_INFORMATION_!L_VM_NET_OPT! LMI, FED_KLZ_LPAR_!L_VM_NET_OPT! KL, FED_KLZ_NETWORK_!L_VM_NET_OPT! KN WHERE KN.!QC!Network_Interface_Name!QC! <> 'Aggregate' AND KN.!QC!System_Name!QC! = LMI.!QC!System_Name!QC! AND LMI.!QC!System_Name!QC! = KL.!QC!System_Name!QC! AND KN.!QC!WRITETIME!QC! = LMI.!QC!WRITETIME!QC! AND LMI.!QC!WRITETIME!QC! = KL.!QC!WRITETIME!QC!) P INNER JOIN (SELECT !QC!LAT_CEC_name!QC!, !QC!CEC_Mfg!QC!, !QC!CEC_Model!QC!, !QC!CEC_SN!QC!, !QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_VM_NET_OPT!) Q ON P.!QC!LAT_Hardware_Model!QC! = Q.!QC!CEC_Model!QC! AND P.!QC!LAT_Machine_Serial!QC! = Q.!QC!CEC_SN!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!)XXX"

    )

    SET L_VIEW_DEF=!L_VM_NET_VIEW_DEF!
	
    IF NOT (!L_SUMM_LEVEL!) == () (
        SET L_VIEW_DEF=!L_VM_NET_VIEW_DEF_AGG!
    )
    SET DB2_CMD_DM_VIEW=!SQL_CREATE_VIEW! !DM_SCHEMA_NAME!.MES_VM_NETWORK!L_SUMM_LEVEL!

    CALL :CreateMESView !DM_SCHEMA_NAME!.MES_VM_NETWORK!L_SUMM_LEVEL! "!DB2_CMD_DM_VIEW!"  !L_VIEW_DEF! RESULT VIEW_NAME
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )

    CALL :UpdatePercentileViews !L_VM_NET_OPT! !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
	
	SET RET_CODE=1
(
ENDLOCAL
SET "%~2=%RET_CODE%"
SET "%~3=%VIEW_NAME%"
EXIT /B
)
REM ############################################################################
REM Defines federated view for Virtual Machine Disk Utilization.
REM Arguments:
REM     %1  :   Option to establish federation for (VM_DS[Summarization Level])
REM ############################################################################
:CREATE_VM_DS
SETLOCAL
    SET L_VM_DS_OPT=%1
	SET RET_CODE=0
    SET L_SUMM_LEVEL=
    IF "!L_VM_DS_OPT:~-2,1!" == "_" (
        SET L_SUMM_LEVEL=!L_VM_DS_OPT:~-2!
    )

    REM In case of DB2 9.5, first drop the nicknames if they exist already.
    IF %DB2_VERSION% == 5 (

        SET L_NICK_NAMES_LIST=FED_DISK_PERFORMANCE_!L_VM_DS_OPT! FED_MACHINE_INFORMATION_!L_VM_DS_OPT! FED_AIX_LPAR_!L_VM_DS_OPT! FED_KPH_SERVER_LPARS_!L_VM_DS_OPT!

        IF !LINUX_ENV! EQU 1 (
            SET L_NICK_NAMES_LIST=!L_NICK_NAMES_LIST! FED_KLZ_LPAR_!L_VM_DS_OPT! FED_KLZ_IO_EXT_!L_VM_DS_OPT! FED_LINUX_MACHINE_INFORMATION_!L_VM_DS_OPT! 
        )

        FOR %%K IN ( %L_NICK_NAMES_LIST% ) DO (
            SET L_NICK=%%K
            CALL :DropNickNameIfExists !L_NICK! !DM_SCHEMA_NAME! RESULT
            IF NOT !RESULT! == !RESULT_OK! (
                ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
            )
        )

    )

    CALL :CreateNickName FED_DISK_PERFORMANCE_!L_VM_DS_OPT! !TDW_SCHEMA_PREFIX!."!QC!Disk_Performance!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_DISK_PERFORMANCE_!L_VM_DS_OPT!

    CALL :CreateNickName FED_MACHINE_INFORMATION_!L_VM_DS_OPT! !TDW_SCHEMA_PREFIX!."!QC!Machine_Information!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_MACHINE_INFORMATION_!L_VM_DS_OPT!

    CALL :CreateNickName FED_AIX_LPAR_!L_VM_DS_OPT! !TDW_SCHEMA_PREFIX!."!QC!AIX_LPAR!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_AIX_LPAR_!L_VM_DS_OPT!

    CALL :CreateNickName FED_KPH_SERVER_LPARS_!L_VM_DS_OPT! !TDW_SCHEMA_PREFIX!."!QC!KPH_SERVER_LPARS!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
    SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KPH_SERVER_LPARS_!L_VM_DS_OPT!

    IF !LINUX_ENV! EQU 1 (
        CALL :CreateNickName FED_KLZ_LPAR_!L_VM_DS_OPT! !TDW_SCHEMA_PREFIX!."!QC!KLZ_LPAR!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
        )
        SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KLZ_LPAR_!L_VM_DS_OPT!

        CALL :CreateNickName FED_KLZ_IO_EXT_!L_VM_DS_OPT! !TDW_SCHEMA_PREFIX!."!QC!KLZ_IO_Ext!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
        )
        SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_KLZ_IO_EXT_!L_VM_DS_OPT!

        CALL :CreateNickName FED_LINUX_MACHINE_INFORMATION_!L_VM_DS_OPT! !TDW_SCHEMA_PREFIX!."!QC!Linux_Machine_Information!L_SUMM_LEVEL!!QC!" !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
        )
        SET ON_ERROR_DROP_NICKNAMES=!ON_ERROR_DROP_NICKNAMES! FED_LINUX_MACHINE_INFORMATION_!L_VM_DS_OPT!
    )

    CALL :DropMESTableIfExists MES_VM_DATA_STORE!L_SUMM_LEVEL! !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )

    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    REM In case of DB2 9.5, first drop the view if it already exists.       +
    REM +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    IF %DB2_VERSION% == 5 (
        CALL :DropMESViewIfExists MES_VM_DATA_STORE!L_SUMM_LEVEL! !DM_SCHEMA_NAME! RESULT
        IF NOT !RESULT! == !RESULT_OK! (
            ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
        )
    )

    SET L_VM_DS_VIEW_DEF="XXX(DATA_STORE_NAME, HOST_NAME, VM_NAME, DATA_CENTER_NAME, TOTAL_READ, TOTAL_WRITE, TOTAL_IO, TIMESTAMP, WRITETIME) AS (SELECT P.!QC!Disk_Name!QC! AS DATA_STORE_NAME, P.!QC!Hostname!QC! AS HOST_NAME, P.!QC!LPAR_Name!QC! AS VM_NAME, Q.!QC!CEC_name!QC! AS DATA_CENTER_NAME, (P.!QC!Disk_Read_Bytes_Sec!QC!/1000) AS TOTAL_READ, (P.!QC!Disk_Write_Bytes_Sec!QC!/1000) AS TOTAL_WRITE, P.!QC!Transfers_KB_per_Sec!QC! AS TOTAL_IO, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! FROM (SELECT MI.!QC!Hostname!QC!, MI.!QC!Hardware_Model!QC!, MI.!QC!Machine_Serial!QC!, AL.!QC!LPAR_Name!QC!, DP.!QC!Disk_Name!QC!, DP.!QC!Disk_Read_Bytes_Sec!QC!, DP.!QC!Disk_Write_Bytes_Sec!QC!, DP.!QC!Transfers_KB_per_Sec!QC!, DP.!QC!WRITETIME!QC! FROM FED_MACHINE_INFORMATION_!L_VM_DS_OPT! MI, FED_DISK_PERFORMANCE_!L_VM_DS_OPT! DP, FED_AIX_LPAR_!L_VM_DS_OPT! AL WHERE DP.!QC!System_Name!QC! = MI.!QC!System_Name!QC! AND MI.!QC!System_Name!QC! = AL.!QC!System_Name!QC! AND DP.!QC!WRITETIME!QC! = MI.!QC!WRITETIME!QC! AND MI.!QC!WRITETIME!QC! = AL.!QC!WRITETIME!QC!) P INNER JOIN (SELECT !QC!CEC_name!QC!, !QC!CEC_Model!QC!, !QC!CEC_SN!QC!, !QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_VM_DS_OPT!) Q ON P.!QC!Hardware_Model!QC! = Q.!QC!CEC_Model!QC! AND SUBSTR(P.!QC!Machine_Serial!QC!, 7) = Q.!QC!CEC_SN!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!)XXX"

    SET L_VM_DS_VIEW_DEF_AGG="XXX(DATA_STORE_NAME, HOST_NAME, VM_NAME, DATA_CENTER_NAME, MIN_TOTAL_READ, MAX_TOTAl_READ, AVG_TOTAL_READ, SUM_TOTAL_READ, MIN_TOTAL_WRITE, MAX_TOTAL_WRITE, AVG_TOTAL_WRITE, SUM_TOTAL_WRITE, MIN_TOTAL_IO, MAX_TOTAL_IO, AVG_TOTAL_IO, SUM_TOTAL_IO, MIN_READ_OPS, MAX_READ_OPS, AVG_READ_OPS, SUM_READ_OPS, MIN_WRITE_OPS, MAX_WRITE_OPS, AVG_WRITE_OPS, SUM_WRITE_OPS, TIMESTAMP, WRITETIME) AS (SELECT P.!QC!LAT_Disk_Name!QC! AS DATA_STORE_NAME, P.!QC!LAT_Hostname!QC! AS HOST_NAME, P.!QC!LAT_LPAR_Name!QC! AS VM_NAME, Q.!QC!LAT_CEC_name!QC! AS DATA_CENTER_NAME, (P.!QC!MIN_Disk_Read_Bytes_Sec!QC!/1000) AS MIN_TOTAL_READ, (P.!QC!MAX_Disk_Read_Bytes_Sec!QC!/1000) AS MAX_TOTAL_READ, (P.!QC!AVG_Disk_Read_Bytes_Sec!QC!/1000) AS AVG_TOTAL_READ, (P.!QC!SUM_Disk_Read_Bytes_Sec!QC!/1000) AS SUM_TOTAL_READ, (P.!QC!MIN_Disk_Write_Bytes_Sec!QC!/1000) AS MIN_TOTAL_WRITE, (P.!QC!MAX_Disk_Write_Bytes_Sec!QC!/1000) AS MAX_TOTAL_WRITE, (P.!QC!AVG_Disk_Write_Bytes_Sec!QC!/1000) AS AVG_TOTAL_WRITE, (P.!QC!SUM_Disk_Write_Bytes_Sec!QC!/1000) AS SUM_TOTAL_WRITE, P.!QC!MIN_Transfers_KB_per_Sec!QC! AS MIN_TOTAL_IO, P.!QC!MAX_Transfers_KB_per_Sec!QC! AS MAX_TOTAL_IO, P.!QC!AVG_Transfers_KB_per_Sec!QC! AS AVG_TOTAL_IO, P.!QC!SUM_Transfers_KB_per_Sec!QC! AS SUM_TOTAL_IO, P.!QC!MIN_Read_Transfers_per_Sec!QC! AS MIN_READ_OPS, P.!QC!MAX_Read_Transfers_per_Sec!QC! AS MAX_READ_OPS, P.!QC!AVG_Read_Transfers_per_Sec!QC! AS AVG_READ_OPS, P.!QC!SUM_Read_Transfers_per_Sec!QC! AS SUM_READ_OPS, P.!QC!MIN_Write_Transfers_per_Sec!QC! AS MIN_WRITE_OPS, P.!QC!MAX_Write_Transfers_per_Sec!QC! AS MAX_WRITE_OPS, P.!QC!AVG_Write_Transfers_per_Sec!QC! AS AVG_WRITE_OPS, P.!QC!SUM_Write_Transfers_per_Sec!QC! AS SUM_WRITE_OPS, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! FROM (SELECT MI.!QC!LAT_Hostname!QC!, MI.!QC!LAT_Hardware_Model!QC!, MI.!QC!LAT_Machine_Serial!QC!, AL.!QC!LAT_LPAR_Name!QC!, DP.!QC!LAT_Disk_Name!QC!, DP.!QC!MIN_Disk_Read_Bytes_Sec!QC!, DP.!QC!MAX_Disk_Read_Bytes_Sec!QC!, DP.!QC!AVG_Disk_Read_Bytes_Sec!QC!, DP.!QC!SUM_Disk_Read_Bytes_Sec!QC!, DP.!QC!MIN_Disk_Write_Bytes_Sec!QC!, DP.!QC!MAX_Disk_Write_Bytes_Sec!QC!, DP.!QC!AVG_Disk_Write_Bytes_Sec!QC!, DP.!QC!SUM_Disk_Write_Bytes_Sec!QC!, DP.!QC!MIN_Transfers_KB_per_Sec!QC!, DP.!QC!MAX_Transfers_KB_per_Sec!QC!, DP.!QC!AVG_Transfers_KB_per_Sec!QC!, DP.!QC!SUM_Transfers_KB_per_Sec!QC!, DP.!QC!MIN_Read_Transfers_per_Sec!QC!, DP.!QC!MAX_Read_Transfers_per_Sec!QC!, DP.!QC!AVG_Read_Transfers_per_Sec!QC!, DP.!QC!SUM_Read_Transfers_per_Sec!QC!, DP.!QC!MIN_Write_Transfers_per_Sec!QC!, DP.!QC!MAX_Write_Transfers_per_Sec!QC!, DP.!QC!AVG_Write_Transfers_per_Sec!QC!, DP.!QC!SUM_Write_Transfers_per_Sec!QC!, DP.!QC!WRITETIME!QC! FROM FED_MACHINE_INFORMATION_!L_VM_DS_OPT! MI, FED_DISK_PERFORMANCE_!L_VM_DS_OPT! DP, FED_AIX_LPAR_!L_VM_DS_OPT! AL WHERE DP.!QC!System_Name!QC! = MI.!QC!System_Name!QC! AND MI.!QC!System_Name!QC! = AL.!QC!System_Name!QC! AND DP.!QC!WRITETIME!QC! = MI.!QC!WRITETIME!QC! AND MI.!QC!WRITETIME!QC! = AL.!QC!WRITETIME!QC!) P INNER JOIN (SELECT !QC!LAT_CEC_name!QC!, !QC!CEC_Model!QC!, !QC!CEC_SN!QC!, !QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_VM_DS_OPT!) Q ON P.!QC!LAT_Hardware_Model!QC! = Q.!QC!CEC_Model!QC! AND SUBSTR(P.!QC!LAT_Machine_Serial!QC!, 7) = Q.!QC!CEC_SN!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!)XXX"

    
    IF !LINUX_ENV! EQU 1 (

        SET L_VM_DS_VIEW_DEF=!L_VM_DS_VIEW_DEF!"XXX UNION (SELECT P.!QC!Device_Name!QC! AS DATA_STORE_NAME, P.!QC!Hostname!QC! AS HOST_NAME, P.!QC!LPAR_Name!QC! AS VM_NAME, Q.!QC!CEC_name!QC! AS DATA_CENTER_NAME, (P.!QC!Read_bytes_per_sec!QC!/1000) AS TOTAL_READ, (P.!QC!Write_bytes_per_sec!QC!/1000) AS TOTAL_WRITE, (P.!QC!Transfers_bytes_per_sec!QC!/1000) AS TOTAL_IO, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! FROM (SELECT LMI.!QC!System_Name!QC!, LMI.!QC!Hostname!QC!, LMI.!QC!Hardware_Model!QC!, LMI.!QC!Machine_Serial!QC!, LMI.!QC!WRITETIME!QC!, KL.!QC!LPAR_Name!QC!, KIOE.!QC!Device_Name!QC!, KIOE.!QC!Read_bytes_per_sec!QC!, KIOE.!QC!Write_bytes_per_sec!QC!, KIOE.!QC!Transfers_bytes_per_sec!QC! FROM FED_LINUX_MACHINE_INFORMATION_!L_VM_DS_OPT! LMI, FED_KLZ_LPAR_!L_VM_DS_OPT! KL, FED_KLZ_IO_EXT_!L_VM_DS_OPT! KIOE WHERE LMI.!QC!System_Name!QC! = KL.!QC!System_Name!QC! AND KL.!QC!System_Name!QC! = KIOE.!QC!System_Name!QC! AND LMI.!QC!WRITETIME!QC! = KL.!QC!WRITETIME!QC! AND KL.!QC!WRITETIME!QC! = KIOE.!QC!WRITETIME!QC!) P INNER JOIN (SELECT !QC!CEC_name!QC!, !QC!CEC_Model!QC!, !QC!CEC_SN!QC!, !QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_VM_DS_OPT!) Q ON P.!QC!Hardware_Model!QC! = Q.!QC!CEC_Model!QC! AND P.!QC!Machine_Serial!QC! = Q.!QC!CEC_SN!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!)XXX"

        SET L_VM_DS_VIEW_DEF_AGG=!L_VM_DS_VIEW_DEF_AGG!"XXX UNION (SELECT P.!QC!Device_Name!QC! AS DATA_STORE_NAME, P.!QC!LAT_Hostname!QC! AS HOST_NAME, P.!QC!LAT_LPAR_Name!QC! AS VM_NAME, Q.!QC!LAT_CEC_name!QC! AS DATA_CENTER_NAME, (P.!QC!MIN_Read_bytes_per_sec!QC!/1000) AS MIN_TOTAL_READ, (P.!QC!MAX_Read_bytes_per_sec!QC!/1000) AS MAX_TOTAL_READ, (P.!QC!AVG_Read_bytes_per_sec!QC!/1000) AS AVG_TOTAL_READ, (P.!QC!SUM_Read_bytes_per_sec!QC!/1000) AS SUM_TOTAL_READ, (P.!QC!MIN_Write_bytes_per_sec!QC!/1000) AS MIN_TOTAL_WRITE, (P.!QC!MAX_Write_bytes_per_sec!QC!/1000) AS MAX_TOTAL_WRITE, (P.!QC!AVG_Write_bytes_per_sec!QC!/1000) AS AVG_TOTAL_WRITE, (P.!QC!SUM_Write_bytes_per_sec!QC!/1000) AS SUM_TOTAL_WRITE, (P.!QC!MIN_Transfers_bytes_per_sec!QC!/1000) AS MIN_TOTAL_IO, (P.!QC!MAX_Transfers_bytes_per_sec!QC!/1000) AS MAX_TOTAL_IO, (P.!QC!AVG_Transfers_bytes_per_sec!QC!/1000) AS AVG_TOTAL_IO, (P.!QC!SUM_Transfers_bytes_per_sec!QC!/1000) AS SUM_TOTAL_IO, P.!QC!MIN_Read_req_per_sec!QC! AS MIN_READ_OPS, P.!QC!MAX_Read_req_per_sec!QC! AS MAX_READ_OPS, P.!QC!AVG_Read_req_per_sec!QC! AS AVG_READ_OPS, P.!QC!SUM_Read_req_per_sec!QC! AS SUM_READ_OPS, P.!QC!MIN_Write_req_per_sec!QC! AS MIN_WRITE_OPS, P.!QC!MAX_Write_req_per_sec!QC! AS MAX_WRITE_OPS, P.!QC!AVG_Write_req_per_sec!QC! AS AVG_WRITE_OPS, P.!QC!SUM_Write_req_per_sec!QC! AS SUM_WRITE_OPS, -1 AS TIMESTAMP, P.!QC!WRITETIME!QC! FROM (SELECT LMI.!QC!System_Name!QC!, LMI.!QC!LAT_Hostname!QC!, LMI.!QC!LAT_Hardware_Model!QC!, LMI.!QC!LAT_Machine_Serial!QC!, LMI.!QC!WRITETIME!QC!, KL.!QC!LAT_LPAR_Name!QC!, KIOE.!QC!Device_Name!QC!, KIOE.!QC!MIN_Read_bytes_per_sec!QC!, KIOE.!QC!MAX_Read_bytes_per_sec!QC!, KIOE.!QC!AVG_Read_bytes_per_sec!QC!, KIOE.!QC!SUM_Read_bytes_per_sec!QC!, KIOE.!QC!MIN_Write_bytes_per_sec!QC!, KIOE.!QC!MAX_Write_bytes_per_sec!QC!, KIOE.!QC!AVG_Write_bytes_per_sec!QC!, KIOE.!QC!SUM_Write_bytes_per_sec!QC!, KIOE.!QC!MIN_Transfers_bytes_per_sec!QC!, KIOE.!QC!MAX_Transfers_bytes_per_sec!QC!, KIOE.!QC!AVG_Transfers_bytes_per_sec!QC!, KIOE.!QC!SUM_Transfers_bytes_per_sec!QC!, KIOE.!QC!MIN_Read_req_per_sec!QC!, KIOE.!QC!MAX_Read_req_per_sec!QC!, KIOE.!QC!AVG_Read_req_per_sec!QC!, KIOE.!QC!SUM_Read_req_per_sec!QC!, KIOE.!QC!MIN_Write_req_per_sec!QC!, KIOE.!QC!MAX_Write_req_per_sec!QC!, KIOE.!QC!AVG_Write_req_per_sec!QC!, KIOE.!QC!SUM_Write_req_per_sec!QC! FROM FED_LINUX_MACHINE_INFORMATION_!L_VM_DS_OPT! LMI, FED_KLZ_LPAR_!L_VM_DS_OPT! KL, FED_KLZ_IO_EXT_!L_VM_DS_OPT! KIOE WHERE LMI.!QC!System_Name!QC! = KL.!QC!System_Name!QC! AND KL.!QC!System_Name!QC! = KIOE.!QC!System_Name!QC! AND LMI.!QC!WRITETIME!QC! = KL.!QC!WRITETIME!QC! AND KL.!QC!WRITETIME!QC! = KIOE.!QC!WRITETIME!QC!) P INNER JOIN (SELECT !QC!LAT_CEC_name!QC!, !QC!CEC_Model!QC!, !QC!CEC_SN!QC!, !QC!WRITETIME!QC! FROM FED_KPH_SERVER_LPARS_!L_VM_DS_OPT!) Q ON P.!QC!LAT_Hardware_Model!QC! = Q.!QC!CEC_Model!QC! AND P.!QC!LAT_Machine_Serial!QC! = Q.!QC!CEC_SN!QC! AND P.!QC!WRITETIME!QC! = Q.!QC!WRITETIME!QC!)XXX"

    )

    SET L_VIEW_DEF=!L_VM_DS_VIEW_DEF!
    IF NOT (!L_SUMM_LEVEL!) == () (
        SET L_VIEW_DEF=!L_VM_DS_VIEW_DEF_AGG!
    )

    SET DB2_CMD_DM_VIEW=!SQL_CREATE_VIEW! !DM_SCHEMA_NAME!.MES_VM_DATA_STORE!L_SUMM_LEVEL!

    CALL :CreateMESView !DM_SCHEMA_NAME!.MES_VM_DATA_STORE!L_SUMM_LEVEL! "!DB2_CMD_DM_VIEW!"  !L_VIEW_DEF! RESULT VIEW_NAME
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )

    CALL :UpdatePercentileViews !L_VM_DS_OPT! !DM_SCHEMA_NAME! RESULT
    IF NOT !RESULT! == !RESULT_OK! (
        ENDLOCAL & SET "%~2=%RET_CODE%" & GOTO :EOF
    )
	
	SET RET_CODE=1

(ENDLOCAL
SET "%~2=%RET_CODE%"
SET "%~3=%VIEW_NAME%"
EXIT /B)


REM ############################################################################
REM Undefines a federated view.
REM Arguments:
REM     %1  :   A federation view to be undone
REM             [PS|VM]_[CPU|MEM|IO/DS|NET]_[H|D|W|M|Q|Y]
REM ############################################################################
:DELETE_A_VIEW
SETLOCAL
    SET L_OPT=%1

    SET L_SUMM_LEVEL=
    IF "!L_OPT:~-2,1!" == "_" (
        SET L_SUMM_LEVEL=!L_OPT:~-2!
    )

    SET L_NICK_NAMES_LIST=
    SET L_TABLE_BODY=

    IF "!L_OPT:~0,6!" == "PS_CPU" (

        SET L_NICK_NAMES_LIST=FED_KPH_SERVER_DETAILS_!L_OPT!

        SET L_TABLE_BODY=!TABLE_BODY_SERVER_CPU!
        IF NOT "X!L_SUMM_LEVEL!X" == "XX" (
            SET L_TABLE_BODY=!TABLE_BODY_SERVER_CPU_AGG!
        )

        CALL :DELETE_COMMON !L_OPT! "!L_NICK_NAMES_LIST!" "!L_TABLE_BODY!"
        GOTO :EOF

    )

    IF "!L_OPT:~0,6!" == "PS_MEM" (

        SET L_NICK_NAMES_LIST=FED_UNIX_MEMORY_!L_OPT! FED_MACHINE_INFORMATION_!L_OPT! FED_KPH_SERVER_LPARS_!L_OPT! FED_KVA_PHYSICAL_MEMORY_!L_OPT! FED_KVA_TADDM_!L_OPT!

        IF !LINUX_ENV! EQU 1 (
            SET L_NICK_NAMES_LIST=!L_NICK_NAMES_LIST! FED_KLZ_VM_STATS_!L_OPT! FED_LINUX_MACHINE_INFORMATION_!L_OPT!
        )

        SET L_TABLE_BODY=!TABLE_BODY_SERVER_MEM!
        IF NOT "X!L_SUMM_LEVEL!X" == "XX" (
            SET L_TABLE_BODY=!TABLE_BODY_SERVER_MEM_AGG!
        )

        CALL :DELETE_COMMON !L_OPT! "!L_NICK_NAMES_LIST!" "!L_TABLE_BODY!"
        GOTO :EOF

    )

    IF "!L_OPT:~0,6!" == "PS_NET" (

        SET L_NICK_NAMES_LIST=FED_KVA_NETWORK_ADAPTERS_RATES_!L_OPT!

        SET L_TABLE_BODY=!TABLE_BODY_SERVER_NET!
        IF NOT "X!L_SUMM_LEVEL!X" == "XX" (
            SET L_TABLE_BODY=!TABLE_BODY_SERVER_NET_AGG!
        )

        CALL :DELETE_COMMON !L_OPT! "!L_NICK_NAMES_LIST!" "!L_TABLE_BODY!"
        GOTO :EOF

    )

    IF "!L_OPT:~0,5!" == "PS_IO" (

        SET L_NICK_NAMES_LIST=FED_KVA_DISKS_!L_OPT!

        SET L_TABLE_BODY=!TABLE_BODY_SERVER_DISK!
        IF NOT "X!L_SUMM_LEVEL!X" == "XX" (
            SET L_TABLE_BODY=!TABLE_BODY_SERVER_DISK_AGG!
        )

        CALL :DELETE_COMMON !L_OPT! "!L_NICK_NAMES_LIST!" "!L_TABLE_BODY!"
        GOTO :EOF

    )

    IF "!L_OPT:~0,6!" == "VM_CPU" (

        SET L_NICK_NAMES_LIST=FED_KPH_SERVER_LPARS_!L_OPT!

        SET L_TABLE_BODY=!TABLE_BODY_VM_CPU!
        IF NOT "X!L_SUMM_LEVEL!X" == "XX" (
            SET L_TABLE_BODY=!TABLE_BODY_VM_CPU_AGG!
        )

        CALL :DELETE_COMMON !L_OPT! "!L_NICK_NAMES_LIST!" "!L_TABLE_BODY!"
        GOTO :EOF

    )

    IF "!L_OPT:~0,6!" == "VM_MEM" (

       SET L_NICK_NAMES_LIST=FED_UNIX_MEMORY_!L_OPT! FED_MACHINE_INFORMATION_!L_OPT! FED_AIX_LPAR_!L_OPT! FED_KPH_SERVER_LPARS_!L_OPT! FED_KVA_PHYSICAL_MEMORY_!L_OPT! FED_KVA_STORAGE_MAPPINGS_!L_OPT! FED_KVA_TADDM_!L_OPT!

        IF !LINUX_ENV! EQU 1 (
            SET L_NICK_NAMES_LIST=!L_NICK_NAMES_LIST! FED_KLZ_LPAR_!L_OPT! FED_KLZ_VM_STATS_!L_OPT! FED_LINUX_MACHINE_INFORMATION_!L_OPT!
        )

        SET L_TABLE_BODY=!TABLE_BODY_VM_MEM!
        IF NOT "X!L_SUMM_LEVEL!X" == "XX" (
            SET L_TABLE_BODY=!TABLE_BODY_VM_MEM_AGG!
        )

        CALL :DELETE_COMMON !L_OPT! "!L_NICK_NAMES_LIST!" "!L_TABLE_BODY!"
        GOTO :EOF

    )

    IF "!L_OPT:~0,6!" == "VM_NET" (

        SET L_NICK_NAMES_LIST=FED_NETWORK_!L_OPT! FED_MACHINE_INFORMATION_!L_OPT! FED_AIX_LPAR_!L_OPT! FED_KPH_SERVER_LPARS_!L_OPT!

        IF !LINUX_ENV! EQU 1 (
            SET L_NICK_NAMES_LIST=!L_NICK_NAMES_LIST! FED_KLZ_LPAR_!L_OPT! FED_KLZ_NETWORK_!L_OPT! FED_LINUX_MACHINE_INFORMATION_!L_OPT!
        )

        SET L_TABLE_BODY=!TABLE_BODY_VM_NET!
        IF NOT "X!L_SUMM_LEVEL!X" == "XX" (
            SET L_TABLE_BODY=!TABLE_BODY_VM_NET_AGG!
        )

        CALL :DELETE_COMMON VM_NETWORK!L_SUMM_LEVEL! "!L_NICK_NAMES_LIST!" "!L_TABLE_BODY!"
        GOTO :EOF

    )

    IF "!L_OPT:~0,5!" == "VM_DS" (

        SET L_NICK_NAMES_LIST=FED_DISK_PERFORMANCE_!L_OPT! FED_MACHINE_INFORMATION_!L_OPT! FED_AIX_LPAR_!L_OPT! FED_KPH_SERVER_LPARS_!L_OPT!

        IF !LINUX_ENV! EQU 1 (
            SET L_NICK_NAMES_LIST=!L_NICK_NAMES_LIST! FED_KLZ_LPAR_!L_OPT! FED_KLZ_IO_EXT_!L_OPT! FED_LINUX_MACHINE_INFORMATION_!L_OPT! 
        )

        SET L_TABLE_BODY=!TABLE_BODY_VM_DS!
        IF NOT "X!L_SUMM_LEVEL!X" == "XX" (
            SET L_TABLE_BODY=!TABLE_BODY_VM_DS_AGG!
        )

        CALL :DELETE_COMMON VM_DATA_STORE!L_SUMM_LEVEL! "!L_NICK_NAMES_LIST!" "!L_TABLE_BODY!"
        GOTO :EOF

    )

ENDLOCAL
EXIT /B

REM ############################################################################
REM Encapsulates logic to undefine a federated view.
REM Arguments:
REM     %1  :   Federated view to be undone
REM     %2  :   List of nick names to be erased
REM     %3  :   Definition of the table replacing the view
REM ############################################################################
:DELETE_COMMON
SETLOCAL
    SET L_OPT=%1
    SET L_NICK_NAMES_LIST=%2
    SET L_TABLE_BODY=%3

    SET L_SUMM_LEVEL=
    IF "!L_OPT:~-2,1!" == "_" (
        SET L_SUMM_LEVEL=!L_OPT:~-2!
    )

    REM Strip off leading and trailing double quotes used to pass the nick names
    REM as an argument to this lable.
    SET L_NICK_NAMES_LIST=%L_NICK_NAMES_LIST:~1%
    SET L_NICK_NAMES_LIST=%L_NICK_NAMES_LIST:~0,-1%
    
    REM Strip off leading and trailing double quotes used to pass the table
    REM definition as an argument to this lable.
    SET L_TABLE_BODY=%L_TABLE_BODY:~1%
    SET L_TABLE_BODY=%L_TABLE_BODY:~0,-1%

    FOR %%K IN ( %L_NICK_NAMES_LIST% ) DO (
        SET L_NICK=%%K
        CALL :DropNickNameIfExists !L_NICK! !DM_SCHEMA_NAME! RESULT
        REM Remove as many nick names as possible.
    )
	
    CALL :DropMESViewIfExists MES_!L_OPT! !DM_SCHEMA_NAME!
    IF NOT !RESULT! == !RESULT_OK! (
        GOTO :EOF
    )
    REM Restore measurements table if not present.
    CALL :RestoreMESTable MES_!L_OPT! !DM_SCHEMA_NAME! "!L_TABLE_BODY!"
    IF NOT !RESULT! == !RESULT_OK! (
        GOTO :EOF
    )
	REM Update Percentile views.
    CALL :UpdatePercentileViews !L_OPT! !DM_SCHEMA_NAME!
    IF NOT !RESULT! == !RESULT_OK! (
        GOTO :EOF
    )
	
ENDLOCAL
EXIT /B

REM ############################################################################
REM Cleans up after the execution, also releasing resources.
REM ############################################################################
:SHUT_DOWN
:: BEGIN {

    %JAVA% %CLASSNAME% "ANA01004I"
	
    REM Clean up: Remove nick names in case required.
    IF NOT (!ON_ERROR_DROP_NICKNAMES!) == () (
        FOR %%I IN ( %ON_ERROR_DROP_NICKNAMES% ) DO (
            SET A_NICK=%%I
            CALL :DropNickNameIfExists !A_NICK! !DM_SCHEMA_NAME! RESULT
            REM Drop as many as possible.
        )
    )

    IF !IS_CONNECTED! EQU 1 (
        ECHO Disconnecting from: !DM_NAME! 
		
        !DB2! TERMINATE 2>&1 
    )
	
	IF "!DBA_MODE!" == "DBAMODE" (
	   ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	)
	
    IF EXIST !TMP_F_NAME! (
    	DEL !TMP_F_NAME!
    )
	REM THE BELOW CODE IS IMPLEMENTED FOR PRINT SUMMARY OF VIEWS STORY
	ECHO SUCCESS_VIEWS=!SUCCESS_VIEW!
	SET TEMPSTR=%SUCCESS_VIEW:MES_VM_MEM_=%
	IF "%SUCCESS_VIEW%"=="%TEMPSTR%" (
	ECHO MEM_TDW_TABLES=Unix_Memory,Machine_Information,AIX_LPAR,KPH_SERVER_LPARS,KLZ_LPAR,KLZ_VM_Stats,Linux_Machine_Information,KVA_PHYSICAL_MEMORY,KVA_STORAGE_MAPPINGS,KVA_TADDM
	)
	
	SET TEMPSTR=%SUCCESS_VIEW:MES_VM_CPU_=%
	IF "%SUCCESS_VIEW%"=="%TEMPSTR%" (
	ECHO CPU_TDW_TABLES=KPH_SERVER_LPARS
	) 
	
	SET TEMPSTR=%SUCCESS_VIEW:MES_VM_DATA_STORE_=%
	IF "%SUCCESS_VIEW%"=="%TEMPSTR%" (
	ECHO DATA_STORE_TDW_TABLES=Disk_Performance,Machine_Information,AIX_LPAR,KPH_SERVER_LPARS,Linux_Machine_Information,KLZ_LPAR,KLZ_IO_Ext
	) 
	
	SET TEMPSTR=%SUCCESS_VIEW:MES_VM_NETWORK_=%
	IF "%SUCCESS_VIEW%"=="%TEMPSTR%" (
	ECHO NETWORK_TDW_TABLES=Network,Machine_Information,AIX_LPAR,KPH_SERVER_LPARS,KLZ_LPAR,KLZ_Network,Linux_Machine_Information
	) 
	REM THE ABOVE CODE IS IMPLEMENTED FOR PRINT SUMMARY OF VIEWS STORY
    SET PROG_NAME=
    SET ARGUMENTS=

    SET DB2=
    SET TMP_F_NAME=
    SET LOG_F_NAME=
    SET SPACE=
    SET DB2_CMD_SEPARATOR=
    SET VERSION=
    SET DB2_VERSION=
    SET TDW_SCHEMA_NAME=
    SET DM_VIEW_SCHEMA_PREFIX=
    SET TDW_SCHEMA_PREFIX=
    SET SQL_CREATE_NICKNAME=
    SET SQL_DROP_NICKNAME=
    SET SQL_CREATE_VIEW=
    SET SQL_DROP_VIEW=
    SET ALL_SUPPORTED=
	SET SUCCESS_VIEW=
    SET VIEW_BODY_SERVER_CPU=
    SET VIEW_BODY_SERVER_CPU_AGG=
    SET VIEW_BODY_SERVER_MEM=
    SET VIEW_BODY_SERVER_MEM_AGG=
    SET VIEW_BODY_SERVER_DISK=
    SET VIEW_BODY_SERVER_DISK_AGG=
    SET VIEW_BODY_SERVER_NET=
    SET VIEW_BODY_SERVER_NET_AGG=
    SET VIEW_BODY_VM_CPU=
    SET VIEW_BODY_VM_CPU_AGG=
    SET VIEW_BODY_VM_MEM=
    SET VIEW_BODY_VM_MEM_AGG=
    SET VIEW_BODY_VM_NET=
    SET VIEW_BODY_VM_NET_AGG=
    SET VIEW_BODY_VM_DS=
    SET VIEW_BODY_VM_DS_AGG=
    SET VIEW_PERC_CPU_H_V=
    SET VIEW_PERC_DISK_H_V=
    SET VIEW_PERC_MEM_H_V=
    SET VIEW_PERC_NW_H_V=
    SET PERC_VIEW=

    SET TABLE_BODY_SERVER_CPU=
    SET TABLE_BODY_SERVER_CPU_AGG=
    SET TABLE_BODY_SERVER_MEM=
    SET TABLE_BODY_SERVER_MEM_AGG=
    SET TABLE_BODY_SERVER_DISK=
    SET TABLE_BODY_SERVER_DISK_AGG=
    SET TABLE_BODY_SERVER_NET=
    SET TABLE_BODY_SERVER_NET_AGG=
    SET TABLE_BODY_VM_CPU=
    SET TABLE_BODY_VM_CPU_AGG=
    SET TABLE_BODY_VM_MEM=
    SET TABLE_BODY_VM_MEM_AGG=
    SET TABLE_BODY_VM_NET=
    SET TABLE_BODY_VM_NET_AGG=
    SET TABLE_BODY_VM_DS=
    SET TABLE_BODY_VM_DS_AGG=

    SET ARGS_CNT=
    SET TMP_CNT=
    SET F=
    SET I=
    SET J=
    SET OPT=
    SET ARG=
    SET FOUND=
    SET T=

    SET ON_ERROR_DROP_NICKNAMES=
    SET ITEM=
    SET A_NICK=

    SET LOCAL_SERVER_NAME=
    SET DM_NAME=
    SET DM_SCHEMA_NAME=
    SET ACTION=

    SET AN_ARG=

    SET DB2_CMD_NICK_NAME=
    SET IS_CONNECTED=
    SET ARGUMENTS_ALL=

    SET MES_NAME=
    SET DM_ENTITY_NAME=
    SET FLAG=
    SET TABLE_BODY=
    SET DB2_CMD_CREATE_TABLE=
    SET NICK_NAME=
	SET DBA_MODE=
	
	ECHO FAILED_COUNT=%ERROR_COUNT%
	
    GOTO :EXIT
:: } END SHUT_DOWN

:strlen <resultVar> <stringVar>
(
SETLOCAL
    set "s=!%~2!#"
    set "len=0"
    for %%P in (4096 2048 1024 512 256 128 64 32 16 8 4 2 1) do (
        if "!s:~%%P,1!" NEQ "" (
            set /a "len+=%%P"
            set "s=!s:~%%P!"
        )
    )
)
(
    endlocal
    set "%~1=%len%"
    exit /b
)

:indexOf <resultVar> <strVar> <find>
SETLOCAL
set str=%~2
call set "part=%%str:%~3=&rem.%%"
set partB=%part%
call :strlen len partB
( ENDLOCAL
set %~1=%len%
EXIT /b
)

REM ############################################################################
REM Deletes a given nick name from the database.
REM Arguments:
REM     %1  :   Nick name to be dropped
REM     %2  :   Database schema
REM ############################################################################
:DropNickNameIfExists
SETLOCAL

    SET L_NAME=%1
    SET L_SCHEMA=%2
    SET RET_CODE=0
	IF "!DBA_MODE!" == "DBAMODE" (
		ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.NICKNAMES WHERE TABNAME = '%L_NAME%' AND TABSCHEMA = '%L_SCHEMA%'" >> !TMP_DDL_FILE_NAME!
	) ELSE (
		!DB2! -x "SELECT TABNAME FROM SYSCAT.NICKNAMES WHERE TABNAME = '%L_NAME%' AND TABSCHEMA = '%L_SCHEMA%'" > !TMP_F_NAME!
	)
    IF "!DBA_MODE!" == "DBAMODE" (
	ECHO %L_NAME% > !TMP_F_NAME!
	)
    IF NOT ERRORLEVEL 1 (
	
		SET FLAG=0
		FOR /F %%T IN (!TMP_F_NAME!) DO (
			SET MES_NAME=%%T
			SET DB2_CMD_NICK_NAME=!SQL_DROP_NICKNAME! %L_SCHEMA%.%L_NAME%
		
			IF "!DBA_MODE!" == "DBAMODE" (
			 	ECHO !DB2! !DB2_CMD_NICK_NAME! >> !TMP_DDL_FILE_NAME!
				SET FLAG=1
			) ELSE (
				ECHO Dropping nick name:  %L_SCHEMA%.%L_NAME% 
				ECHO !DB2_CMD_NICK_NAME! 
				!DB2! "!DB2_CMD_NICK_NAME!" 2>&1 
			)
			
			IF NOT ERRORLEVEL 1 (
				SET FLAG=1
			)
			
		)
		IF !FLAG! EQU 0 (
			ECHO Nick name: %L_SCHEMA%.%L_NAME% does not exist. 
		)
		SET RET_CODE=1
	)
	

(ENDLOCAL 
	SET %~3=%RET_CODE%
	EXIT /B
)

REM ############################################################################
REM Creates a given nick name.
REM Arguments:
REM     %1  :   Nick name
REM     %2  :   TDW table for the nick name
REM     %3  :   Capacity Planner database schema
REM ############################################################################
:CreateNickName
SETLOCAL

    SET L_NAME=%1
    SET L_TDW_NAME=%2
    SET L_SCHEMA=%3
    SET RET_CODE=0
   
    SET DB2_CMD_NICK_NAME=!SQL_CREATE_NICKNAME! %L_SCHEMA%.%L_NAME% FOR %L_TDW_NAME%
   
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! "!DB2_CMD_NICK_NAME!" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	ECHO Creating nick name:  %L_SCHEMA%.%L_NAME% 
	ECHO Running: !DB2_CMD_NICK_NAME! 
    !DB2! "!DB2_CMD_NICK_NAME!" 2>&1 
	)

    REM Verify that the nickname was created.
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.NICKNAMES WHERE TABNAME = '%L_NAME%' AND TABSCHEMA = '%L_SCHEMA%'" >> !TMP_DDL_FILE_NAME!
	) ELSE (
    !DB2! -x "SELECT TABNAME FROM SYSCAT.NICKNAMES WHERE TABNAME = '%L_NAME%' AND TABSCHEMA = '%L_SCHEMA%'" > !TMP_F_NAME!
	)
    IF NOT ERRORLEVEL 1 (
        SET FLAG=0
        FOR /F %%T IN (!TMP_F_NAME!) DO (
            SET FLAG=1
        )
		IF "!DBA_MODE!" == "DBAMODE" (
		SET FLAG=1
		)
        IF !FLAG! EQU 0 (
            ECHO Failed to create nick name: %L_NAME% 
			SET RET_CODE=0
        ) ELSE (
        	ECHO Nick name: %L_NAME% created successfully
            SET RET_CODE=1
        )
    )

(
ENDLOCAL
SET %~4=%RET_CODE%
EXIT /B
)

REM ############################################################################
REM Drops a utilization metrics table from the database.
REM Arguments:
REM     %1  :   Metrics table
REM     %2  :   Capacity Planner database schema
REM ############################################################################
:DropMESTableIfExists
SETLOCAL

    SET L_NAME=%1
    SET L_SCHEMA=%2
    SET RET_CODE=0
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '%L_NAME%' AND TABSCHEMA = '%L_SCHEMA%' AND TYPE = 'T'" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '%L_NAME%' AND TABSCHEMA = '%L_SCHEMA%' AND TYPE = 'T'" > !TMP_F_NAME!
	)
    
	IF ERRORLEVEL 1 (
		GOTO :EOF
	)
	IF "!DBA_MODE!" == "DBAMODE" (
		ECHO %L_NAME% > !TMP_F_NAME!
	)
    FOR /F %%T IN (!TMP_F_NAME!) DO (
        SET MES_NAME=%%T
		REM ECHO Dropping Datamart table: %L_SCHEMA%.!MES_NAME! 
		IF "!DBA_MODE!" == "DBAMODE" (
		ECHO !DB2! DROP TABLE %L_SCHEMA%.!L_NAME! >> !TMP_DDL_FILE_NAME!
		exit /B
		) ELSE (
		ECHO DropMESTableIfExists !MES_NAME! 
        !DB2! DROP TABLE %L_SCHEMA%.!MES_NAME! > NUL 2>&1
		)
        IF ERRORLEVEL 1 (
			echo "in error level 2" 2>&1
			ENDLOCAL & SET "%~3=%RET_CODE%" & GOTO :EOF
		)
    )
    SET RET_CODE=1

(ENDLOCAL 
	SET %~3=%RET_CODE%
	EXIT /B
)

REM ############################################################################
REM Drops a utilization metrics view from the database.
REM Arguments:
REM     %1  :   View name
REM     %2  :   Capacity Planner database schema
REM ############################################################################
:DropMESViewIfExists
SETLOCAL

    SET L_NAME=%1
    SET L_SCHEMA=%2
    SET RET_CODE=0

    REM Check if the view exists.
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '%L_NAME%' AND TABSCHEMA = '%L_SCHEMA%' AND TYPE = 'V'" >> !TMP_DDL_FILE_NAME!
	) ELSE (
    !DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '%L_NAME%' AND TABSCHEMA = '%L_SCHEMA%' AND TYPE = 'V'" > !TMP_F_NAME!
	)
    IF ERRORLEVEL 1 (
        ECHO View: %L_SCHEMA%.%L_NAME% does not exist. 
        GOTO :EOF
    )
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO %L_NAME% > !TMP_F_NAME!
	)
    SET FLAG=0
    FOR /F %%T IN (!TMP_F_NAME!) DO (
        SET MES_NAME=%%T
        IF "!DBA_MODE!" == "DBAMODE" (
		ECHO !DB2! DROP VIEW !L_SCHEMA!.!L_NAME! >> !TMP_DDL_FILE_NAME!
		) ELSE (
		ECHO Dropping Datamart view: %L_SCHEMA%.!MES_NAME! 
        !DB2! DROP VIEW %L_SCHEMA%.!MES_NAME! 2>&1 
		)
        IF ERRORLEVEL 1 GOTO :EOF

        ECHO. 
        SET FLAG=1
    )
    IF !FLAG! EQU 0 (
        ECHO View: %L_SCHEMA%.%L_NAME% does not exist. 
    )
    SET RET_CODE=1
	
ENDLOCAL & SET RESULT=%RET_CODE%
EXIT /B

REM ############################################################################
REM Creates a utilization metrics view in the database.
REM Arguments:
REM     %1  :   View name
REM     %2  :   Capacity Planner database schema
REM ############################################################################
:CreateMESView
SETLOCAL

    SET L_NAME=%1
    SET L_CMD=%2
    SET L_VIEW_BODY=%3
    SET RET_CODE=0
	REM Strip off leading and trailing double quotes used to pass the command
    REM as an argument to this lable.
    SET L_CMD=%L_CMD:~1%
    SET L_CMD=%L_CMD:~0,-1%
    REM Strip off the sentinels.
    IF NOT (!L_VIEW_BODY!) == () (
        SET L_VIEW_BODY=!L_VIEW_BODY:"XXX=!
        SET L_VIEW_BODY=!L_VIEW_BODY:XXX"=!
    )

    ECHO !L_CMD!  !L_VIEW_BODY! > !TMP_F_NAME!
    ECHO !DB2_CMD_SEPARATOR! >> !TMP_F_NAME!
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !L_CMD! !L_VIEW_BODY! >> !TMP_DDL_FILE_NAME!
	) ELSE (
	ECHO Creating Datamart view:  !L_NAME! 
	ECHO !L_CMD! !L_VIEW_BODY!
    !DB2! -td@ -sf !TMP_F_NAME! 2>&1 
	)
	
    IF ERRORLEVEL 1 (
   	 	ECHO Failed to create a view !L_NAME!
		ENDLOCAL & SET %~4=%RET_CODE% & GOTO :EOF 
	) ELSE (
	SET VIEW_NAME=%L_NAME%
	IF NOT "!DBA_MODE!" == "DBAMODE" (
	ECHO View !L_NAME! created successfully 
	)
	)
	SET RET_CODE=1

(
	ENDLOCAL
	SET %~4=%RET_CODE%
	SET %~5=%VIEW_NAME%
	EXIT /B
)


REM ############################################################################
REM Updates the percentile views defined over the utilization metrics views in
REM the database.
REM Arguments:
REM     %1  :   Capacity Planner database schema
REM ############################################################################
:UpdatePercentileViews
SETLOCAL

    SET L_SCHEMA=%2
    SET RET_CODE=0

    SET PERC_VIEW=UNKNOWN
    IF %DB2_VERSION% == 5 (
        IF "%1" == "VM_CPU_H" (
            SET PERC_VIEW=MES_PERCENTILE_CPU_H_V
            SET DB2_CMD_DM_VIEW=!VIEW_PERC_CPU_H_V!
        ) ELSE IF "%1" == "VM_MEM_H" (
            SET PERC_VIEW=MES_PERCENTILE_MEM_H_V
            SET DB2_CMD_DM_VIEW=!VIEW_PERC_MEM_H_V!
        ) ELSE IF "%1" == "VM_DS_H" (
            SET PERC_VIEW=MES_PERCENTILE_DISK_H_V
            SET DB2_CMD_DM_VIEW=!VIEW_PERC_DISK_H_V!
        ) ELSE IF "%1" == "VM_NET_H" (
            SET PERC_VIEW=MES_PERCENTILE_NW_H_V
            SET DB2_CMD_DM_VIEW=!VIEW_PERC_NW_H_V!
        )
        IF NOT "!PERC_VIEW!" == "UNKNOWN" (
            
            
			IF "!DBA_MODE!" == "DBAMODE" (
			ECHO !DB2! DROP VIEW %L_SCHEMA%.!PERC_VIEW! >> !TMP_DDL_FILE_NAME!
			) ELSE (
			ECHO. 
			ECHO Dropping Datamart view: %L_SCHEMA%.!PERC_VIEW! 
			!DB2! DROP VIEW %L_SCHEMA%.!PERC_VIEW! 2>&1 
			)
            IF ERRORLEVEL 1 GOTO :EOF

            ECHO !SQL_CREATE_VIEW! %L_SCHEMA%.!DB2_CMD_DM_VIEW! > !TMP_F_NAME!
            ECHO !DB2_CMD_SEPARATOR! >> !TMP_F_NAME!
			IF "!DBA_MODE!" == "DBAMODE" (
			ECHO !SQL_CREATE_VIEW! %L_SCHEMA%.!DB2_CMD_DM_VIEW! >> !TMP_DDL_FILE_NAME!
			) ELSE (
			ECHO. 
            ECHO Creating Datamart view:  %L_SCHEMA%.!PERC_VIEW! 
            ECHO !SQL_CREATE_VIEW! %L_SCHEMA%.!DB2_CMD_DM_VIEW! 
			!DB2! -td@ -sf !TMP_F_NAME! 2>&1 
			)
            
            IF ERRORLEVEL 1 GOTO :EOF

            ECHO. 
        )
    )
    SET RET_CODE=1

ENDLOCAL & SET RESULT=%RET_CODE%
EXIT /B

REM ############################################################################
REM Establishes utilization metrics table in the database.
REM Arguments:
REM     %1  :   Table name
REM     %2  :   Capacity Planner database schema
REM     %3  :   Table definition
REM ############################################################################
:RestoreMESTable
SETLOCAL

    SET L_NAME=%1
    SET L_SCHEMA=%2
    SET L_BODY=%3
    SET RET_CODE=0
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '%L_NAME%' AND TABSCHEMA = '%L_SCHEMA%' AND TYPE = 'T'" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! -x "SELECT TABNAME FROM SYSCAT.TABLES WHERE TABNAME = '%L_NAME%' AND TABSCHEMA = '%L_SCHEMA%' AND TYPE = 'T'" > !TMP_F_NAME!
	)
	
    SET FLAG=0
	
	IF "!DBA_MODE!" == "DBAMODE" (
		ECHO !L_NAME! > !TMP_F_NAME!
	)
	
    FOR /F %%T IN (!TMP_F_NAME!) DO (
		SET MES_NAME=%%T
		IF "!MES_NAME!" == "!L_NAME!" (
			SET FLAG=1
		)
		
    )
	
	IF "!DBA_MODE!" == "DBAMODE" (
	SET FLAG=0
	)
	
    IF !FLAG! EQU 0 (
	
		IF "!DBA_MODE!" == "DBAMODE" (
			ECHO !DB2! "!SQL_CREATE_TABLE! !L_SCHEMA!.!L_NAME! !L_BODY!" >> !TMP_DDL_FILE_NAME!
		) ELSE (
			
			!DB2! "!SQL_CREATE_TABLE! !L_SCHEMA!.!L_NAME! !L_BODY!"  > NUL 2>&1
		)
        IF ERRORLEVEL 1 GOTO :EOF
	  )
    SET RET_CODE=1
	
ENDLOCAL & SET RESULT=%RET_CODE%
EXIT /B

:GET_WRAPPER_NAME_FOR_SERVER
SETLOCAL
	SET DB_NAME=%4
	SET SERVER_NAME=%2
	SET WN=
	SET DBA_MODE=%7
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! CONNECT TO !DB_NAME! >> !TMP_DDL_FILE_NAME!
	ECHO !DB2! -x "SELECT WRAPNAME FROM SYSCAT.SERVERS WHERE SERVERNAME='!SERVER_NAME!'" >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! CONNECT TO !DB_NAME! 
	!DB2! -x "SELECT WRAPNAME FROM SYSCAT.SERVERS WHERE SERVERNAME='!SERVER_NAME!'" > !TMP_F_NAME!
	)
	
	
	FOR /F %%T IN (!TMP_F_NAME!) DO (
        SET WN=%%T
        IF ERRORLEVEL 1 GOTO :EOF
    )
	SET Q_CHAR="
	SET TPACKPS_STRING=TPACKPS
	IF "!WN!" == "MSSQLODBC3" (
		SET Q_CHAR=
		SET TPACKPS_STRING=Packets_Transmitted_per_sec
	)
	IF "!DBA_MODE!" == "DBAMODE" (
	ECHO !DB2! TERMINATE >> !TMP_DDL_FILE_NAME!
	) ELSE (
	!DB2! TERMINATE 2>&1
	)
(ENDLOCAL 
SET QC=%Q_CHAR%
SET TRANSMITTED_PKTS_COL_NAME=%TPACKPS_STRING%
set WRAPPER_NAME=%WN%
EXIT /B
)
:INIT_TABLE_DEFS
REM ############################################################################
REM List of SQL statements forming bodies of the DB2 commands to be run.
REM ############################################################################
SET VIEW_BODY_SERVER_CPU=SELECT T.!QC!CEC_name!QC! AS HOST_NAME, -1 AS CPU_NUMBER, T.!QC!CPU_Used_Pct!QC! AS CPU_UTILIZATION, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_SERVER_CPU_AGG=SELECT T.!QC!LAT_CEC_name!QC! AS HOST_NAME, -1 AS CPU_NUMBER, T.!QC!MIN_CPU_Used_Pct!QC! AS MIN_CPU_UTILIZATION, T.!QC!MAX_CPU_Used_Pct!QC! AS MAX_CPU_UTILIZATION, T.!QC!SUM_CPU_Used_Pct!QC! AS SUM_CPU_UTILIZATION, T.!QC!AVG_CPU_Used_Pct!QC! AS AVG_CPU_UTILIZATION, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_SERVER_DISK=SELECT 'NA' AS HOST_NAME, T.!QC!Name!QC! AS DISK_NAME, T.!QC!Name!QC! AS DATA_STORE_NAME, T.!QC!Read_KB_per_Sec!QC! AS READ_KBPS, T.!QC!Written_KB_per_Sec!QC! AS WRITE_KBPS, T.!QC!Read_Transfers_per_Sec!QC! AS READ_COUNT, T.!QC!Written_KB_per_Sec!QC! AS WRITE_COUNT, -1 AS BUS_RESET, T.!QC!Transfers_per_Sec!QC! AS COMMANDS_COUNT, -1 AS COMMANDS_ABORTED_COUNT, -1 AS DEVICE_READ_LATENCY, -1 AS DEVICE_WRITE_LATENCY, -1 AS DEVICE_TOTAL_LATENCY, -1 AS DEVICE_LATENCY, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_SERVER_DISK_AGG=SELECT 'NA' AS HOST_NAME, T.!QC!Name!QC! AS DISK_NAME, T.!QC!Name!QC! AS DATA_STORE_NAME, T.!QC!MIN_Read_KB_per_Sec!QC! AS MIN_READ_KBPS, T.!QC!MAX_Read_KB_per_Sec!QC! AS MAX_READ_KBPS, T.!QC!SUM_Read_KB_per_Sec!QC! AS	SUM_READ_KBPS, T.!QC!AVG_Read_KB_per_Sec!QC! AS	AVG_READ_KBPS, T.!QC!MIN_Written_KB_per_Sec!QC! AS MIN_WRITE_KBPS, T.!QC!MAX_Written_KB_per_Sec!QC! AS MAX_WRITE_KBPS, T.!QC!SUM_Written_KB_per_Sec!QC! AS SUM_WRITE_KBPS, T.!QC!AVG_Written_KB_per_Sec!QC! AS AVG_WRITE_KBPS, T.!QC!MIN_Read_Transfers_per_Sec!QC! AS MIN_READ_COUNT, T.!QC!MAX_Read_Transfers_per_Sec!QC! AS MAX_READ_COUNT, T.!QC!SUM_Read_Transfers_per_Sec!QC! AS SUM_READ_COUNT, T.!QC!AVG_Read_Transfers_per_Sec!QC! AS AVG_READ_COUNT, T.!QC!MIN_Write_Transfers_per_Sec!QC! AS MIN_WRITE_COUNT, T.!QC!MAX_Write_Transfers_per_Sec!QC! AS MAX_WRITE_COUNT, T.!QC!SUM_Write_Transfers_per_Sec!QC! AS SUM_WRITE_COUNT, T.!QC!AVG_Write_Transfers_per_Sec!QC! AS AVG_WRITE_COUNT, -1 AS MIN_BUS_RESET, -1 AS MAX_BUS_RESET, -1 AS SUM_BUS_RESET, -1 AS AVG_BUS_RESET, T.!QC!MIN_Transfers_per_Sec!QC! AS MIN_COMMANDS_COUNT, T.!QC!MAX_Transfers_per_Sec!QC! AS	MAX_COMMANDS_COUNT, T.!QC!SUM_Transfers_per_Sec!QC! AS SUM_COMMANDS_COUNT, T.!QC!AVG_Transfers_per_Sec!QC! AS AVG_COMMANDS_COUNT, -1 AS MIN_COMMANDS_ABORTED_COUNT, -1 AS MAX_COMMANDS_ABORTED_COUNT, -1 AS SUM_COMMANDS_ABORTED_COUNT, -1 AS AVG_COMMANDS_ABORTED_COUNT, -1 AS MIN_DEVICE_READ_LATENCY, -1 AS MAX_DEVICE_READ_LATENCY, -1 AS SUM_DEVICE_READ_LATENCY, -1 AS AVG_DEVICE_READ_LATENCY, -1 AS MIN_DEVICE_WRITE_LATENCY, -1 AS MAX_DEVICE_WRITE_LATENCY, -1 AS SUM_DEVICE_WRITE_LATENCY, -1 AS AVG_DEVICE_WRITE_LATENCY, -1 AS MIN_DEVICE_TOTAL_LATENCY, -1 AS MAX_DEVICE_TOTAL_LATENCY, -1 AS SUM_DEVICE_TOTAL_LATENCY, -1 AS AVG_DEVICE_TOTAL_LATENCY, -1 AS MIN_DEVICE_LATENCY, -1 AS MAX_DEVICE_LATENCY, -1 AS SUM_DEVICE_LATENCY, -1 AS AVG_DEVICE_LATENCY, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_SERVER_NET=SELECT 'NA' AS HOST_NAME, T.!QC!Name!QC! AS NIC_NAME, T.!QC!Bandwidth_Util_Pct!QC! AS USAGE, T.!QC!Bytes_Sent_per_Sec!QC!/1000	AS TRANSMITTED_KBPS, T.!QC!Bytes_Recvd_per_Sec!QC!/1000 AS RECEIVED_KBPS, T.!QC!Pkts_Sent_per_Sec!QC! AS PKTS_TRANSMITTED, T.!QC!Pkts_Recvd_per_Sec!QC! AS PKTS_RECEIVED, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_SERVER_NET_AGG=SELECT 'NA' AS HOST_NAME, T.!QC!Name!QC! AS NIC_NAME, T.!QC!MIN_Bandwidth_Util_Pct!QC! AS MIN_USAGE, T.!QC!MAX_Bandwidth_Util_Pct!QC! AS MAX_USAGE, T.!QC!SUM_Bandwidth_Util_Pct!QC! AS SUM_USAGE, T.!QC!AVG_Bandwidth_Util_Pct!QC! AS AVG_USAGE, T.!QC!MIN_Bytes_Sent_per_Sec!QC!/1000 AS MIN_TRANSMITTED_KBPS, T.!QC!MAX_Bytes_Sent_per_Sec!QC!/1000 AS MAX_TRANSMITTED_KBPS, T.!QC!SUM_Bytes_Sent_per_Sec!QC!/1000 AS SUM_TRANSMITTED_KBPS, T.!QC!AVG_Bytes_Sent_per_Sec!QC!/1000 AS AVG_TRANSMITTED_KBPS, T.!QC!MIN_Bytes_Recvd_per_Sec!QC!/1000 AS MIN_RECEIVED_KBPS, T.!QC!MAX_Bytes_Recvd_per_Sec!QC!/1000 AS MAX_RECEIVED_KBPS, T.!QC!SUM_Bytes_Recvd_per_Sec!QC!/1000 AS SUM_RECEIVED_KBPS, T.!QC!AVG_Bytes_Recvd_per_Sec!QC!/1000 AS AVG_RECEIVED_KBPS, T.!QC!MIN_Pkts_Sent_per_Sec!QC! AS MIN_PKTS_TRANSMITTED, T.!QC!MAX_Pkts_Sent_per_Sec!QC! AS MAX_PKTS_TRANSMITTED, T.!QC!SUM_Pkts_Sent_per_Sec!QC! AS SUM_PKTS_TRANSMITTED, T.!QC!AVG_Pkts_Sent_per_Sec!QC! AS AVG_PKTS_TRANSMITTED, T.!QC!MIN_Pkts_Recvd_per_Sec!QC! AS MIN_PKTS_RECEIVED, T.!QC!MAX_Pkts_Recvd_per_Sec!QC! AS MAX_PKTS_RECEIVED, T.!QC!SUM_Pkts_Recvd_per_Sec!QC! AS SUM_PKTS_RECEIVED, T.!QC!AVG_Pkts_Recvd_per_Sec!QC! AS AVG_PKTS_RECEIVED, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_VM_CPU=SELECT T.!QC!Hostname!QC! AS HOST_NAME, T.!QC!CEC_name!QC! AS VM_SERVER_NAME, T.!QC!LPAR_Name!QC! AS VM_NAME, 'GLOBAL' AS DATA_CENTER_NAME, 'GLOBAL' AS VM_POOL_NAME, T.!QC!Entitled_Capacity_Used_Pct!QC! AS CPU_UTILIZATION, T.!QC!CPU_Units_Used!QC! AS USED_CPU_MHZ, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

SET VIEW_BODY_VM_CPU_AGG=SELECT T.!QC!LAT_Hostname!QC! AS HOST_NAME, T.!QC!LAT_CEC_name!QC! AS VM_SERVER_NAME, T.!QC!LAT_LPAR_Name!QC! AS VM_NAME, 'GLOBAL' AS DATA_CENTER_NAME, 'GLOBAL' AS VM_POOL_NAME, T.!QC!MIN_CPU_Units_Used!QC! AS MIN_USED_CPU_MHZ, T.!QC!MAX_CPU_Units_Used!QC! AS MAX_USED_CPU_MHZ, T.!QC!SUM_CPU_Units_Used!QC! AS SUM_USED_CPU_MHZ, T.!QC!AVG_CPU_Units_Used!QC! AS AVG_USED_CPU_MHZ, T.!QC!MIN_Entitled_Capacity_Used_Pct!QC! AS MIN_CPU_UTILIZATION, T.!QC!MAX_Entitled_Capacity_Used_Pct!QC! AS MAX_CPU_UTILIZATION, T.!QC!SUM_Entitled_Capacity_Used_Pct!QC! AS SUM_CPU_UTILIZATION, T.!QC!AVG_Entitled_Capacity_Used_Pct!QC! AS AVG_CPU_UTILIZATION, T.!QC!Timestamp!QC! AS TIMESTAMP, T.!QC!WRITETIME!QC! AS WRITETIME

EXIT /B

:EXIT
EXIT /B %STATUS%